Package: gdxrrw
Title: An Interface Between 'GAMS' and R
Version: 1.0.5
Depends: R (>= 2.14)
Date: 2019-09-27
SystemRequirements: GAMS (>= 24.2.1)
Authors@R: c(person("Steve","Dirkse", role=c("aut","cre"),
	             email="R@gams.com"),
             person("Michael","Ferris", role=c("aut")),
	     person("Rishabh","Jain", role=c("aut")) )
Description: A data interface between 'GAMS' and R.  The 'GAMS'
  (General Algebraic Modeling System) software includes a data
  specification called 'GDX' that is the preferred way to store and
  exchange 'GAMS' data.  This package includes several functions to
  transfer data between 'GDX' and R, and some related utility
  functions.
URL: http://www.gams.com
License: EPL2 with Secondary License GPL-2.0 or greater
Imports: reshape2
LazyData: no
Author: Steve Dirkse [aut, cre],
  Michael Ferris [aut],
  Rishabh Jain [aut]
Maintainer: Steve Dirkse <R@gams.com>
Built: R 3.6.1; x86_64-apple-darwin15.6.0; 2019-09-30 19:32:05 UTC; unix

useDynLib(gdxrrw, gamsExt=gams, gdxInfoExt=gdxInfo, igdxExt=igdx,
          rgdxExt=rgdx, wgdxExt=wgdx)

# export the functions
export (rgdx, wgdx, gams, gdxInfo, igdx)
export (rgdx.param, rgdx.scalar, rgdx.set)
export (wgdx.lst, wgdx.reshape)

# export the constants used in the interface
export (GMS_VARTYPE, GMS_EQUTYPE)

# compare the lists f1 and f2, return TRUE if the same, FALSE o/w
## this test assumes a certain ordering of the list elements
## it is not really necessary that they be ordered in this way but it
## makes the test easier to implement
chkLists <- function(s, f1, f2) {
  if (! is.list(f1))   return (FALSE)
  if (! is.list(f2))   return (FALSE)
  n     <- length(f1)
  if (n != length(f2))     return (FALSE)
  if (n < 3)     return (FALSE)

  f1Names <- names(f1)
  f2Names <- names(f2)

  ## element 1: symbol name
  if (! is.character(f1[[1]]))   return (FALSE)
  if (! is.character(f2[[1]]))   return (FALSE)
  if ("name"       != f2Names[[1]])   return (FALSE)
  if (f1Names[[1]] != f2Names[[1]])   return (FALSE)
  if (f1[[1]] != f2[[1]])        return (FALSE)

  ## element 2: symbol type
  if (! is.character(f1[[2]]))   return (FALSE)
  if (! is.character(f2[[2]]))   return (FALSE)
  if ("type"       != f2Names[[2]])   return (FALSE)
  if (f1Names[[2]] != f2Names[[2]])   return (FALSE)
  if (f1[[2]] != f2[[2]])        return (FALSE)

  if ("set" == f2[[2]]) {
    ## element 3: set uels
    if (! is.list(f1[[3]]))   return (FALSE)
    if (! is.list(f2[[3]]))   return (FALSE)
    if ("uels"       != f2Names[[3]])   return (FALSE)
    if (f1Names[[3]] != f2Names[[3]])   return (FALSE)
    uList1 <- f1[[3]]
    uList2 <- f2[[3]]
    if (length(uList1) != length(uList2))  return (FALSE)
    ## loop through the dimensions, comparing the UELs in each
    for (d in 1:length(uList1)) {
      uels1 <- uList1[[d]]
      uels2 <- uList2[[d]]
      nk <- length(uels1)
      if (nk != length(uels2))  return (FALSE)
      for (k in 1:nk) {
        if (uels1[[k]] != uels2[[k]]) {
          return (FALSE)
        }
      }
    }
    if (n > 3) {
      ## element 4: symbol text
      if (! is.character(f1[[4]]))   return (FALSE)
      if (! is.character(f2[[4]]))   return (FALSE)
      if ("ts"         != f2Names[[4]])   return (FALSE)
      if (f1Names[[4]] != f2Names[[4]])   return (FALSE)
      if (f1[[4]] != f2[[4]])        return (FALSE)
    }
    if (n > 4) {
      return (FALSE)
    }
    return (TRUE)
  }

  print (paste("checking", s, ": test is not fully implemented"))
  return (FALSE)
  return (TRUE)
} # chkLists



# compare the data frames f1 and f2, return TRUE if the same, FALSE o/w
chkFrames <- function(s, f1, f2) {
  if (! is.data.frame(f1))   return (FALSE)
  if (! is.data.frame(f2))   return (FALSE)
  nc     <- ncol(f1)
  if (nc != ncol(f2))     return (FALSE)
  nr     <- nrow(f1)
  if (nr != nrow(f2))     return (FALSE)
  if (nr == 0)            return (TRUE)
  if (attr(f1,"symName") != attr(f2,"symName"))   return (FALSE)

  cNames1 <- names(f1)
  cNames2 <- names(f2)
  for (j in c(1:nc)) {
    if (cNames1[j] != cNames2[j]) {
      print (paste("checking", s, ": column", j, "names differ"))
      return (FALSE)
    }
    fc1 <- f1[[j]]
    fc2 <- f2[[j]]
    if (is.factor(fc1)) {
      if (! is.factor(fc2))   return (FALSE)
      if (nlevels(fc1) != nlevels(fc2))   return (FALSE)
      lvl1 <- levels(fc1)
      lvl2 <- levels(fc2)
      for (k in c(1:nlevels(fc1))) {
        if (lvl1[[k]] != lvl2[[k]])   return (FALSE)
      }
      if (length(fc1) != length(fc2))   return (FALSE)
      iv1 <- as.integer(fc1)
      iv2 <- as.integer(fc2)
      for (k in c(1:length(fc1))) {
        if (iv1[[k]] != iv2[[k]])   return (FALSE)
      }
    }
    else if (is.vector(fc1)) {
      if (! is.vector(fc2))   return (FALSE)
      if (length(fc1) != length(fc2))   return (FALSE)
      for (k in c(1:length(fc1))) {
        if (fc1[[k]] != fc2[[k]])   return (FALSE)
      }
    }
    else {
      print (paste("checking", s, ": column", j, "type unrecognized"))
      return (FALSE)
    }
  }

  rNames1 <- row.names(f1)
  rNames2 <- row.names(f2)
  for (i in c(1:nr)) {
    if (rNames1[i] != rNames2[i]) {
      print (paste("checking", s, ": row", i, "names differ"))
      return (FALSE)
    }
  }
  return (TRUE)
} # chkFrames

## ## test wgdx with form='sparse', 1-d equations, write different types
## gdxdump or gdxdiff do not really do what we want here, so just have
## to read from the generated GDX and the target GDX and compare the results

if (! require(gdxrrw))      stop ("gdxrrw package is not available")
if (0 == igdx(silent=TRUE)) stop ("the gdx shared library has not been loaded")

testName <- 'all types of equation writes form=sparse'

errFunc <- function(ex) {
  print (paste0("test of wgdx on ",testName,": FAILED"))
  print(ex)
  FALSE
} # errFunc

tryCatch({
  print (paste("testing wgdx on", testName))
  wgdx('?')
  fnOut <- "tmp.gdx"
  fnWant <- "tEquTypes.gdx"
  if (! file_test ('-f', fnWant)) {
    stop (paste("FAIL: File-to-duplicate", fnWant, "does not exist"))
  }

  ## all writes should use the same uels
  iUels <- paste0("i","1":"10")
  fUels <- c("l", "m", "lo", "up", "s")
  uels <- list(iUels,fUels)

  ## write =E= equation to GDX, compare with fnWant version
  val0 <- matrix(0,nrow=5,ncol=3)
  for (i in 1:5) {
    val0[i,1] <- i
    val0[i,2] <- 2                      # only marginals are set non-default
  }
  val0[c(1,3,5),3] <- -1
  val0[c(2,4),3] <- 0
  vE <- list(name='equ_e_0',type='equation',val=val0,uels=uels,domains='i',
             typeCode=GMS_EQUTYPE$E,ts='=e= equation')
  wgdx (fnOut, vE)
  if (file_test ('-f', fnOut) == TRUE) {
    print (paste("File", fnOut, "was created"))
  } else {
    stop (paste("FAIL: File", fnOut, "is not readable"))
  }
  eWant <- rgdx(fnWant,list(name='equ_e_0',form='sparse',field='all',ts=TRUE))
  eWrot <- rgdx(fnOut, list(name='equ_e_0',form='sparse',field='all',ts=TRUE))
  ## patch up domInfo
  if (identical(eWrot$domInfo,"relaxed"))
    eWrot$domInfo <- "full"
  if (! identical(eWant,eWrot)) {
    print(all.equal(eWant,eWrot))
    stop ("FAIL: for equ_e_0, eWant and eWrot do not agree")
  }

  ## write =G= equation to GDX, compare with fnWant version
  val1 <- matrix(0,nrow=12,ncol=3)
  b <- 0                                # set base
  for (i in 1:5) {
    val1[b+i,1] <- i
    val1[b+i,2] <- 3
    val1[b+i,3] <- 2                    # equ_g_1.lo = 2
  }
  b <- b + 5
  for (i in 1:5) {
    val1[b+i,1] <- i
    val1[b+i,2] <- 1
    val1[b+i,3] <- 8                    # equ_g_1.l = 8
  }
  val1[b+c(2,4),3] <- 2                 # equ_g_1.l = 2 for some rows
  b <- b + 5
  val1[b+1,1] <- 2
  val1[b+2,1] <- 4
  val1[b+(1:2),2] <- 2
  val1[b+(1:2),3] <- 1                  # equ_g.m('i2','i4') = 1
  vE <- list(name='equ_g_1',type='equation',val=val1,uels=uels,domains='i',
                   typeCode=GMS_EQUTYPE$G,ts='=g= equation')
  wgdx (fnOut, vE)
  if (file_test ('-f', fnOut) == TRUE) {
    print (paste("File", fnOut, "was created"))
  } else {
    stop (paste("FAIL: File", fnOut, "is not readable"))
  }
  eWant <- rgdx(fnWant,list(name='equ_g_1',form='sparse',field='all',ts=TRUE))
  eWrot <- rgdx(fnOut, list(name='equ_g_1',form='sparse',field='all',ts=TRUE))
  if (identical(eWrot$domInfo,"relaxed"))
    eWrot$domInfo <- "full"
  if (! identical(eWant,eWrot)) {
    print(all.equal(eWant,eWrot))
    stop ("FAIL: for equ_g_1, eWant and eWrot do not agree")
  }

  ## write =L= equation to GDX, compare with fnWant version
  val2 <- matrix(0,nrow=13,ncol=3)
  b <- 0                                # set base
  val2[b+(1:5),1] <- (1:5)
  val2[b+(1:5),2] <- 4
  val2[b+(1:5),3] <- 8                  # equ_g_1(i1..i5).up = 8
  b <- b + 5
  val2[b+(1:5),1] <- (1:5)
  val2[b+(1:5),2] <- 1
  val2[b+c(1,3,5),3] <- 8               # equ_g_1(i1,i3,i5).L = 8
  val2[b+c(2,4)  ,3] <- 2               # equ_g_1(i2,i4).L = 8
  b <- b + 5
  val2[b+(1:3),1] <- c(1,3,5)
  val2[b+(1:3),2] <- 2
  val2[b+(1:3),3] <- -1                 # equ_g_1(i1,i3,i5).m = -1
  vL <- list(name='equ_l_2',type='equation',val=val2,uels=uels,domains='i',
                    typeCode=GMS_EQUTYPE$L,ts='=l= equation')
  wgdx (fnOut, vL)
  if (file_test ('-f', fnOut) == TRUE) {
    print (paste("File", fnOut, "was created"))
  } else {
    stop (paste("FAIL: File", fnOut, "is not readable"))
  }
  eWant <- rgdx(fnWant,list(name='equ_l_2',form='sparse',field='all',ts=TRUE))
  eWrot <- rgdx(fnOut, list(name='equ_l_2',form='sparse',field='all',ts=TRUE))
  if (identical(eWrot$domInfo,"relaxed"))
    eWrot$domInfo <- "full"
  if (! identical(eWant,eWrot)) {
    print(all.equal(eWant,eWrot))
    stop ("FAIL: for equ_l_2, eWant and eWrot do not agree")
  }

  ## write =N= equation to GDX, compare with fnWant version
  val3 <- matrix(0,nrow=5,ncol=3)
  val3[(1:5),1] <- (1:5)
  val3[(1:5),2] <- 1
  val3[(1:5),3] <- c(56,2,56,2,56)
  vN <- list(name='equ_n_3',type='equation',val=val3,uels=uels,domains='i',
                    typeCode=GMS_EQUTYPE$N,ts='=n= equation')
  wgdx (fnOut, vN)
  if (file_test ('-f', fnOut) == TRUE) {
    print (paste("File", fnOut, "was created"))
  } else {
    stop (paste("FAIL: File", fnOut, "is not readable"))
  }
  eWant <- rgdx(fnWant,list(name='equ_n_3',form='sparse',field='all',ts=TRUE))
  eWrot <- rgdx(fnOut, list(name='equ_n_3',form='sparse',field='all',ts=TRUE))
  if (identical(eWrot$domInfo,"relaxed"))
    eWrot$domInfo <- "full"
  if (! identical(eWant,eWrot)) {
    print(all.equal(eWant,eWrot))
    stop ("FAIL: for equ_n_3, eWant and eWrot do not agree")
  }


  print (paste0("test of wgdx on ", testName, ": PASSED"))
  invisible(TRUE)   ## all tests passed: return TRUE
},

error = errFunc
)

#### test wgdx with form='sparse', 2-d variable, on sorted and un-sorted 'val'

if (! require(gdxrrw))      stop ("gdxrrw package is not available")
if (0 == igdx(silent=TRUE)) stop ("the gdx shared library has not been loaded")

testName <- 'sorted and unsorted variable writes'
logFile <- 'diffLog.txt'

errFunc <- function(ex) {
  print (paste0("test of wgdx on ",testName,": FAILED"))
  print (paste("Check file", logFile, "for possible gdxdiff output"))
  print (ex)
  FALSE
} # errFunc

tryCatch({
  print ("testing wgdx on sparse variable write, sorted and unsorted")
  wgdx('?')
  fnIn <- "var2d.gdx"
  fnOut <- "tmp.gdx"
  if (! file_test ('-f', fnIn)) {
    stop (paste("FAIL: File", fnIn, "does not exist"))
  }

  xIn <- rgdx(fnIn,list(name='x',form='sparse',field='all'))
  xIn

  wgdx (fnOut, xIn)
  if (file_test ('-f', fnOut) == TRUE) {
    print (paste("File", fnOut, "was created"))
  } else {
    stop (paste("FAIL: File", fnOut, "is not readable"))
  }
  rc <- system2 ("gdxdiff",args=c(fnIn, fnOut), stdout=logFile)
  if (0 != rc) {
    stop(paste("Bad return from gdxdiff: wanted 0, got",rc))
  } else {
    print ("gdxdiff call succeeded")
  }

  x2 <- xIn[c("name","type","dim","val","form","uels","typeCode")]
  wgdx (fnOut, x2)
  if (file_test ('-f', fnOut) == TRUE) {
    print (paste("File", fnOut, "was created"))
  } else {
    stop (paste("FAIL: File", fnOut, "is not readable"))
  }
  rc <- system2 ("gdxdiff",args=c(fnIn, fnOut), stdout=logFile)
  if (0 != rc) {
    stop(paste("Bad return from gdxdiff: wanted 0, got",rc))
  } else {
    print ("gdxdiff call succeeded")
  }

  x3 <- xIn[c("name","type","dim","form","uels","typeCode")]
  v <- xIn$val
  dv <- dim(v)
  nrow <- dv[1]
  ncol <- dv[2]
  vv <- matrix(nrow=nrow,ncol=ncol)
  for (i in 1:nrow) {
    iFrom <- nrow + 1 - i
    for (j in 1:ncol)
      vv[i,j] = v[iFrom,j]
  }
  x3$val <- vv
  wgdx (fnOut, x3)
  if (file_test ('-f', fnOut) == TRUE) {
    print (paste("File", fnOut, "was created"))
  } else {
    stop (paste("FAIL: File", fnOut, "is not readable"))
  }
  rc <- system2 ("gdxdiff",args=c(fnIn, fnOut), stdout=logFile)
  if (0 != rc) {
    stop(paste("Bad return from gdxdiff: wanted 0, got",rc))
  } else {
    print ("gdxdiff call succeeded")
  }


  print (paste0("test of wgdx on ", testName, ": PASSED"))
  suppressWarnings(file.remove(logFile))
  invisible(TRUE)   ## all tests passed: return TRUE
},

error = errFunc
)

#### test rgdx case-insensitivity in handling of uel input filter

if (! require(gdxrrw))      stop ("gdxrrw package is not available")
if (0 == igdx(silent=TRUE)) stop ("the gdx shared library has not been loaded")

testName <- 'case-insensitivity in handling of uel input filter'

errFunc <- function(ex) {
  print (paste0("test of rgdx on ",testName,": FAILED"))
  print(ex)
  FALSE
} # errFunc

tryCatch({
  print ("testing rgdx case-insensitivity in handling of uel input filter")
  wgdx('?')
  fnIn <- "trnsport.gdx"
  if (! file_test ('-f', fnIn)) {
    stop (paste("FAIL: File", fnIn, "does not exist"))
  }

  uLst <- rgdx(fnIn)
  iUels <- uLst$uels
  loUels <- tolower(iUels)
  upUels <- toupper(iUels)
  iLst  <- rgdx(fnIn,list(name='i'))
  loLst <- rgdx(fnIn,list(name='i',uels=list(loUels)))
  upLst <- rgdx(fnIn,list(name='i',uels=list(upUels)))
  if (! identical(iLst$val,loLst$val)) {
    stop ("rgdx error: unexpected return in filtered read using loUels")
  }
  if (! identical(iLst$val,upLst$val)) {
    stop ("rgdx error: unexpected return in filtered read using upUels")
  }
  ## OK, the vals should be the same, no matter the case of the uels

  ## now check that the euls are really different
  if (identical(loUels,upUels)) {
    stop ("rgdx error: unexpected identical uels")
  }
  ## and that they match what comes back in the list
  if (! identical(loUels,loLst$uels[[1]])) {
    stop ("rgdx error: unexpected return in filtered read using loUels")
  }
  if (! identical(upUels,upLst$uels[[1]])) {
    stop ("rgdx error: unexpected return in filtered read using upUels")
  }


  print (paste0("test of rgdx on ", testName, ": PASSED"))
  invisible(TRUE)   ## all tests passed: return TRUE
},

error = errFunc
)

### Test gdxInfo
# We get a list of symbol names from the transport data

if (! require(gdxrrw))      stop ("gdxrrw package is not available")
if (0 == igdx(silent=TRUE)) stop ("the gdx shared library has not been loaded")

source ("chkSame.R")

tryCatch({

  fn <- "trnsport.gdx"
  s <- gdxInfo (fn, dump=FALSE, returnList=TRUE)

  if (!is.list(s))
    stop ("Expected gdxInfo output to be in list form")
  if (10 != length(s))
    stop ("Expected gdxInfo output to have length 10")
  if (12 != s$symCount)
    stop ("gdxInfo: expected trnsport symCount==12")
  if (5 != s$uelCount)
    stop ("gdxInfo: expected trnsport uelCount==5")
  if (! chkSameVec("sets", c("i","j"), s$sets))
    stop ("gdxInfo: s$sets for trnsport is bogus")
  if (! chkSameVec("parameters", c("a","b", "d", "f", "c"), s$parameters))
    stop ("gdxInfo: s$parameters for trnsport is bogus")
  if (! chkSameVec("variables", c("x","z"), s$variables))
    stop ("gdxInfo: s$variables for trnsport is bogus")
  if (! chkSameVec("equations", c("cost","supply", "demand"), s$equations))
    stop ("gdxInfo: s$equations for trnsport is bogus")
  if (! chkSameVec("aliases", character(0), s$aliases))
    stop ("gdxInfo: s$aliases for trnsport is bogus")

  print ("Successfully completed gdxInfo test 1")
  return (TRUE)
}

, error = function(ex) { print(ex) ; return (FALSE) }
)

### R code from vignette source 'tutorial.Rnw'

###################################################
### code chunk number 1: loadPackage
###################################################
library(gdxrrw)
igdx('')
if (! igdx(silent=T)) stop ('Could not load GDX API')


###################################################
### code chunk number 2: genData
###################################################
gms <- system.file('doc','transport.gms',package='gdxrrw', mustWork=T)
isWindows <- ("mingw32" == R.Version()$os)
if (isWindows) gms <- gsub("/","\\",gms,fixed=TRUE)
ingdx <- system.file('doc','inputs.gdx',package='gdxrrw', mustWork=T)
if (isWindows) ingdx <- gsub("/","\\",ingdx,fixed=TRUE)
rc <- gams(paste0(gms, " --INPUT=", ingdx))
if (0 != rc) stop ('GAMS run failed: rc = ',rc)


###################################################
### code chunk number 3: inCase
###################################################
if (! file.exists('outputs.gdx')) {
  ogdx <- system.file('doc','outputs.gdx',package='gdxrrw', mustWork=T)
  file.copy(ogdx,'outputs.gdx')
}


###################################################
### code chunk number 4: origData
###################################################
outgdx <- 'outputs.gdx'
if (! file.exists(outgdx)) stop (paste('File not found:',outgdx))
I <- rgdx.set(outgdx,'I')
J <- rgdx.set(outgdx,'J')
a <- rgdx.param(outgdx,'a')
b <- rgdx.param(outgdx,'b')
c <- rgdx.param(outgdx,'c')


###################################################
### code chunk number 5: identData
###################################################
wgdx.lst('intest',list(I,J,a,b,c))
rc <- system2('gdxdiff', paste('intest.gdx', ingdx), stdout=F)
if (0 != rc) stop ('gdxdiff says intest.gdx and inputs.gdx differ: rc = ',rc)
rc <- gams(paste(gms, '--INPUT intest.gdx --OUTPUT outtest.gdx'))
if (0 != rc) stop ('gams failed: rc = ',rc)
# system2('gams', 'transport.gms --INPUT intest.gdx --OUTPUT outtest.gdx')
zlst <- rgdx('outputs.gdx',list(name='z'))
z <- zlst$val
# we don't need to use the intermediate zlst variable to get the val
zz <- rgdx('outtest.gdx',list(name='z'))$val
if (0.0 != round(z-zz,6)) stop (paste("different objectives!! ", z, zz))


###################################################
### code chunk number 6: doubleData
###################################################
c2 <- c
c2[[3]] <- c[[3]] * 2
wgdx.lst('in2',list(I,J,a,b,c2))
gams(paste(gms,'--INPUT in2.gdx --OUTPUT out2.gdx'))
z2 <- rgdx('out2.gdx',list(name='z'))$val
print(paste('original=', z,'  double=',z2))


###################################################
### code chunk number 7: statesData
###################################################
data(state)
src <- c('California','Washington','New York','Maryland')
dst <- setdiff(state.name,src)
supTotal <- 1001
demTotal <- 1000
srcPop <- state.x77[src,'Population']
srcPopTot <- sum(srcPop)
dstPop <- state.x77[dst,'Population']
dstPopTot <- sum(dstPop)
sup <- (srcPop / srcPopTot) * supTotal
dem <- (dstPop / dstPopTot) * demTotal
x <- state.center$x
names(x) <- state.name
y <- state.center$x
names(y) <- state.name
cost <- matrix(0,nrow=length(src),ncol=length(dst),dimnames=list(src,dst))
for (s in src) {
  for (d in dst) {
    cost[s,d] <- sqrt((x[s]-x[d])^2 + (y[s]-y[d])^2)
  }
}


###################################################
### code chunk number 8: statesGDX
###################################################
ilst <- list(name='I',uels=list(src),ts='supply states')
jlst <- list(name='J',uels=list(dst),ts='demand states')
suplst <- list(name='a',val=as.array(sup),uels=list(src),
               dim=1,form='full',type='parameter',ts='supply limits')
demlst <- list(name='b',val=as.array(dem),uels=list(dst),
               dim=1,form='full',type='parameter',ts='demand quantities')
clst <- list(name='c',val=cost,uels=list(src,dst),
             dim=2,form='full',type='parameter',
             ts='transportation costs')
wgdx.lst('inStates',list(ilst,jlst,suplst,demlst,clst))


###################################################
### code chunk number 9: statesSolve
###################################################
gams(paste(gms,'--INPUT inStates.gdx --OUTPUT outStates.gdx'))
ms <- rgdx.scalar('outStates.gdx','modelStat')
print(paste('Model status:',ms))


###################################################
### code chunk number 10: missingGDX
###################################################
rc <- gams('transport --INPUT notHere')
if (0 == rc) print ("SHOULD NOT GET HERE") else print ("abnormal gams return as expected")


###################################################
### code chunk number 11: infeas
###################################################
a2 <- a
rows <- a2$i == 'seattle'
a2[rows,2] <- a2[rows,2] - 100
wgdx.lst('inInf',list(I,J,a2,b,c))
gams(paste(gms,'--INPUT inInf.gdx --OUTPUT outInf.gdx'))
ms <- rgdx.scalar('outInf.gdx','modelStat')
if (4 == ms) print ("Reduced supply makes model infeasible")

## ## test rgdx.XXX wrappers and checking of dataframe names

if (! require(gdxrrw))      stop ("gdxrrw package is not available")
if (0 == igdx(silent=TRUE)) stop ("the gdx shared library has not been loaded")

testName <- 'valid variable names in data frame'

errFunc <- function(ex) {
  print (paste0("test of rgdx on ",testName,": FAILED"))
  print(ex)
  FALSE
} # errFunc

tryCatch({
  print (paste("testing rgdx on", testName))
  rgdx('?')
  fnIn <- "checkNames.gdx"
  if (! file_test ('-f', fnIn)) {
    stop (paste("FAIL: File", fnIn, "does not exist"))
  }

  nm1  <- c('aa bb','s')
  nm1x <- c('aa.bb','s')

  # reserved words not allowed
  nm2  <- c('curr','next' ,'function')
  nm2x <- c('curr','next.','function.')

  # duplicates not allowed
  nm3  <- c('xxx','xxx')
  nm3x <- c('xxx','xxx.1')

  # not allowed: start with digit, any ?, start with .digit
  nm4  <- c('111' ,'???' ,'.1234')
  nm4x <- c('X111','X...','X.1234')

  # duplicates allowed if check.names=F
  nm5  <- c('xxx','xxx','xxx')

  # create desired data frame
  f1 <- factor(c("s1","s1","s2","s2"))
  f2 <- factor(c("s1","s2","s1","s2"))
  ssdf <- data.frame(list("var1"=f1,"var2"=f2))
  attr(ssdf,"symName") <- "ss"
  attr(ssdf,"domains") <- c("s","s")
  attr(ssdf,"domInfo") <- "full"
  ccdf <- data.frame(list("var1"=f1,"var2"=f2,"var3"=c(4,4,4,4)))
  attr(ccdf,"symName") <- "c"
  attr(ccdf,"domains") <- c("s","s")
  attr(ccdf,"domInfo") <- "full"
  
  ## test with default check.names: should be TRUE
  ss <- rgdx.set ('checkNames.gdx','ss',names=nm1)
  if (!identical(nm1x,names(ss))) {
    stop ("test rgdx.set with default check.names failed: bad names")
  }
  ssx <- ssdf
  names(ssx) <- nm1x
  if (!identical(ssx,ss)) {
    stop ("test rgdx.set with default check.names failed: bad ss")
  }
  cc <- rgdx.param ('checkNames.gdx','c',names=nm2)
  if (!identical(nm2x,names(cc))) {
    stop ("test rgdx.param with default check.names failed: bad names")
  }
  ccx <- ccdf
  names(ccx) <- nm2x
  if (!identical(ccx,cc)) {
    stop ("test rgdx.param with default check.names failed: bad cc")
  }

  ## test with check.names=TRUE
  ss <- rgdx.set ('checkNames.gdx','ss',names=nm3,check.names=TRUE)
  if (!identical(nm3x,names(ss))) {
    stop ("test rgdx.set with check.names=TRUE failed: bad names")
  }
  ssx <- ssdf
  names(ssx) <- nm3x
  if (!identical(ssx,ss)) {
    stop ("test rgdx.set with check.names=TRUE failed: bad ss")
  }
  cc <- rgdx.param ('checkNames.gdx','c',names=nm4,check.names=TRUE)
  if (!identical(nm4x,names(cc))) {
    stop ("test rgdx.param with check.names=TRUE failed: bad names")
  }
  ccx <- ccdf
  names(ccx) <- nm4x
  if (!identical(ccx,cc)) {
    stop ("test rgdx.param with check.names=TRUE failed: bad cc")
  }

  ## test with check.names=FALSE
  ss <- rgdx.set ('checkNames.gdx','ss',names=nm1,check.names=FALSE)
  if (!identical(nm1,names(ss))) {
    stop ("test rgdx.set with check.names=FALSE failed: bad names")
  }
  ssx <- ssdf
  names(ssx) <- nm1
  if (!identical(ssx,ss)) {
    stop ("test rgdx.set with check.names=FALSE failed: bad ss")
  }
  cc <- rgdx.param ('checkNames.gdx','c',names=nm2,check.names=FALSE)
  if (!identical(nm2,names(cc))) {
    stop ("test rgdx.param with check.names=FALSE failed: bad names")
  }
  ccx <- ccdf
  names(ccx) <- nm2
  if (!identical(ccx,cc)) {
    stop ("test rgdx.param with check.names=FALSE failed: bad cc")
  }
  ss <- rgdx.set ('checkNames.gdx','ss',names=nm3,check.names=FALSE)
  if (!identical(nm3,names(ss))) {
    stop ("test rgdx.set(...,'ss',names=nm3,check.names=FALSE) failed: bad names")
  }
  ssx <- ssdf
  names(ssx) <- nm3
  if (!identical(ssx,ss)) {
    stop ("test rgdx.set(...,'ss',names=nm3,check.names=FALSE) failed: bad ss")
  }
  cc <- rgdx.param ('checkNames.gdx','c',names=nm5,check.names=FALSE)
  if (!identical(nm5,names(cc))) {
    stop ("test rgdx.param(...,'c',names=nm5,check.names=FALSE) failed: bad names")
  }
  ccx <- ccdf
  names(ccx) <- nm5
  if (!identical(ccx,cc)) {
    stop ("test rgdx.param(...,'c',names=nm5,check.names=FALSE) failed: bad cc")
  }

  print (paste0("test of rgdx on ", testName, ": PASSED"))
  invisible(TRUE)   ## all tests passed: return TRUE
},

error = errFunc
)

#### test runtime of filtered reads

print ("timing test for filtered reads")
gams('?')
fnIn <- "aIJ.gdx"


## first read the universe
u <- rgdx(fnIn)

## read a parameter unfiltered
t1 <- system.time(c1 <- rgdx(fnIn,list(name='A')))

## same read but filtered with the universe
t2 <- system.time(c2 <-
         rgdx(fnIn,list(name='A',
                        uels=list(u$uels,u$uels) )))

print (paste(" card(universe):", length(u$uels)))
print (paste("unfiltered time:", t1[[3]]))
print (paste("  filtered time:", t2[[3]]))

#### test rgdx reading empty data

#### wanted lists can be produced with    dump("listName",file="")

if (! require(gdxrrw))      stop ("gdxrrw package is not available")
if (0 == igdx(silent=TRUE)) stop ("the gdx shared library has not been loaded")

source ("chkSame.R")
reqIdent <- TRUE

testName <- 'empty data'

errFunc <- function(ex) {
  print (paste0("test of rgdx on ",testName,": FAILED"))
  print (ex)
  FALSE
} # errFunc

tryCatch({
  print (paste("testing rgdx on", testName))
  rgdx('?')
  fnIn <- "tReadEmpty.gdx"
  if (! file_test ('-f', fnIn)) {
    stop (paste("FAIL: File", fnIn, "does not exist"))
  }

  ### ---------- reading empty set
  esetWant <- structure(
      list(i = structure(integer(0), .Label=character(0), class="factor")),
      .Names="i", row.names=integer(0),
      class="data.frame", symName="bb", domains="*", domInfo="none"
  )
  eset <- rgdx.set(fnIn,'bb')
  chk <- chkRgdxDF (eset, esetWant, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx.set() on empty set bb failed",chk$msg))
  }

  attr(esetWant,'domInfo') <- 'compressed'
  names(esetWant) <- '.i'
  eset <- rgdx.set(fnIn,'bb',compress=T)
  chk <- chkRgdxDF (eset, esetWant, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx.set(,compress=T) on empty set bb failed",chk$msg))
  }

  ### ---------- reading 3-dim empty set
  es3Want <- structure(
      list(d1 = structure(integer(0), .Label=character(0), class="factor"),
           d2 = structure(integer(0), .Label=character(0), class="factor"),
           d3 = structure(integer(0), .Label=character(0), class="factor")
           ),
      .Names=c("d1","d2","d3"), row.names=integer(0), class="data.frame",
      symName="basket", domains=c("d1","d2","d3"), domInfo="full"
  )
  es3 <- rgdx.set(fnIn,'basket')
  chk <- chkRgdxDF (es3, es3Want, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx.set() on empty set basket failed",chk$msg))
  }

  attr(es3Want,'domInfo') <- 'compressed'
  # names(es3Want) <- '.i'
  es3 <- rgdx.set(fnIn,'basket',compress=T)
  chk <- chkRgdxDF (es3, es3Want, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx.set(,compress=T) on empty set basket failed",chk$msg))
  }

  ### ---------- reading empty 1-d param
  ep1Want <- structure(list(
      d1 = structure(integer(0), .Label=character(0), class="factor"),
      e1 = numeric(0)
    ),
    .Names=c("d1","e1"), row.names=integer(0), class="data.frame",
    symName="e1", domains="d1", domInfo="full"
  )
  ep1 <- rgdx.param(fnIn,'e1')
  chk <- chkRgdxDF (ep1, ep1Want, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx.param() on empty param e1 failed",chk$msg))
  }

  attr(ep1Want,'domInfo') <- 'compressed'
  ep1 <- rgdx.param(fnIn,'e1',compress=T)
  chk <- chkRgdxDF (ep1, ep1Want, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx.param(,compress=T) on empty param e1 failed",chk$msg))
  }


  ### ---------- reading empty 3-d param
  ep3Want <- structure(list(
      d1 = structure(integer(0), .Label=character(0), class="factor"),
      d2 = structure(integer(0), .Label=character(0), class="factor"),
      d3 = structure(integer(0), .Label=character(0), class="factor"),
      e3 = numeric(0)
    ),
    .Names=c("d1","d2","d3","e3"), row.names=integer(0), class="data.frame",
    symName="e3", domains=c("d1","d2","d3"), domInfo="full"
  )
  ep3 <- rgdx.param(fnIn,'e3')
  chk <- chkRgdxDF (ep3, ep3Want, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx.param() on empty param e3 failed",chk$msg))
  }

  attr(ep3Want,'domInfo') <- 'compressed'
  ep3 <- rgdx.param(fnIn,'e3',compress=T)
  chk <- chkRgdxDF (ep3, ep3Want, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx.param(,compress=T) on empty param e3 failed",chk$msg))
  }


  print (paste("test of rgdx on", testName, "passed"))
  TRUE   ## all tests passed: return TRUE
},

error = errFunc
)

### Test wgdx with special values and zero

if (! require(gdxrrw))      stop ("gdxrrw package is not available")
if (0 == igdx(silent=TRUE)) stop ("the gdx shared library has not been loaded")

tryCatch({

  print ("test writing special values with form='sparse' and no filter")
  wgdx ('?')

  uels <- list(c('dummy',"R-PInf","R-MInf","R-NaN","R-NA","R-Zero","R-denorm"));
  sv <- matrix(c(1,2, 1,
                 2,2, Inf,
                 1,3, 1,
                 3,3, -Inf,
                 1,4, 1,
                 4,4, NaN,
                 1,5, 1,
                 5,5, NA,
                 1,6, 1,
                 6,6, 0,
                 1,7, 1,
                 7,7, 1e-320),
                 nrow=12,ncol=3,byrow=TRUE);

  svList <- list (name='sv', type='parameter', form='sparse', dim=2,
                  ts='special values with default squeeze="yes"',
                  val=sv, uels=c(uels,uels))

  fn1 <- "wSV1.gdx"
  want1 <- "wSV1_want.gdx"
  print (paste("first write with defaults: output =",fn1));
  wgdx (fn1, svList)

  fn2 <- "wSV2.gdx"
  want2 <- "wSV2_want.gdx"
  print (paste("second write with option squeeze=FALSE: output =",fn2));
  wgdx (fn2, svList, squeeze=FALSE)

  fn3 <- "wSV3.gdx"
  want3 <- "wSV3_want.gdx"
  print (paste("third write with option squeeze='eps': output =",fn3));
  wgdx (fn3, svList, squeeze='Eps')


  if (file_test ('-f', fn1) == TRUE) {
    print (paste("File", fn1, "was created"))
  } else {
    stop (paste("FAIL: File", fn1, "is not readable"))
  }
  rc <- system (paste("gdxdiff",fn1,want1))
  if (0 != rc) {
    stop(paste("Bad return from gdxdiff: wanted 0, got",rc))
  } else {
    print (paste("gdxdiff call succeeded, file",fn1,"is OK"))
  }

  if (file_test ('-f', fn2) == TRUE) {
    print (paste("File", fn2, "was created"))
  } else {
    stop (paste("FAIL: File", fn2, "is not readable"))
  }
  rc <- system (paste("gdxdiff",fn2,want2))
  if (0 != rc) {
    stop(paste("Bad return from gdxdiff: wanted 0, got",rc))
  } else {
    print (paste("gdxdiff call succeeded, file",fn2,"is OK"))
  }

  if (file_test ('-f', fn3) == TRUE) {
    print (paste("File", fn3, "was created"))
  } else {
    stop (paste("FAIL: File", fn3, "is not readable"))
  }
  rc <- system (paste("gdxdiff",fn3,want3))
  if (0 != rc) {
    stop(paste("Bad return from gdxdiff: wanted 0, got",rc))
  } else {
    print (paste("gdxdiff call succeeded, file",fn3,"is OK"))
  }

  print ("all tests for writing special values and zero passed")
  return (TRUE)
}

, error = function(ex) { print(ex) ; return (FALSE) }
)

#### test rgdx errors: some things should be an error,
#### and we expect certain behavior in these cases

if (! require(gdxrrw))      stop ("gdxrrw package is not available")
if (0 == igdx(silent=TRUE)) stop ("the gdx shared library has not been loaded")

tryCatch({
  print ("testing error detection and handling for rgdx")
  rgdx('?')
  fnIn <- "teTest.gdx"
  if (! file_test ('-f', fnIn)) {
    stop (paste("FAIL: File", fnIn, "does not exist"))
  }

  msg <- "rgdx test with bogus form specifier"
  tcr <- tryCatch({
    IJ <- rgdx(fnIn,list(name='IJ',form='invalidForm',compress=TRUE)) ; FALSE
    },
    error = function(e) { print(paste(' Caught error: msg =',e)) ; TRUE }
  )
  if (tcr) {
    print(paste(msg,": passed",sep=""))
  }
  else {
    stop (paste(msg, ": failed",sep=""))
  }

  # set IJ has dimension 2, not 4
  msg <- "rgdx test with bogus dim specifier"
  tcr <- tryCatch({
    IJ <- rgdx(fnIn,list(name='IJ',dim=4)) ; FALSE
    },
    error = function(e) { print(paste(' Caught error: msg =',e)) ; TRUE }
  )
  if (tcr) {
    print(paste(msg,": passed",sep=""))
  }
  else {
    stop (paste(msg, ": failed",sep=""))
  }


  # parameters do not have text elements
  msg <- "rgdx test with specifier te=TRUE for a parameter"
  tcr <- tryCatch({
    IJ <- rgdx(fnIn,list(name='A',te=TRUE)) ; FALSE
    },
    error = function(e) { print(paste(' Caught error: msg =',e)) ; TRUE }
  )
  if (tcr) {
    print(paste(msg,": passed",sep=""))
  }
  else {
    stop (paste(msg, ": failed",sep=""))
  }

  # we do not allow compressed reads of variables
  msg <- "rgdx test with compressed read of a variable"
  tcr <- tryCatch({
    IJ <- rgdx('tReadVar0',list(name='z',compress=TRUE)) ; FALSE
    },
    error = function(e) { print(paste(' Caught error: msg =',e)) ; TRUE }
  )
  if (tcr) {
    print(paste(msg,": passed",sep=""))
  }
  else {
    stop (paste(msg, ": failed",sep=""))
  }



  ## all tests passed: return TRUE
  print ("test of rgdx error handling: all passed")
  TRUE
},

error = function(ex) { print ("test of rgdx error handling failed"); print(ex) ; FALSE }
)

## ## test wgdx.lst wrapper on dplyr table input

if (! require(gdxrrw))      stop ("gdxrrw package is not available")
if (0 == igdx(silent=TRUE)) stop ("the gdx shared library has not been loaded")

testName <- 'writing from dplyr tables'
logFile <- 'diffLog.txt'
 
errFunc <- function(ex) {
  print (paste0("test of wgdx on ",testName,": FAILED"))
  print (paste("Check file", logFile, "for possible gdxdiff output"))
  print(ex)
  FALSE
} # errFunc

ok <- library(dplyr,logical.return=T)
if (!ok) {
  print (paste0("test of wgdx on ", testName, ": SKIPPED"))
  invisible(TRUE)
} else {
tryCatch({
  print (paste("testing wgdx on", testName))
  wgdx('?')
  fnDF <- 'junkDF.gdx'
  fnTBL <- 'junkTBL.gdx'

  tdf <- data.frame(
    name=factor(c('Wietse','Foppe','Gea','Wietse')),
    year=factor(c(2016,2015,2014,2020)),
    value=c(100,99,98,112)
  )

  attr(tdf,'symName') <- 't';
  attr(tdf,'ts') <- 'test of tbl input';
  attr(tdf,'domains') <- names(tdf)[1:(ncol(tdf)-1)]
  str(tdf)

  sdf <- tdf[c(1,2)]
  attr(sdf,'symName') <- 's';
  str(sdf)

  ssdf <- sdf
  ssdf[[3]] <- c('text one', 'text 2', 'text III', 'text vier')
  attr(ssdf,'symName') <- 'ss';
  str(ssdf)

  wgdx.lst(fnDF, list(tdf,sdf,ssdf))
  if (file_test ('-f', fnDF) == TRUE) {
    print (paste("File", fnDF, "was created"))
  } else {
    stop (paste("FAIL: File", fnDF, "is not readable"))
  }

  ttbl <- as.tbl(tdf)
  str(ttbl)
  stbl <- as.tbl(sdf)
  str(stbl)
  sstbl <- as.tbl(ssdf)
  str(sstbl)

  wgdx.lst(fnTBL, list(ttbl,stbl,sstbl))
  if (file_test ('-f', fnTBL) == TRUE) {
    print (paste("File", fnTBL, "was created"))
  } else {
    stop (paste("FAIL: File", fnTBL, "is not readable"))
  }
  rc <- system2 ("gdxdiff",args=c(fnDF, fnTBL), stdout=logFile)
  if (0 != rc) {
    stop(paste("Bad return from gdxdiff: wanted 0, got",rc))
  } else {
    print ("gdxdiff call succeeded")
  }

  print (paste0("test of wgdx on ", testName, ": PASSED"))
  invisible(TRUE)   ## all tests passed: return TRUE
},

error = errFunc
)
}

### Test all the wrappers: rgdx.set, rgdx.param, rgdx.scalar, and wgdx.lst
# We first read the trnsport data from GDX,
# and write it out again using the wgdx.lst wrapper

if (! require(gdxrrw))      stop ("gdxrrw package is not available")
if (0 == igdx(silent=TRUE)) stop ("the gdx shared library has not been loaded")

testName <- 'basic wrapper functioning'
logFile <- 'diffLog.txt'

errFunc <- function(ex) {
  print (paste0("test of gdxrrw on ",testName,": FAILED"))
  print (paste("Check file", logFile, "for possible gdxdiff output"))
  print (ex)
  FALSE
} # errFunc

tryCatch({
  print (paste("testing gdxrrw on", testName))
  fnIn <- "trnsport.gdx"
  fnOut <- "wtransport.gdx"
  if (file_test ('-f', fnOut) == TRUE) {
    file.remove (fnOut)
  }

  # read all the data, using various combination of options
  idf <- rgdx.set(fnIn,'i',ts=TRUE)
  jdf <- rgdx.set(fnIn,'j',names="J",compress=TRUE)
  adf <- rgdx.param(fnIn,'a')
  bdf <- rgdx.param(fnIn,'b', names=c('JJ','theValues'), ts=TRUE)
  cdf <- rgdx.param(fnIn,'c', names=c('from','to'), compress=TRUE, ts=TRUE)
  ddf <- rgdx.param(fnIn,'d')
  fsc <- rgdx.scalar(fnIn,'f')

  wgdx.lst (fnOut, list(idf,jdf,adf,bdf,cdf,ddf,fsc))
  if (file_test ('-f', fnOut) == TRUE) {
    print (paste("File", fnOut, "was created"))
  } else {
    stop (paste("FAIL: File", fnOut, "is not readable"))
  }
  rc <- system2 ("gdxdiff",args=c(fnIn, fnOut,
                               "releps=1e-15", "id=i,j,a,b,c,d,f"), stdout=logFile)
  if (0 != rc) {
    stop(paste("Bad return from gdxdiff: wanted 0, got",rc))
  } else {
    print ("gdxdiff call succeeded")
  }
  if (file_test ('-f', fnOut) == TRUE) {
    file.remove (fnOut)
  }

  # do the write again, but mix in some symLists
  ilst <- list(name='i',type='set',ts='canning plants', uels=list(as.character(idf$i)))
  blst <- list(name='b',type='parameter',ts=attr(bdf,"symName"),
               form="full", uels=list(as.character(bdf$JJ)),
               val=as.array(as.numeric(bdf$theValues)) )
  clst <- list(name="c", type="parameter", ts=attr(cdf,"symName"),
               form="sparse", uels=c(list(levels(cdf$from)),list(levels(cdf$to))),
               val=matrix(data=NA,nrow=nrow(cdf),ncol=ncol(cdf)) )
  clst$val[,1] <- as.numeric(cdf$from)
  clst$val[,2] <- as.numeric(cdf$to)
  clst$val[,3] <- cdf$value
  wgdx.lst (fnOut, list(ilst,jdf,adf,blst,clst,ddf,fsc))
  if (file_test ('-f', fnOut) == TRUE) {
    print (paste("File", fnOut, "was created"))
  } else {
    stop (paste("FAIL: File", fnOut, "is not readable"))
  }
  rc <- system2 ("gdxdiff",args=c(fnIn, fnOut,
                               "releps=1e-15", "id=i,j,a,b,c,d,f"), stdout=logFile)
  if (0 != rc) {
    stop(paste("Bad return from gdxdiff: wanted 0, got",rc))
  } else {
    print ("gdxdiff call succeeded")
  }
  if (file_test ('-f', fnOut) == TRUE) {
    file.remove (fnOut)
  }

  print (paste0("test of gdxrrw on ",testName,": PASSED"))
  suppressWarnings(file.remove(logFile))
  invisible(TRUE)   ## all tests passed: return TRUE
},

error = errFunc
)

### Test rgdx.param
# we read the distance matrix from the eurodist data set
# previously stored in a GDX file and compare that to the eurodist data

if (! require(gdxrrw))      stop ("gdxrrw package is not available")
if (0 == igdx(silent=TRUE)) stop ("the gdx shared library has not been loaded")

tryCatch({
  gdxName <- "euroDistTest"
  symName <- "dist"
  df <- rgdx.param(gdxName,symName)
  df3 <- rgdx.param(gdxName,symName,names=c("from","to","distance"))

  n <- attr(eurodist,"Size")
  cities <- attr(eurodist,"Labels")
  dm <- as.matrix(eurodist)

  k <- 0
  doPrint <- TRUE;
  for (i in c(1:n)) {
    for (j in c(1:n)) {
      if (dm[i,j] > 0) {
        k <- k + 1
        if (doPrint) {
          print (paste("checking eurodist:", i, j, cities[i], cities[j], dm[i,j]))
          print (paste("              df3:", as.numeric(df3$from[k]), as.numeric(df3$to[k]), as.character(df3$from[k]), as.character(df3$to[k]), df3$distance[k]))
          if (k > 10) {
            print ("Further output suppressed")
            doPrint <- FALSE;
          }
        }
        if (i != as.numeric(df3$from[k])) {
          stop ("mismatch in i")
        }
        if (j != as.numeric(df3$to[k])) {
          stop ("mismatch in j")
        }
        if (cities[i] != as.character(df3$from[k])) {
          stop ("mismatch in cities[i]")
        }
        if (cities[j] != as.character(df3$to[k])) {
          stop ("mismatch in cities[j]")
        }
        if (dm[i,j] != df3$distance[k]) {
          stop ("mismatch in distance[k]")
        }
      }
    }
  }

  print ("All tests for rgdx.param passed");
  return (TRUE)
}

, error = function(ex) { print(ex) ; return (FALSE) }
)

### Test that the gdxdiff utility can be run successfully via system2()

if (! require(gdxrrw))      stop ("gdxrrw package is not available")
if (0 == igdx(silent=TRUE)) stop ("the gdx shared library has not been loaded")

fnData <- "trnsport.gdx"
logFile <- 'diffLog.txt'

errFunc <- function(ex) {
  print (paste("Check file", logFile, "for possible gdxdiff output"))
  print (ex)
  FALSE
} # errFunc

tryCatch({
  if (! file_test ('-f', fnData)) {
    stop (paste("FAIL: File", fnData, "does not exist"))
  }
  rc <- system2 ("gdxdiff",args=c(fnData, fnData), stdout=logFile)
  if (0 != rc) {
    stop(paste("Bad return from trivial gdxdiff: wanted 0, got",rc))
  } else {
    print ("gdxdiff call succeeded: it must be available and functional")
  }

  suppressWarnings(file.remove(logFile))
  invisible(TRUE)   ## all tests passed: return TRUE
},

error = errFunc
)

# ss <- list(name='I',type='set',form='full',dim=1,uels=uels,val=array(c(1,1,0,0,0)));
# sI <- list(name='I',type='set',form='full',uels=uels,val=array(c(1,1,0,0,0)));

# sI <- list(name='I',type='set',form='full',uels=uels,val=array(c(1:2),c(2,1)));
# sI <- list(name='I',type='set',form='sparse',uels=uels,val=array(c(1:2),c(2,1)));
# sI <- list(name='I',type='set',form='full',uels=uels,val=array(c(1:2)));
# sJ <- list(name='J',type='set',form='full',uels=uels);
# sAll <- list(name='Ix',type='set',uels=uels);

### Test rgdx, rgdx.param with special values and zero
# We read a parameter containing special values and test the results

if (! require(gdxrrw))      stop ("gdxrrw package is not available")
if (0 == igdx(silent=TRUE)) stop ("the gdx shared library has not been loaded")

tryCatch({
  print ("test reading special values with form='sparse' and no filter")
  rgdx('?')

  fn <- "svxls.gdx"

  print (paste("first read with defaults: input =",fn))
  sv1 <- rgdx (fn,list(name='sv'))

  print (paste("second read with squeeze=FALSE: input =",fn))
  sv2 <- rgdx (fn,list(name='sv'),squeeze=FALSE)

  print (paste("third read as data frame with default squeeze: input =",fn))
  svdf3 <- rgdx.param (fn, 'sv', ts=TRUE)

  print (paste("fourth read as data frame with squeeze=FALSE: input =",fn))
  svdf4 <- rgdx.param (fn, 'sv', ts=TRUE, squeeze=FALSE)

  if (dim(sv1$val)[1] != 15)
    stop ("Expected dim(sv1$val)[1] to be 15")
  if (dim(sv1$val)[2] != 3)
    stop ("Expected dim(sv1$val)[1] to be 3")
  if (! is.nan(sv1$val[12,3]))
    stop ("Expected sv1$val[12,3] to be NaN")
  if (! is.na(sv1$val[13,3]))
    stop ("Expected sv1$val[13,3] to be NA")
  if (! is.infinite(sv1$val[14,3]))
    stop ("Expected sv1$val[14,3] to be infinite")
  if (sv1$val[14,3] <= 0)
    stop ("Expected sv1$val[14,3] to be positive")
  if (! is.infinite(sv1$val[15,3]))
    stop ("Expected sv1$val[15,3] to be infinite")
  if (sv1$val[15,3] >= 0)
    stop ("Expected sv1$val[15,3] to be negative")

  if (dim(sv2$val)[1] != 17)
    stop ("Expected dim(sv2$val)[1] to be 17")
  if (dim(sv2$val)[2] != 3)
    stop ("Expected dim(sv2$val)[1] to be 3")
  if (0 != sv2$val[12,3])
    stop ("Expected sv2$val[12,3] to be 0")
  if (! is.nan(sv2$val[13,3]))
    stop ("Expected sv2$val[13,3] to be NaN")
  if (! is.na(sv2$val[14,3]))
    stop ("Expected sv2$val[14,3] to be NA")
  if (! is.infinite(sv2$val[15,3]))
    stop ("Expected sv2$val[15,3] to be infinite")
  if (sv2$val[15,3] <= 0)
    stop ("Expected sv2$val[15,3] to be positive")
  if (! is.infinite(sv2$val[16,3]))
    stop ("Expected sv2$val[16,3] to be infinite")
  if (sv2$val[16,3] >= 0)
    stop ("Expected sv2$val[16,3] to be negative")
  if (0 != sv2$val[17,3])
    stop ("Expected sv2$val[17,3] to be 0")

  # test data frame returns with squeezed zero
  if (dim(svdf3)[1] != 15)
    stop ("Expected dim(svdf3)[1] to be 15")
  if (dim(svdf3)[2] != 3)
    stop ("Expected dim(svdf3)[1] to be 3")
  if (! is.nan(svdf3[12,'value']))
    stop ("Expected svdf3[12,'value'] to be NaN")
  if (! is.na(svdf3[13,'value']))
    stop ("Expected svdf3[13,'value'] to be NA")
  if (! is.infinite(svdf3[14,'value']))
    stop ("Expected svdf3[14,'value'] to be infinite")
  if (svdf3[14,'value'] <= 0)
    stop ("Expected svdf3[14,'value'] to be positive")
  if (! is.infinite(svdf3[15,'value']))
    stop ("Expected svdf3[15,'value'] to be infinite")
  if (svdf3[15,'value'] >= 0)
    stop ("Expected svdf3[15,'value'] to be negative")

  if (dim(svdf4)[1] != 17)
    stop ("Expected dim(svdf4)[1] to be 17")
  if (dim(svdf4)[2] != 3)
    stop ("Expected dim(svdf4)[1] to be 3")
  if (0 != svdf4[12,'value'])
    stop ("Expected svdf4[12,'value'] to be 0")
  if (! is.nan(svdf4[13,'value']))
    stop ("Expected svdf4[13,'value'] to be NaN")
  if (! is.na(svdf4[14,'value']))
    stop ("Expected svdf4[14,'value'] to be NA")
  if (! is.infinite(svdf4[15,'value']))
    stop ("Expected svdf4[15,'value'] to be infinite")
  if (svdf4[15,'value'] <= 0)
    stop ("Expected svdf4[15,'value'] to be positive")
  if (! is.infinite(svdf4[16,'value']))
    stop ("Expected svdf4[16,'value'] to be infinite")
  if (svdf4[16,'value'] >= 0)
    stop ("Expected svdf4[16,'value'] to be negative")
  if (0 != svdf4[17,'value'])
    stop ("Expected svdf4[17,'value'] to be 0")

  print ("all tests for reading special values and zero passed")
  TRUE
}

, error = function(ex) { print(ex) ; FALSE }
)

## body of tests for comparing behavior in two rgdx cases:
##   1. compress=TRUE and useDomInfo=FALSE
##   2. compress=TRUE and useDomInfo=TRUE
## We expect very similar behavior so we use a common test file

u1 <- c('*')
u2 <- c('*','*')

iUels <- c("i1", "i2", "i3", "i4", "i5", "i6", "i7")
iCard <- length(iUels)
iVals <- matrix(as.double(c(1:iCard)), nrow=iCard, ncol=1)
iOnes <- matrix(1, nrow=iCard, ncol=1,dimnames=list('*'=iUels))
jUels <- c("j1", "j2", "j3", "j4", "j5")
jCard <- length(jUels)
jVals <- matrix(as.double(c(1:jCard)), nrow=jCard, ncol=1)
jOnes <- matrix(1, nrow=jCard, ncol=1,dimnames=list('*'=jUels))
aVals <- matrix(c(1,1, 33.11,
                  2,2, 54.22), nrow=2, ncol=3, byrow=TRUE)
aDoms <- u2
if (useDomInfo) aDoms <- c('I','J')
aUels <- list(c("i3", "i5"), c("j3", "j4"))
aUelsN <- aUels
names(aUelsN) <- aDoms
aFull <- matrix(c(33.11, 0,
                      0, 54.22), nrow=2, ncol=2, byrow=TRUE,
                dimnames=aUelsN)
bVals <- matrix(nrow=iCard*jCard, ncol=3)
for (i in 1:iCard) {
  for (j in 1:jCard) {
    k <- (i-1)*jCard + j
    bVals[k,1] <- i
    bVals[k,2] <- j
    bVals[k,3] <- 525
  }
}
bDoms <- aDoms
bUels <- list(iUels,jUels)
bUelsN <- bUels
names(bUelsN) <- bDoms
bFull <- matrix(525,nrow=iCard, ncol=jCard, dimnames=bUelsN)
dVals <- matrix(nrow=iCard,ncol=3)
for (i in 1:iCard) {
  dVals[i,1] <- i
  dVals[i,2] <- 1
  dVals[i,3] <- (10*i + 1) * 1.01
}
dDoms <- aDoms
dUels <- list(iUels,c('j1'))
dUelsN <- dUels
names(dUelsN) <- dDoms
dFull <- matrix(nrow=iCard,ncol=1,dimnames=dUelsN)
for (i in 1:iCard) {
  dFull[i,1] <- (10*i + 1) * 1.01
}
eVals <- matrix(nrow=jCard,ncol=3)
for (j in 1:jCard) {
  eVals[j,1] <- 1
  eVals[j,2] <- j
  eVals[j,3] <- (30 + j) + (10 + j)/100
}
eUels <- list(c('i3'),jUels)
eUelsN <- eUels
eDoms <- aDoms
names(eUelsN) <- eDoms
eFull <- matrix(nrow=1,ncol=jCard,dimnames=eUelsN)
for (j in 1:jCard) {
  eFull[1,j] <- (30 + j) + (10 + j)/100
}

cVals <- matrix(c(1,1.1,
                  2,5.1), nrow=2, ncol=2, byrow=TRUE)
cDoms <- u1
if (useDomInfo) cDoms <- c('J')
cUels <- list(c("j1", "j5"))
cUelsN <- cUels ; names(cUelsN) <- cDoms
cFull <- matrix(c(1.1, 5.1), nrow=2,ncol=1,dimnames=cUelsN)


## ---------- reading form=sparse

iwant <- list(name="I", type="set", dim=1L,
              val=iVals,
              form="sparse",
              uels=list(iUels),
              domains=u1, domInfo='compressed')
i <- rgdx(fnIn,list(name='i',form='sparse',compress=TRUE),useDomInfo=useDomInfo)
chk <- chkRgdxRes (i, iwant, reqIdent=reqIdent)
if (!chk$same) {
  stop (paste("test rgdx(i,sparse) failed:",chk$msg))
}

jwant <- list(name="J", type="set", dim=1L,
              val=jVals,
              form="sparse",
              uels=list(jUels),
              domains=u1, domInfo='compressed')
j <- rgdx(fnIn,list(name='j',form='sparse',compress=TRUE),useDomInfo=useDomInfo)
chk <- chkRgdxRes (j, jwant, reqIdent=reqIdent)
if (!chk$same) {
  stop (paste("test rgdx(j,sparse) failed:",chk$msg))
}

awant <- list(name="A", type="parameter", dim=2L,
              val=aVals,
              form="sparse",
              uels=aUels,
              domains=aDoms, domInfo='compressed')
a <- rgdx(fnIn,list(name='a',form='sparse',compress=TRUE),useDomInfo=useDomInfo)
chk <- chkRgdxRes (a, awant, reqIdent=reqIdent)
if (!chk$same) {
  stop (paste("test rgdx(a,sparse) failed:",chk$msg))
}

bwant <- list(name="B", type="parameter", dim=2L,
              val=bVals,
              form="sparse",
              uels=bUels,
              domains=bDoms, domInfo='compressed')
b <- rgdx(fnIn,list(name='b',form='sparse',compress=TRUE),useDomInfo=useDomInfo)
chk <- chkRgdxRes (b, bwant, reqIdent=reqIdent)
if (!chk$same) {
  stop (paste("test rgdx(b,sparse) failed:",chk$msg))
}

dwant <- list(name="D", type="parameter", dim=2L,
              val=dVals,
              form="sparse",
              uels=dUels,
              domains=dDoms, domInfo='compressed')
d <- rgdx(fnIn,list(name='d',form='sparse',compress=TRUE),useDomInfo=useDomInfo)
# floating point values in dVals may be off a bit
chk <- chkRgdxRes (d, dwant, reqIdent=F)
if (!chk$same) {
  stop (paste("test rgdx(d,sparse) failed:",chk$msg))
}

ewant <- list(name="E", type="parameter", dim=2L,
              val=eVals,
              form="sparse",
              uels=eUels,
              domains=eDoms, domInfo='compressed')
e <- rgdx(fnIn,list(name='e',form='sparse',compress=TRUE),useDomInfo=useDomInfo)
chk <- chkRgdxRes (e, ewant, reqIdent=reqIdent)
if (!chk$same) {
  stop (paste("test rgdx(e,sparse) failed:",chk$msg))
}

cwant <- list(name="c", type="parameter", dim=1L,
              val=cVals,
              form="sparse",
              uels=cUels,
              domains=cDoms, domInfo='compressed')
c <- rgdx(fnIn,list(name='c',form='sparse',compress=TRUE),useDomInfo=useDomInfo)
chk <- chkRgdxRes (c, cwant, reqIdent=reqIdent)
if (!chk$same) {
  stop (paste("test rgdx(c,sparse) failed:",chk$msg))
}


## ---------- reading form=full

iwant <- list(name="I", type="set", dim=1L,
              val=iOnes,
              form="full",
              uels=list('*'=iUels),
              domains=u1, domInfo='compressed')
i <- rgdx(fnIn,list(name='i',form='full',compress=TRUE),useDomInfo=useDomInfo)
chk <- chkRgdxRes (i, iwant, reqIdent=reqIdent)
if (!chk$same) {
  stop (paste("test rgdx(i,full) failed:",chk$msg))
}

jwant <- list(name="J", type="set", dim=1L,
              val=jOnes,
              form="full",
              uels=list('*'=jUels),
              domains=u1, domInfo='compressed')
j <- rgdx(fnIn,list(name='j',form='full',compress=TRUE),useDomInfo=useDomInfo)
chk <- chkRgdxRes (j, jwant, reqIdent=reqIdent)
if (!chk$same) {
  stop (paste("test rgdx(j,full) failed:",chk$msg))
}

awant <- list(name="A", type="parameter", dim=2L,
              val=aFull,
              form="full",
              uels=aUelsN,
              domains=aDoms, domInfo='compressed')
a <- rgdx(fnIn,list(name='a',form='full',compress=TRUE),useDomInfo=useDomInfo)
chk <- chkRgdxRes (a, awant, reqIdent=reqIdent)
if (!chk$same) {
  stop (paste("test rgdx(a,full) failed:",chk$msg))
}

bwant <- list(name="B", type="parameter", dim=2L,
              val=bFull,
              form="full",
              uels=bUelsN,
              domains=bDoms, domInfo='compressed')
b <- rgdx(fnIn,list(name='b',form='full',compress=TRUE),useDomInfo=useDomInfo)
chk <- chkRgdxRes (b, bwant, reqIdent=reqIdent)
if (!chk$same) {
  stop (paste("test rgdx(b,full) failed:",chk$msg))
}

dwant <- list(name="D", type="parameter", dim=2L,
              val=dFull,
              form="full",
              uels=dUelsN,
              domains=dDoms, domInfo='compressed')
d <- rgdx(fnIn,list(name='d',form='full',compress=TRUE),useDomInfo=useDomInfo)
# floating point values in dVals may be off a bit
chk <- chkRgdxRes (d, dwant, reqIdent=F)
if (!chk$same) {
  stop (paste("test rgdx(d,full) failed:",chk$msg))
}

ewant <- list(name="E", type="parameter", dim=2L,
              val=eFull,
              form="full",
              uels=eUelsN,
              domains=eDoms, domInfo='compressed')
e <- rgdx(fnIn,list(name='e',form='full',compress=TRUE),useDomInfo=useDomInfo)
chk <- chkRgdxRes (e, ewant, reqIdent=reqIdent)
if (!chk$same) {
  stop (paste("test rgdx(e,full) failed:",chk$msg))
}

cwant <- list(name="c", type="parameter", dim=1L,
              val=cFull,
              form="full",
              uels=cUelsN,
              domains=cDoms, domInfo='compressed')
c <- rgdx(fnIn,list(name='c',form='full',compress=TRUE),useDomInfo=useDomInfo)
chk <- chkRgdxRes (c, cwant, reqIdent=reqIdent)
if (!chk$same) {
  stop (paste("test rgdx(c,full) failed",chk$msg))
}

### Test rgdx
# We read the transport data using defaults: form=sparse and a full universe
# This test does near-exhaustive checks on the returned structure

if (! require(gdxrrw))      stop ("gdxrrw package is not available")
if (0 == igdx(silent=TRUE)) stop ("the gdx shared library has not been loaded")

source ("chkSame.R")

iUels <- c("seattle", "san-diego")
iCard <- length(iUels)
jUels <- c("new-york", "chicago", "topeka")
jCard <- length(jUels)
uUels <- c(iUels, jUels)
uCard <- length(uUels)

iVals <- matrix(1:iCard, nrow=iCard, ncol=1)
jVals <- matrix(iCard+(1:jCard), nrow=jCard, ncol=1)
aVals <- matrix(c(1:iCard,350,600), nrow=iCard, ncol=2)
bVals <- matrix(c(1:jCard,325,300,275), nrow=jCard, ncol=2)
dVals <- matrix(c(1,1, 2.5,
                  1,2, 1.7,
                  1,3, 1.8,
                  2,1, 2.5,
                  2,2, 1.8,
                  2,3, 1.4) , c(6,3), byrow=TRUE)
cVals <- dVals
cVals[,3] <- dVals[,3] * 90 / 1000
xVals <- matrix(c(1,1, 50,
                  1,2, 300,
                  2,1, 275,
                  2,3, 275) , c(4,3), byrow=TRUE)

tryCatch({
  print ("Test rgdx with defaults (form='sparse' and no filter)")
  print ("using the transport data as input")
  rgdx('?')

  u <- rgdx('trnsport')
  uwant <- list(name="*", type="set", dim=1,
                val=NULL,
                form=NULL,
                uels=uUels)
  chk <- chkRgdxRes (u, uwant)
  if (!chk$same) {
    stop (paste("test rgdx('gdxname') to read universe failed",chk$msg))
  }
  print ("Done reading universe")

  i <- rgdx('trnsport',list(name='i'))
  iwant <- list(name="i", type="set", dim=1,
                val=iVals,
                form="sparse",
                uels=list(uUels),
                domains=c("*"))
  chk <- chkRgdxRes (i, iwant)
  if (!chk$same) {
    stop (paste("test rgdx(i,form=sparse) failed",chk$msg))
  }
  print ("Done reading set i")

  j <- rgdx('trnsport',list(name='j'))
  jwant <- list(name="j", type="set", dim=1,
                val=jVals,
                form="sparse",
                uels=list(uUels),
                domains=c("*"))
  chk <- chkRgdxRes (j, jwant)
  if (!chk$same) {
    stop (paste("test rgdx(j,form=sparse) failed",chk$msg))
  }
  print ("Done reading set j")

  f <- rgdx('trnsport',list(name='f'))
  fwant <- list(name="f", type="parameter", dim=0,
                val=matrix(90,c(1,1)),
                form="sparse",
                uels=list(),
                domains=character(0) )
  chk <- chkRgdxRes (f, fwant)
  if (!chk$same) {
    stop (paste("test rgdx(f,form=sparse) failed",chk$msg))
  }
  print ("Done reading scalar f")

  a <- rgdx('trnsport',list(name='a'))
  awant <- list(name="a", type="parameter", dim=1,
                val=aVals,
                form="sparse",
                uels=list(iUels),
                domains=c("i") )
  chk <- chkRgdxRes (a, awant)
  if (!chk$same) {
    stop (paste("test rgdx(a,form='sparse') failed",chk$msg))
  }
  print ("Done reading parameter a")

  b <- rgdx('trnsport',list(name='b'))
  bwant <- list(name="b", type="parameter", dim=1,
                val=bVals,
                form="sparse",
                uels=list(jUels),
                domains=c('j') )
  chk <- chkRgdxRes (b, bwant)
  if (!chk$same) {
    stop (paste("test rgdx(b,form='sparse') failed",chk$msg))
  }
  print ("Done reading parameter b")

  c <- rgdx('trnsport',list(name='c'))
  cwant <- list(name="c", type="parameter", dim=2,
                val=cVals,
                form="sparse",
                uels=list(iUels,jUels),
                domains=c("i","j") )
  chk <- chkRgdxRes (c, cwant)
  if (!chk$same) {
    stop (paste("test rgdx(c,form='sparse') failed",chk$msg))
  }
  print ("Done reading parameter c")

  d <- rgdx('trnsport',list(name='d'))
  dwant <- list(name="d", type="parameter", dim=2,
                val=dVals,
                form="sparse",
                uels=list(iUels,jUels),
                domains=c("i","j") )
  chk <- chkRgdxRes (d, dwant)
  if (!chk$same) {
    stop (paste("test rgdx(d,form='sparse') failed",chk$msg))
  }
  print ("Done reading parameter d")

  x <- rgdx('trnsport',list(name='x'))
  xwant <- list(name="x", type="variable", dim=2,
                val=xVals,
                form="sparse",
                uels=list(iUels,jUels),
                domains=c("i","j"),
                field="l")
  chk <- chkRgdxRes (x, xwant)
  if (!chk$same) {
    stop (paste("test rgdx(x,form='sparse') failed",chk$msg))
  }
  print ("Done reading variable x")

  z <- rgdx('trnsport',list(name='z'))
  zwant <- list(name="z", type="variable", dim=0,
                val=matrix(153.675,c(1,1)),
                form="sparse",
                uels=list(),
                domains=character(0),
                field="l")
  chk <- chkRgdxRes (z, zwant)
  if (!chk$same) {
    stop (paste("test rgdx(z,form='sparse') failed",chk$msg))
  }
  print ("Done reading variable z")


  print ("Successfully completed tests")
  return (TRUE)
}

, error = function(ex) { print(ex) ; return (FALSE) }
)

### Test wgdx
# We write all the transport data using sparse writes and universe
# subsets, with or without values

if (! require(gdxrrw))      stop ("gdxrrw package is not available")
if (0 == igdx(silent=TRUE)) stop ("the gdx shared library has not been loaded")

tryCatch({

  fn <- "tws2.gdx"

  print ("Test wgdx with form='sparse' and universe subsets,")
  print ("using the transport data as the output target")
  wgdx('?')

  # set i: supply nodes
  si <- list(c("seattle", "san-diego"))

  # set j: demand nodes
  sj <- list(c("new-york", "chicago", "topeka"))

  ilst <- list (name='i', type='set', dim=1, form='sparse', ts='canning plants',
                uels=c(si))

  jv <- matrix(c(1:3), c(3,1))
  jlst <- list (name='j', type='set', dim=1, form='sparse', ts='markets',
          val=jv, uels=c(sj))

  av <- matrix(c(1:2,350,600), c(2,2))
  alst <- list (name='a', type='parameter', dim=1, form='sparse',
                ts='capacity of plant i in cases', val=av, uels=c(si))

  bv <- matrix(c(1, 325,
                 2, 300,
                 3, 275),  c(3,1), byrow=TRUE)
  blst <- list (name='b', type='parameter', form='sparse',
                ts='demand at market j in cases', val=bv, uels=c(sj))

  f <- 90
  fv <- matrix(c(f),c(1,1))
  dv <- matrix(c(1, 1, 2.5,
                 1, 2, 1.7,
                 1, 3, 1.8,
                 2, 1, 2.5,
                 2, 2, 1.8,
                 2, 3, 1.4),  c(6,3), byrow=TRUE)
  cv <- dv
  cv[,3] <- dv[,3] * f / 1000

  clst <- list (name='c', type='parameter', dim=2, form='sparse',
                ts='transport cost in thousands of dollars per case', val=cv, uels=c(si,sj))
  dlst <- list (name='d', type='parameter', form='sparse',
                ts='distance in thousands of miles', val=dv, uels=c(si,sj))

  flst <- list (name='f', type='parameter', dim=0, form='sparse',
                ts='freight in dollars per case per thousand miles', val=fv)

  wgdx (fn, ilst, jlst, alst, blst, clst, dlst, flst)

  if (file_test ('-f', fn) == TRUE) {
    print (paste("File", fn, "was created"))
  } else {
    stop (paste("FAIL: File", fn, "is not readable"))
  }
  rc <- system (paste("gdxdiff trnsport.gdx",fn,"releps=1e-15 id=i,j,a,b,c,d,f"))
  if (0 != rc) {
    stop(paste("Bad return from gdxdiff: wanted 0, got",rc))
  } else {
    print ("gdxdiff call succeeded")
  }
  return (TRUE)
}

, error = function(ex) { print(ex) ; return (FALSE) }
)

### Test all the wrappers: rgdx.set, rgdx.param, rgdx.scalar, and wgdx.lst
# We first read the trnsport data from GDX,
# and write it out again using the wgdx.lst wrapper

if (! require(gdxrrw))      stop ("gdxrrw package is not available")
if (0 == igdx(silent=TRUE)) stop ("the gdx shared library has not been loaded")

tryCatch({
  fnIn <- "trnsport.gdx"
  fnOut <- "wtransport.gdx"
  if (file_test ('-f', fnOut) == TRUE) {
    file.remove (fnOut)
  }
  print ("Test of rgdx/wgdx wrappers")
  # read all the data, using various combination of options
  idf <- rgdx.set(fnIn,'i',ts=TRUE)
  jdf <- rgdx.set(fnIn,'j',names="J",compress=TRUE)
  adf <- rgdx.param(fnIn,'a')
  bdf <- rgdx.param(fnIn,'b', names=c('JJ','theValues'), ts=TRUE)
  cdf <- rgdx.param(fnIn,'c', names=c('from','to'), compress=TRUE, ts=TRUE)
  ddf <- rgdx.param(fnIn,'d')
  fsc <- rgdx.scalar(fnIn,'f')

  wgdx.lst (fnOut, list(idf,jdf,adf,bdf,cdf,ddf,fsc))
  if (file_test ('-f', fnOut) == TRUE) {
    print (paste("File", fnOut, "was created"))
  } else {
    stop (paste("FAIL: File", fnOut, "is not readable"))
  }
  rc <- system (paste("gdxdiff",fnIn,fnOut,"releps=1e-15 id=i,j,a,b,c,d,f"))
  if (0 != rc) {
    stop(paste("Bad return from gdxdiff: wanted 0, got",rc))
  } else {
    print ("gdxdiff call succeeded")
  }
  if (file_test ('-f', fnOut) == TRUE) {
    file.remove (fnOut)
  }

  # do the write again, but mix in some symLists
  ilst <- list(name='i',type='set',ts='canning plants', uels=list(as.character(idf$i)))
  blst <- list(name='b',type='parameter',ts=attr(bdf,"symName"),
               form="full", uels=list(as.character(bdf$JJ)),
               val=as.array(as.numeric(bdf$theValues)) )
  clst <- list(name="c", type="parameter", ts=attr(cdf,"symName"),
               form="sparse", uels=c(list(levels(cdf$from)),list(levels(cdf$to))),
               val=matrix(data=NA,nrow=nrow(cdf),ncol=ncol(cdf)) )
  clst$val[,1] <- as.numeric(cdf$from)
  clst$val[,2] <- as.numeric(cdf$to)
  clst$val[,3] <- cdf$value
  wgdx.lst (fnOut, list(ilst,jdf,adf,blst,clst,ddf,fsc))
  if (file_test ('-f', fnOut) == TRUE) {
    print (paste("File", fnOut, "was created"))
  } else {
    stop (paste("FAIL: File", fnOut, "is not readable"))
  }
  rc <- system (paste("gdxdiff",fnIn,fnOut,"releps=1e-15 id=i,j,a,b,c,d,f"))
  if (0 != rc) {
    stop(paste("Bad return from gdxdiff: wanted 0, got",rc))
  } else {
    print ("gdxdiff call succeeded")
  }
  if (file_test ('-f', fnOut) == TRUE) {
    file.remove (fnOut)
  }

  print ("All tests for wrappers passed")
  return (TRUE)
}

, error = function(ex) { print(ex) ; return (FALSE) }
)

#### test rgdx reading equations
#### test form=['sparse','full'] X [filtered,unfiltered] X squeeze=[T(default),F]
#### ['all','l','m','lo','up','s']

## still to do:
##  # form=full  , filtered, all

#### wanted lists can be produced with    dump("listName",file="")

if (! require(gdxrrw))      stop ("gdxrrw package is not available")
if (0 == igdx(silent=TRUE)) stop ("the gdx shared library has not been loaded")

source ("chkSame.R")
reqIdent <- TRUE

lev <- 1
mar <- 2
low <- 3
upp <- 4
sca <- 5
fields <- c('l','m','lo','up','s')
nFields <- length(fields)
userDom1 <- c('K')
userDom1f <- c('K','_field')
userDom3 <- c('I','J','K')
userDom3f <- c('I','J','K','_field')
iUels <- c('i1')
iCard <- length(iUels)
jUels <- c('j1','j2')
jCard <- length(jUels)
kUels <- c('k1')
kCard <- length(kUels)
domF <- c('_field')
domK <- c('K')
domKF <- c('K','_field')
domIJK <- c('I','J','K')
domIJKF <- c('I','J','K','_field')
cartK <- list(kUels)
cartKn <- cartK ; names(cartKn) <- domK
cartKF <- list(kUels,fields)
cartKFn <- cartKF ; names(cartKFn) <- domKF
cartIJK <- list(iUels,jUels,kUels)
cartIJKF <- list(iUels,jUels,kUels,fields)

tryCatch({
  print ("test of rgdx on equation reads")
  rgdx('?')
  fnIn <- "tReadEqu.gdx"
  if (! file_test ('-f', fnIn)) {
    stop (paste("FAIL: File", fnIn, "does not exist"))
  }

  ### ---------- reading form=sparse, no filter
  # all
  t <- matrix(c( lev,  0
                ,mar,  1
                ,low,  0
                ,upp,  0
                ,sca,  1
               ), nrow=nFields, ncol=2, byrow=T)
  e0wantA <- list(name='e0', type='equation', dim=0L,
                 val=t,
                 form='sparse', uels=list(fields),
                 domains=domF, domInfo="NA",
                 field='all',
                 typeCode=GMS_EQUTYPE$E)
  e0 <- rgdx(fnIn,list(name='e0',form='sparse',field='all'))
  chk <- chkRgdxRes (e0, e0wantA, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(e0,'all',unfiltered) failed:",chk$msg))
  }
  e0 <- rgdx(fnIn,list(name='e0',form='sparse',field='all'),squeeze=F)
  chk <- chkRgdxRes (e0, e0wantA, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(e0,'all',unfiltered,squeeze=F) failed:",chk$msg))
  }
  t <- matrix(c( 1, lev,   -2
                ,1, mar,   -3.5
                ,1, low,   -2
                ,1, upp,   Inf
                ,1, sca,   2
             ), nrow=5, ncol=3, byrow=T)
  e1wantA <- list(name='e1', type='equation', dim=1L,
                 val=t,
                 form='sparse', uels=cartKF,
                 domains=domKF, domInfo='full',
                 field='all', typeCode=GMS_EQUTYPE$G)
  e1 <- rgdx(fnIn,list(name='e1',form='sparse',field='ALL'))
  chk <- chkRgdxRes (e1, e1wantA, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(e1,'all',unfiltered) failed:",chk$msg))
  }
  e1 <- rgdx(fnIn,list(name='e1',form='sparse',field='all'),squeeze=F)
  chk <- chkRgdxRes (e1, e1wantA, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(e1,'all',unfiltered,squeeze=F) failed:",chk$msg))
  }
  t <- matrix(c( 1,1,1,lev,   3
                ,1,1,1,mar,   0
                ,1,1,1,low,   -Inf
                ,1,1,1,upp,   4
                ,1,1,1,sca,   1
                ,1,2,1,lev,   4
                ,1,2,1,mar,   0.5
                ,1,2,1,low,   -Inf
                ,1,2,1,upp,   4
                ,1,2,1,sca,   1
               ), nrow=10, ncol=5, byrow=T)
  e3wantA <- list(name="e3", type="equation", dim=3L,
                 val=t,
                 form="sparse",
                 uels=cartIJKF,
                 domains=domIJKF, domInfo='full',
                 field='all',
                 typeCode=GMS_EQUTYPE$L)
  e3 <- rgdx(fnIn,list(name='e3',form='sparse',field='alL'))
  chk <- chkRgdxRes (e3, e3wantA, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(e3,'all',unfiltered) failed:",chk$msg))
  }
  e3 <- rgdx(fnIn,list(name='e3',form='sparse',field='alL'),squeeze=F)
  chk <- chkRgdxRes (e3, e3wantA, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(e3,'all',unfiltered,squeeze=F) failed:",chk$msg))
  }
  # level
  e0wantL <- list(name='e0', type='equation', dim=0L,
                 val=matrix(0, nrow=0, ncol=1),
                 form='sparse', uels=list(),
                 domains=character(0), domInfo='NA',
                 field='l', typeCode=GMS_EQUTYPE$E)
  e0 <- rgdx(fnIn,list(name='e0',form='sparse',field='L'))
  chk <- chkRgdxRes (e0, e0wantL, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(e0,'L',unfiltered) failed:",chk$msg))
  }
  e0wantL$val <- matrix(0, nrow=1, ncol=1)
  e0 <- rgdx(fnIn,list(name='e0',form='sparse',field='L'),squeeze=F)
  chk <- chkRgdxRes (e0, e0wantL, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(e0,'L',unfiltered,squeeze=F) failed:",chk$msg))
  }
  e1wantL <- list(name='e1', type='equation', dim=1L,
                 val=matrix(c(1,  -2), nrow=1, ncol=2),
                 form='sparse', uels=cartK,
                 domains=domK, domInfo='full',
                 field='l', typeCode=GMS_EQUTYPE$G)
  e1 <- rgdx(fnIn,list(name='e1',form='sparse',field='L'))
  chk <- chkRgdxRes (e1, e1wantL, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(e1,'L',unfiltered) failed:",chk$msg))
  }
  e1 <- rgdx(fnIn,list(name='e1',form='sparse',field='L'),squeeze=F)
  chk <- chkRgdxRes (e1, e1wantL, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(e1,'L',unfiltered,squeeze=F) failed:",chk$msg))
  }
  e3wantL <- list(name='e3', type='equation', dim=3L,
                  val=matrix(c(1, 1, 1,  3
                              ,1, 2, 1,  4
                              ), nrow=2, ncol=4, byrow=T),
                  form='sparse', uels=cartIJK,
                  domains=domIJK, domInfo='full',
                  field='l', typeCode=GMS_EQUTYPE$L)
  e3 <- rgdx(fnIn,list(name='e3',form='sparse',field='L'))
  chk <- chkRgdxRes (e3, e3wantL, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(e3,'L',unfiltered) failed:",chk$msg))
  }
  e3 <- rgdx(fnIn,list(name='e3',form='sparse',field='L'),squeeze=F)
  chk <- chkRgdxRes (e3, e3wantL, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(e3,'L',unfiltered,squeeze=F) failed:",chk$msg))
  }
  # marginal
  e0wantM <- list(name='e0', type='equation', dim=0L,
                 val=matrix(1, nrow=1, ncol=1),
                 form='sparse', uels=list(),
                 domains=character(0), domInfo="NA",
                 field='m', typeCode=GMS_EQUTYPE$E)
  e0 <- rgdx(fnIn,list(name='e0',form='sparse',field='M'))
  chk <- chkRgdxRes (e0, e0wantM, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(e0,'M',unfiltered) failed:",chk$msg))
  }
  e0 <- rgdx(fnIn,list(name='e0',form='sparse',field='M'),squeeze=F)
  chk <- chkRgdxRes (e0, e0wantM, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(e0,'M',unfiltered,squeeze=F) failed:",chk$msg))
  }
  e1wantM <- list(name='e1', type='equation', dim=1L,
                 val=matrix(c(1,  -3.5), nrow=1, ncol=2),
                 form='sparse', uels=cartK,
                 domains=domK, domInfo="full",
                 field='m', typeCode=GMS_EQUTYPE$G)
  e1 <- rgdx(fnIn,list(name='e1',form='sparse',field='M'))
  chk <- chkRgdxRes (e1, e1wantM, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(e1,'M',unfiltered) failed:",chk$msg))
  }
  e1 <- rgdx(fnIn,list(name='e1',form='sparse',field='M'),squeeze=F)
  chk <- chkRgdxRes (e1, e1wantM, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(e1,'M',unfiltered,squeeze=F) failed:",chk$msg))
  }
  v3s <- matrix(c(1, 2, 1,  0.5
                 ), nrow=1, ncol=4, byrow=T)
  v3  <- matrix(c(1, 1, 1,  0
                 ,1, 2, 1,  0.5
                 ), nrow=2, ncol=4, byrow=T)
  e3wantM <- list(name='e3', type='equation', dim=3L,
                  val=v3s,
                 form='sparse', uels=cartIJK,
                 domains=domIJK, domInfo="full",
                 field='m', typeCode=GMS_EQUTYPE$L)
  e3 <- rgdx(fnIn,list(name='e3',form='sparse',field='m'))
  chk <- chkRgdxRes (e3, e3wantM, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(e3,'M',unfiltered) failed:",chk$msg))
  }
  e3 <- rgdx(fnIn,list(name='e3',form='sparse',field='m'),squeeze=F)
  e3wantM$val <- v3
  chk <- chkRgdxRes (e3, e3wantM, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(e3,'M',unfiltered,squeeze=F) failed:",chk$msg))
  }
  # lower
  e0wantLo <- list(name='e0', type='equation', dim=0L,
                   val=matrix(0, nrow=0, ncol=1),
                   form='sparse', uels=list(),
                   domains=character(0), domInfo="NA",
                   field='lo', typeCode=GMS_EQUTYPE$E)
  e0 <- rgdx(fnIn,list(name='e0',form='sparse',field='lo'))
  chk <- chkRgdxRes (e0, e0wantLo, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(e0,'lo',unfiltered) failed:",chk$msg))
  }
  e0wantLo$val <- matrix(0, nrow=1, ncol=1)
  e0 <- rgdx(fnIn,list(name='e0',form='sparse',field='lo'),squeeze=F)
  chk <- chkRgdxRes (e0, e0wantLo, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(e0,'lo',unfiltered,squeeze=F) failed:",chk$msg))
  }
  e1wantLo <- list(name='e1', type='equation', dim=1L,
                  val=matrix(c(1,  -2), nrow=1, ncol=2),
                  form='sparse', uels=cartK,
                  domains=domK, domInfo="full",
                  field='lo', typeCode=GMS_EQUTYPE$G)
  e1 <- rgdx(fnIn,list(name='e1',form='sparse',field='lO'))
  chk <- chkRgdxRes (e1, e1wantLo, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(e1,'LO',unfiltered) failed:",chk$msg))
  }
  e1 <- rgdx(fnIn,list(name='e1',form='sparse',field='lO'),squeeze=F)
  chk <- chkRgdxRes (e1, e1wantLo, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(e1,'LO',unfiltered,squeeze=F) failed:",chk$msg))
  }
  v3s <- matrix(0, nrow=0, ncol=4, byrow=T)
  v3  <- matrix(c(1, 1, 1,  -Inf
                 ,1, 2, 1,  -Inf
                 ), nrow=2, ncol=4, byrow=T)
  e3wantLo <- list(name='e3', type='equation', dim=3L,
                   val=v3s,
                   form='sparse', uels=cartIJK,
                   domains=domIJK, domInfo="full",
                   field='lo', typeCode=GMS_EQUTYPE$L)
  e3 <- rgdx(fnIn,list(name='e3',form='sparse',field='lo'))
  chk <- chkRgdxRes (e3, e3wantLo, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(e3,'LO',unfiltered) failed:",chk$msg))
  }
  e3wantLo$val <- v3
  e3 <- rgdx(fnIn,list(name='e3',form='sparse',field='lo'),squeeze=F)
  chk <- chkRgdxRes (e3, e3wantLo, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(e3,'LO',unfiltered,squeeze=F) failed:",chk$msg))
  }
  # upper
  e0wantUp <- list(name='e0', type='equation', dim=0L,
                   val=matrix(0, nrow=0, ncol=1),
                   form='sparse', uels=list(),
                   domains=character(0), domInfo="NA",
                   field='up', typeCode=GMS_EQUTYPE$E)
  e0 <- rgdx(fnIn,list(name='e0',form='sparse',field='UP'))
  chk <- chkRgdxRes (e0, e0wantUp, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(e0,'up',unfiltered) failed:",chk$msg))
  }
  e0wantUp$val <- matrix(0, nrow=1, ncol=1)
  e0 <- rgdx(fnIn,list(name='e0',form='sparse',field='UP'),squeeze=F)
  chk <- chkRgdxRes (e0, e0wantUp, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(e0,'up',unfiltered,squeeze=F) failed:",chk$msg))
  }
  e1wantUp <- list(name='e1', type='equation', dim=1L,
                  val=matrix(0, nrow=0, ncol=2),
                  form='sparse', uels=cartK,
                  domains=domK, domInfo="full",
                  field='up', typeCode=GMS_EQUTYPE$G)
  e1 <- rgdx(fnIn,list(name='e1',form='sparse',field='Up'))
  chk <- chkRgdxRes (e1, e1wantUp, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(e1,'UP',unfiltered) failed:",chk$msg))
  }
  e1wantUp$val <- matrix(c(1,  Inf), nrow=1, ncol=2)
  e1 <- rgdx(fnIn,list(name='e1',form='sparse',field='Up'),squeeze=F)
  chk <- chkRgdxRes (e1, e1wantUp, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(e1,'UP',unfiltered,squeeze=F) failed:",chk$msg))
  }
  v3 <- matrix(c(1, 1, 1,  4
                ,1, 2, 1,  4
                 ), nrow=2, ncol=4, byrow=T)
  e3wantUp <- list(name='e3', type='equation', dim=3L,
                   val=v3,
                   form='sparse', uels=cartIJK,
                   domains=domIJK, domInfo='full',
                   field='up', typeCode=GMS_EQUTYPE$L)
  e3 <- rgdx(fnIn,list(name='e3',form='sparse',field='up'))
  chk <- chkRgdxRes (e3, e3wantUp, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(e3,'UP',unfiltered) failed:",chk$msg))
  }
  e3 <- rgdx(fnIn,list(name='e3',form='sparse',field='up'),squeeze=F)
  chk <- chkRgdxRes (e3, e3wantUp, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(e3,'UP',unfiltered,squeeze=F) failed:",chk$msg))
  }
  # scale
  e0wantS <- list(name='e0', type='equation', dim=0L,
                  val=matrix(1, nrow=0, ncol=1),
                  form='sparse', uels=list(),
                  domains=character(0), domInfo='NA',
                  field='s', typeCode=GMS_EQUTYPE$E)
  e0 <- rgdx(fnIn,list(name='e0',form='sparse',field='s'))
  chk <- chkRgdxRes (e0, e0wantS, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(e0,'s',unfiltered) failed:",chk$msg))
  }
  e0wantS$val <- matrix(1, nrow=1, ncol=1)
  e0 <- rgdx(fnIn,list(name='e0',form='sparse',field='s'),squeeze=F)
  chk <- chkRgdxRes (e0, e0wantS, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(e0,'s',unfiltered,squeeze=F) failed:",chk$msg))
  }
  e1wantS <- list(name='e1', type='equation', dim=1L,
                 val=matrix(c(1,  2), nrow=1, ncol=2),
                 form='sparse', uels=cartK,
                 domains=domK, domInfo='full',
                 field='s', typeCode=GMS_EQUTYPE$G)
  e1 <- rgdx(fnIn,list(name='e1',form='sparse',field='S'))
  chk <- chkRgdxRes (e1, e1wantS, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(e1,'S',unfiltered) failed:",chk$msg))
  }
  e1 <- rgdx(fnIn,list(name='e1',form='sparse',field='S'),squeeze=F)
  chk <- chkRgdxRes (e1, e1wantS, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(e1,'S',unfiltered,squeeze=F) failed:",chk$msg))
  }
  v3s <- matrix(0, nrow=0, ncol=4, byrow=T)
  v3 <- matrix(c(1, 1, 1,  1
                ,1, 2, 1,  1
                 ), nrow=2, ncol=4, byrow=T)
  e3wantS <- list(name='e3', type='equation', dim=3L,
                  val=v3s,
                  form='sparse', uels=cartIJK,
                  domains=domIJK, domInfo='full',
                  field='s', typeCode=GMS_EQUTYPE$L)
  e3 <- rgdx(fnIn,list(name='e3',form='sparse',field='s'))
  chk <- chkRgdxRes (e3, e3wantS, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(e3,'S',unfiltered) failed:",chk$msg))
  }
  e3wantS$val <- v3
  e3 <- rgdx(fnIn,list(name='e3',form='sparse',field='s'),squeeze=F)
  chk <- chkRgdxRes (e3, e3wantS, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(e3,'S',unfiltered,squeeze=F) failed:",chk$msg))
  }

  ### ---------- reading form=sparse, filtered
  f0 <- list()
  f1 <- list(kUels)
  f3 <- list(iUels,c('j1'),kUels)
  # all
  t <- matrix(c( lev,  0
                ,mar,  1
                ,low,  0
                ,upp,  0
                ,sca,  1
               ), nrow=nFields, ncol=2, byrow=T)
  e0wantA <- list(name='e0', type='equation', dim=0L,
                  val=t,
                  form='sparse', uels=list(fields),
                  domains=domF, domInfo='filtered',
                  field='all',
                  typeCode=GMS_EQUTYPE$E)
  e0 <- rgdx(fnIn,list(name='e0',form='sparse',uels=f0,field='all'))
  chk <- chkRgdxRes (e0, e0wantA, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(e0,'all',filtered) failed:",chk$msg))
  }
  e0 <- rgdx(fnIn,list(name='e0',form='sparse',uels=f0,field='all'),squeeze=F)
  chk <- chkRgdxRes (e0, e0wantA, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(e0,'all',filtered,squeeze=F) failed:",chk$msg))
  }
  t <- matrix(c( 1, lev,   -2
                ,1, mar,   -3.5
                ,1, low,   -2
                ,1, upp,   Inf
                ,1, sca,   2
             ), nrow=5, ncol=3, byrow=T)
  e1wantA <- list(name='e1', type='equation', dim=1L,
                  val=t,
                  form='sparse', uels=list(f1[[1]],fields),
                  domains=userDom1f, domInfo='filtered',
                  field='all', typeCode=GMS_EQUTYPE$G)
  e1 <- rgdx(fnIn,list(name='e1',form='sparse',uels=f1,field='all'))
  chk <- chkRgdxRes (e1, e1wantA, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(e1,'all',filtered) failed:",chk$msg))
  }
  e1 <- rgdx(fnIn,list(name='e1',field='all',form='sparse',uels=f1),squeeze=F)
  chk <- chkRgdxRes (e1, e1wantA, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(e1,'all',filtered,squeeze=F) failed:",chk$msg))
  }
  t <- matrix(c( 1,1,1,lev,   3
                ,1,1,1,mar,   0
                ,1,1,1,low,   -Inf
                ,1,1,1,upp,   4
                ,1,1,1,sca,   1
               ), nrow=5, ncol=5, byrow=T)
  e3wantA <- list(name="e3", type="equation", dim=3L,
                  val=t,
                  form="sparse",
                  uels=list(f3[[1]],f3[[2]],f3[[3]],fields),
                  domains=userDom3f, domInfo='filtered',
                  field='all',
                  typeCode=GMS_EQUTYPE$L)
  e3 <- rgdx(fnIn,list(name='e3',form='sparse',uels=f3,field='all'))
  chk <- chkRgdxRes (e3, e3wantA, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(e3,'all',filtered) failed:",chk$msg))
  }
  e3 <- rgdx(fnIn,list(name='e3',form='sparse',uels=f3,field='all'),squeeze=F)
  chk <- chkRgdxRes (e3, e3wantA, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(e3,'all',filtered,squeeze=F) failed:",chk$msg))
  }
  # level
  e0wantL <- list(name='e0', type='equation', dim=0L,
                  val=matrix(0, nrow=0, ncol=1),
                  form='sparse', uels=f0,
                  domains=character(0), domInfo='filtered',
                  field='l', typeCode=GMS_EQUTYPE$E)
  e0 <- rgdx(fnIn,list(name='e0',form='sparse',uels=f0))
  chk <- chkRgdxRes (e0, e0wantL, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(e0,'L',filtered) failed:",chk$msg))
  }
  e0wantL$val <- matrix(0, nrow=1, ncol=1)
  e0 <- rgdx(fnIn,list(name='e0',form='sparse',uels=f0),squeeze=F)
  chk <- chkRgdxRes (e0, e0wantL, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(e0,'L',filtered,squeeze=F) failed:",chk$msg))
  }
  e1wantL <- list(name='e1', type='equation', dim=1L,
                  val=matrix(c(1, -2), nrow=1, ncol=2),
                  form='sparse', uels=f1,
                  domains=userDom1, domInfo='filtered',
                  field='l', typeCode=GMS_EQUTYPE$G)
  e1 <- rgdx(fnIn,list(name='e1',form='sparse',uels=f1))
  chk <- chkRgdxRes (e1, e1wantL, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(e1,'L',filtered) failed:",chk$msg))
  }
  e1 <- rgdx(fnIn,list(name='e1',form='sparse',uels=f1),squeeze=F)
  chk <- chkRgdxRes (e1, e1wantL, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(e1,'L',filtered,squeeze=F) failed:",chk$msg))
  }
  v3 <- matrix(c(1, 1, 1,  3), nrow=1, ncol=4, byrow=T)
  e3wantL <- list(name='e3', type='equation', dim=3L,
                  val=v3,
                  form='sparse', uels=f3,
                  domains=userDom3, domInfo='filtered',
                  field='l', typeCode=GMS_EQUTYPE$L)
  e3 <- rgdx(fnIn,list(name='e3',form='sparse',uels=f3))
  chk <- chkRgdxRes (e3, e3wantL, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(e3,'L',filtered) failed:",chk$msg))
  }
  e3 <- rgdx(fnIn,list(name='e3',form='sparse',uels=f3),squeeze=F)
  chk <- chkRgdxRes (e3, e3wantL, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(e3,'L',filtered,squeeze=F) failed:",chk$msg))
  }
  # marginal
  e0wantM <- list(name='e0', type='equation', dim=0L,
                  val=matrix(1, nrow=1, ncol=1),
                  form='sparse', uels=f0,
                  domains=character(0), domInfo='filtered',
                  field='m', typeCode=GMS_EQUTYPE$E)
  e0 <- rgdx(fnIn,list(name='e0',form='sparse',uels=f0,field='m'))
  chk <- chkRgdxRes (e0, e0wantM, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(e0,'M',filtered) failed:",chk$msg))
  }
  e0 <- rgdx(fnIn,list(name='e0',form='sparse',uels=f0,field='m'),squeeze=F)
  chk <- chkRgdxRes (e0, e0wantM, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(e0,'M',filtered,squeeze=F) failed:",chk$msg))
  }
  e1wantM <- list(name='e1', type='equation', dim=1L,
                  val=matrix(c(1, -3.5), nrow=1, ncol=2),
                  form='sparse', uels=f1,
                  domains=userDom1, domInfo='filtered',
                  field='m', typeCode=GMS_EQUTYPE$G)
  e1 <- rgdx(fnIn,list(name='e1',form='sparse',field='m',uels=f1))
  chk <- chkRgdxRes (e1, e1wantM, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(e1,'m',filtered) failed:",chk$msg))
  }
  e1 <- rgdx(fnIn,list(name='e1',form='sparse',field='m',uels=f1),squeeze=F)
  chk <- chkRgdxRes (e1, e1wantM, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(e1,'m',filtered,squeeze=F) failed:",chk$msg))
  }
  v3s <- matrix(0, nrow=0, ncol=4, byrow=T)
  v3 <- matrix(c(1, 1, 1,  0), nrow=1, ncol=4, byrow=T)
  e3wantM <- list(name='e3', type='equation', dim=3L,
                  val=v3s,
                  form='sparse', uels=f3,
                  domains=userDom3, domInfo='filtered',
                  field='m', typeCode=GMS_EQUTYPE$L)
  e3 <- rgdx(fnIn,list(name='e3',form='sparse',uels=f3,field='m'))
  chk <- chkRgdxRes (e3, e3wantM, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(e3,'M',filtered) failed:",chk$msg))
  }
  e3wantM$val <- v3
  e3 <- rgdx(fnIn,list(name='e3',form='sparse',uels=f3,field='m'),squeeze=F)
  chk <- chkRgdxRes (e3, e3wantM, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(e3,'M',filtered,squeeze=F) failed:",chk$msg))
  }
  # lower
  e0wantLo <- list(name='e0', type='equation', dim=0L,
                   val=matrix(0, nrow=0, ncol=1),
                   form='sparse', uels=f0,
                   domains=character(0), domInfo='filtered',
                   field='lo', typeCode=GMS_EQUTYPE$E)
  e0 <- rgdx(fnIn,list(name='e0',form='sparse',uels=f0,field='lo'))
  chk <- chkRgdxRes (e0, e0wantLo, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(e0,'LO',filtered) failed:",chk$msg))
  }
  e0wantLo$val <- matrix(0, nrow=1, ncol=1)
  e0 <- rgdx(fnIn,list(name='e0',form='sparse',uels=f0,field='lo'),squeeze=F)
  chk <- chkRgdxRes (e0, e0wantLo, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(e0,'LO',filtered,squeeze=F) failed:",chk$msg))
  }
  e1wantLo <- list(name='e1', type='equation', dim=1L,
                   val=matrix(c(1, -2), nrow=1, ncol=2),
                   form='sparse', uels=f1,
                   domains=userDom1, domInfo='filtered',
                   field='lo', typeCode=GMS_EQUTYPE$G)
  e1 <- rgdx(fnIn,list(name='e1',form='sparse',field='lo',uels=f1))
  chk <- chkRgdxRes (e1, e1wantLo, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(e1,'lo',filtered) failed:",chk$msg))
  }
  e1 <- rgdx(fnIn,list(name='e1',form='sparse',field='lo',uels=f1),squeeze=F)
  chk <- chkRgdxRes (e1, e1wantLo, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(e1,'lo',filtered,squeeze=F) failed:",chk$msg))
  }
  v3s <- matrix(0, nrow=0, ncol=4, byrow=T)
  v3 <- matrix(c(1, 1, 1,  -Inf), nrow=1, ncol=4, byrow=T)
  e3wantLo <- list(name='e3', type='equation', dim=3L,
                   val=v3s,
                   form='sparse', uels=f3,
                   domains=userDom3, domInfo='filtered',
                   field='lo', typeCode=GMS_EQUTYPE$L)
  e3 <- rgdx(fnIn,list(name='e3',form='sparse',uels=f3,field='lo'))
  chk <- chkRgdxRes (e3, e3wantLo, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(e3,'LO',filtered) failed:",chk$msg))
  }
  e3wantLo$val <- v3
  e3 <- rgdx(fnIn,list(name='e3',form='sparse',uels=f3,field='lo'),squeeze=F)
  chk <- chkRgdxRes (e3, e3wantLo, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(e3,'LO',filtered,squeeze=F) failed:",chk$msg))
  }
  # upper
  e0wantUp <- list(name='e0', type='equation', dim=0L,
                   val=matrix(0, nrow=0, ncol=1),
                   form='sparse', uels=f0,
                   domains=character(0), domInfo='filtered',
                   field='up', typeCode=GMS_EQUTYPE$E)
  e0 <- rgdx(fnIn,list(name='e0',form='sparse',uels=f0,field='up'))
  chk <- chkRgdxRes (e0, e0wantUp, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(e0,'UP',filtered) failed:",chk$msg))
  }
  e0wantUp$val <- matrix(0, nrow=1, ncol=1)
  e0 <- rgdx(fnIn,list(name='e0',form='sparse',uels=f0,field='up'),squeeze=F)
  chk <- chkRgdxRes (e0, e0wantUp, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(e0,'UP',filtered,squeeze=F) failed:",chk$msg))
  }
  e1wantUp <- list(name='e1', type='equation', dim=1L,
                   val=matrix(Inf, nrow=0, ncol=2),
                   form='sparse', uels=f1,
                   domains=userDom1, domInfo='filtered',
                   field='up', typeCode=GMS_EQUTYPE$G)
  e1 <- rgdx(fnIn,list(name='e1',form='sparse',field='up',uels=f1))
  chk <- chkRgdxRes (e1, e1wantUp, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(e1,'up',filtered) failed:",chk$msg))
  }
  e1wantUp$val <- matrix(c(1, +Inf), nrow=1, ncol=2)
  e1 <- rgdx(fnIn,list(name='e1',form='sparse',field='up',uels=f1),squeeze=F)
  chk <- chkRgdxRes (e1, e1wantUp, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(e1,'up',filtered,squeeze=F) failed:",chk$msg))
  }
  v3s <- matrix(c(1, 1, 1,  4), nrow=1, ncol=4, byrow=T)
  e3wantUp <- list(name='e3', type='equation', dim=3L,
                   val=v3s,
                   form='sparse', uels=f3,
                   domains=userDom3, domInfo='filtered',
                   field='up', typeCode=GMS_EQUTYPE$L)
  e3 <- rgdx(fnIn,list(name='e3',form='sparse',uels=f3,field='up'))
  chk <- chkRgdxRes (e3, e3wantUp, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(e3,'UP',filtered) failed:",chk$msg))
  }
  e3 <- rgdx(fnIn,list(name='e3',form='sparse',uels=f3,field='up'),squeeze=F)
  chk <- chkRgdxRes (e3, e3wantUp, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(e3,'UP',filtered,squeeze=F) failed:",chk$msg))
  }
  # scale
  e0wantS <- list(name='e0', type='equation', dim=0L,
                  val=matrix(1, nrow=0, ncol=1),
                  form='sparse', uels=f0,
                  domains=character(0), domInfo='filtered',
                  field='s', typeCode=GMS_EQUTYPE$E)
  e0 <- rgdx(fnIn,list(name='e0',form='sparse',uels=f0,field='s'))
  chk <- chkRgdxRes (e0, e0wantS, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(e0,'S',filtered) failed:",chk$msg))
  }
  e0wantS$val <- matrix(1, nrow=1, ncol=1)
  e0 <- rgdx(fnIn,list(name='e0',form='sparse',uels=f0,field='s'),squeeze=F)
  chk <- chkRgdxRes (e0, e0wantS, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(e0,'S',filtered,squeeze=F) failed:",chk$msg))
  }
  e1wantS <- list(name='e1', type='equation', dim=1L,
                  val=matrix(c(1,2), nrow=1, ncol=2),
                  form='sparse', uels=f1,
                  domains=userDom1, domInfo='filtered',
                  field='s', typeCode=GMS_EQUTYPE$G)
  e1 <- rgdx(fnIn,list(name='e1',form='sparse',field='S',uels=f1))
  chk <- chkRgdxRes (e1, e1wantS, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(e1,'s',filtered) failed:",chk$msg))
  }
  e1 <- rgdx(fnIn,list(name='e1',form='sparse',field='S',uels=f1),squeeze=F)
  chk <- chkRgdxRes (e1, e1wantS, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(e1,'s',filtered,squeeze=F) failed:",chk$msg))
  }
  v3s <- matrix(0, nrow=0, ncol=4, byrow=T)
  v3 <- matrix(c(1, 1, 1,  1), nrow=1, ncol=4, byrow=T)
  e3wantS <- list(name='e3', type='equation', dim=3L,
                  val=v3s,
                  form='sparse', uels=f3,
                  domains=userDom3, domInfo='filtered',
                  field='s', typeCode=GMS_EQUTYPE$L)
  e3 <- rgdx(fnIn,list(name='e3',form='sparse',uels=f3,field='s'))
  chk <- chkRgdxRes (e3, e3wantS, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(e3,'S',filtered) failed:",chk$msg))
  }
  e3wantS$val <- v3
  e3 <- rgdx(fnIn,list(name='e3',form='sparse',uels=f3,field='s'),squeeze=F)
  chk <- chkRgdxRes (e3, e3wantS, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(e3,'S',filtered,squeeze=F) failed:",chk$msg))
  }

  ### ---------- reading form=full, no filter
  # all
  t <- array(0,c(nFields),dimnames=list('_field'=fields))
  t[['l' ]] <- 0
  t[['m' ]] <- 1
  t[['lo']] <- 0
  t[['up']] <- 0
  t[['s' ]] <- 1
  e0wantA <- list(name='e0', type='equation', dim=0L,
                  val=t,
                  form='full', uels=list('_field'=fields),
                  domains=domF, domInfo='NA',
                  field='all',
                  typeCode=GMS_EQUTYPE$E)
  e0 <- rgdx(fnIn,list(name='e0',form='full',field='all'))
  chk <- chkRgdxRes (e0, e0wantA, T, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(e0,'all',full,unfiltered) failed:",chk$msg))
  }
  e0 <- rgdx(fnIn,list(name='e0',form='full',field='all'),squeeze=F)
  chk <- chkRgdxRes (e0, e0wantA, T, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(e0,'all',full,unfiltered,squeeze=F) failed:",chk$msg))
  }
  t <- array(0,c(kCard,nFields),dimnames=cartKFn)
  t[    ,'up'] <- Inf
  t[    ,'s' ] <- 2
  t['k1','l' ] <- -2
  t['k1','m' ] <- -3.5
  t['k1','lo'] <- -2
  e1wantA <- list(name='e1', type='equation', dim=1L,
                  val=t,
                  form='full', uels=cartKFn,
                  domains=domKF, domInfo='full',
                  field='all', typeCode=GMS_EQUTYPE$G)
  e1 <- rgdx(fnIn,list(name='e1',form='full',field='aLL'))
  chk <- chkRgdxRes (e1, e1wantA, T, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(e1,'all',full,unfiltered) failed:",chk$msg))
  }
  e1 <- rgdx(fnIn,list(name='e1',form='full',field='all'),squeeze=F)
  chk <- chkRgdxRes (e1, e1wantA, T, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(e1,'all',full,unfiltered,squeeze=F) failed:",chk$msg))
  }
  v <- array(0,c(iCard,jCard,kCard,nFields),
             dimnames=list('I'=iUels,'J'=jUels,'K'=kUels,'_field'=fields))
  v[iUels,'j1' ,kUels,'l' ] <- 3
  v[iUels,'j2' ,kUels,'l' ] <- 4
  v[iUels,'j1' ,kUels,'m' ] <- 0
  v[iUels,'j2' ,kUels,'m' ] <- 0.5
  v[iUels,jUels,kUels,'lo'] <- -Inf
  v[iUels,jUels,kUels,'up'] <- 4
  v[iUels,jUels,kUels,'s' ] <- 1

  e3wantA <- list(name="e3", type="equation", dim=3L,
                  val=v,
                  form="full",
                  uels=list('I'=iUels,'J'=jUels,'K'=kUels,'_field'=fields),
                  domains=domIJKF, domInfo='full',
                  field='all',
                  typeCode=GMS_EQUTYPE$L)
  e3 <- rgdx(fnIn,list(name='e3',form='full',field='all'))
  chk <- chkRgdxRes (e3, e3wantA, T, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(e3,'all',full,unfiltered) failed:",chk$msg))
  }
  e3 <- rgdx(fnIn,list(name='e3',form='full',field='all'),squeeze=F)
  chk <- chkRgdxRes (e3, e3wantA, T, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(e3,'all',full,unfiltered,squeeze=F) failed:",chk$msg))
  }
  # level
  e0wantL <- list(name='e0', type='equation', dim=0L,
                  val=0,
                  form='full', uels=list(),
                  domains=character(0), domInfo='NA',
                  field='l', typeCode=GMS_EQUTYPE$E)
  e0 <- rgdx(fnIn,list(name='e0',form='full',field='L'))
  chk <- chkRgdxRes (e0, e0wantL, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(e0,'L',full,unfiltered) failed:",chk$msg))
  }
  e0 <- rgdx(fnIn,list(name='e0',form='full',field='L'),squeeze=F)
  chk <- chkRgdxRes (e0, e0wantL, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(e0,'L',full,unfiltered,squeeze=F) failed:",chk$msg))
  }
  t <- array(0,c(kCard,1),dimnames=cartKn)
  t['k1',1] <- -2
  e1wantL <- list(name='e1', type='equation', dim=1L,
                  val=t,
                  form='full', uels=cartKn,
                  domains=domK, domInfo="full",
                  field='l', typeCode=GMS_EQUTYPE$G)
  e1 <- rgdx(fnIn,list(name='e1',form='full',field='L'))
  chk <- chkRgdxRes (e1, e1wantL, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(e1,'L',full,unfiltered) failed:",chk$msg))
  }
  e1 <- rgdx(fnIn,list(name='e1',form='full',field='L'),squeeze=F)
  chk <- chkRgdxRes (e1, e1wantL, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(e1,'L',full,unfiltered,squeeze=F) failed:",chk$msg))
  }
  t3 <- array(0,c(iCard,jCard,kCard),
              dimnames=list('I'=iUels,'J'=jUels,'K'=kUels))
  t3['i1','j1','k1'] <- 3
  t3['i1','j2','k1'] <- 4
  e3wantL <- list(name='e3', type='equation', dim=3L,
                  val=t3,
                  form='full',
                  uels=list('I'=iUels,'J'=jUels,'K'=kUels),
                  domains=domIJK, domInfo="full",
                  field='l', typeCode=GMS_EQUTYPE$L)
  e3 <- rgdx(fnIn,list(name='e3',form='full',field='L'))
  chk <- chkRgdxRes (e3, e3wantL, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(e3,'L',full,unfiltered) failed:",chk$msg))
  }
  e3 <- rgdx(fnIn,list(name='e3',form='full',field='L'),squeeze=F)
  chk <- chkRgdxRes (e3, e3wantL, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(e3,'L',full,unfiltered,squeeze=F) failed:",chk$msg))
  }
  # marginal
  e0wantM <- list(name='e0', type='equation', dim=0L,
                  val=1,
                  form='full', uels=list(),
                  domains=character(0), domInfo="NA",
                  field='m', typeCode=GMS_EQUTYPE$E)
  e0 <- rgdx(fnIn,list(name='e0',form='full',field='M'))
  chk <- chkRgdxRes (e0, e0wantM, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(e0,'M',full,unfiltered) failed:",chk$msg))
  }
  e0 <- rgdx(fnIn,list(name='e0',form='full',field='M'),squeeze=F)
  chk <- chkRgdxRes (e0, e0wantM, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(e0,'M',full,unfiltered,squeeze=F) failed:",chk$msg))
  }
  t <- array(0,c(kCard,1),dimnames=cartKn)
  t['k1',1] <- -3.5
  e1wantM <- list(name='e1', type='equation', dim=1L,
                  val=t,
                  form='full', uels=cartKn,
                  domains=domK, domInfo="full",
                  field='m', typeCode=GMS_EQUTYPE$G)
  e1 <- rgdx(fnIn,list(name='e1',form='full',field='M'))
  chk <- chkRgdxRes (e1, e1wantM, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(e1,'M',full,unfiltered) failed:",chk$msg))
  }
  e1 <- rgdx(fnIn,list(name='e1',form='full',field='M'),squeeze=F)
  chk <- chkRgdxRes (e1, e1wantM, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(e1,'M',full,unfiltered,squeeze=F) failed:",chk$msg))
  }
  t3['i1','j1','k1'] <- 0
  t3['i1','j2','k1'] <- 0.5
  e3wantM <- list(name='e3', type='equation', dim=3L,
                  val=t3,
                  form='full',
                  uels=list('I'=iUels,'J'=jUels,'K'=kUels),
                  domains=domIJK, domInfo="full",
                  field='m', typeCode=GMS_EQUTYPE$L)
  e3 <- rgdx(fnIn,list(name='e3',form='full',field='M'))
  chk <- chkRgdxRes (e3, e3wantM, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(e3,'M',full,unfiltered) failed:",chk$msg))
  }
  e3 <- rgdx(fnIn,list(name='e3',form='full',field='M'),squeeze=F)
  chk <- chkRgdxRes (e3, e3wantM, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(e3,'M',full,unfiltered,squeeze=F) failed:",chk$msg))
  }
  # lower
  e0wantLo <- list(name='e0', type='equation', dim=0L,
                   val=0,
                   form='full', uels=list(),
                   domains=character(0), domInfo="NA",
                   field='lo', typeCode=GMS_EQUTYPE$E)
  e0 <- rgdx(fnIn,list(name='e0',form='full',field='lo'))
  chk <- chkRgdxRes (e0, e0wantLo, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(e0,'Lo',full,unfiltered) failed:",chk$msg))
  }
  e0 <- rgdx(fnIn,list(name='e0',form='full',field='lo'),squeeze=F)
  chk <- chkRgdxRes (e0, e0wantLo, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(e0,'Lo',full,unfiltered,squeeze=F) failed:",chk$msg))
  }
  t <- array(0,c(kCard,1),dimnames=cartKn)
  t['k1',1] <- -2
  e1wantLo <- list(name='e1', type='equation', dim=1L,
                   val=t,
                   form='full', uels=cartKn,
                   domains=domK, domInfo="full",
                   field='lo', typeCode=GMS_EQUTYPE$G)
  e1 <- rgdx(fnIn,list(name='e1',form='full',field='Lo'))
  chk <- chkRgdxRes (e1, e1wantLo, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(e1,'LO',full,unfiltered) failed:",chk$msg))
  }
  e1 <- rgdx(fnIn,list(name='e1',form='full',field='Lo'),squeeze=F)
  chk <- chkRgdxRes (e1, e1wantLo, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(e1,'LO',full,unfiltered,squeeze=F) failed:",chk$msg))
  }
  t3['i1','j1','k1'] <- -Inf
  t3['i1','j2','k1'] <- -Inf
  e3wantLo <- list(name='e3', type='equation', dim=3L,
                   val=t3,
                   form='full',
                   uels=list('I'=iUels,'J'=jUels,'K'=kUels),
                   domains=domIJK, domInfo="full",
                   field='lo', typeCode=GMS_EQUTYPE$L)
  e3 <- rgdx(fnIn,list(name='e3',form='full',field='LO'))
  chk <- chkRgdxRes (e3, e3wantLo, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(e3,'LO',full,unfiltered) failed:",chk$msg))
  }
  e3 <- rgdx(fnIn,list(name='e3',form='full',field='LO'),squeeze=F)
  chk <- chkRgdxRes (e3, e3wantLo, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(e3,'LO',full,unfiltered,squeeze=F) failed:",chk$msg))
  }
  # upper
  e0wantUp <- list(name='e0', type='equation', dim=0L,
                   val=0,
                   form='full', uels=list(),
                   domains=character(0), domInfo="NA",
                   field='up', typeCode=GMS_EQUTYPE$E)
  e0 <- rgdx(fnIn,list(name='e0',form='full',field='up'))
  chk <- chkRgdxRes (e0, e0wantUp, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(e0,'up',full,unfiltered) failed:",chk$msg))
  }
  e0 <- rgdx(fnIn,list(name='e0',form='full',field='up'),squeeze=F)
  chk <- chkRgdxRes (e0, e0wantUp, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(e0,'up',full,unfiltered,squeeze=F) failed:",chk$msg))
  }
  t <- array(0,c(kCard,1),dimnames=cartKn)
  t['k1',1] <- Inf
  e1wantUp <- list(name='e1', type='equation', dim=1L,
                   val=t,
                   form='full', uels=cartKn,
                   domains=domK, domInfo="full",
                   field='up', typeCode=GMS_EQUTYPE$G)
  e1 <- rgdx(fnIn,list(name='e1',form='full',field='up'))
  chk <- chkRgdxRes (e1, e1wantUp, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(e1,'up',full,unfiltered) failed:",chk$msg))
  }
  e1 <- rgdx(fnIn,list(name='e1',form='full',field='up'),squeeze=F)
  chk <- chkRgdxRes (e1, e1wantUp, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(e1,'up',full,unfiltered,squeeze=F) failed:",chk$msg))
  }
  t3['i1','j1','k1'] <- 4
  t3['i1','j2','k1'] <- 4
  e3wantUp <- list(name='e3', type='equation', dim=3L,
                   val=t3,
                   form='full',
                   uels=list('I'=iUels,'J'=jUels,'K'=kUels),
                   domains=domIJK, domInfo="full",
                   field='up', typeCode=GMS_EQUTYPE$L)
  e3 <- rgdx(fnIn,list(name='e3',form='full',field='UP'))
  chk <- chkRgdxRes (e3, e3wantUp, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(e3,'UP',full,unfiltered) failed:",chk$msg))
  }
  e3 <- rgdx(fnIn,list(name='e3',form='full',field='UP'),squeeze=F)
  chk <- chkRgdxRes (e3, e3wantUp, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(e3,'UP',full,unfiltered,squeeze=F) failed:",chk$msg))
  }
  # scale
  e0wantS <- list(name='e0', type='equation', dim=0L,
                  val=1,
                  form='full', uels=list(),
                  domains=character(0), domInfo="NA",
                  field='s', typeCode=GMS_EQUTYPE$E)
  e0 <- rgdx(fnIn,list(name='e0',form='full',field='s'))
  chk <- chkRgdxRes (e0, e0wantS, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(e0,'s',full,unfiltered) failed:",chk$msg))
  }
  e0 <- rgdx(fnIn,list(name='e0',form='full',field='s'),squeeze=F)
  chk <- chkRgdxRes (e0, e0wantS, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(e0,'s',full,unfiltered,squeeze=F) failed:",chk$msg))
  }
  t <- array(0,c(kCard,1),dimnames=cartKn)
  t['k1',1] <- 2
  e1wantS <- list(name='e1', type='equation', dim=1L,
                  val=t,
                  form='full', uels=cartKn,
                  domains=domK, domInfo="full",
                  field='s', typeCode=GMS_EQUTYPE$G)
  e1 <- rgdx(fnIn,list(name='e1',form='full',field='s'))
  chk <- chkRgdxRes (e1, e1wantS, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(e1,'s',full,unfiltered) failed:",chk$msg))
  }
  t3['i1','j1','k1'] <- 1
  t3['i1','j2','k1'] <- 1
  e3wantS <- list(name='e3', type='equation', dim=3L,
                  val=t3,
                  form='full',
                  uels=list('I'=iUels,'J'=jUels,'K'=kUels),
                  domains=domIJK, domInfo="full",
                  field='s', typeCode=GMS_EQUTYPE$L)
  e3 <- rgdx(fnIn,list(name='e3',form='full',field='S'))
  chk <- chkRgdxRes (e3, e3wantS, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(e3,'S',full,unfiltered) failed:",chk$msg))
  }
  e3 <- rgdx(fnIn,list(name='e3',form='full',field='S'),squeeze=F)
  chk <- chkRgdxRes (e3, e3wantS, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(e3,'S',full,unfiltered,squeeze=F) failed:",chk$msg))
  }


  ### ---------- reading form=full, filtered
  f0 <- list()
  f <- list(kUels)
  f3 <- list(iUels,c('j1'),kUels)
  filtercartIJKF <- list(iUels,c('j1'),kUels,fields)
  # all
  t <- array(0,c(nFields),dimnames=list('_field'=fields))
  t[['m' ]] <- 1
  t[['s' ]] <- 1
  e0wantA <- list(name='e0', type='equation', dim=0L,
                  val=t,
                  form='full', uels=list('_field'=fields),
                  domains=domF, domInfo="NA",
                  field='all',
                  typeCode=GMS_EQUTYPE$E)
  e0 <- rgdx(fnIn,list(name='e0',form='full',field='all'))
  chk <- chkRgdxRes (e0, e0wantA, T, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(e0,'all',full,filtered) failed:",chk$msg))
  }
  e0 <- rgdx(fnIn,list(name='e0',form='full',field='all'),squeeze=F)
  chk <- chkRgdxRes (e0, e0wantA, T, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(e0,'all',full,filtered,squeeze=F) failed:",chk$msg))
  }
  dnames <- cartKF ; names(dnames) <- userDom1f
  t <- array(0,c(kCard,nFields),dimnames=dnames)
  t['k1','l' ] <- -2
  t['k1','m' ] <- -3.5
  t['k1','lo'] <- -2
  t['k1','up'] <- +Inf
  t['k1','s' ] <- 2
  e1wantA <- list(name='e1', type='equation', dim=1L,
                  val=t,
                  form='full', uels=dnames,
                  domains=userDom1f, domInfo="filtered",
                  field='all', typeCode=GMS_EQUTYPE$G)
  e1 <- rgdx(fnIn,list(name='e1',form='full',uels=cartK,field='all'))
  chk <- chkRgdxRes (e1, e1wantA, T, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(e1,'all',full,filtered) failed:",chk$msg))
  }
  e1 <- rgdx(fnIn,list(name='e1',form='full',uels=cartK,field='all'),squeeze=F)
  chk <- chkRgdxRes (e1, e1wantA, T, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(e1,'all',full,filtered,squeeze=F) failed:",chk$msg))
  }
  e3uels <- list('I'=f3[[1]],'J'=f3[[2]],'K'=f3[[3]],'_field'=fields)
  v <- array(0,c(iCard,1,kCard,nFields),
             dimnames=e3uels)
  v['i1','j1','k1','l' ] <- 3
  v['i1','j1','k1','m' ] <- 0
  v['i1','j1','k1','lo'] <- -Inf
  v['i1','j1','k1','up'] <- 4
  v['i1','j1','k1','s' ] <- 1
  e3wantA <- list(name="e3", type="equation", dim=3L,
                  val=v,
                  form="full",
                  uels=e3uels,
                  domains=userDom3f, domInfo="filtered",
                  field='all',
                  typeCode=GMS_EQUTYPE$L)
  e3 <- rgdx(fnIn,list(name='e3',form='full',field='all',uels=f3))
  chk <- chkRgdxRes (e3, e3wantA, T, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(e3,'all',full,filtered) failed:",chk$msg))
  }
  e3 <- rgdx(fnIn,list(name='e3',form='full',field='all',uels=f3),squeeze=F)
  chk <- chkRgdxRes (e3, e3wantA, T, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(e3,'all',full,filtered,squeeze=F) failed:",chk$msg))
  }
  # level
  e0wantL <- list(name='e0', type='equation', dim=0L,
                  val=0,
                  form='full', uels=list(),
                  domains=character(0), domInfo="filtered",
                  field='l', typeCode=GMS_EQUTYPE$E)
  e0 <- rgdx(fnIn,list(name='e0',form='full',field='L',uels=f0))
  chk <- chkRgdxRes (e0, e0wantL, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(e0,'L',full,filtered) failed:",chk$msg))
  }
  e0 <- rgdx(fnIn,list(name='e0',form='full',field='L',uels=f0),squeeze=F)
  chk <- chkRgdxRes (e0, e0wantL, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(e0,'L',full,filtered,squeeze=F) failed:",chk$msg))
  }
  dnames <- cartK ; names(dnames) <- userDom1
  t <- array(0,c(kCard,1),dimnames=dnames)
  t['k1',1] <- -2
  e1wantL <- list(name='e1', type='equation', dim=1L,
                  val=t,
                  form='full', uels=dnames,
                  domains=userDom1, domInfo="filtered",
                  field='l', typeCode=GMS_EQUTYPE$G)
  e1 <- rgdx(fnIn,list(name='e1',uels=f1,form='full',field='L'))
  chk <- chkRgdxRes (e1, e1wantL, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(e1,'L',full,filtered) failed:",chk$msg))
  }
  e1 <- rgdx(fnIn,list(name='e1',uels=f1,form='full',field='L'),squeeze=F)
  chk <- chkRgdxRes (e1, e1wantL, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(e1,'L',full,filtered,squeeze=F) failed:",chk$msg))
  }
  dnames <- list(iUels,c('j1'),kUels) ; names(dnames) <- userDom3
  t3 <- array(0,c(iCard,1,kCard),dimnames=dnames)
  t3['i1','j1','k1'] <- 3
  e3wantL <- list(name='e3', type='equation', dim=3L,
                  val=t3,
                  form='full', uels=dnames,
                  domains=userDom3, domInfo="filtered",
                  field='l', typeCode=GMS_EQUTYPE$L)
  e3 <- rgdx(fnIn,list(name='e3',uels=f3,form='full',field='L'))
  chk <- chkRgdxRes (e3, e3wantL, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(e3,'L',full,filtered) failed:",chk$msg))
  }
  e3 <- rgdx(fnIn,list(name='e3',uels=f3,form='full',field='L'),squeeze=F)
  chk <- chkRgdxRes (e3, e3wantL, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(e3,'L',full,filtered,squeeze=F) failed:",chk$msg))
  }
  # marginal
  e0wantM <- list(name='e0', type='equation', dim=0L,
                  val=1,
                  form='full', uels=list(),
                  domains=character(0), domInfo="filtered",
                  field='m', typeCode=GMS_EQUTYPE$E)
  e0 <- rgdx(fnIn,list(name='e0',form='full',field='M',uels=f0))
  chk <- chkRgdxRes (e0, e0wantM, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(e0,'M',full,filtered) failed:",chk$msg))
  }
  e0 <- rgdx(fnIn,list(name='e0',form='full',field='M',uels=f0),squeeze=F)
  chk <- chkRgdxRes (e0, e0wantM, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(e0,'M',full,filtered,squeeze=F) failed:",chk$msg))
  }
  dnames <- cartK ; names(dnames) <- userDom1
  t <- array(0,c(kCard,1),dimnames=dnames)
  t['k1',1] <- -3.5
  e1wantM <- list(name='e1', type='equation', dim=1L,
                  val=t,
                  form='full', uels=dnames,
                  domains=userDom1, domInfo="filtered",
                  field='m', typeCode=GMS_EQUTYPE$G)
  e1 <- rgdx(fnIn,list(name='e1',uels=f1,form='full',field='M'))
  chk <- chkRgdxRes (e1, e1wantM, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(e1,'M',full,filtered) failed:",chk$msg))
  }
  e1 <- rgdx(fnIn,list(name='e1',uels=f1,form='full',field='M'),squeeze=F)
  chk <- chkRgdxRes (e1, e1wantM, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(e1,'M',full,filtered,squeeze=F) failed:",chk$msg))
  }
  dnames <- list(iUels,c('j1'),kUels) ; names(dnames) <- userDom3
  t3 <- array(0,c(iCard,1,kCard),dimnames=dnames)
  t3['i1','j1','k1'] <- 0
  e3wantM <- list(name='e3', type='equation', dim=3L,
                  val=t3,
                  form='full', uels=dnames,
                  domains=userDom3, domInfo="filtered",
                  field='m', typeCode=GMS_EQUTYPE$L)
  e3 <- rgdx(fnIn,list(name='e3',uels=f3,form='full',field='M'))
  chk <- chkRgdxRes (e3, e3wantM, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(e3,'M',full,filtered) failed:",chk$msg))
  }
  e3 <- rgdx(fnIn,list(name='e3',uels=f3,form='full',field='M'),squeeze=F)
  chk <- chkRgdxRes (e3, e3wantM, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(e3,'M',full,filtered,squeeze=F) failed:",chk$msg))
  }
  # lower
  e0wantLo <- list(name='e0', type='equation', dim=0L,
                   val=0,
                   form='full', uels=list(),
                   domains=character(0), domInfo="filtered",
                   field='lo', typeCode=GMS_EQUTYPE$E)
  e0 <- rgdx(fnIn,list(name='e0',form='full',field='lo',uels=f0))
  chk <- chkRgdxRes (e0, e0wantLo, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(e0,'lo',full,filtered) failed:",chk$msg))
  }
  e0 <- rgdx(fnIn,list(name='e0',form='full',field='lo',uels=f0),squeeze=F)
  chk <- chkRgdxRes (e0, e0wantLo, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(e0,'lo',full,filtered,squeeze=F) failed:",chk$msg))
  }
  dnames <- cartK ; names(dnames) <- userDom1
  t <- array(0,c(kCard,1),dimnames=dnames)
  t['k1',1] <- -2
  e1wantLo <- list(name='e1', type='equation', dim=1L,
                   val=t,
                   form='full', uels=dnames,
                   domains=userDom1, domInfo="filtered",
                   field='lo', typeCode=GMS_EQUTYPE$G)
  e1 <- rgdx(fnIn,list(name='e1',uels=f1,form='full',field='Lo'))
  chk <- chkRgdxRes (e1, e1wantLo, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(e1,'LO',full,filtered) failed:",chk$msg))
  }
  e1 <- rgdx(fnIn,list(name='e1',uels=f1,form='full',field='Lo'),squeeze=F)
  chk <- chkRgdxRes (e1, e1wantLo, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(e1,'LO',full,filtered,squeeze=F) failed:",chk$msg))
  }
  dnames <- list(iUels,c('j1'),kUels) ; names(dnames) <- userDom3
  t3 <- array(0,c(iCard,1,kCard),dimnames=dnames)
  t3['i1','j1','k1'] <- -Inf
  e3wantLo <- list(name='e3', type='equation', dim=3L,
                   val=t3,
                   form='full', uels=dnames,
                   domains=userDom3, domInfo="filtered",
                   field='lo', typeCode=GMS_EQUTYPE$L)
  e3 <- rgdx(fnIn,list(name='e3',uels=f3,form='full',field='LO'))
  chk <- chkRgdxRes (e3, e3wantLo, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(e3,'LO',full,filtered) failed:",chk$msg))
  }
  e3 <- rgdx(fnIn,list(name='e3',uels=f3,form='full',field='LO'),squeeze=F)
  chk <- chkRgdxRes (e3, e3wantLo, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(e3,'LO',full,filtered,squeeze=F) failed:",chk$msg))
  }
  # upper
  e0wantUp <- list(name='e0', type='equation', dim=0L,
                   val=0,
                   form='full', uels=list(),
                   domains=character(0), domInfo="filtered",
                   field='up', typeCode=GMS_EQUTYPE$E)
  e0 <- rgdx(fnIn,list(name='e0',form='full',field='up',uels=f0))
  chk <- chkRgdxRes (e0, e0wantUp, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(e0,'up',full,filtered) failed:",chk$msg))
  }
  e0 <- rgdx(fnIn,list(name='e0',form='full',field='up',uels=f0),squeeze=F)
  chk <- chkRgdxRes (e0, e0wantUp, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(e0,'up',full,filtered,squeeze=F) failed:",chk$msg))
  }
  dnames <- cartK ; names(dnames) <- userDom1
  t <- array(0,c(kCard,1),dimnames=dnames)
  t['k1',1] <- Inf
  e1wantUp <- list(name='e1', type='equation', dim=1L,
                   val=t,
                   form='full', uels=dnames,
                   domains=userDom1, domInfo="filtered",
                   field='up', typeCode=GMS_EQUTYPE$G)
  e1 <- rgdx(fnIn,list(name='e1',uels=f1,form='full',field='Up'))
  chk <- chkRgdxRes (e1, e1wantUp, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(e1,'UP',full,filtered) failed:",chk$msg))
  }
  e1 <- rgdx(fnIn,list(name='e1',uels=f1,form='full',field='Up'),squeeze=F)
  chk <- chkRgdxRes (e1, e1wantUp, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(e1,'UP',full,filtered,squeeze=F) failed:",chk$msg))
  }
  dnames <- list(iUels,c('j1'),kUels) ; names(dnames) <- userDom3
  t3 <- array(0,c(iCard,1,kCard),dimnames=dnames)
  t3['i1','j1','k1'] <- 4
  e3wantUp <- list(name='e3', type='equation', dim=3L,
                   val=t3,
                   form='full', uels=dnames,
                   domains=userDom3, domInfo="filtered",
                   field='up', typeCode=GMS_EQUTYPE$L)
  e3 <- rgdx(fnIn,list(name='e3',uels=f3,form='full',field='UP'))
  chk <- chkRgdxRes (e3, e3wantUp, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(e3,'UP',full,filtered) failed:",chk$msg))
  }
  e3 <- rgdx(fnIn,list(name='e3',uels=f3,form='full',field='UP'),squeeze=F)
  chk <- chkRgdxRes (e3, e3wantUp, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(e3,'UP',full,filtered,squeeze=F) failed:",chk$msg))
  }
  # scale
  e0wantS <- list(name='e0', type='equation', dim=0L,
                  val=1,
                  form='full', uels=list(),
                  domains=character(0), domInfo="filtered",
                  field='s', typeCode=GMS_EQUTYPE$E)
  e0 <- rgdx(fnIn,list(name='e0',form='full',field='s',uels=f0))
  chk <- chkRgdxRes (e0, e0wantS, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(e0,'s',full,filtered) failed:",chk$msg))
  }
  e0 <- rgdx(fnIn,list(name='e0',form='full',field='s',uels=f0),squeeze=F)
  chk <- chkRgdxRes (e0, e0wantS, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(e0,'s',full,filtered,squeeze=F) failed:",chk$msg))
  }
  dnames <- cartK ; names(dnames) <- userDom1
  t <- array(0,c(kCard,1),dimnames=dnames)
  t['k1',1] <- 2
  e1wantS <- list(name='e1', type='equation', dim=1L,
                  val=t,
                  form='full', uels=dnames,
                  domains=userDom1, domInfo="filtered",
                  field='s', typeCode=GMS_EQUTYPE$G)
  e1 <- rgdx(fnIn,list(name='e1',uels=f1,form='full',field='s'))
  chk <- chkRgdxRes (e1, e1wantS, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(e1,'s',full,filtered) failed:",chk$msg))
  }
  e1 <- rgdx(fnIn,list(name='e1',uels=f1,form='full',field='s'),squeeze=F)
  chk <- chkRgdxRes (e1, e1wantS, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(e1,'s',full,filtered,squeeze=F) failed:",chk$msg))
  }
  dnames <- list(iUels,c('j1'),kUels) ; names(dnames) <- userDom3
  t3 <- array(0,c(iCard,1,kCard),dimnames=dnames)
  t3['i1','j1','k1'] <- 1
  e3wantS <- list(name='e3', type='equation', dim=3L,
                  val=t3,
                  form='full', uels=dnames,
                  domains=userDom3, domInfo="filtered",
                  field='s', typeCode=GMS_EQUTYPE$L)
  e3 <- rgdx(fnIn,list(name='e3',uels=f3,form='full',field='S'))
  chk <- chkRgdxRes (e3, e3wantS, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(e3,'S',full,filtered) failed:",chk$msg))
  }
  e3 <- rgdx(fnIn,list(name='e3',uels=f3,form='full',field='S'),squeeze=F)
  chk <- chkRgdxRes (e3, e3wantS, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(e3,'S',full,filtered,squeeze=F) failed:",chk$msg))
  }


  print ("test of rgdx on equation reads passed")
  TRUE   ## all tests passed: return TRUE
},

error = function(ex) { print ("test of rgdx on equation reads failed"); print(ex) ; FALSE }
)

### Test rgdx, rgdx.param with special values and zero
# We read a parameter containing special values and test the results

if (! require(gdxrrw))      stop ("gdxrrw package is not available")
if (0 == igdx(silent=TRUE)) stop ("the gdx shared library has not been loaded")

tryCatch({
  print ("test reading special values with form='sparse' and no filter")
  rgdx('?')

  fn <- "svxls.gdx"

  print (paste("first read with defaults: input =",fn))
  sv1 <- rgdx (fn,list(name='sv'))

  print (paste("second read with squeeze=FALSE: input =",fn))
  sv2 <- rgdx (fn,list(name='sv'),squeeze=FALSE)

  print (paste("third read as data frame with default squeeze: input =",fn))
  svdf3 <- rgdx.param (fn, 'sv', ts=TRUE)

  print (paste("fourth read as data frame with squeeze=FALSE: input =",fn))
  svdf4 <- rgdx.param (fn, 'sv', ts=TRUE, squeeze=FALSE)

  if (dim(sv1$val)[1] != 15)
    stop ("Expected dim(sv1$val)[1] to be 15")
  if (dim(sv1$val)[2] != 3)
    stop ("Expected dim(sv1$val)[1] to be 3")
  if (! is.nan(sv1$val[12,3]))
    stop ("Expected sv1$val[12,3] to be NaN")
  if (! is.na(sv1$val[13,3]))
    stop ("Expected sv1$val[13,3] to be NA")
  if (! is.infinite(sv1$val[14,3]))
    stop ("Expected sv1$val[14,3] to be infinite")
  if (sv1$val[14,3] <= 0)
    stop ("Expected sv1$val[14,3] to be positive")
  if (! is.infinite(sv1$val[15,3]))
    stop ("Expected sv1$val[15,3] to be infinite")
  if (sv1$val[15,3] >= 0)
    stop ("Expected sv1$val[15,3] to be negative")

  if (dim(sv2$val)[1] != 17)
    stop ("Expected dim(sv2$val)[1] to be 17")
  if (dim(sv2$val)[2] != 3)
    stop ("Expected dim(sv2$val)[1] to be 3")
  if (0 != sv2$val[12,3])
    stop ("Expected sv2$val[12,3] to be 0")
  if (! is.nan(sv2$val[13,3]))
    stop ("Expected sv2$val[13,3] to be NaN")
  if (! is.na(sv2$val[14,3]))
    stop ("Expected sv2$val[14,3] to be NA")
  if (! is.infinite(sv2$val[15,3]))
    stop ("Expected sv2$val[15,3] to be infinite")
  if (sv2$val[15,3] <= 0)
    stop ("Expected sv2$val[15,3] to be positive")
  if (! is.infinite(sv2$val[16,3]))
    stop ("Expected sv2$val[16,3] to be infinite")
  if (sv2$val[16,3] >= 0)
    stop ("Expected sv2$val[16,3] to be negative")
  if (0 != sv2$val[17,3])
    stop ("Expected sv2$val[17,3] to be 0")

  # test data frame returns with squeezed zero
  if (dim(svdf3)[1] != 15)
    stop ("Expected dim(svdf3)[1] to be 15")
  if (dim(svdf3)[2] != 3)
    stop ("Expected dim(svdf3)[1] to be 3")
  if (! is.nan(svdf3[12,'value']))
    stop ("Expected svdf3[12,'value'] to be NaN")
  if (! is.na(svdf3[13,'value']))
    stop ("Expected svdf3[13,'value'] to be NA")
  if (! is.infinite(svdf3[14,'value']))
    stop ("Expected svdf3[14,'value'] to be infinite")
  if (svdf3[14,'value'] <= 0)
    stop ("Expected svdf3[14,'value'] to be positive")
  if (! is.infinite(svdf3[15,'value']))
    stop ("Expected svdf3[15,'value'] to be infinite")
  if (svdf3[15,'value'] >= 0)
    stop ("Expected svdf3[15,'value'] to be negative")

  if (dim(svdf4)[1] != 17)
    stop ("Expected dim(svdf4)[1] to be 17")
  if (dim(svdf4)[2] != 3)
    stop ("Expected dim(svdf4)[1] to be 3")
  if (0 != svdf4[12,'value'])
    stop ("Expected svdf4[12,'value'] to be 0")
  if (! is.nan(svdf4[13,'value']))
    stop ("Expected svdf4[13,'value'] to be NaN")
  if (! is.na(svdf4[14,'value']))
    stop ("Expected svdf4[14,'value'] to be NA")
  if (! is.infinite(svdf4[15,'value']))
    stop ("Expected svdf4[15,'value'] to be infinite")
  if (svdf4[15,'value'] <= 0)
    stop ("Expected svdf4[15,'value'] to be positive")
  if (! is.infinite(svdf4[16,'value']))
    stop ("Expected svdf4[16,'value'] to be infinite")
  if (svdf4[16,'value'] >= 0)
    stop ("Expected svdf4[16,'value'] to be negative")
  if (0 != svdf4[17,'value'])
    stop ("Expected svdf4[17,'value'] to be 0")

  print ("all tests for reading special values and zero passed")
  return (TRUE)
}

, error = function(ex) { print(ex) ; return (FALSE) }
)

#### test rgdx with a recent GDX file containing full domain info
#### with useDomInfo=FALSE it should behave as if no dom info is there
#### test form=['sparse','full'] X [filtered,unfiltered] X compress=[T,F]

#### wanted lists produced with    dump("listName",file="")

if (! require(gdxrrw))      stop ("gdxrrw package is not available")
if (0 == igdx(silent=TRUE)) stop ("the gdx shared library has not been loaded")

source ("chkSame.R")
reqIdent <- TRUE

tryCatch({
  print ("testing rgdx handling of GDX file with useDomInfo=FALSE")
  rgdx('?')
  fnIn <- "teTestWithDomainInfo.gdx"
  if (! file_test ('-f', fnIn)) {
    stop (paste("FAIL: File", fnIn, "does not exist"))
  }
  useDomInfo <- FALSE
  noInfo <- "NA"   # domInfo="NA" means you didn't ask or it doesn't make sense to ask
  
  source ("tReadDomInfoBody.R")


  print ("test of rgdx with useDomInfo=FALSE passed")
  TRUE   ## all tests passed: return TRUE
},

error = function(ex) { print ("test of rgdx with useDomInfo=FALSE failed"); print(ex) ; FALSE }
)

#### test rgdx with a file generated prior to domain info in GDX
#### test form=['sparse','full'] X [filtered,unfiltered] X compress=[T,F]

#### wanted lists produced with    dump("listName",file="")

if (! require(gdxrrw))      stop ("gdxrrw package is not available")
if (0 == igdx(silent=TRUE)) stop ("the gdx shared library has not been loaded")

source ("chkSame.R")

tryCatch({
  print ("testing rgdx handling of GDX file with no domain info")
  rgdx('?')
  fnIn <- "teTestPreDomainInfo.gdx"
  if (! file_test ('-f', fnIn)) {
    stop (paste("FAIL: File", fnIn, "does not exist"))
  }
  useDomInfo <- TRUE

  source ("tReadDomInfoBody.R")


  print ("test of rgdx on pre-domain-info GDX file passed")
  TRUE   ## all tests passed: return TRUE
},

error = function(ex) { print ("test of rgdx on pre-domain-info GDX file failed"); print(ex) ; FALSE }
)

#### test wgdx for handling of 'field' list element

if (! require(gdxrrw))      stop ("gdxrrw package is not available")
if (0 == igdx(silent=TRUE)) stop ("the gdx shared library has not been loaded")

testName <- "'field' list element for variable writes"
logFile <- 'diffLog.txt'

errFunc <- function(ex) {
  print (paste0("test of wgdx on ",testName,": FAILED"))
  print (paste("Check file", logFile, "for possible gdxdiff output"))
  print (ex)
  FALSE
} # errFunc

tryCatch({
  print ("testing wgdx on 'field' list element for variable writes")
  wgdx('?')
  fnIn <- "var2d.gdx"
  fnOut <- "tmp.gdx"
  if (! file_test ('-f', fnIn)) {
    stop (paste("FAIL: File", fnIn, "does not exist"))
  }

  xIn <- rgdx(fnIn,list(name='x',form='sparse',field='all'))
  if (xIn$field != 'all') {
    stop (paste("FAIL: rgdx output '$field' not 'all' as expected"))
  }

  ## test field='all'
  wgdx (fnOut, xIn)
  if (file_test ('-f', fnOut) == TRUE) {
    print (paste("File", fnOut, "was created"))
  } else {
    stop (paste("FAIL: File", fnOut, "is not readable"))
  }
  rc <- system2 ("gdxdiff",args=c(fnIn, fnOut), stdout=logFile)
  if (0 != rc) {
    stop(paste("Bad return from gdxdiff: wanted 0, got",rc))
  } else {
    print ("gdxdiff call succeeded")
  }

  ## test empty field, identical to 'all'
  x2 <- xIn
  x2$field <- NULL
  wgdx (fnOut, x2)
  if (file_test ('-f', fnOut) == TRUE) {
    print (paste("File", fnOut, "was created"))
  } else {
    stop (paste("FAIL: File", fnOut, "is not readable"))
  }
  rc <- system2 ("gdxdiff",args=c(fnIn, fnOut), stdout=logFile)
  if (0 != rc) {
    stop(paste("Bad return from gdxdiff: wanted 0, got",rc))
  } else {
    print ("gdxdiff call succeeded")
  }

  for (ff in c('notGood','l','m','lo','up','s')) {
    msg <- paste0("wgdx test for variable handling bogus field specifier '", ff, "'")
    x2$field <- ff
    tcr <- tryCatch({
      wgdx(fnOut, x2) ; FALSE
    },
    error = function(e) { print(paste(' Caught error: msg =',e)) ; TRUE }
    )
    if (tcr) {
      print(paste(msg,": passed",sep=""))
    }
    else {
      stop (paste(msg, ": failed",sep=""))
    }
  } # for loop

  print (paste0("test of wgdx on ", testName, ": PASSED"))
  suppressWarnings(file.remove(logFile))
  invisible(TRUE)   ## all tests passed: return TRUE
},

error = errFunc
)

## ## test wgdx with form='sparse', 2-d variable, when some typical orders are not present
## ##   0. Start with input to wgdx that is identical to what rgdx will give
## ##   1. Usually, index positions that are aliases will use the same order.  But what if not?
## ##   2. the variable fields come out of rgdx() like (1,2,3,4,5) -> ("l","m","lo","up","s")
## ##      We can make this anything though on input, like
## ##        (500,600,700,800,801) -> ('lo','up','s','M','L')
## ##   3. Usually, the 'val' matrix will be ordered.  But it doesn't have to be.
## ##      We randomize it completely and test.

if (! require(gdxrrw))      stop ("gdxrrw package is not available")
if (0 == igdx(silent=TRUE)) stop ("the gdx shared library has not been loaded")

testName <- 'unordered variable writes'
logFile <- 'diffLog.txt'
iCard <- 2
fCard <- 5
n <- 10

errFunc <- function(ex) {
  print (paste0("test of wgdx on ",testName,": FAILED"))
  print (paste("Check file", logFile, "for possible gdxdiff output"))
  print (ex)
  FALSE
} # errFunc

tryCatch({
  print (paste("testing wgdx on", testName))
  wgdx('?')
  fnWant <- "tVar2d.gdx"
  fnOut <- "tmp.gdx"
  if (! file_test ('-f', fnWant)) {
    stop (paste("FAIL: File-to-duplicate", fnWant, "does not exist"))
  }

  ## 0. first generate things nice and ordered and simple
  print ("case 0: easy, ordered, simple")
  nrow <- iCard * iCard * fCard
  val0 <- matrix(0,nrow=nrow,ncol=4)
  irow <- 0
  for (i in 1:iCard) {
    for (j in 1:iCard) {

      ## level: v.l(i,j) = n * ord(i) + ord(j);
      lev <- n * i + j
      irow <- irow + 1
      val0[irow,1] <- i
      val0[irow,2] <- j
      val0[irow,3] <- 1
      val0[irow,4] <- lev

      ## marginal: v.m(i,j) = ord(j);
      irow <- irow + 1
      val0[irow,1] <- i
      val0[irow,2] <- j
      val0[irow,3] <- 2
      val0[irow,4] <- j

      ## lo: v.lo(i,j) = v.l(i,j) - 1;
      irow <- irow + 1
      val0[irow,1] <- i
      val0[irow,2] <- j
      val0[irow,3] <- 3
      val0[irow,4] <- lev-1

      ## up: v.up(i,j) = v.l(i,j) * 2;
      irow <- irow + 1
      val0[irow,1] <- i
      val0[irow,2] <- j
      val0[irow,3] <- 4
      val0[irow,4] <- lev*2

      ## scale: v.scale(i,j) = ord(i);
      irow <- irow + 1
      val0[irow,1] <- i
      val0[irow,2] <- j
      val0[irow,3] <- 5
      val0[irow,4] <- i

    }                                   # j loop
  }                                     # i loop
  if (irow != nrow)
    error ("bad test implementation");
  iUels <- c("i1","i2")
  fUels <- c("l", "m", "lo", "up", "s")
  uels0 <- list(iUels,iUels,fUels)

  vOut <- list(name='v',type='variable',val=val0,uels=uels0,varTypeText='free',typeCode=5)
  wgdx (fnOut, vOut)
  if (file_test ('-f', fnOut) == TRUE) {
    print (paste("File", fnOut, "was created"))
  } else {
    stop (paste("FAIL: File", fnOut, "is not readable"))
  }
  rc <- system2 ("gdxdiff",args=c(fnWant, fnOut, "id=v"), stdout=logFile)
  if (0 != rc) {
    stop(paste("Bad return from gdxdiff: wanted 0, got",rc))
  } else {
    print ("gdxdiff call succeeded")
  }

  ## 1. swap order in 2nd dim: 1 -> "i2", 2 -> "i1
  print ("case 1: swap order of UELs in 2nd dim of variable")
  iiUels <- c('i2','i1')
  uels1 <- list(iUels, iiUels, fUels)
  val1 <- val0
  for (irow in 1:nrow) {
    if (1 == val1[irow,2]) {            # was 1 -> 'i1' in iUels
      val1[irow,2] <- 2                 # now 2 -> 'i1' in iiUels
    }
    else if (2 == val1[irow,2]) {       # was 2 -> 'i2' in iUels
      val1[irow,2] <- 1                 # now 1 -> 'i2' in iiUels
    }
    else {
      error ('bad test implementation');
    }
  }
  vOut <- list(name='v',type='variable',val=val1,uels=uels1,varTypeText='free',typeCode=5)
  wgdx (fnOut, vOut)
  if (file_test ('-f', fnOut) == TRUE) {
    print (paste("File", fnOut, "was created"))
  } else {
    stop (paste("FAIL: File", fnOut, "is not readable"))
  }
  rc <- system2 ("gdxdiff",args=c(fnWant, fnOut, "id=v"), stdout=logFile)
  if (0 != rc) {
    stop(paste("Bad return from gdxdiff: wanted 0, got",rc))
  } else {
    print ("gdxdiff call succeeded")
  }
  ## will not work if we adjust vals and not uels
  vOut <- list(name='v',type='variable',val=val1,uels=uels0,varTypeText='free',typeCode=5)
  wgdx (fnOut, vOut)
  if (file_test ('-f', fnOut) == TRUE) {
    print (paste("File", fnOut, "was created"))
  } else {
    stop (paste("FAIL: File", fnOut, "is not readable"))
  }
  rc <- system2 ("gdxdiff",args=c(fnWant, fnOut, "id=v"), stdout=logFile)
  if (0 == rc) {
    stop(paste("Bad return from gdxdiff: wanted nonzero indicating different content"))
  } else {
    print ("gdxdiff call indicated different content as expected")
  }


  ## 2. change field mapping, from
  ##       (1,2,3,4,5) -> ("l","m","lo","up","s")
  ##    to
  ##       (500,600,700,800,801) -> ('lo','up','s','M','L')
  print ("case 2: goofy indexing for 'field' column of $val")
  ffUels <- vector(mode="character",length=1000)
  ffMap <- vector(mode="integer",length=fCard)
  ffUels[500] <- 'lo' ; ffMap[3] <- 500
  ffUels[600] <- 'up' ; ffMap[4] <- 600
  ffUels[700] <- 's'  ; ffMap[5] <- 700
  ffUels[800] <- 'M'  ; ffMap[2] <- 800
  ffUels[801] <- 'L'  ; ffMap[1] <- 801
  uels2 <- list(iUels, iiUels, ffUels)
  val2 <- val1
  for (irow in 1:nrow) {
    val2[irow,3] <- ffMap[val1[irow,3]]
  }

  vOut <- list(name='v',type='variable',val=val2,uels=uels1,varTypeText='free',typeCode=5)
  ## will not work if we adjust vals and not uels, should raise exception
  msg <- "wgdx test with bogus field specifiers should raise exception"
  tcr <- tryCatch({
    wgdx (fnOut, vOut) ; FALSE          # should not complete this branch
  },
    error = function(e) { print(paste(' Caught expected error: msg =',e)) ; TRUE }
  )
  if (tcr) {
    print(paste0(msg,": as expected, passed"))
  }
  else {
    stop (paste0(msg, ": not expected, failed"))
  }
  vOut <- list(name='v',type='variable',val=val2,uels=uels2,varTypeText='free',typeCode=5)
  wgdx (fnOut, vOut)
  if (file_test ('-f', fnOut) == TRUE) {
    print (paste("File", fnOut, "was created"))
  } else {
    stop (paste("FAIL: File", fnOut, "is not readable"))
  }
  rc <- system2 ("gdxdiff",args=c(fnWant, fnOut, "id=v"), stdout=logFile)
  if (0 != rc) {
    stop(paste("Bad return from gdxdiff: wanted 0, got",rc))
  } else {
    print ("gdxdiff call succeeded")
  }

  ##   3. Usually, the 'val' matrix will be ordered.  But it doesn't have to be.
  ##      We randomize it completely and test.
  print ("case 3: permute the rows in the $val matrix from case 2")

  ## first compute a reproducible permutation of 1..nrow
  set.seed (525)
  perm <- sample.int(nrow)
  val3 <- matrix(0,nrow=nrow,ncol=4)

  for (irow in 1:nrow) {
    val3[perm[irow],] <- val2[irow,]
  }  # irow loop
  ## just to try it, we'll make val3 an integer matrix, not a double one
  storage.mode(val3) <- "integer"
  ## if we only change ordering of rows in val, no other change is necessary in vOut
  vOut <- list(name='v',type='variable',val=val3,uels=uels2,varTypeText='free',typeCode=5)
  wgdx (fnOut, vOut)
  if (file_test ('-f', fnOut) == TRUE) {
    print (paste("File", fnOut, "was created"))
  } else {
    stop (paste("FAIL: File", fnOut, "is not readable"))
  }
  rc <- system2 ("gdxdiff",args=c(fnWant, fnOut, "id=v"), stdout=logFile)
  if (0 != rc) {
    stop(paste("Bad return from gdxdiff: wanted 0, got",rc))
  } else {
    print ("gdxdiff call succeeded")
  }

  val3 <- val3 * 0L
  for (irow in 1:nrow) {
    val3[irow,] <- val2[perm[irow],]
  }  # irow loop
  ## just to try it, we'll make val3 an integer matrix, not a double one
  storage.mode(val3) <- "integer"
  ## if we only change ordering of rows in val, no other change is necessary in vOut
  vOut <- list(name='v',type='variable',val=val3,uels=uels2,varTypeText='free',typeCode=5)
  wgdx (fnOut, vOut)
  if (file_test ('-f', fnOut) == TRUE) {
    print (paste("File", fnOut, "was created"))
  } else {
    stop (paste("FAIL: File", fnOut, "is not readable"))
  }
  rc <- system2 ("gdxdiff",args=c(fnWant, fnOut, "id=v"), stdout=logFile)
  if (0 != rc) {
    stop(paste("Bad return from gdxdiff: wanted 0, got",rc))
  } else {
    print ("gdxdiff call succeeded")
  }

  print (paste0("test of wgdx on ", testName, ": PASSED"))
  suppressWarnings(file.remove(logFile))
  invisible(TRUE)   ## all tests passed: return TRUE
},

error = errFunc
)

### Test rgdx on all the transport data using full reads and no filter
### N.B.  This test depends on the domain info in the GDX file
### wanted lists produced with    dump("listName",file="")

if (! require(gdxrrw))      stop ("gdxrrw package is not available")
if (0 == igdx(silent=TRUE)) stop ("the gdx shared library has not been loaded")

source ("chkSame.R")

iUels <- c("seattle", "san-diego")
iCard <- length(iUels)
jUels <- c("new-york", "chicago", "topeka")
jCard <- length(jUels)
uUels <- c(iUels, jUels)
uCard <- length(uUels)

iVals <- matrix(0, nrow=uCard, ncol=1, dimnames=list(uUels)) ; iVals[iUels,1] <- 1
jVals <- matrix(0, nrow=uCard, ncol=1, dimnames=list(uUels)) ; jVals[jUels,1] <- 1
aVals <- matrix(c(350,600), nrow=iCard, ncol=1, dimnames=list(iUels,NULL))
bVals <- matrix(c(325,300,275), nrow=jCard, ncol=1, dimnames=list(jUels,NULL))

dVals <- matrix(c(2.5, 1.7, 1.8,
                  2.5, 1.8, 1.4), nrow=iCard, ncol=jCard,
                dimnames=list(iUels,jUels), byrow=TRUE)
cVals <- dVals * 90 / 1000


tryCatch({
  fn <- "trnsport.gdx"
  print ("Test rgdx with form='full' and no filter,")
  print ("using the transport data as the input")
  rgdx('?')

  u <- rgdx('trnsport')
  uwant <- list(name="*", type="set", dim=1,
                val=NULL,
                form=NULL,
                uels=uUels)
  chk <- chkRgdxRes (u, uwant)
  if (!chk$same) {
    stop (paste("test rgdx('gdxname') to read universe failed",chk$msg))
  }
  print ("Done reading universe")

  i <- rgdx('trnsport',list(name='i',form='full'))
  iwant <- list(name="i", type="set", dim=1,
                val=iVals,
                form="full",
                uels=list(uUels),
                domains=c("*"))
  chk <- chkRgdxRes (i, iwant)
  if (!chk$same) {
    stop (paste("test rgdx(i,form=full) failed",chk$msg))
  }
  print ("Done reading set i")

  j <- rgdx('trnsport',list(name='j',form='full'))
  jwant <- list(name="j", type="set", dim=1,
                val=jVals,
                form="full",
                uels=list(uUels),
                domains=c("*"))
  chk <- chkRgdxRes (j, jwant)
  if (!chk$same) {
    stop (paste("test rgdx(j,form=full) failed",chk$msg))
  }
  print ("Done reading set j")

  f <- rgdx('trnsport',list(name='f',form='full'))
  fwant <- list(name="f", type="parameter", dim=0,
                val=90,
                form="full",
                uels=list(),
                domains=character(0) )
  chk <- chkRgdxRes (f, fwant)
  if (!chk$same) {
    stop (paste("test rgdx(f,form=full) failed",chk$msg))
  }
  print ("Done reading scalar f")

  a <- rgdx('trnsport',list(name='a',form='full'))
  awant <- list(name="a", type="parameter", dim=1,
                val=aVals,
                form="full",
                uels=list(iUels),
                domains=c("i") )
  chk <- chkRgdxRes (a, awant)
  if (!chk$same) {
    stop (paste("test rgdx(a,form='full') failed",chk$msg))
  }
  print ("Done reading parameter a")

  b <- rgdx('trnsport',list(name='b',form='full'))
  bwant <- list(name="b", type="parameter", dim=1,
                val=bVals,
                form="full",
                uels=list(jUels),
                domains=c('j') )
  chk <- chkRgdxRes (b, bwant)
  if (!chk$same) {
    stop (paste("test rgdx(b,form='full') failed",chk$msg))
  }
  print ("Done reading parameter b")

  c <- rgdx('trnsport',list(name='c',form='full'))
  cwant <- list(name="c", type="parameter", dim=2,
                val=cVals,
                form="full",
                uels=list(iUels,jUels),
                domains=c("i","j") )
  chk <- chkRgdxRes (c, cwant)
  if (!chk$same) {
    stop (paste("test rgdx(c,form='full') failed",chk$msg))
  }
  print ("Done reading parameter c")


  print ("Successfully completed tests")
  return (TRUE)
}

, error = function(ex) { print(ex) ; return (FALSE) }
)

### Test wgdx.reshape

source ("chkSame.R")

tryCatch({
  print ("test wgdx.reshape")

  # start with a dataframe as you might read it with read.delim
  df <-
structure(list(hdrA = structure(c(2L, 2L, 2L, 1L, 1L, 1L), .Label = c("crn",
"wht"), class = "factor"), hdrB = c(100, 200, 300, 400, 500,
600), hdrC = c(1, 2, 3, 4, 5, 6), hdrD = c(1.4, 2.4, 3.4,
4.4, 5.4, 6.4), hdrE = c(1.5, 2.5, 3.5, 4.5, 5.5, 6.5)),
.Names = c("hdrA", "hdrB", "hdrC", "hdrD", "hdrE"),
row.names = c(NA, -6L), class = "data.frame", symName = "defName")

  # df has one factor column => one existing index.  The next two
  # columns are integer and could be viewed as data or index columns.
  # The final columns are double and will be data columns.  So this
  # could be a 2-, 3-, or 4-dimensional parameter

  lstA <- structure(list(name = "hdrA", type = "set", uels = list(c("crn",
"wht"))), .Names = c("name", "type", "uels"))
  lstB <- structure(list(name = "hdrB", type = "set", uels = list(c("100",
"200","300","400","500","600"))), .Names = c("name", "type", "uels"))
  lstC <- structure(list(name = "hdrC", type = "set", uels = list(c("1",
"2","3","4","5","6"))), .Names = c("name", "type", "uels"))

  ## -----------------------------------------------------------------------------
  ## test1: simple call, symDim=2
  lst1 <- wgdx.reshape (df, 2)
  if (! chkLists ("test1 index 1", lst1[[1]], lstA))
    stop ("test1: index set 1 'hdrA' failed check");
  lstT1 <- structure(list(
                          name = "time", type = "set",
                          uels = list(c("hdrB", "hdrC", "hdrD", "hdrE"))),
                     .Names = c("name", "type", "uels"))
  if (! chkLists ("test1 index 2(time agg)", lst1[[2]], lstT1))
    stop ("test1: index set 2 'time' failed check");
  df1_ <- structure(list(hdrA = structure(c(2L, 2L, 2L, 1L, 1L, 1L, 2L,
2L, 2L, 1L, 1L, 1L, 2L, 2L, 2L, 1L, 1L, 1L, 2L, 2L, 2L, 1L, 1L,
1L), class = "factor", .Label = c("crn", "wht")), time = structure(c(1L,
1L, 1L, 1L, 1L, 1L, 2L, 2L, 2L, 2L, 2L, 2L, 3L, 3L, 3L, 3L, 3L,
3L, 4L, 4L, 4L, 4L, 4L, 4L), .Label = c("hdrB", "hdrC", "hdrD",
"hdrE"), class = "factor"), value = c(100, 200, 300, 400, 500,
600, 1, 2, 3, 4, 5, 6, 1.4, 2.4, 3.4, 4.4, 5.4, 6.4, 1.5, 2.5,
3.5, 4.5, 5.5, 6.5)), .Names = c("hdrA", "time", "value"), row.names = c(NA,
-24L), class = "data.frame", symName = "defName")
  if (! chkFrames ("test1 df", lst1[[3]], df1_))
    stop ("test1: data frame failed check");


  ## -----------------------------------------------------------------------------
  ## test2: simple call, symDim=3
  lst2 <- wgdx.reshape (df, 3)
  if (! chkLists ("test2 index 1", lst2[[1]], lstA))
    stop ("test2: index set 1 'hdrA' failed check");
  if (! chkLists ("test2 index 2", lst2[[2]], lstB))
    stop ("test2: index set 2 'hdrB' failed check");
  lstT2 <- structure(list(
                         name = "time", type = "set",
                         uels = list(c("hdrC", "hdrD", "hdrE"))),
                    .Names = c("name", "type", "uels"))
  if (! chkLists ("test2 index 3(time agg)", lst2[[3]], lstT2))
    stop ("test2: index set 3 'time' failed check");
df2_ <-
structure(list(hdrA = structure(c(2L, 2L, 2L, 1L, 1L, 1L, 2L,
2L, 2L, 1L, 1L, 1L, 2L, 2L, 2L, 1L, 1L, 1L), class = "factor", .Label = c("crn",
"wht")), hdrB = structure(c(1L, 2L, 3L, 4L, 5L, 6L, 1L, 2L, 3L,
4L, 5L, 6L, 1L, 2L, 3L, 4L, 5L, 6L), class = "factor", .Label = c("100",
"200", "300", "400", "500", "600")), time = structure(c(1L, 1L,
1L, 1L, 1L, 1L, 2L, 2L, 2L, 2L, 2L, 2L, 3L, 3L, 3L, 3L, 3L, 3L
), .Label = c("hdrC", "hdrD", "hdrE"), class = "factor"), value = c(1,
2, 3, 4, 5, 6, 1.4, 2.4, 3.4, 4.4, 5.4, 6.4, 1.5, 2.5, 3.5, 4.5,
5.5, 6.5)), .Names = c("hdrA", "hdrB", "time", "value"), row.names = c(NA,
-18L), class = "data.frame", symName = "defName")
  if (! chkFrames ("test2 df", lst2[[4]], df2_))
    stop ("test2: data frame failed check");


  ## -----------------------------------------------------------------------------
  ## test3: simple call, symDim=4
  lst3 <- wgdx.reshape (df, 4)
  if (! chkLists ("test3 index 1", lst3[[1]], lstA))
    stop ("test3: index set 1 'hdrA' failed check");
  if (! chkLists ("test3 index 2", lst3[[2]], lstB))
    stop ("test3: index set 2 'hdrB' failed check");
  if (! chkLists ("test3 index 3", lst3[[3]], lstC))
    stop ("test3: index set 3 'hdrC' failed check");
  lstT3 <- structure(list(
                         name = "time", type = "set",
                         uels = list(c("hdrD", "hdrE"))),
                    .Names = c("name", "type", "uels"))
  if (! chkLists ("test3 index 4(time agg)", lst3[[4]], lstT3))
    stop ("test3: index set 4 'time' failed check");
df3_ <-
structure(list(hdrA = structure(c(2L, 2L, 2L, 1L, 1L, 1L, 2L,
2L, 2L, 1L, 1L, 1L), class = "factor", .Label = c("crn", "wht"
)), hdrB = structure(c(1L, 2L, 3L, 4L, 5L, 6L, 1L, 2L, 3L, 4L,
5L, 6L), class = "factor", .Label = c("100", "200", "300", "400",
"500", "600")), hdrC = structure(c(1L, 2L, 3L, 4L, 5L, 6L, 1L,
2L, 3L, 4L, 5L, 6L), class = "factor", .Label = c("1", "2", "3",
"4", "5", "6")), time = structure(c(1L, 1L, 1L, 1L, 1L, 1L, 2L,
2L, 2L, 2L, 2L, 2L), .Label = c("hdrD", "hdrE"), class = "factor"),
    value = c(1.4, 2.4, 3.4, 4.4, 5.4, 6.4, 1.5, 2.5, 3.5, 4.5,
    5.5, 6.5)), .Names = c("hdrA", "hdrB", "hdrC", "time", "value"
), row.names = c(NA, -12L), class = "data.frame", symName = "defName")
  if (! chkFrames ("test3 df", lst3[[5]], df3_))
    stop ("test3: data frame failed check");


  ## -----------------------------------------------------------------------------
  ## test4: use optional args symName and tName
  lst4 <- wgdx.reshape (df, 4, tName = 'leftovers', symName = 'mySymName')
  if (! chkLists ("test4 index 1", lst4[[1]], lstA))
    stop ("test4: index set 1 'hdrA' failed check");
  if (! chkLists ("test3 index 2", lst4[[2]], lstB))
    stop ("test4: index set 2 'hdrB' failed check");
  if (! chkLists ("test3 index 3", lst4[[3]], lstC))
    stop ("test4: index set 3 'hdrC' failed check");
  lstT4 <- lstT3
  lstT4$name <- 'leftovers'
  if (! chkLists ("test4 index 4(time agg)", lst4[[4]], lstT4))
    stop ("test4: index set 4 'time' failed check");
  df4_ <- df3_
  attr(df4_,"symName") <- 'mySymName'
  names(df4_)[[4]] <- 'leftovers'
  if (! chkFrames ("test4 df", lst4[[5]], df4_))
    stop ("test4: data frame failed check");


  ## -----------------------------------------------------------------------------
  ## test5: use optional arg setsToo=FALSE
  lst5 <- wgdx.reshape (df, 4, setsToo = FALSE)
  if (1 != length(lst5))
    stop ("test5: expected a return list of length 1 with setsToo = FALSE");
  ## should be the same data as test 3
  if (! chkFrames ("test5 df", lst5[[1]], df3_))
    stop ("test5: data frame failed check");


  ## -----------------------------------------------------------------------------
  ## test6: use optional arg setNames and attribute "ts",
  dfts <- df
  attr(dfts,"ts") <- 'explanatory text for parameter'
  lst6 <- wgdx.reshape (dfts, 4, setNames = c("column A","column B","column C", "aggregated index"))
  lstAtxt <- lstA
  lstAtxt$ts <- "column A"
  if (! chkLists ("test6 index 1", lst6[[1]], lstAtxt))
    stop ("test6: index set 1 'hdrA' failed check");
  lstBtxt <- lstB
  lstBtxt$ts <- "column B"
  if (! chkLists ("test6 index 2", lst6[[2]], lstBtxt))
    stop ("test6: index set 2 'hdrB' failed check");
  lstCtxt <- lstC
  lstCtxt$ts <- "column C"
  if (! chkLists ("test6 index 3", lst6[[3]], lstCtxt))
    stop ("test6: index set 3 'hdrC' failed check");
  lstT6 <- lstT3
  lstT6$ts <- 'aggregated index'
  if (! chkLists ("test6 index 4(time agg)", lst6[[4]], lstT6))
    stop ("test6: index set 4 'time' failed check");
  df6_ <- df3_
  attr(df6_,"ts") <- 'explanatory text for parameter'
  if (! chkFrames ("test6 df", lst6[[5]], df6_))
    stop ("test6: data frame failed check");


  ## -----------------------------------------------------------------------------
  ## test7: use optional arg order, but set to reproduce the default order
  lst7 <- wgdx.reshape (df, 4, order = c(1,2,3,0))
  if (! chkLists ("test7 index 1", lst7[[1]], lstA))
    stop ("test7: index set 1 'hdrA' failed check");
  if (! chkLists ("test7 index 2", lst7[[2]], lstB))
    stop ("test7: index set 2 'hdrB' failed check");
  if (! chkLists ("test7 index 3", lst7[[3]], lstC))
    stop ("test7: index set 3 'hdrC' failed check");
  if (! chkLists ("test7 index 4(time agg)", lst7[[4]], lstT3))
    stop ("test7: index set 4 'time' failed check");
  if (! chkFrames ("test7 df", lst7[[5]], df3_))
    stop ("test7: data frame failed check");


  ## -----------------------------------------------------------------------------
  ## test8: use optional arg order to get defName(hdrA, hdrC, time)
  lst8 <- wgdx.reshape (df, 3, order = c(1,3,0))
  if (! chkLists ("test8 index 1", lst8[[1]], lstA))
    stop ("test8: index set 1 'hdrA' failed check");
  if (! chkLists ("test8 index 2", lst8[[2]], lstC))
    stop ("test8: index set 2 'hdrC' failed check");
  lstT8 <- structure(list(
                         name = "time", type = "set",
                         uels = list(c("hdrB", "hdrD", "hdrE"))),
                    .Names = c("name", "type", "uels"))
  if (! chkLists ("test8 index 3(time agg)", lst8[[3]], lstT8))
    stop ("test8: index set 3 'time' failed check");
df8_ <-
structure(list(hdrA = structure(c(2L, 2L, 2L, 1L, 1L, 1L,
2L, 2L, 2L, 1L, 1L, 1L, 2L, 2L, 2L, 1L, 1L, 1L), class = "factor", .Label = c("crn",
"wht")), hdrC = structure(c(1L, 2L, 3L, 4L, 5L, 6L, 1L, 2L, 3L,
4L, 5L, 6L, 1L, 2L, 3L, 4L, 5L, 6L), class = "factor", .Label = c("1",
"2", "3", "4", "5", "6")), time = structure(c(1L, 1L, 1L, 1L,
1L, 1L, 2L, 2L, 2L, 2L, 2L, 2L, 3L, 3L, 3L, 3L, 3L, 3L), .Label = c("hdrB",
"hdrD", "hdrE"), class = "factor"), value = c(100, 200, 300,
400, 500, 600, 1.4, 2.4, 3.4, 4.4, 5.4, 6.4, 1.5, 2.5, 3.5, 4.5,
5.5, 6.5)), .Names = c("hdrA", "hdrC", "time", "value"), row.names = c(NA,
-18L), class = "data.frame", symName = "defName")
  if (! chkFrames ("test8 df", lst8[[4]], df8_))
    stop ("test8: data frame failed check");


  ## -----------------------------------------------------------------------------
  ## test9: use optional arg order to get defName(hdrC, hdrA, time)
  lst9 <- wgdx.reshape (df, 3, order = c(3,1,0))
  if (! chkLists ("test9 index 1", lst9[[1]], lstC))
    stop ("test9: index set 1 'hdrC' failed check");
  if (! chkLists ("test8 index 2", lst9[[2]], lstA))
    stop ("test9: index set 2 'hdrA' failed check");
  if (! chkLists ("test9 index 3(time agg)", lst9[[3]], lstT8))
    stop ("test9: index set 3 'time' failed check");
df9_ <-
structure(list(hdrC = structure(c(1L, 2L, 3L, 4L, 5L, 6L, 1L,
2L, 3L, 4L, 5L, 6L, 1L, 2L, 3L, 4L, 5L, 6L), class = "factor", .Label = c("1",
"2", "3", "4", "5", "6")), hdrA = structure(c(2L, 2L, 2L, 1L,
1L, 1L, 2L, 2L, 2L, 1L, 1L, 1L, 2L, 2L, 2L, 1L, 1L, 1L), class = "factor", .Label = c("crn",
"wht")), time = structure(c(1L, 1L, 1L, 1L, 1L, 1L, 2L, 2L, 2L,
2L, 2L, 2L, 3L, 3L, 3L, 3L, 3L, 3L), .Label = c("hdrB", "hdrD",
"hdrE"), class = "factor"), value = c(100, 200, 300, 400, 500,
600, 1.4, 2.4, 3.4, 4.4, 5.4, 6.4, 1.5, 2.5, 3.5, 4.5, 5.5, 6.5
)), .Names = c("hdrC", "hdrA", "time", "value"), row.names = c(NA,
-18L), class = "data.frame", symName = "defName")
  if (! chkFrames ("test9 df", lst9[[4]], df9_))
    stop ("test9: data frame failed check");


  ## -----------------------------------------------------------------------------
  print ("all tests for wgdx.reshape passed")
  return (TRUE)
}

, error = function(ex) { print(ex) ; return (FALSE) }
)

### Test wgdx
# We write all the transport data using full writes and universe
# subsets, with or without values

tryCatch({

  fn <- "twd2.gdx"

  print ("Test wgdx with form='full' and universe subsets,")
  print ("using the transport data as the output target")
  wgdx('?')

  # set i: supply nodes
  si <- list(c("seattle", "san-diego"))

  # set j: demand nodes
  sj <- list(c("new-york", "chicago", "topeka"))

  iv <- as.array(c(1,1))
  ilst <- list (name='i', type='set', dim=1, form='full', ts='canning plants', val=iv, uels=c(si))

  jlst <- list (name='j', type='set', form='full', ts='markets', uels=c(sj))

  av <- as.array(c(350,600))
  alst <- list (name='a', type='parameter', dim=1, form='full',
                ts='capacity of plant i in cases', val=av, uels=c(si))

  bv <- as.array(c(325,300,275))
  blst <- list (name='b', type='parameter', form='full',
                ts='demand at market j in cases', val=bv, uels=c(sj))

  f <- 90
  d <- matrix(c(2.5, 1.7, 1.8,
                2.5, 1.8, 1.4),  c(2,3), byrow=TRUE)
  c <- d * f / 1000

  clst <- list (name='c', type='parameter', dim=2, form='full',
                ts='transport cost in thousands of dollars per case', val=c, uels=c(si,sj))
  dlst <- list (name='d', type='parameter', form='full',
                ts='distance in thousands of miles', val=d, uels=c(si,sj))

  flst <- list (name='f', type='parameter', form='full',
                ts='freight in dollars per case per thousand miles', val=f)

  wgdx (fn, ilst, jlst, alst, blst, clst, dlst, flst)

  if (file_test ('-f', fn) == TRUE) {
    print (paste("File", fn, "was created"))
  } else {
    stop (paste("FAIL: File", fn, "is not readable"))
  }
  rc <- system (paste("gdxdiff trnsport.gdx",fn,"releps=1e-15 id=i,j,a,b,c,d,f"))
  if (0 != rc) {
    stop(paste("Bad return from gdxdiff: wanted 0, got",rc))
  } else {
    print ("gdxdiff call succeeded")
  }
  return (TRUE)
}

, error = function(ex) { print(ex) ; return (FALSE) }
)

### Test gdxInfo
# with returnDF=TRUE we get data frames with symbol info for the transport data

if (! require(gdxrrw))      stop ("gdxrrw package is not available")
if (0 == igdx(silent=TRUE)) stop ("the gdx shared library has not been loaded")

# compare the data frames f1 and f2, return TRUE if the same, FALSE o/w
chkFrame <- function(s, f1, f2) {
  if (! is.data.frame(f1))   return (FALSE)
  if (! is.data.frame(f2))   return (FALSE)
  nc     <- ncol(f1)
  if (nc != ncol(f2))     return (FALSE)
  nr     <- nrow(f1)
  if (nr != nrow(f2))     return (FALSE)
  if (nr == 0)            return (TRUE)
  for (k in c(1:nr)) {
    if (f1[k,"name"] != f2[k,"name"]) {
      print (paste("checking", s, ": item", k, "name is wrong"))
      return (FALSE)
    }
    if (f1[k,"index"] != f2[k,"index"]) {
      print (paste("checking", s, ": item", k, "index is wrong"))
      return (FALSE)
    }
    if (f1[k,"dim"] != f2[k,"dim"]) {
      print (paste("checking", s, ": item", k, "dim is wrong"))
      return (FALSE)
    }
    if (f1[k,"card"] != f2[k,"card"]) {
      print (paste("checking", s, ": item", k, "card is wrong"))
      return (FALSE)
    }
    if (! (is.null(f1[k,"text"]) && is.null(f2[k,"text"]))) {
      if (f1[k,"text"] != f2[k,"text"]) {
        print (paste("checking", s, ": item", k, "text is wrong"))
        return (FALSE)
      }
    }
    f1d <- f1[k,"doms"][[1]]
    f2d <- f2[k,"doms"][[1]]
    if (length(f1d) != length(f2d)) {
      print (paste("checking", s, ": item", k, "doms length is wrong"))
      return (FALSE)
    }
    n <- length(f1d)
    if (n > 0) {
      for (kk in c(1:n)) {
        if (f1d[kk] != f2d[kk]) {
          print (paste("checking", s, ": item", k, "doms is wrong"))
          return (FALSE)
        }
      }
    }
  }
  return (TRUE)
} # chkFrame

# compare the data frames f1 and f2, return TRUE if the same, FALSE o/w
chkVarEqu <- function(s, f1, f2) {
  if (! is.data.frame(f1))   return (FALSE)
  if (! is.data.frame(f2))   return (FALSE)
  nc     <- ncol(f1)
  if (nc != ncol(f2))     return (FALSE)
  nr     <- nrow(f1)
  if (nr != nrow(f2))     return (FALSE)
  if (nr == 0)            return (TRUE)
  for (k in c(1:nr)) {
    if (f1[k,"name"] != f2[k,"name"]) {
      print (paste("checking", s, ": item", k, "name is wrong"))
      return (FALSE)
    }
    if (f1[k,"index"] != f2[k,"index"]) {
      print (paste("checking", s, ": item", k, "index is wrong"))
      return (FALSE)
    }
    if (f1[k,"dim"] != f2[k,"dim"]) {
      print (paste("checking", s, ": item", k, "dim is wrong"))
      return (FALSE)
    }
    if (f1[k,"card"] != f2[k,"card"]) {
      print (paste("checking", s, ": item", k, "card is wrong"))
      return (FALSE)
    }
    if (! (is.null(f1[k,"text"]) && is.null(f2[k,"text"]))) {
      print ("unchecked text")
      return (FALSE)
    }
    f1d <- f1[k,"doms"][[1]]
    f2d <- f2[k,"doms"][[1]]
    if (length(f1d) != length(f2d)) {
      print (paste("checking", s, ": item", k, "doms length is wrong"))
      return (FALSE)
    }
    n <- length(f1d)
    if (n > 0) {
      for (kk in c(1:n)) {
        if (f1d[kk] != f2d[kk]) {
          print (paste("checking", s, ": item", k, "doms is wrong"))
          return (FALSE)
        }
      }
    }
  }
  return (TRUE)
} # chkVarEqu

tryCatch({

  fn <- "trnsport.gdx"
  s <- gdxInfo (fn, dump=FALSE, returnDF=TRUE)

  if (!is.list(s))
    stop ("Expected gdxInfo output to be in list form")
  if (10 != length(s))
    stop ("Expected gdxInfo output to have length 10")
  if (12 != s$symCount)
    stop ("gdxInfo: expected trnsport symCount==12")
  if (5 != s$uelCount)
    stop ("gdxInfo: expected trnsport uelCount==5")

  s_sets <- structure(list(
          name = c("i", "j"),
          index = c(1, 2),
          dim = c(1, 1),
          card = c(2, 3),
          text = c("canning plants", "markets"),
          doms = c("0", "0")),
      .Names = c("name", "index", "dim", "card", "text", "doms"),
      row.names = 1:2, class = "data.frame")

  s_parameters <- structure(list(
    name = c("a", "b", "d", "f", "c"),
    index = 3:7,
    dim = c(1L, 1L, 2L, 0L, 2L),
    card = c(2L, 3L, 6L, 1L, 6L),
    text = c("capacity of plant i in cases", "demand at market j in cases", 
      "distance in thousands of miles", "freight in dollars per case per thousand miles", 
      "transport cost in thousands of dollars per case"),
    doms = structure(list(1L, 2L, 1:2, integer(0), 1:2), class = "AsIs")),
  .Names = c("name", "index", "dim", "card", "text", "doms"),
  row.names = c(NA, 5L), class = "data.frame")

  s_variables <- structure(list(
    name = c("x", "z"),
    index = 8:9,
    dim = c(2L, 0L),
    card = c(6L, 1L),
    doms = structure(list(1:2, integer(0)), class = "AsIs")),
  .Names = c("name", "index", "dim", "card", "doms"),
  row.names = 1:2, class = "data.frame")

  s_equations <- structure(list(
    name = c("cost", "supply", "demand"),
    index = 10:12,
    dim = c(0L, 1L, 1L),
    card = 1:3,
    doms = structure(list(integer(0), 1L, 2L), class = "AsIs")),
  .Names = c("name", "index", "dim", "card", "doms"),
  row.names = c(NA, 3L), class = "data.frame")

  if (! chkFrame("sets", s_sets, s$sets))
    stop ("gdxInfo: s$sets for trnsport is bogus")
  if (! chkFrame("parameters", s_parameters, s$parameters))
    stop ("gdxInfo: s$parameters for trnsport is bogus")
  if (! chkFrame("variables", s_variables, s$variables))
    stop ("gdxInfo: s$variables for trnsport is bogus")
  if (! chkFrame("equations", s_equations, s$equations))
    stop ("gdxInfo: s$equations for trnsport is bogus")
  if (0 != nrow(s$aliases))
    stop ("gdxInfo: s$aliases for trnsport is bogus")

  print ("Successfully completed gdxInfo test 2")
  return (TRUE)
}

, error = function(ex) { print(ex) ; return (FALSE) }
)

#### test rgdx reading a 0-dim variable
#### test form=['sparse','full'] X [filtered,unfiltered]
#### ['l','m','lo','up','s']

#### wanted lists can be produced with    dump("listName",file="")

if (! require(gdxrrw))      stop ("gdxrrw package is not available")
if (0 == igdx(silent=TRUE)) stop ("the gdx shared library has not been loaded")

source ("chkSame.R")
reqIdent <- TRUE

fields <- c('l','m','lo','up','s')
nFields <- length(fields)
userDomf <- c('_field')
lev <- 1
mar <- 2
low <- 3
upp <- 4
sca <- 5

tryCatch({
  print ("testing rgdx on variable reads")
  rgdx('?')
  fnIn <- "tReadVar0.gdx"
  if (! file_test ('-f', fnIn)) {
    stop (paste("FAIL: File", fnIn, "does not exist"))
  }

  ### ---------- reading form=sparse, no filter
  # all
  t <- matrix(c( lev,  24
                ,mar,  -1
                ,low,  0
                ,upp,  100
                ,sca,  10
               ), nrow=nFields, ncol=2, byrow=T)
  xwantA <- list(name='xpos0', type='variable', dim=0L,
                 val=t,
                 form='sparse', uels=list(fields),
                 domains=userDomf, domInfo="NA",
                 field='all',
                 varTypeText='positive', typeCode=GMS_VARTYPE$POSITIVE)
  x <- rgdx(fnIn,list(name='xpos0',form='sparse',field='all'))
  chk <- chkRgdxRes (x, xwantA, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(xpos0,'all',unfiltered) failed:",chk$msg))
  }
  x <- rgdx(fnIn,list(name='xpos0',form='sparse',field='all'),squeeze=F)
  chk <- chkRgdxRes (x, xwantA, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(xpos0,'all',unfiltered,squeeze=F) failed:",chk$msg))
  }
  t <- matrix(c( lev,  1
                ,mar,  0.5
                ,low,  1
                ,upp,  1
                ,sca,  1
               ), nrow=nFields, ncol=2, byrow=T)
  ywantA <- list(name='y0', type='variable', dim=0L,
                 val=t,
                 form='sparse', uels=list(fields),
                 domains=userDomf, domInfo="NA",
                 field='all',
                 varTypeText='binary', typeCode=GMS_VARTYPE$BINARY)
  y <- rgdx(fnIn,list(name='y0',form='sparse',field='alL'))
  chk <- chkRgdxRes (y, ywantA, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(y0,'all',unfiltered) failed:",chk$msg))
  }
  y <- rgdx(fnIn,list(name='y0',form='sparse',field='alL'),squeeze=F)
  chk <- chkRgdxRes (y, ywantA, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(y0,'all',unfiltered,squeeze=F) failed:",chk$msg))
  }
  t <- matrix(c( lev,  26
                ,mar,  0
                ,low,  -Inf
                ,upp,  +Inf
                ,sca,  1
               ), nrow=nFields, ncol=2, byrow=T)
  zwantA <- list(name='z', type='variable', dim=0L,
                 val=t,
                 form='sparse', uels=list(fields),
                 domains=userDomf, domInfo="NA",
                 field='all',
                 varTypeText='free', typeCode=GMS_VARTYPE$FREE)
  z <- rgdx(fnIn,list(name='z',form='sparse',field='all'))
  chk <- chkRgdxRes (z, zwantA, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(z,'all',unfiltered) failed:",chk$msg))
  }
  z <- rgdx(fnIn,list(name='z',form='sparse',field='all'),squeeze=F)
  chk <- chkRgdxRes (z, zwantA, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(z,'all',unfiltered,squeeze=F) failed:",chk$msg))
  }
  # level
  xwantL <- list(name='xpos0', type='variable', dim=0L,
                 val=matrix(24, nrow=1, ncol=1),
                 form='sparse', uels=list(),
                 domains=character(0), domInfo="NA",
                 field='l',
                 varTypeText='positive', typeCode=GMS_VARTYPE$POSITIVE)
  x <- rgdx(fnIn,list(name='xpos0',form='sparse',field='L'))
  chk <- chkRgdxRes (x, xwantL, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(xpos0,'L',unfiltered) failed:",chk$msg))
  }
  x <- rgdx(fnIn,list(name='xpos0',form='sparse',field='L'),squeeze=F)
  chk <- chkRgdxRes (x, xwantL, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(xpos0,'L',unfiltered,squeeze=F) failed:",chk$msg))
  }
  ywantL <- list(name='y0', type='variable', dim=0L,
                 val=matrix(1, nrow=1, ncol=1),
                 form='sparse', uels=list(),
                 domains=character(0), domInfo="NA",
                 field='l',
                 varTypeText='binary', typeCode=GMS_VARTYPE$BINARY)
  y <- rgdx(fnIn,list(name='y0',form='sparse',field='L'))
  chk <- chkRgdxRes (y, ywantL, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(y0,'L',unfiltered) failed:",chk$msg))
  }
  y <- rgdx(fnIn,list(name='y0',form='sparse',field='L'),squeeze=F)
  chk <- chkRgdxRes (y, ywantL, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(y0,'L',unfiltered,squeeze=F) failed:",chk$msg))
  }
  zwantL <- list(name='z', type='variable', dim=0L,
                 val=matrix(26, nrow=1, ncol=1),
                 form='sparse', uels=list(),
                 domains=character(0), domInfo="NA",
                 field='l',
                 varTypeText='free', typeCode=GMS_VARTYPE$FREE)
  z <- rgdx(fnIn,list(name='z',form='sparse',field='L'))
  chk <- chkRgdxRes (z, zwantL, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(z,'L',unfiltered) failed:",chk$msg))
  }
  z <- rgdx(fnIn,list(name='z',form='sparse',field='L'),squeeze=F)
  chk <- chkRgdxRes (z, zwantL, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(z,'L',unfiltered,squeeze=F) failed:",chk$msg))
  }
  # marginal
  xwantM <- list(name='xpos0', type='variable', dim=0L,
                 val=matrix(-1, nrow=1, ncol=1),
                 form='sparse', uels=list(),
                 domains=character(0), domInfo="NA",
                 field='m',
                 varTypeText='positive', typeCode=GMS_VARTYPE$POSITIVE)
  x <- rgdx(fnIn,list(name='xpos0',form='sparse',field='M'))
  chk <- chkRgdxRes (x, xwantM, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(xpos0,'M',unfiltered) failed:",chk$msg))
  }
  x <- rgdx(fnIn,list(name='xpos0',form='sparse',field='M'),squeeze=F)
  chk <- chkRgdxRes (x, xwantM, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(xpos0,'M',unfiltered,squeeze=F) failed:",chk$msg))
  }
  ywantM <- list(name='y0', type='variable', dim=0L,
                 val=matrix(0.5, nrow=1, ncol=1),
                 form='sparse', uels=list(),
                 domains=character(0), domInfo="NA",
                 field='m',
                 varTypeText='binary', typeCode=GMS_VARTYPE$BINARY)
  y <- rgdx(fnIn,list(name='y0',form='sparse',field='M'))
  chk <- chkRgdxRes (y, ywantM, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(y0,'M',unfiltered) failed:",chk$msg))
  }
  y <- rgdx(fnIn,list(name='y0',form='sparse',field='M'),squeeze=F)
  chk <- chkRgdxRes (y, ywantM, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(y0,'M',unfiltered,squeeze=F) failed:",chk$msg))
  }
  zwantM <- list(name='z', type='variable', dim=0L,
                 val=matrix(0, nrow=0, ncol=1),
                 form='sparse', uels=list(),
                 domains=character(0), domInfo="NA",
                 field='m',
                 varTypeText='free', typeCode=GMS_VARTYPE$FREE)
  z <- rgdx(fnIn,list(name='z',form='sparse',field='M'))
  chk <- chkRgdxRes (z, zwantM, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(z,'M',unfiltered) failed:",chk$msg))
  }
  zwantM$val <- matrix(0, nrow=1, ncol=1)
  z <- rgdx(fnIn,list(name='z',form='sparse',field='M'),squeeze=F)
  chk <- chkRgdxRes (z, zwantM, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(z,'M',unfiltered,squeeze=F) failed:",chk$msg))
  }
  # lower
  xwantLo <- list(name='xpos0', type='variable', dim=0L,
                  val=matrix(0, nrow=0, ncol=1),
                  form='sparse', uels=list(),
                  domains=character(0), domInfo="NA",
                  field='lo',
                  varTypeText='positive', typeCode=GMS_VARTYPE$POSITIVE)
  x <- rgdx(fnIn,list(name='xpos0',form='sparse',field='lo'))
  chk <- chkRgdxRes (x, xwantLo, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(xpos0,'lo',unfiltered) failed:",chk$msg))
  }
  xwantLo$val <- matrix(0, nrow=1, ncol=1)
  x <- rgdx(fnIn,list(name='xpos0',form='sparse',field='lo'),squeeze=F)
  chk <- chkRgdxRes (x, xwantLo, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(xpos0,'lo',unfiltered,squeeze=F) failed:",chk$msg))
  }
  ywantLo <- list(name='y0', type='variable', dim=0L,
                  val=matrix(1, nrow=1, ncol=1),
                  form='sparse', uels=list(),
                  domains=character(0), domInfo="NA",
                  field='lo',
                  varTypeText='binary', typeCode=GMS_VARTYPE$BINARY)
  y <- rgdx(fnIn,list(name='y0',form='sparse',field='lo'))
  chk <- chkRgdxRes (y, ywantLo, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(y0,'lo',unfiltered) failed:",chk$msg))
  }
  y <- rgdx(fnIn,list(name='y0',form='sparse',field='lo'),squeeze=F)
  chk <- chkRgdxRes (y, ywantLo, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(y0,'lo',unfiltered,squeeze=F) failed:",chk$msg))
  }
  zwantLo <- list(name='z', type='variable', dim=0L,
                  val=matrix(-Inf, nrow=0, ncol=1),
                  form='sparse', uels=list(),
                  domains=character(0), domInfo="NA",
                  field='lo',
                  varTypeText='free', typeCode=GMS_VARTYPE$FREE)
  z <- rgdx(fnIn,list(name='z',form='sparse',field='lo'))
  chk <- chkRgdxRes (z, zwantLo, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(z,'lo',unfiltered) failed:",chk$msg))
  }
  zwantLo$val <- matrix(-Inf, nrow=1, ncol=1)
  z <- rgdx(fnIn,list(name='z',form='sparse',field='lo'),squeeze=F)
  chk <- chkRgdxRes (z, zwantLo, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(z,'lo',unfiltered,squeeze=F) failed:",chk$msg))
  }
  # upper
  xwantUp <- list(name='xpos0', type='variable', dim=0L,
                  val=matrix(100, nrow=1, ncol=1),
                  form='sparse', uels=list(),
                  domains=character(0), domInfo="NA",
                  field='up',
                  varTypeText='positive', typeCode=GMS_VARTYPE$POSITIVE)
  x <- rgdx(fnIn,list(name='xpos0',form='sparse',field='up'))
  chk <- chkRgdxRes (x, xwantUp, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(xpos0,'up',unfiltered) failed:",chk$msg))
  }
  x <- rgdx(fnIn,list(name='xpos0',form='sparse',field='up'),squeeze=F)
  chk <- chkRgdxRes (x, xwantUp, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(xpos0,'up',unfiltered,squeeze=F) failed:",chk$msg))
  }
  ywantUp <- list(name='y0', type='variable', dim=0L,
                  val=matrix(1, nrow=0, ncol=1),
                  form='sparse', uels=list(),
                  domains=character(0), domInfo="NA",
                  field='up',
                  varTypeText='binary', typeCode=GMS_VARTYPE$BINARY)
  y <- rgdx(fnIn,list(name='y0',form='sparse',field='up'))
  chk <- chkRgdxRes (y, ywantUp, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(y0,'up',unfiltered) failed:",chk$msg))
  }
  ywantUp$val <- matrix(1, nrow=1, ncol=1)
  y <- rgdx(fnIn,list(name='y0',form='sparse',field='up'),squeeze=F)
  chk <- chkRgdxRes (y, ywantUp, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(y0,'up',unfiltered,squeeze=F) failed:",chk$msg))
  }
  zwantUp <- list(name='z', type='variable', dim=0L,
                  val=matrix(Inf, nrow=0, ncol=1),
                  form='sparse', uels=list(),
                  domains=character(0), domInfo="NA",
                  field='up',
                  varTypeText='free', typeCode=GMS_VARTYPE$FREE)
  z <- rgdx(fnIn,list(name='z',form='sparse',field='up'))
  chk <- chkRgdxRes (z, zwantUp, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(z,'up',unfiltered) failed:",chk$msg))
  }
  zwantUp$val <- matrix(Inf, nrow=1, ncol=1)
  z <- rgdx(fnIn,list(name='z',form='sparse',field='up'),squeeze=F)
  chk <- chkRgdxRes (z, zwantUp, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(z,'up',unfiltered,squeeze=F) failed:",chk$msg))
  }
  # scale
  xwantS <- list(name='xpos0', type='variable', dim=0L,
                 val=matrix(10, nrow=1, ncol=1),
                 form='sparse', uels=list(),
                 domains=character(0), domInfo="NA",
                 field='s',
                 varTypeText='positive', typeCode=GMS_VARTYPE$POSITIVE)
  x <- rgdx(fnIn,list(name='xpos0',form='sparse',field='s'))
  chk <- chkRgdxRes (x, xwantS, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(xpos0,'s',unfiltered) failed:",chk$msg))
  }
  x <- rgdx(fnIn,list(name='xpos0',form='sparse',field='s'),squeeze=F)
  chk <- chkRgdxRes (x, xwantS, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(xpos0,'s',unfiltered,squeeze=F) failed:",chk$msg))
  }
  ywantS <- list(name='y0', type='variable', dim=0L,
                 val=matrix(1, nrow=0, ncol=1),
                 form='sparse', uels=list(),
                 domains=character(0), domInfo="NA",
                 field='s',
                 varTypeText='binary', typeCode=GMS_VARTYPE$BINARY)
  y <- rgdx(fnIn,list(name='y0',form='sparse',field='s'))
  chk <- chkRgdxRes (y, ywantS, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(y0,'s',unfiltered) failed:",chk$msg))
  }
  ywantS$val <- matrix(1, nrow=1, ncol=1)
  y <- rgdx(fnIn,list(name='y0',form='sparse',field='s'),squeeze=F)
  chk <- chkRgdxRes (y, ywantS, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(y0,'s',unfiltered,squeeze=F) failed:",chk$msg))
  }
  zwantS <- list(name='z', type='variable', dim=0L,
                 val=matrix(1, nrow=0, ncol=1),
                 form='sparse', uels=list(),
                 domains=character(0), domInfo="NA",
                 field='s',
                 varTypeText='free', typeCode=GMS_VARTYPE$FREE)
  z <- rgdx(fnIn,list(name='z',form='sparse',field='s'))
  chk <- chkRgdxRes (z, zwantS, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(z,'s',unfiltered) failed:",chk$msg))
  }
  zwantS$val <- matrix(1, nrow=1, ncol=1)
  z <- rgdx(fnIn,list(name='z',form='sparse',field='s'),squeeze=F)
  chk <- chkRgdxRes (z, zwantS, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(z,'s',unfiltered,squeeze=F) failed:",chk$msg))
  }

  ### ---------- reading form=sparse, filtered
  f <- list()
  # all
  t <- matrix(c( lev,  24
                ,mar,  -1
                ,low,  0
                ,upp,  100
                ,sca,  10
               ), nrow=nFields, ncol=2, byrow=T)
  xwantA <- list(name='xpos0', type='variable', dim=0L,
                 val=t,
                 form='sparse', uels=list(fields),
                 domains=userDomf, domInfo="filtered",
                 field='all',
                 varTypeText='positive', typeCode=GMS_VARTYPE$POSITIVE)
  x <- rgdx(fnIn,list(name='xpos0',form='sparse',uels=f,field='all'))
  chk <- chkRgdxRes (x, xwantA, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(xpos0,'all',filtered) failed:",chk$msg))
  }
  x <- rgdx(fnIn,list(name='xpos0',form='sparse',uels=f,field='all'),squeeze=F)
  chk <- chkRgdxRes (x, xwantA, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(xpos0,'all',filtered,squeeze=F) failed:",chk$msg))
  }
  # level
  xwantL <- list(name='xpos0', type='variable', dim=0L,
                 val=matrix(24, nrow=1, ncol=1),
                 form='sparse', uels=f,
                 domains=character(0), domInfo="filtered",
                 field='l',
                 varTypeText='positive', typeCode=GMS_VARTYPE$POSITIVE)
  x <- rgdx(fnIn,list(name='xpos0',form='sparse',uels=f))
  chk <- chkRgdxRes (x, xwantL, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(xpos0,'L',filtered) failed:",chk$msg))
  }
  x <- rgdx(fnIn,list(name='xpos0',form='sparse',uels=f),squeeze=F)
  chk <- chkRgdxRes (x, xwantL, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(xpos0,'L',filtered,squeeze=F) failed:",chk$msg))
  }
  ywantL <- list(name='y0', type='variable', dim=0L,
                 val=matrix(1, nrow=1, ncol=1),
                 form='sparse', uels=f,
                 domains=character(0), domInfo="filtered",
                 field='l',
                 varTypeText='binary', typeCode=GMS_VARTYPE$BINARY)
  y <- rgdx(fnIn,list(name='y0',form='sparse',uels=f))
  chk <- chkRgdxRes (y, ywantL, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(y0,'L',filtered) failed:",chk$msg))
  }
  y <- rgdx(fnIn,list(name='y0',form='sparse',uels=f),squeeze=F)
  chk <- chkRgdxRes (y, ywantL, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(y0,'L',filtered,squeeze=F) failed:",chk$msg))
  }
  zwantL <- list(name='z', type='variable', dim=0L,
                 val=matrix(26, nrow=1, ncol=1),
                 form='sparse', uels=f,
                 domains=character(0), domInfo="filtered",
                 field='l',
                 varTypeText='free', typeCode=GMS_VARTYPE$FREE)
  z <- rgdx(fnIn,list(name='z',form='sparse',uels=f))
  chk <- chkRgdxRes (z, zwantL, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(z,'L',filtered) failed:",chk$msg))
  }
  z <- rgdx(fnIn,list(name='z',form='sparse',uels=f),squeeze=F)
  chk <- chkRgdxRes (z, zwantL, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(z,'L',filtered,squeeze=F) failed:",chk$msg))
  }
  # marginal
  xwantM <- list(name='xpos0', type='variable', dim=0L,
                 val=matrix(-1, nrow=1, ncol=1),
                 form='sparse', uels=f,
                 domains=character(0), domInfo="filtered",
                 field='m',
                 varTypeText='positive', typeCode=GMS_VARTYPE$POSITIVE)
  x <- rgdx(fnIn,list(name='xpos0',form='sparse',uels=f,field='M'))
  chk <- chkRgdxRes (x, xwantM, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(xpos0,'M',filtered) failed:",chk$msg))
  }
  x <- rgdx(fnIn,list(name='xpos0',form='sparse',uels=f,field='M'))
  chk <- chkRgdxRes (x, xwantM, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(xpos0,'M',filtered) failed:",chk$msg))
  }
  ywantM <- list(name='y0', type='variable', dim=0L,
                 val=matrix(0.5, nrow=1, ncol=1),
                 form='sparse', uels=f,
                 domains=character(0), domInfo="filtered",
                 field='m',
                 varTypeText='binary', typeCode=GMS_VARTYPE$BINARY)
  y <- rgdx(fnIn,list(name='y0',form='sparse',uels=f,field='M'))
  chk <- chkRgdxRes (y, ywantM, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(y0,'M',filtered) failed:",chk$msg))
  }
  y <- rgdx(fnIn,list(name='y0',form='sparse',uels=f,field='M'),squeeze=F)
  chk <- chkRgdxRes (y, ywantM, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(y0,'M',filtered,squeeze=F) failed:",chk$msg))
  }
  zwantM <- list(name='z', type='variable', dim=0L,
                 val=matrix(0, nrow=0, ncol=1),
                 form='sparse', uels=f,
                 domains=character(0), domInfo="filtered",
                 field='m',
                 varTypeText='free', typeCode=GMS_VARTYPE$FREE)
  z <- rgdx(fnIn,list(name='z',form='sparse',uels=f,field='M'))
  chk <- chkRgdxRes (z, zwantM, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(z,'M',filtered) failed:",chk$msg))
  }
  zwantM$val <- matrix(0, nrow=1, ncol=1)
  z <- rgdx(fnIn,list(name='z',form='sparse',uels=f,field='M'),squeeze=F)
  chk <- chkRgdxRes (z, zwantM, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(z,'M',filtered,squeeze=F) failed:",chk$msg))
  }
  # lower
  xwantLo <- list(name='xpos0', type='variable', dim=0L,
                  val=matrix(0, nrow=0, ncol=1),
                  form='sparse', uels=f,
                  domains=character(0), domInfo="filtered",
                  field='lo',
                  varTypeText='positive', typeCode=GMS_VARTYPE$POSITIVE)
  x <- rgdx(fnIn,list(name='xpos0',form='sparse',uels=f,field='lo'))
  chk <- chkRgdxRes (x, xwantLo, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(xpos0,'lo',filtered) failed:",chk$msg))
  }
  xwantLo$val <- matrix(0, nrow=1, ncol=1)
  x <- rgdx(fnIn,list(name='xpos0',form='sparse',uels=f,field='lo'),squeeze=F)
  chk <- chkRgdxRes (x, xwantLo, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(xpos0,'lo',filtered,squeeze=F) failed:",chk$msg))
  }
  ywantLo <- list(name='y0', type='variable', dim=0L,
                  val=matrix(1, nrow=1, ncol=1),
                  form='sparse', uels=f,
                  domains=character(0), domInfo="filtered",
                  field='lo',
                  varTypeText='binary', typeCode=GMS_VARTYPE$BINARY)
  y <- rgdx(fnIn,list(name='y0',form='sparse',uels=f,field='lo'))
  chk <- chkRgdxRes (y, ywantLo, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(y0,'lo',filtered) failed:",chk$msg))
  }
  y <- rgdx(fnIn,list(name='y0',form='sparse',uels=f,field='lo'),squeeze=F)
  chk <- chkRgdxRes (y, ywantLo, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(y0,'lo',filtered,squeeze=F) failed:",chk$msg))
  }
  zwantLo <- list(name='z', type='variable', dim=0L,
                  val=matrix(-Inf, nrow=0, ncol=1),
                  form='sparse', uels=f,
                  domains=character(0), domInfo="filtered",
                  field='lo',
                  varTypeText='free', typeCode=GMS_VARTYPE$FREE)
  z <- rgdx(fnIn,list(name='z',form='sparse',uels=f,field='lo'))
  chk <- chkRgdxRes (z, zwantLo, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(z,'lo',filtered) failed:",chk$msg))
  }
  zwantLo$val <- matrix(-Inf, nrow=1, ncol=1)
  z <- rgdx(fnIn,list(name='z',form='sparse',uels=f,field='lo'),squeeze=F)
  chk <- chkRgdxRes (z, zwantLo, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(z,'lo',filtered,squeeze=F) failed:",chk$msg))
  }
  # upper
  xwantUp <- list(name='xpos0', type='variable', dim=0L,
                  val=matrix(100, nrow=1, ncol=1),
                  form='sparse', uels=f,
                  domains=character(0), domInfo="filtered",
                  field='up',
                  varTypeText='positive', typeCode=GMS_VARTYPE$POSITIVE)
  x <- rgdx(fnIn,list(name='xpos0',form='sparse',uels=f,field='UP'))
  chk <- chkRgdxRes (x, xwantUp, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(xpos0,'up',filtered) failed:",chk$msg))
  }
  x <- rgdx(fnIn,list(name='xpos0',form='sparse',uels=f,field='UP'),squeeze=F)
  chk <- chkRgdxRes (x, xwantUp, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(xpos0,'up',filtered,squeeze=F) failed:",chk$msg))
  }
  ywantUp <- list(name='y0', type='variable', dim=0L,
                  val=matrix(1, nrow=0, ncol=1),
                  form='sparse', uels=f,
                  domains=character(0), domInfo="filtered",
                  field='up',
                  varTypeText='binary', typeCode=GMS_VARTYPE$BINARY)
  y <- rgdx(fnIn,list(name='y0',form='sparse',uels=f,field='UP'))
  chk <- chkRgdxRes (y, ywantUp, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(y0,'up',filtered) failed:",chk$msg))
  }
  ywantUp$val <- matrix(1, nrow=1, ncol=1)
  y <- rgdx(fnIn,list(name='y0',form='sparse',uels=f,field='UP'),squeeze=F)
  chk <- chkRgdxRes (y, ywantUp, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(y0,'up',filtered,squeeze=F) failed:",chk$msg))
  }
  zwantUp <- list(name='z', type='variable', dim=0L,
                  val=matrix(+Inf, nrow=0, ncol=1),
                  form='sparse', uels=f,
                  domains=character(0), domInfo="filtered",
                  field='up',
                  varTypeText='free', typeCode=GMS_VARTYPE$FREE)
  z <- rgdx(fnIn,list(name='z',form='sparse',uels=f,field='UP'))
  chk <- chkRgdxRes (z, zwantUp, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(z,'up',filtered) failed:",chk$msg))
  }
  zwantUp$val <- matrix(+Inf, nrow=1, ncol=1)
  z <- rgdx(fnIn,list(name='z',form='sparse',uels=f,field='UP'),squeeze=F)
  chk <- chkRgdxRes (z, zwantUp, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(z,'up',filtered,squeeze=F) failed:",chk$msg))
  }
  # scale
  xwantS <- list(name='xpos0', type='variable', dim=0L,
                 val=matrix(10, nrow=1, ncol=1),
                 form='sparse', uels=f,
                 domains=character(0), domInfo="filtered",
                 field='s',
                 varTypeText='positive', typeCode=GMS_VARTYPE$POSITIVE)
  x <- rgdx(fnIn,list(name='xpos0',form='sparse',field='S',uels=f))
  chk <- chkRgdxRes (x, xwantS, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(xpos0,'S',filtered) failed:",chk$msg))
  }
  x <- rgdx(fnIn,list(name='xpos0',form='sparse',field='S',uels=f),squeeze=F)
  chk <- chkRgdxRes (x, xwantS, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(xpos0,'S',filtered,squeeze=F) failed:",chk$msg))
  }
  ywantS <- list(name='y0', type='variable', dim=0L,
                 val=matrix(1, nrow=0, ncol=1),
                 form='sparse', uels=f,
                 domains=character(0), domInfo="filtered",
                 field='s',
                 varTypeText='binary', typeCode=GMS_VARTYPE$BINARY)
  y <- rgdx(fnIn,list(name='y0',form='sparse',field='S',uels=f))
  chk <- chkRgdxRes (y, ywantS, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(y0,'S',filtered) failed:",chk$msg))
  }
  ywantS$val <- matrix(1, nrow=1, ncol=1)
  y <- rgdx(fnIn,list(name='y0',form='sparse',field='S',uels=f),squeeze=F)
  chk <- chkRgdxRes (y, ywantS, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(y0,'S',filtered,squeeze=F) failed:",chk$msg))
  }
  zwantS <- list(name='z', type='variable', dim=0L,
                 val=matrix(1, nrow=0, ncol=1),
                 form='sparse', uels=f,
                 domains=character(0), domInfo="filtered",
                 field='s',
                 varTypeText='free', typeCode=GMS_VARTYPE$FREE)
  z <- rgdx(fnIn,list(name='z',form='sparse',field='S',uels=f))
  chk <- chkRgdxRes (z, zwantS, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(z,'S',filtered) failed:",chk$msg))
  }
  zwantS$val <- matrix(1, nrow=1, ncol=1)
  z <- rgdx(fnIn,list(name='z',form='sparse',field='S',uels=f),squeeze=F)
  chk <- chkRgdxRes (z, zwantS, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(z,'S',filtered,squeeze=F) failed:",chk$msg))
  }

  ### ---------- reading form=full, no filter
  # all
  t <- array(0,c(nFields),dimnames=list('_field'=fields))
  t[['l' ]] <- 24
  t[['m' ]] <- -1
  t[['up']] <- 100
  t[['s' ]] <- 10
  xwantA <- list(name='xpos0', type='variable', dim=0L,
                 val=t,
                 form='full',
                 uels=list('_field'=fields),
                 domains=userDomf, domInfo="NA",
                 field='all',
                 varTypeText='positive', typeCode=GMS_VARTYPE$POSITIVE)
  x <- rgdx(fnIn,list(name='xpos0',form='full',field='all'))
  chk <- chkRgdxRes (x, xwantA, T, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(xpos0,'all',full,unfiltered) failed:",chk$msg))
  }
  x <- rgdx(fnIn,list(name='xpos0',form='full',field='all'),squeeze=F)
  chk <- chkRgdxRes (x, xwantA, T, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(xpos0,'all',full,unfiltered,squeeze=F) failed:",chk$msg))
  }
  t <- array(0,c(nFields),dimnames=list('_field'=fields))
  t[['l' ]] <- 1
  t[['m' ]] <- 0.5
  t[['lo']] <- 1
  t[['up']] <- 1
  t[['s' ]] <- 1
  ywantA <- list(name='y0', type='variable', dim=0L,
                 val=t,
                 form='full',
                 uels=list('_field'=fields),
                 domains=userDomf, domInfo="NA",
                 field='all',
                 varTypeText='binary', typeCode=GMS_VARTYPE$BINARY)
  y <- rgdx(fnIn,list(name='y0',form='full',field='all'))
  chk <- chkRgdxRes (y, ywantA, T, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(y0,'all',full,unfiltered) failed:",chk$msg))
  }
  y <- rgdx(fnIn,list(name='y0',form='full',field='all'),squeeze=F)
  chk <- chkRgdxRes (y, ywantA, T, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(y0,'all',full,unfiltered,squeeze=F) failed:",chk$msg))
  }
  t <- array(0,c(nFields),dimnames=list('_field'=fields))
  t[['l' ]] <- 26
  t[['m' ]] <- 0
  t[['lo']] <- -Inf
  t[['up']] <- +Inf
  t[['s' ]] <- 1
  zwantA <- list(name='z', type='variable', dim=0L,
                 val=t,
                 form='full', uels=list('_field'=fields),
                 domains=userDomf, domInfo="NA",
                 field='all',
                 varTypeText='free', typeCode=GMS_VARTYPE$FREE)
  z <- rgdx(fnIn,list(name='z',form='full',field='all'))
  chk <- chkRgdxRes (z, zwantA, T, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(z,'all',full,unfiltered) failed:",chk$msg))
  }
  z <- rgdx(fnIn,list(name='z',form='full',field='all'),squeeze=F)
  chk <- chkRgdxRes (z, zwantA, T, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(z,'all',full,unfiltered,squeeze=F) failed:",chk$msg))
  }
  # level
  xwantL <- list(name='xpos0', type='variable', dim=0L,
                 val=24,
                 form='full', uels=list(),
                 domains=character(0), domInfo="NA",
                 field='l',
                 varTypeText='positive', typeCode=GMS_VARTYPE$POSITIVE)
  x <- rgdx(fnIn,list(name='xpos0',form='full'))
  chk <- chkRgdxRes (x, xwantL, T, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(xpos0,'L',full,unfiltered) failed:",chk$msg))
  }
  x <- rgdx(fnIn,list(name='xpos0',form='full'),squeeze=F)
  chk <- chkRgdxRes (x, xwantL, T, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(xpos0,'L',full,unfiltered,squeeze=F) failed:",chk$msg))
  }
  ywantL <- list(name='y0', type='variable', dim=0L,
                 val=1,
                 form='full', uels=list(),
                 domains=character(0), domInfo="NA",
                 field='l',
                 varTypeText='binary', typeCode=GMS_VARTYPE$BINARY)
  y <- rgdx(fnIn,list(name='y0',form='full'))
  chk <- chkRgdxRes (y, ywantL, T, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(y0,'L',full,unfiltered) failed:",chk$msg))
  }
  y <- rgdx(fnIn,list(name='y0',form='full'),squeeze=F)
  chk <- chkRgdxRes (y, ywantL, T, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(y0,'L',full,unfiltered,squeeze=F) failed:",chk$msg))
  }
  zwantL <- list(name='z', type='variable', dim=0L,
                 val=26,
                 form='full', uels=list(),
                 domains=character(0), domInfo="NA",
                 field='l',
                 varTypeText='free', typeCode=GMS_VARTYPE$FREE)
  z <- rgdx(fnIn,list(name='z',form='full'))
  chk <- chkRgdxRes (z, zwantL, T, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(z,'L',full,unfiltered) failed:",chk$msg))
  }
  z <- rgdx(fnIn,list(name='z',form='full'),squeeze=F)
  chk <- chkRgdxRes (z, zwantL, T, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(z,'L',full,unfiltered,squeeze=F) failed:",chk$msg))
  }
  # marginal
  xwantM <- list(name='xpos0', type='variable', dim=0L,
                 val=-1,
                 form='full', uels=list(),
                 domains=character(0), domInfo="NA",
                 field='m',
                 varTypeText='positive', typeCode=GMS_VARTYPE$POSITIVE)
  x <- rgdx(fnIn,list(name='xpos0',form='full',field='m'))
  chk <- chkRgdxRes (x, xwantM, T, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(xpos0,'M',full,unfiltered) failed:",chk$msg))
  }
  ywantM <- list(name='y0', type='variable', dim=0L,
                 val=0.5,
                 form='full', uels=list(),
                 domains=character(0), domInfo="NA",
                 field='m',
                 varTypeText='binary', typeCode=GMS_VARTYPE$BINARY)
  y <- rgdx(fnIn,list(name='y0',form='full',field='m'))
  chk <- chkRgdxRes (y, ywantM, T, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(y0,'M',full,unfiltered) failed:",chk$msg))
  }
  zwantM <- list(name='z', type='variable', dim=0L,
                 val=0,
                 form='full', uels=list(),
                 domains=character(0), domInfo="NA",
                 field='m',
                 varTypeText='free', typeCode=GMS_VARTYPE$FREE)
  z <- rgdx(fnIn,list(name='z',form='full',field='m'))
  chk <- chkRgdxRes (z, zwantM, T, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(z,'M',full,unfiltered) failed:",chk$msg))
  }
  # lower
  xwantLo <- list(name='xpos0', type='variable', dim=0L,
                  val=0,
                  form='full', uels=list(),
                  domains=character(0), domInfo="NA",
                  field='lo',
                  varTypeText='positive', typeCode=GMS_VARTYPE$POSITIVE)
  x <- rgdx(fnIn,list(name='xpos0',form='full',field='lo'))
  chk <- chkRgdxRes (x, xwantLo, T, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(xpos0,'lo',full,unfiltered) failed:",chk$msg))
  }
  ywantLo <- list(name='y0', type='variable', dim=0L,
                  val=1,
                  form='full', uels=list(),
                  domains=character(0), domInfo="NA",
                  field='lo',
                 varTypeText='binary', typeCode=GMS_VARTYPE$BINARY)
  y <- rgdx(fnIn,list(name='y0',form='full',field='lo'))
  chk <- chkRgdxRes (y, ywantLo, T, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(y0,'lo',full,unfiltered) failed:",chk$msg))
  }
  zwantLo <- list(name='z', type='variable', dim=0L,
                  val=-Inf,
                  form='full', uels=list(),
                  domains=character(0), domInfo="NA",
                  field='lo',
                  varTypeText='free', typeCode=GMS_VARTYPE$FREE)
  z <- rgdx(fnIn,list(name='z',form='full',field='lo'))
  chk <- chkRgdxRes (z, zwantLo, T, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(z,'lo',full,unfiltered) failed:",chk$msg))
  }
  # upper
  xwantUp <- list(name='xpos0', type='variable', dim=0L,
                  val=100,
                  form='full', uels=list(),
                  domains=character(0), domInfo="NA",
                  field='up',
                  varTypeText='positive', typeCode=GMS_VARTYPE$POSITIVE)
  x <- rgdx(fnIn,list(name='xpos0',form='full',field='up'))
  chk <- chkRgdxRes (x, xwantUp, T, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(xpos0,'up',full,unfiltered) failed:",chk$msg))
  }
  ywantUp <- list(name='y0', type='variable', dim=0L,
                  val=1,
                  form='full', uels=list(),
                  domains=character(0), domInfo="NA",
                  field='up',
                  varTypeText='binary', typeCode=GMS_VARTYPE$BINARY)
  y <- rgdx(fnIn,list(name='y0',form='full',field='up'))
  chk <- chkRgdxRes (y, ywantUp, T, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(y0,'up',full,unfiltered) failed:",chk$msg))
  }
  zwantUp <- list(name='z', type='variable', dim=0L,
                  val=+Inf,
                  form='full', uels=list(),
                  domains=character(0), domInfo="NA",
                  field='up',
                  varTypeText='free', typeCode=GMS_VARTYPE$FREE)
  z <- rgdx(fnIn,list(name='z',form='full',field='up'))
  chk <- chkRgdxRes (z, zwantUp, T, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(z,'up',full,unfiltered) failed:",chk$msg))
  }
  # scale
  xwantS <- list(name='xpos0', type='variable', dim=0L,
                 val=10,
                 form='full', uels=list(),
                 domains=character(0), domInfo="NA",
                 field='s',
                 varTypeText='positive', typeCode=GMS_VARTYPE$POSITIVE)
  x <- rgdx(fnIn,list(name='xpos0',form='full',field='s'))
  chk <- chkRgdxRes (x, xwantS, T, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(xpos0,'s',full,unfiltered) failed:",chk$msg))
  }
  ywantS <- list(name='y0', type='variable', dim=0L,
                 val=1,
                 form='full', uels=list(),
                 domains=character(0), domInfo="NA",
                 field='s',
                 varTypeText='binary', typeCode=GMS_VARTYPE$BINARY)
  y <- rgdx(fnIn,list(name='y0',form='full',field='s'))
  chk <- chkRgdxRes (y, ywantS, T, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(y0,'s',full,unfiltered) failed:",chk$msg))
  }
  zwantS <- list(name='z', type='variable', dim=0L,
                 val=1,
                 form='full', uels=list(),
                 domains=character(0), domInfo="NA",
                 field='s',
                 varTypeText='free', typeCode=GMS_VARTYPE$FREE)
  z <- rgdx(fnIn,list(name='z',form='full',field='s'))
  chk <- chkRgdxRes (z, zwantS, T, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(z,'s',full,unfiltered) failed:",chk$msg))
  }

  ### ---------- reading form=full, filtered
  # all
  xwantA$domInfo <- "filtered"
  x <- rgdx(fnIn,list(name='xpos0',form='full',uels=f,field='all'))
  chk <- chkRgdxRes (x, xwantA, T, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(xpos0,'all',full,filtered) failed:",chk$msg))
  }
  x <- rgdx(fnIn,list(name='xpos0',form='full',uels=f,field='all'),squeeze=F)
  chk <- chkRgdxRes (x, xwantA, T, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(xpos0,'all',full,filtered,squeeze=F) failed:",chk$msg))
  }
  ywantA$domInfo <- "filtered"
  y <- rgdx(fnIn,list(name='y0',form='full',uels=f,field='all'))
  chk <- chkRgdxRes (y, ywantA, T, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(y0,'all',full,filtered) failed:",chk$msg))
  }
  y <- rgdx(fnIn,list(name='y0',form='full',uels=f,field='all'),squeeze=F)
  chk <- chkRgdxRes (y, ywantA, T, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(y0,'all',full,filtered,squeeze=F) failed:",chk$msg))
  }
  zwantA$domInfo <- "filtered"
  z <- rgdx(fnIn,list(name='z',form='full',uels=f,field='all'))
  chk <- chkRgdxRes (z, zwantA, T, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(z,'all',full,filtered) failed:",chk$msg))
  }
  z <- rgdx(fnIn,list(name='z',form='full',uels=f,field='all'),squeeze=F)
  chk <- chkRgdxRes (z, zwantA, T, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(z,'all',full,filtered,squeeze=F) failed:",chk$msg))
  }
  # level
  xwantL <- list(name='xpos0', type='variable', dim=0L,
                 val=24,
                 form='full', uels=f,
                 domains=character(0), domInfo="filtered",
                 field='l',
                 varTypeText='positive', typeCode=GMS_VARTYPE$POSITIVE)
  x <- rgdx(fnIn,list(name='xpos0',form='full',uels=f))
  chk <- chkRgdxRes (x, xwantL, T, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(xpos0,'L',full,filtered) failed:",chk$msg))
  }
  x <- rgdx(fnIn,list(name='xpos0',form='full',uels=f),squeeze=F)
  chk <- chkRgdxRes (x, xwantL, T, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(xpos0,'L',full,filtered,squeeze=F) failed:",chk$msg))
  }
  ywantL <- list(name='y0', type='variable', dim=0L,
                 val=1,
                 form='full', uels=f,
                 domains=character(0), domInfo="filtered",
                 field='l',
                 varTypeText='binary', typeCode=GMS_VARTYPE$BINARY)
  y <- rgdx(fnIn,list(name='y0',form='full',uels=f))
  chk <- chkRgdxRes (y, ywantL, T, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(y0,'L',full,filtered) failed:",chk$msg))
  }
  y <- rgdx(fnIn,list(name='y0',form='full',uels=f),squeeze=F)
  chk <- chkRgdxRes (y, ywantL, T, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(y0,'L',full,filtered,squeeze=F) failed:",chk$msg))
  }
  zwantL <- list(name='z', type='variable', dim=0L,
                 val=26,
                 form='full', uels=f,
                 domains=character(0), domInfo="filtered",
                 field='l',
                 varTypeText='free', typeCode=GMS_VARTYPE$FREE)
  z <- rgdx(fnIn,list(name='z',form='full',uels=f))
  chk <- chkRgdxRes (z, zwantL, T, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(z,'L',full,filtered) failed:",chk$msg))
  }
  z <- rgdx(fnIn,list(name='z',form='full',uels=f),squeeze=F)
  chk <- chkRgdxRes (z, zwantL, T, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(z,'L',full,filtered,squeeze=F) failed:",chk$msg))
  }
  # marginal
  xwantM <- list(name='xpos0', type='variable', dim=0L,
                 val=-1,
                 form='full', uels=f,
                 domains=character(0), domInfo="filtered",
                 field='m',
                 varTypeText='positive', typeCode=GMS_VARTYPE$POSITIVE)
  x <- rgdx(fnIn,list(name='xpos0',form='full',uels=f,field='M'))
  chk <- chkRgdxRes (x, xwantM, T, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(xpos0,'M',full,filtered) failed:",chk$msg))
  }
  x <- rgdx(fnIn,list(name='xpos0',form='full',uels=f,field='M'),squeeze=F)
  chk <- chkRgdxRes (x, xwantM, T, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(xpos0,'M',full,filtered,squeeze=F) failed:",chk$msg))
  }
  ywantM <- list(name='y0', type='variable', dim=0L,
                 val=0.5,
                 form='full', uels=f,
                 domains=character(0), domInfo="filtered",
                 field='m',
                 varTypeText='binary', typeCode=GMS_VARTYPE$BINARY)
  y <- rgdx(fnIn,list(name='y0',form='full',uels=f,field='M'))
  chk <- chkRgdxRes (y, ywantM, T, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(y0,'M',full,filtered) failed:",chk$msg))
  }
  y <- rgdx(fnIn,list(name='y0',form='full',uels=f,field='M'),squeeze=F)
  chk <- chkRgdxRes (y, ywantM, T, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(y0,'M',full,filtered,squeeze=F) failed:",chk$msg))
  }
  zwantM <- list(name='z', type='variable', dim=0L,
                 val=0,
                 form='full', uels=f,
                 domains=character(0), domInfo="filtered",
                 field='m',
                 varTypeText='free', typeCode=GMS_VARTYPE$FREE)
  z <- rgdx(fnIn,list(name='z',form='full',uels=f,field='M'))
  chk <- chkRgdxRes (z, zwantM, T, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(z,'M',full,filtered) failed:",chk$msg))
  }
  z <- rgdx(fnIn,list(name='z',form='full',uels=f,field='M'),squeeze=F)
  chk <- chkRgdxRes (z, zwantM, T, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(z,'M',full,filtered,squeeze=F) failed:",chk$msg))
  }
  # lower
  xwantLo <- list(name='xpos0', type='variable', dim=0L,
                  val=0,
                  form='full', uels=f,
                  domains=character(0), domInfo="filtered",
                  field='lo',
                  varTypeText='positive', typeCode=GMS_VARTYPE$POSITIVE)
  x <- rgdx(fnIn,list(name='xpos0',form='full',uels=f,field='lo'))
  chk <- chkRgdxRes (x, xwantLo, T, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(xpos0,'lo',full,filtered) failed:",chk$msg))
  }
  x <- rgdx(fnIn,list(name='xpos0',form='full',uels=f,field='lo'),squeeze=F)
  chk <- chkRgdxRes (x, xwantLo, T, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(xpos0,'lo',full,filtered,squeeze=F) failed:",chk$msg))
  }
  ywantLo <- list(name='y0', type='variable', dim=0L,
                  val=1,
                  form='full', uels=f,
                  domains=character(0), domInfo="filtered",
                  field='lo',
                  varTypeText='binary', typeCode=GMS_VARTYPE$BINARY)
  y <- rgdx(fnIn,list(name='y0',form='full',uels=f,field='lo'))
  chk <- chkRgdxRes (y, ywantLo, T, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(y0,'lo',full,filtered) failed:",chk$msg))
  }
  y <- rgdx(fnIn,list(name='y0',form='full',uels=f,field='lo'),squeeze=F)
  chk <- chkRgdxRes (y, ywantLo, T, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(y0,'lo',full,filtered,squeeze=F) failed:",chk$msg))
  }
  zwantLo <- list(name='z', type='variable', dim=0L,
                  val=-Inf,
                  form='full', uels=f,
                  domains=character(0), domInfo="filtered",
                  field='lo',
                  varTypeText='free', typeCode=GMS_VARTYPE$FREE)
  z <- rgdx(fnIn,list(name='z',form='full',uels=f,field='lo'))
  chk <- chkRgdxRes (z, zwantLo, T, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(z,'lo',full,filtered) failed:",chk$msg))
  }
  z <- rgdx(fnIn,list(name='z',form='full',uels=f,field='lo'),squeeze=F)
  chk <- chkRgdxRes (z, zwantLo, T, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(z,'lo',full,filtered,squeeze=F) failed:",chk$msg))
  }
  # upper
  xwantUp <- list(name='xpos0', type='variable', dim=0L,
                  val=100,
                  form='full', uels=f,
                  domains=character(0), domInfo="filtered",
                  field='up',
                  varTypeText='positive', typeCode=GMS_VARTYPE$POSITIVE)
  x <- rgdx(fnIn,list(name='xpos0',form='full',uels=f,field='up'))
  chk <- chkRgdxRes (x, xwantUp, T, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(xpos0,'up',full,filtered) failed:",chk$msg))
  }
  x <- rgdx(fnIn,list(name='xpos0',form='full',uels=f,field='up'),squeeze=F)
  chk <- chkRgdxRes (x, xwantUp, T, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(xpos0,'up',full,filtered,squeeze=F) failed:",chk$msg))
  }
  ywantUp <- list(name='y0', type='variable', dim=0L,
                  val=1,
                  form='full', uels=f,
                  domains=character(0), domInfo="filtered",
                  field='up',
                  varTypeText='binary', typeCode=GMS_VARTYPE$BINARY)
  y <- rgdx(fnIn,list(name='y0',form='full',uels=f,field='up'))
  chk <- chkRgdxRes (y, ywantUp, T, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(y0,'up',full,filtered) failed:",chk$msg))
  }
  y <- rgdx(fnIn,list(name='y0',form='full',uels=f,field='up'),squeeze=F)
  chk <- chkRgdxRes (y, ywantUp, T, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(y0,'up',full,filtered,squeeze=F) failed:",chk$msg))
  }
  zwantUp <- list(name='z', type='variable', dim=0L,
                  val=+Inf,
                  form='full', uels=f,
                  domains=character(0), domInfo="filtered",
                  field='up',
                  varTypeText='free', typeCode=GMS_VARTYPE$FREE)
  z <- rgdx(fnIn,list(name='z',form='full',uels=f,field='up'))
  chk <- chkRgdxRes (z, zwantUp, T, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(z,'up',full,filtered) failed:",chk$msg))
  }
  z <- rgdx(fnIn,list(name='z',form='full',uels=f,field='up'),squeeze=F)
  chk <- chkRgdxRes (z, zwantUp, T, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(z,'up',full,filtered,squeeze=F) failed:",chk$msg))
  }
  # scale
  xwantS <- list(name='xpos0', type='variable', dim=0L,
                 val=10,
                 form='full', uels=f,
                 domains=character(0), domInfo="filtered",
                 field='s',
                 varTypeText='positive', typeCode=GMS_VARTYPE$POSITIVE)
  x <- rgdx(fnIn,list(name='xpos0',form='full',uels=f,field='s'))
  chk <- chkRgdxRes (x, xwantS, T, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(xpos0,'s',full,filtered) failed:",chk$msg))
  }
  x <- rgdx(fnIn,list(name='xpos0',form='full',uels=f,field='s'),squeeze=F)
  chk <- chkRgdxRes (x, xwantS, T, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(xpos0,'s',full,filtered,squeeze=F) failed:",chk$msg))
  }
  ywantS <- list(name='y0', type='variable', dim=0L,
                 val=1,
                 form='full', uels=f,
                 domains=character(0), domInfo="filtered",
                 field='s',
                 varTypeText='binary', typeCode=GMS_VARTYPE$BINARY)
  y <- rgdx(fnIn,list(name='y0',form='full',uels=f,field='s'))
  chk <- chkRgdxRes (y, ywantS, T, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(y0,'s',full,filtered) failed:",chk$msg))
  }
  y <- rgdx(fnIn,list(name='y0',form='full',uels=f,field='s'),squeeze=F)
  chk <- chkRgdxRes (y, ywantS, T, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(y0,'s',full,filtered,squeeze=F) failed:",chk$msg))
  }
  zwantS <- list(name='z', type='variable', dim=0L,
                 val=1,
                 form='full', uels=f,
                 domains=character(0), domInfo="filtered",
                 field='s',
                 varTypeText='free', typeCode=GMS_VARTYPE$FREE)
  z <- rgdx(fnIn,list(name='z',form='full',uels=f,field='s'))
  chk <- chkRgdxRes (z, zwantS, T, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(z,'s',full,filtered) failed:",chk$msg))
  }
  z <- rgdx(fnIn,list(name='z',form='full',uels=f,field='s'),squeeze=F)
  chk <- chkRgdxRes (z, zwantS, T, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(z,'s',full,filtered,squeeze=F) failed:",chk$msg))
  }


  print ("test of rgdx on variable reads passed")
  TRUE   ## all tests passed: return TRUE
},

error = function(ex) { print ("test of rgdx on variable reads failed"); print(ex) ; FALSE }
)

#### test rgdx with a file generated prior to domain info in GDX
#### test form=['sparse','full'] X [filtered,unfiltered] X compress=[T,F]

#### wanted lists produced with    dump("listName",file="")

if (! require(gdxrrw))      stop ("gdxrrw package is not available")
if (0 == igdx(silent=TRUE)) stop ("the gdx shared library has not been loaded")

source ("chkSame.R")
reqIdent <- TRUE

tryCatch({
  print ("testing rgdx handling of GDX file with no domain info")
  rgdx('?')
  fnIn <- "teTestPreDomainInfo.gdx"
  if (! file_test ('-f', fnIn)) {
    stop (paste("FAIL: File", fnIn, "does not exist"))
  }
  useDomInfo <- TRUE
  noInfo <- "none"   # domInfo="none" means we checked, but none is available

  source ("tReadDomInfoBody.R")


  print ("test of rgdx on pre-domain-info GDX file passed")
  TRUE   ## all tests passed: return TRUE
},

error = function(ex) { print ("test of rgdx on pre-domain-info GDX file failed"); print(ex) ; FALSE }
)

#### test rgdx errors: some things should be an error,
#### and we expect certain behavior in these cases

if (! require(gdxrrw))      stop ("gdxrrw package is not available")
if (0 == igdx(silent=TRUE)) stop ("the gdx shared library has not been loaded")

tryCatch({
  print ("testing error detection and handling for rgdx")
  rgdx('?')
  fnIn <- "teTest.gdx"
  if (! file_test ('-f', fnIn)) {
    stop (paste("FAIL: File", fnIn, "does not exist"))
  }

  msg <- "rgdx test with bogus form specifier"
  tcr <- tryCatch({
    IJ <- rgdx(fnIn,list(name='IJ',form='invalidForm',compress=TRUE)) ; FALSE
    },
    error = function(e) { print(paste(' Caught error: msg =',e)) ; TRUE }
  )
  if (tcr) {
    print(paste(msg,": passed",sep=""))
  }
  else {
    stop (paste(msg, ": failed",sep=""))
  }

  # set IJ has dimension 2, not 4
  msg <- "rgdx test with bogus dim specifier"
  tcr <- tryCatch({
    IJ <- rgdx(fnIn,list(name='IJ',dim=4)) ; FALSE
    },
    error = function(e) { print(paste(' Caught error: msg =',e)) ; TRUE }
  )
  if (tcr) {
    print(paste(msg,": passed",sep=""))
  }
  else {
    stop (paste(msg, ": failed",sep=""))
  }


  # parameters do not have text elements
  msg <- "rgdx test with specifier te=TRUE for a parameter"
  tcr <- tryCatch({
    IJ <- rgdx(fnIn,list(name='A',te=TRUE)) ; FALSE
    },
    error = function(e) { print(paste(' Caught error: msg =',e)) ; TRUE }
  )
  if (tcr) {
    print(paste(msg,": passed",sep=""))
  }
  else {
    stop (paste(msg, ": failed",sep=""))
  }
  ## all tests passed: return TRUE
  print ("test of rgdx error handling: all passed")
  TRUE
},

error = function(ex) { print ("test of rgdx error handling failed"); print(ex) ; FALSE }
)

#### test rgdx with a recent GDX file containing full domain info
#### with useDomInfo=FALSE it should behave as if no dom info is there
#### test form=['sparse','full'] X [filtered,unfiltered] X compress=[T,F]

#### wanted lists produced with    dump("listName",file="")

if (! require(gdxrrw))      stop ("gdxrrw package is not available")
if (0 == igdx(silent=TRUE)) stop ("the gdx shared library has not been loaded")

source ("chkSame.R")

tryCatch({
  print ("testing rgdx handling of GDX file with useDomInfo=FALSE")
  rgdx('?')
  fnIn <- "teTestWithDomainInfo.gdx"
  if (! file_test ('-f', fnIn)) {
    stop (paste("FAIL: File", fnIn, "does not exist"))
  }
  useDomInfo <- FALSE

  source ("tReadDomInfoBody.R")


  print ("test of rgdx with useDomInfo=FALSE passed")
  TRUE   ## all tests passed: return TRUE
},

error = function(ex) { print ("test of rgdx with useDomInfo=FALSE failed"); print(ex) ; FALSE }
)

### Test rgdx.set
# We read 3 sets I,J,K and a subset over their Cartesian product,
# first from GDX and then from .csv files produced by GAMS,
# and compare the contents to be sure we get the same results

if (! require(gdxrrw))      stop ("gdxrrw package is not available")
if (0 == igdx(silent=TRUE)) stop ("the gdx shared library has not been loaded")

tryCatch({
  ix <- rgdx.set('ijk','i',names="I")
  jx <- rgdx.set('ijk','j',names="J")
  kx <- rgdx.set('ijk','k',names="K")

  iv <- read.csv("I.csv")
  jv <- read.csv("J.csv")
  kv <- read.csv("K.csv")

  # both rgdx.set and read.csv return a data frame with one factor for
  # each set/column.  We extract the factors and compare them.  Note
  # that we compare the characters in the factors, not the scheme to
  # encode these characters.

  ixf <- ix$I
  jxf <- jx$J
  kxf <- kx$K
  ivf <- iv$I
  jvf <- jv$J
  kvf <- kv$K
  ixfc <- as.character(ixf)
  jxfc <- as.character(jxf)
  kxfc <- as.character(kxf)
  ivfc <- as.character(ivf)
  jvfc <- as.character(jvf)
  kvfc <- as.character(kvf)

  if (prod(ixfc != ivfc)) stop ("mismatch in set I")
  if (prod(jxfc != jvfc)) stop ("mismatch in set J")
  if (prod(kxfc != kvfc)) stop ("mismatch in set K")

  ijkx <- rgdx.set('ijk','ijk',names=c("I","J","K"))
  ijkv <- read.csv("ijk.csv")

  ixf <- ijkx$I
  jxf <- ijkx$J
  kxf <- ijkx$K
  ivf <- ijkv$I
  jvf <- ijkv$J
  kvf <- ijkv$K
  ixfc <- as.character(ixf)
  jxfc <- as.character(jxf)
  kxfc <- as.character(kxf)
  ivfc <- as.character(ivf)
  jvfc <- as.character(jvf)
  kvfc <- as.character(kvf)

  if (prod(ixfc != ivfc)) stop ("mismatch in set ijk, index I")
  if (prod(jxfc != jvfc)) stop ("mismatch in set ijk, index J")
  if (prod(kxfc != kvfc)) stop ("mismatch in set ijk, index K")

  print ("All tests for rgdx.set passed")
  return (TRUE)
}

, error = function(ex) { print(ex) ; return (FALSE) }
)

### Test rgdx.param
# we read the distance matrix from the eurodist data set
# previously stored in a GDX file and compare that to the eurodist data

if (! require(gdxrrw))      stop ("gdxrrw package is not available")
if (0 == igdx(silent=TRUE)) stop ("the gdx shared library has not been loaded")

tryCatch({
  gdxName <- "euroDistTest"
  symName <- "dist"
  df <- rgdx.param(gdxName,symName)
  df3 <- rgdx.param(gdxName,symName,names=c("from","to","distance"))

  n <- attr(eurodist,"Size")
  cities <- attr(eurodist,"Labels")
  dm <- as.matrix(eurodist)

  k <- 0
  doPrint <- TRUE;
  for (i in c(1:n)) {
    for (j in c(1:n)) {
      if (dm[i,j] > 0) {
        k <- k + 1
        if (doPrint) {
          print (paste("checking eurodist:", i, j, cities[i], cities[j], dm[i,j]))
          print (paste("              df3:", as.numeric(df3$from[k]), as.numeric(df3$to[k]), as.character(df3$from[k]), as.character(df3$to[k]), df3$distance[k]))
          if (k > 10) {
            print ("Further output suppressed")
            doPrint <- FALSE;
          }
        }
        if (i != as.numeric(df3$from[k])) {
          stop ("mismatch in i")
        }
        if (j != as.numeric(df3$to[k])) {
          stop ("mismatch in j")
        }
        if (cities[i] != as.character(df3$from[k])) {
          stop ("mismatch in cities[i]")
        }
        if (cities[j] != as.character(df3$to[k])) {
          stop ("mismatch in cities[j]")
        }
        if (dm[i,j] != df3$distance[k]) {
          stop ("mismatch in distance[k]")
        }
      }
    }
  }

  print ("All tests for rgdx.param passed");
  TRUE
}

, error = function(ex) { print(ex) ; FALSE }
)

#### test rgdx and compress=TRUE with a recent GDX file containing full domain info
#### test both form=['sparse','full']

if (! require(gdxrrw))      stop ("gdxrrw package is not available")
if (0 == igdx(silent=TRUE)) stop ("the gdx shared library has not been loaded")

source ("chkSame.R")

tryCatch({
  print ("testing rgdx handling of GDX file with compress=TRUE")
  rgdx('?')
  fnIn <- "compressTest.gdx"
  if (! file_test ('-f', fnIn)) {
    stop (paste("FAIL: File", fnIn, "does not exist"))
  }
  useDomInfo <- TRUE                    # the default

  source ("tReadCompressBody.R")


  print ("test of rgdx with compress=TRUE passed")
  TRUE   ## all tests passed: return TRUE
},

error = function(ex) { print ("test of rgdx with compress=TRUE failed"); print(ex) ; FALSE }
)

## body of tests for comparing behavior in two rgdx cases:
##   1. compress=TRUE and useDomInfo=FALSE
##   2. compress=TRUE and useDomInfo=TRUE
## We expect identical behavior so we use a common test file

iUels <- c("i1", "i2", "i3", "i4", "i5", "i6", "i7")
iCard <- length(iUels)
iVals <- matrix(c(1:iCard), nrow=iCard, ncol=1)
iOnes <- matrix(1, nrow=iCard, ncol=1)
jUels <- c("j1", "j2", "j3", "j4", "j5")
jCard <- length(jUels)
jVals <- matrix(c(1:jCard), nrow=jCard, ncol=1)
jOnes <- matrix(1, nrow=jCard, ncol=1)
aVals <- matrix(c(1,1, 33.11,
                  2,2, 54.22), nrow=2, ncol=3, byrow=TRUE)
aFull <- matrix(c(33.11, 0,
                      0, 54.22), nrow=2, ncol=2, byrow=TRUE)
aUels <- list(c("i3", "i5"), c("j3", "j4"))
bVals <- matrix(nrow=iCard*jCard, ncol=3)
for (i in 1:iCard) {
  for (j in 1:jCard) {
    k <- (i-1)*jCard + j
    bVals[k,1] <- i
    bVals[k,2] <- j
    bVals[k,3] <- 525
  }
}
bFull <- matrix(525,nrow=iCard, ncol=jCard)
bUels <- list(iUels,jUels)
dVals <- matrix(nrow=iCard,ncol=3)
for (i in 1:iCard) {
  dVals[i,1] <- i
  dVals[i,2] <- 1
  dVals[i,3] <- (10*i + 1) * 1.01
}
dFull <- matrix(nrow=iCard,ncol=1)
for (i in 1:iCard) {
  dFull[i,1] <- (10*i + 1) * 1.01
}
dUels <- list(iUels,c('j1'))
eVals <- matrix(nrow=jCard,ncol=3)
for (j in 1:jCard) {
  eVals[j,1] <- 1
  eVals[j,2] <- j
  eVals[j,3] <- (30 + j) + (10 + j)/100
}
eFull <- matrix(nrow=1,ncol=jCard)
for (j in 1:jCard) {
  eFull[1,j] <- (30 + j) + (10 + j)/100
}
eUels <- list(c('i3'),jUels)

cVals <- matrix(c(1,1.1,
                  2,5.1), nrow=2, ncol=2, byrow=TRUE)
cFull <- matrix(c(1.1, 5.1), nrow=2,ncol=1)
cUels <- list(c("j1", "j5"))


## ---------- reading form=sparse

iwant <- list(name="I", type="set", dim=1,
              val=iVals,
              form="sparse",
              uels=list(iUels),
              domains=c('_compressed'))
i <- rgdx(fnIn,list(name='i',form='sparse',compress=TRUE),useDomInfo=useDomInfo)
chk <- chkRgdxRes (i, iwant)
if (!chk$same) {
  stop (paste("test rgdx(i,sparse) failed",chk$msg))
}

jwant <- list(name="J", type="set", dim=1,
              val=jVals,
              form="sparse",
              uels=list(jUels),
              domains=c('_compressed'))
j <- rgdx(fnIn,list(name='j',form='sparse',compress=TRUE),useDomInfo=useDomInfo)
chk <- chkRgdxRes (j, jwant)
if (!chk$same) {
  stop (paste("test rgdx(j,sparse) failed",chk$msg))
}

awant <- list(name="A", type="parameter", dim=2,
              val=aVals,
              form="sparse",
              uels=aUels,
              domains=c('_compressed','_compressed'))
a <- rgdx(fnIn,list(name='a',form='sparse',compress=TRUE),useDomInfo=useDomInfo)
chk <- chkRgdxRes (a, awant)
if (!chk$same) {
  stop (paste("test rgdx(a,sparse) failed",chk$msg))
}

bwant <- list(name="B", type="parameter", dim=2,
              val=bVals,
              form="sparse",
              uels=bUels,
              domains=c('_compressed','_compressed'))
b <- rgdx(fnIn,list(name='b',form='sparse',compress=TRUE),useDomInfo=useDomInfo)
chk <- chkRgdxRes (b, bwant)
if (!chk$same) {
  stop (paste("test rgdx(b,sparse) failed",chk$msg))
}

dwant <- list(name="D", type="parameter", dim=2,
              val=dVals,
              form="sparse",
              uels=dUels,
              domains=c('_compressed','_compressed'))
d <- rgdx(fnIn,list(name='d',form='sparse',compress=TRUE),useDomInfo=useDomInfo)
chk <- chkRgdxRes (d, dwant)
if (!chk$same) {
  stop (paste("test rgdx(d,sparse) failed",chk$msg))
}

ewant <- list(name="E", type="parameter", dim=2,
              val=eVals,
              form="sparse",
              uels=eUels,
              domains=c('_compressed','_compressed'))
e <- rgdx(fnIn,list(name='e',form='sparse',compress=TRUE),useDomInfo=useDomInfo)
chk <- chkRgdxRes (e, ewant)
if (!chk$same) {
  stop (paste("test rgdx(e,sparse) failed",chk$msg))
}

cwant <- list(name="c", type="parameter", dim=1,
              val=cVals,
              form="sparse",
              uels=cUels,
              domains=c('_compressed'))
c <- rgdx(fnIn,list(name='c',form='sparse',compress=TRUE),useDomInfo=useDomInfo)
chk <- chkRgdxRes (c, cwant)
if (!chk$same) {
  stop (paste("test rgdx(c,sparse) failed",chk$msg))
}


## ---------- reading form=full

iwant <- list(name="I", type="set", dim=1,
              val=iOnes,
              form="full",
              uels=list(iUels),
              domains=c('_compressed'))
i <- rgdx(fnIn,list(name='i',form='full',compress=TRUE),useDomInfo=useDomInfo)
chk <- chkRgdxRes (i, iwant)
if (!chk$same) {
  stop (paste("test rgdx(i,full) failed",chk$msg))
}

jwant <- list(name="J", type="set", dim=1,
              val=jOnes,
              form="full",
              uels=list(jUels),
              domains=c('_compressed'))
j <- rgdx(fnIn,list(name='j',form='full',compress=TRUE),useDomInfo=useDomInfo)
chk <- chkRgdxRes (j, jwant)
if (!chk$same) {
  stop (paste("test rgdx(j,full) failed",chk$msg))
}

awant <- list(name="A", type="parameter", dim=2,
              val=aFull,
              form="full",
              uels=aUels,
              domains=c('_compressed','_compressed'))
a <- rgdx(fnIn,list(name='a',form='full',compress=TRUE),useDomInfo=useDomInfo)
chk <- chkRgdxRes (a, awant)
if (!chk$same) {
  stop (paste("test rgdx(a,full) failed",chk$msg))
}

bwant <- list(name="B", type="parameter", dim=2,
              val=bFull,
              form="full",
              uels=bUels,
              domains=c('_compressed','_compressed'))
b <- rgdx(fnIn,list(name='b',form='full',compress=TRUE),useDomInfo=useDomInfo)
chk <- chkRgdxRes (b, bwant)
if (!chk$same) {
  stop (paste("test rgdx(b,full) failed",chk$msg))
}

dwant <- list(name="D", type="parameter", dim=2,
              val=dFull,
              form="full",
              uels=dUels,
              domains=c('_compressed','_compressed'))
d <- rgdx(fnIn,list(name='d',form='full',compress=TRUE),useDomInfo=useDomInfo)
chk <- chkRgdxRes (d, dwant)
if (!chk$same) {
  stop (paste("test rgdx(d,full) failed",chk$msg))
}

ewant <- list(name="E", type="parameter", dim=2,
              val=eFull,
              form="full",
              uels=eUels,
              domains=c('_compressed','_compressed'))
e <- rgdx(fnIn,list(name='e',form='full',compress=TRUE),useDomInfo=useDomInfo)
chk <- chkRgdxRes (e, ewant)
if (!chk$same) {
  stop (paste("test rgdx(e,full) failed",chk$msg))
}

cwant <- list(name="c", type="parameter", dim=1,
              val=cFull,
              form="full",
              uels=cUels,
              domains=c('_compressed'))
c <- rgdx(fnIn,list(name='c',form='full',compress=TRUE),useDomInfo=useDomInfo)
chk <- chkRgdxRes (c, cwant)
if (!chk$same) {
  stop (paste("test rgdx(c,full) failed",chk$msg))
}

## ## test wgdx with form='sparse', 20-d variable: see if we can go big

if (! require(gdxrrw))      stop ("gdxrrw package is not available")
if (0 == igdx(silent=TRUE)) stop ("the gdx shared library has not been loaded")

testName <- '20-dim var with 2**20 ~= 1M entries'
logFile <- 'diffLog.txt'

errFunc <- function(ex) {
  print (paste0("test of wgdx on ",testName,": FAILED"))
  print (paste("Check file", logFile, "for possible gdxdiff output"))
  print (ex)
  FALSE
} # errFunc

tryCatch({
  print (paste("testing wgdx on", testName))
  print ("-----------------------------------------------")
  print ("--- N.B.: This test may take a minute or so ---")
  print ("-----------------------------------------------")
  wgdx('?')
  fnOut <- "tmp.gdx"
  fnWant <- "tVar20.gdx"
  if (! file_test ('-f', fnWant)) {
    stop (paste("FAIL: File-to-duplicate", fnWant, "does not exist"))
  }

  u1 <- c("d1_1","d1_2")
  u2 <- c("d2_1","d2_2")
  u3 <- c("d3_1","d3_2")
  u4 <- c("d4_1","d4_2")
  u5 <- c("d5_1","d5_2")
  u6 <- c("d6_1","d6_2")
  u7 <- c("d7_1","d7_2")
  u8 <- c("d8_1","d8_2")
  u9 <- c("d9_1","d9_2")
  ua <- c("da_1","da_2")
  ub <- c("db_1","db_2")
  uc <- c("dc_1","dc_2")
  ud <- c("dd_1","dd_2")
  ue <- c("de_1","de_2")
  uf <- c("df_1","df_2")
  ug <- c("dg_1","dg_2")
  uh <- c("dh_1","dh_2")
  ui <- c("di_1","di_2")
  uj <- c("dj_1","dj_2")
  uk <- c("dk_1","dk_2")
  fUels <- c("l", "m", "lo", "up", "s")
  uels <- list(u1,u2,u3,u4,u5,u6,u7,u8,u9,ua,
               ub,uc,ud,ue,uf,ug,uh,ui,uj,uk,fUels)
#  uels <- list(u1,u2,u3,u4,fUels)

  nd <- 20                              # number of dimensions
  ncol <- nd + 2
  nrow <- 2**nd
  step <- nrow / 2
  v <- matrix(0,nrow=nrow,ncol=ncol)
  for (d in 1:nd) {
    print(paste("d = ",d))
    b <- 0
    while (b < nrow) {
      # print(paste("  assigning 1 to",b+(1:step)))
      v[b+1:step,d] <- 1
      b <- b + step
      # print(paste("  assigning 2 to",b+(1:step)))
      v[b+1:step,d] <- 2
      b <- b + step
    }
    step <- step / 2
  }
  v[1:nrow,nd+1] <- 1                  # field=level
  v[1:nrow,ncol] <- 0.75

  ## patch in a marginal: idx = (1,2,1,1,1,***)
  b <- nrow / 4
  irow <- b + 1
  v[irow,nd+1] <- 2                     # field=marginal
  v[irow,ncol] <- 0.5

  ## patch in a lower: idx = (1,1,2,1,1,1,***)
  b <- b / 2
  irow <- b + 1
  v[irow,nd+1] <- 3                     # field=lower
  v[irow,ncol] <- 0

  ## patch in an upper: idx = (1,1,1,2,1,1,1,***)
  b <- b / 2
  irow <- b + 1
  v[irow,nd+1] <- 4                     # field=upper
  v[irow,ncol] <- 0

  ## patch in a scale: idx = (1,1,1,1,2,1,1,1,***)
  b <- b / 2
  irow <- b + 1
  v[irow,nd+1] <- 5                     # field=scale
  v[irow,ncol] <- 100

  vList <- list(name='big',type='variable',val=v,uels=uels,
                  typeCode=GMS_VARTYPE$FREE,ts='20-dim var')
  wgdx (fnOut, vList)
  if (file_test ('-f', fnOut) == TRUE) {
    print (paste("File", fnOut, "was created"))
  } else {
    stop (paste("FAIL: File", fnOut, "is not readable"))
  }
  rc <- system2 ("gdxdiff",args=c(fnWant, fnOut, "id=big"), stdout=logFile)
  if (0 != rc) {
    stop(paste("Bad return from gdxdiff: wanted 0, got",rc))
  } else {
    print ("gdxdiff call succeeded")
  }


  ## full test
  dims <- sapply(uels,length)
  symDim <- length(dims)-1
  step <- 2**symDim
  vf <- array(0, dim=dims, dimnames=uels)
  for (k in 0:(step-1)) {
    vf[k+1   ] <- 0.75
    vf[k+1 + step] <- 0
    vf[k+1 + 2*step] <- -Inf
    vf[k+1 + 3*step] <-  Inf
    vf[k+1 + 4*step] <-  1
  }
  k <- 3
  vf[k] <- 0
  vf[k+step] <- 0.5

  k <- 5
  vf[k] <- 0
  vf[k+2*step] <- 0

  k <- 9
  vf[k] <- 0
  vf[k+3*step] <- 0

  k <- 17
  vf[k] <- 0
  vf[k+4*step] <- 100

  vList <- list(name='big',type='variable',val=vf,form='full',uels=uels,
                typeCode=GMS_VARTYPE$FREE,ts='20-dim var')
  wgdx (fnOut, vList)
  if (file_test ('-f', fnOut) == TRUE) {
    print (paste("File", fnOut, "was created"))
  } else {
    stop (paste("FAIL: File", fnOut, "is not readable"))
  }
  rc <- system2 ("gdxdiff",args=c(fnWant, fnOut, "id=big"), stdout=logFile)
  if (0 != rc) {
    stop(paste("Bad return from gdxdiff: wanted 0, got",rc))
  } else {
    print ("gdxdiff call succeeded")
  }


  print (paste0("test of wgdx on ", testName, ": PASSED"))
  suppressWarnings(file.remove(logFile))
  invisible(TRUE)   ## all tests passed: return TRUE
},

error = errFunc
)

### Test rgdx and wgdx, checking that the ls01 model from testlib is
# giving the same results as R

# In this test we take data from GAMS describing a simple linear
# least-squares model, do the analysis in R, and compare the R results
# with those computed by the GAMS LS solver and verified to be
# consistent with the "certified" results on the NIST site.
# For a test problem we use the data from the GAMS test model ls01,
# originally taken from the Norris test problem on the NIST web site.

# options(list("digits"=10))

if (! require(gdxrrw))      stop ("gdxrrw package is not available")
if (0 == igdx(silent=TRUE)) stop ("the gdx shared library has not been loaded")

fnData <- "ls01Data.gdx"
fnRSol <- "ls01RSolu.gdx"
fnGSol <- "ls01GamsSolu.gdx"

tryCatch({
  if (! file_test ('-f', fnData)) {
    stop (paste("FAIL: File", fnData, "does not exist"))
  }
  lst <- list(name='p',form='full',compress=TRUE)
  data <- rgdx(fnData,lst)
  p <- data$uels
  lst <- list(name='i',form='full',compress=TRUE)
  data <- rgdx(fnData,lst)
  i <- data$uels
  lst <- list(name='data',form='full',compress=TRUE)
  data <- rgdx(fnData,lst)
  d <- data.frame(y=data$val[,1],x=data$val[,2])

  f <- y ~ x
  res <- lm(f, data = d)
  est <- as.array(coef(res))
  smry <- summary(res)
  se <- as.array(smry$coefficients[,'Std. Error'])
  df <- res$df.residual
  residuals <- res$residuals

  estlst <- list(name='estimate', type='parameter', form='full',
                 ts='Estimated coefficients', val=est, uels=p)

  selst <- list(name='se', type='parameter', form='full',
              ts='Standard errors',
              val=se, uels=p)

  tlst <- list(name='tval', type='parameter', form='full',
               ts='t values',
               val=as.array(smry$coefficients[,'t value']), uels=p)

  plst <- list(name='pval', type='parameter', form='full',
              ts='p values',
              val=as.array(smry$coefficients[,'Pr(>|t|)']), uels=p)

  dflst <- list(name='df', type='parameter', form='full', dim=0,
                ts='Degrees of freedom', val=df)

  sigmalst <- list(name='sigma', type='parameter', form='full', dim=0,
                   ts='Standard error',
                   val=smry$sigma)

  r2lst <- list(name='r2', type='parameter', form='full', dim=0,
                ts='R Squared',
                val=smry$r.squared)

  resvarlst <- list(name='resvar', type='parameter', form='full', dim=0,
                    ts='Residual variance',
                    val=(smry$sigma)^2)

  rsslst <- list(name='rss', type='parameter', form='full', dim=0,
                 ts='Residual sum of squares',
                 val=sum(residuals^2))

  residualslst <- list(name='resid', type='parameter', form='full',
                  ts='residuals',
                  val=as.array(residuals), uels=i)

  fittedlst <- list(name='fitted', type='parameter', form='full',
               ts='fitted values for dependent variable',
               val=as.array(res$fitted.values), uels=i)

  # set of confidence intervals to write
  cnf <- c("90%"=.9, "95%"=.95, "97.5%"=.975, "99%"=.99)
  confs <- list(attr(cnf,"names"))
  ncnf  <- length(cnf)
  bnds  <- list(c("LO", "UP"))
  nbnds <- length(bnds[[1]])
  confint <- array(0.5,dim=c(ncnf,length(p[[1]]),nbnds))
  for (k in 1:ncnf) {
    tstar <- qt((1+cnf[k])/2,df=df)
    confint[k,,1] <- est - tstar * se
    confint[k,,2] <- est + tstar * se
  }
  conflst <- list(name='confint', type='parameter', form='full',
               ts='confidence intervals',
               val=confint, uels=c(confs,p,bnds))

  covlst <- list(name='covar', type='parameter', form='full',
               ts='variance-covariance matrix',
               val=vcov(res), uels=c(p,p))

  wgdx (fnRSol, estlst, selst, tlst, plst, dflst, sigmalst, r2lst,
        resvarlst, rsslst, residualslst, fittedlst, conflst, covlst)

  if (file_test ('-f', fnRSol) == TRUE) {
    print (paste("File", fnRSol, "was created"))
  } else {
    stop (paste("FAIL: File", fnRSol, "is not readable"))
  }
  rc <- system (paste("gdxdiff",fnGSol,fnRSol,
                "releps=5e-12 eps=1e-30",
                " id=estimate,se,df,sigma,r2,resid,fitted,resvar,rss"))
  if (0 != rc) {
    stop(paste("Bad return from tight gdxdiff: wanted 0, got",rc))
  } else {
    print ("tight gdxdiff call succeeded")
  }

  rc <- system (paste("gdxdiff",fnGSol,fnRSol,"releps=1e-5 eps=1e-30",
                "id=tval,pval,confint,covar"))
  if (0 != rc) {
    stop(paste("Bad return from loose gdxdiff: wanted 0, got",rc))
  } else {
    print ("loose gdxdiff call succeeded")
  }
  return (TRUE)
}

, error = function(ex) { print(ex) ; return (FALSE) }
)

#### test rgdx and compress=TRUE and useDomInfo=FALSE with a recent GDX file containing full domain info
#### test both form=['sparse','full']

if (! require(gdxrrw))      stop ("gdxrrw package is not available")
if (0 == igdx(silent=TRUE)) stop ("the gdx shared library has not been loaded")

source ("chkSame.R")
reqIdent <- TRUE

tryCatch({
  print ("testing rgdx handling of GDX file with compress=TRUE and useDomInfo=FALSE")
  rgdx('?')
  fnIn <- "compressTest.gdx"
  if (! file_test ('-f', fnIn)) {
    stop (paste("FAIL: File", fnIn, "does not exist"))
  }
  useDomInfo <- FALSE                   # NOT the default

  source ("tReadCompressBody.R")


  print ("test of rgdx with compress=TRUE and useDomInfo=FALSE passed")
  TRUE   ## all tests passed: return TRUE
},

error = function(ex) { print ("test of rgdx with compress=TRUE and useDomInfo=FALSE failed"); print(ex) ; FALSE }
)

### run through all the tests

if (! require(gdxrrw))      stop ("gdxrrw package is not available")
if (0 == igdx(silent=TRUE)) stop ("the gdx shared library has not been loaded")

gdir <- igdx(NULL,silent=TRUE,returnStr=TRUE)
pth <- Sys.getenv('PATH')
sepChar <- ':'
if (Sys.info()[[1]] == "Windows") sepChar <- ';'
Sys.setenv(PATH=paste(gdir,pth,sep=sepChar))

rc <- source ("tgdxdiff.R")
if (! rc$value)  stop ("The gdxdiff utility is unavailable or broken: Test run aborted.")

tests <- c(
           "tLS")
f <- find('interact',mode='logical')
doPrompt <- FALSE
if (length(f) > 0) {
  doPrompt <- interact
} else {
  doPrompt <- interactive()
}

nRuns <- 0
nFails  <- 0
fTests <- list()
for (ttt in tests) {
  print ('---------------------------------------------------------------')
  print (paste("Starting test", ttt))
  rc <- source (paste(ttt,".R",sep=""))
  if (rc$value) {
    print (paste("Test", ttt, "result: PASSED"))
  } else {
    print (paste("Test", ttt, "result: FAILED"))
    nFails  <- nFails + 1
    fTests[[ttt]] <- T
  }
  nRuns  <- nRuns + 1
  if (doPrompt) {
    ans <- readline("Hit enter to continue ")
    print ("")
  }
}
Sys.setenv(PATH=pth)
if (nFails) {
  print (paste("Tests complete. ", nRuns,"tests run,",nFails,"tests FAILED"))
  for (nm in names(fTests)) print(paste0('  ',nm))
} else {
  print (paste("Testing complete.  All", nRuns,"tests PASSED"))
}

#### test rgdx and reading set text data, i.e. I.te(I) in gams
#### test form=['sparse','full'] X [filtered,unfiltered] X compress=[T,F]

#### wanted lists produced with    dump("listName",file="")

if (! require(gdxrrw))      stop ("gdxrrw package is not available")
if (0 == igdx(silent=TRUE)) stop ("the gdx shared library has not been loaded")

source ("chkSame.R")

tryCatch({
  print ("testing rgdx handling of set text")
  rgdx('?')
  fnIn <- "teTest.gdx"
  if (! file_test ('-f', fnIn)) {
    stop (paste("FAIL: File", fnIn, "does not exist"))
  }
  iUels <- c("i1", "i2", "i3", "i4")
  iCard <- length(iUels)
  iText <- iUels                        # since no text is in GDX
  i2uels <- iUels[1:3]                  # uels from i that appear in ij
  i2card <- length(i2uels)
  ifUels <- iUels[2:4]                  # uels from i to use in filtered read
  ifCard <- length(ifUels)
  ifText <- iText[2:4]
  jUels <- c("j1", "j2", "j3")
  jCard <- length(jUels)
  jText <- c("j1 text", "j2 text", "j3 text")
  jfUels <- jUels[1:3]                  # uels from j to use in filtered read
  jfCard <- length(jfUels)
  jfText <- jText[1:3]
  cUels <- c("berlin", "paris", "vienna")
  cCard <- length(cUels)
  cText <- c("city of airport delays", "city of light", "city of dreams")
  u <- c(iUels, jUels, cUels)
  uCard <- length(u)


  ## ---------- reading form=sparse, no filter, no compress

  iwant <- list(name="I", type="set", dim=1,
                val=matrix(c(1:4), nrow=4, ncol=1),
                form="sparse",
                uels=list(u), domains=c("*"), te=iText)
  i <- rgdx(fnIn,list(name='i',form='sparse',te=TRUE))
  chk <- chkRgdxRes (i, iwant)
  if (!chk$same) {
    stop (paste("test rgdx(i,unfiltered,uncompressed) failed",chk$msg))
  }

  jwant <- list(name="J", type="set", dim=1,
                val=matrix(c(5:7), nrow=3, ncol=1),
                form="sparse",
                uels=list(u), domains=c("*"),
                te=jText)
  j <- rgdx(fnIn,list(name='j',form='sparse',te=TRUE))
  chk <- chkRgdxRes (j, jwant)
  if (!chk$same) {
    stop (paste("test rgdx(j,unfiltered,uncompressed) failed",chk$msg))
  }

  cwant <- list(name="c", type="set", dim=1,
                val=matrix(c(8:10), nrow=3, ncol=1),
                form="sparse",
                uels=list(u), domains=c("*"),
                ts='cities',
                te=cText)
  c <- rgdx(fnIn,list(name='c',form='sparse',te=TRUE,ts=TRUE))
  chk <- chkRgdxRes (c, cwant)
  if (!chk$same) {
    stop (paste("test rgdx(c,unfiltered,uncompressed) failed",chk$msg))
  }

  ijwant <- list(name="IJ", type="set", dim=2,
                 val=matrix(c(1,1,
                              1,3,
                              2,2,
                              2,3,
                              3,3), nrow=5, ncol=2, byrow=TRUE),
                 form="sparse",
                 uels=list(iUels,jUels), domains=c("I","J"),
                 ts='',
                 te=c("one.one", "one.three", "two.two", "two.three", "three.three"))
  ij <- rgdx(fnIn,list(name='ij',form='sparse',te=TRUE,ts=TRUE))
  chk <- chkRgdxRes (ij, ijwant)
  if (!chk$same) {
    stop (paste("test rgdx(ij,unfiltered,uncompressed) failed",chk$msg))
  }

  ijcwant <- list(name="IJc", type="set", dim=3,
                  val=matrix(c(1,1,1,
                               1,3,1,
                               2,2,2,
			       2,3,2,
			       3,3,3),
                             nrow=5, ncol=3, byrow=TRUE),
                  form="sparse",
                  uels=list(iUels,jUels,cUels), domains=c("I","J","c"),
                  te=c("eins eins tempelhof", "eins drei tempelhof", "deux deux orly",
                    "deux trois orly", "drei drei schwechat"))
  ijc <- rgdx(fnIn,list(name='ijc',form='sparse',te=TRUE))
  chk <- chkRgdxRes (ijc, ijcwant)
  if (!chk$same) {
    stop (paste("test rgdx(ijc,unfiltered,uncompressed) failed",chk$msg))
  }

  ## ---------- reading form=sparse, no filter, compress=TRUE

  iwant <- list(name="I", type="set", dim=1,
                val=matrix(c(1:4), nrow=4, ncol=1),
                form="sparse",
                uels=list(iUels), domains=c("_compressed"), te=iText)
  i <- rgdx(fnIn,list(name='i',form='sparse',te=TRUE,compress=TRUE))
  chk <- chkRgdxRes (i, iwant)
  if (!chk$same) {
    stop (paste("test rgdx(i,unfiltered,compressed) failed",chk$msg))
  }

  jwant <- list(name="J", type="set", dim=1,
                val=matrix(c(1:3), nrow=3, ncol=1),
                form="sparse",
                uels=list(jUels), domains=c("_compressed"),
                te=jText)
  j <- rgdx(fnIn,list(name='j',form='sparse',te=TRUE,compress=TRUE))
  chk <- chkRgdxRes (j, jwant)
  if (!chk$same) {
    stop (paste("test rgdx(j,unfiltered,compressed) failed",chk$msg))
  }

  ijwant <- list(name="IJ", type="set", dim=2,
                 val=matrix(c(1,1,
                              1,3,
                              2,2,
                              2,3,
                              3,3), nrow=5, ncol=2, byrow=TRUE),
                 form="sparse",
                 uels=list(i2uels,jUels), # i4 is compressed out
                 domains=c("_compressed","_compressed"),
                 ts='',
                 te=c("one.one", "one.three", "two.two", "two.three", "three.three"))
  ij <- rgdx(fnIn,list(name='ij',form='sparse',te=TRUE,ts=TRUE,compress=TRUE))
  chk <- chkRgdxRes (ij, ijwant)
  if (!chk$same) {
    stop (paste("test rgdx(ij,unfiltered,compressed) failed",chk$msg))
  }

  ijcwant <- list(name="IJc", type="set", dim=3,
                  val=matrix(c(1,1,1, 1,3,1, 2,2,2, 2,3,2, 3,3,3),
                             nrow=5, ncol=3, byrow=TRUE),
                  form="sparse",
                  uels=list(iUels[1:3],jUels,cUels),
                  domains=c("_compressed","_compressed","_compressed"),
                  te=c("eins eins tempelhof", "eins drei tempelhof", "deux deux orly",
                    "deux trois orly", "drei drei schwechat"))
  ijc <- rgdx(fnIn,list(name='ijc',form='sparse',te=TRUE,compress=TRUE))
  chk <- chkRgdxRes (ijc, ijcwant)
  if (!chk$same) {
    stop (paste("test rgdx(ijc,unfiltered,compressed) failed",chk$msg))
  }

  ## ---------- reading form=sparse, filtered, no compress

  iwant <- list(name="I", type="set", dim=1,
                val=matrix(c(1:3), nrow=3, ncol=1),
                form="sparse",
                uels=list(ifUels), domains=c("_user"), te=ifText)
  i <- rgdx(fnIn,list(name='i',form='sparse',uels=list(ifUels),te=TRUE))
  chk <- chkRgdxRes (i, iwant)
  if (!chk$same) {
    stop (paste("test rgdx(i,filtered,uncompressed) failed",chk$msg))
  }

  jwant <- list(name="J", type="set", dim=1,
                val=matrix(1:3, nrow=3, ncol=1),
                form="sparse",
                uels=list(jfUels), domains=c("_user"),
                te=jfText)
  j <- rgdx(fnIn,list(name='j',form='sparse',uels=list(jfUels),te=TRUE))
  chk <- chkRgdxRes (j, jwant)
  if (!chk$same) {
    stop (paste("test rgdx(j,filtered,uncompressed) failed",chk$msg))
  }

  cwant <- list(name="c", type="set", dim=1,
                val=matrix(c(8:10), nrow=3, ncol=1),
                form="sparse",
                uels=list(u), domains=c("_user"),
                ts='cities',
                te=cText)
  c <- rgdx(fnIn,list(name='c',form='sparse',uels=list(u),te=TRUE,ts=TRUE))
  chk <- chkRgdxRes (c, cwant)
  if (!chk$same) {
    stop (paste("test rgdx(c,filtered,uncompressed) failed",chk$msg))
  }

  ijwant <- list(name="IJ", type="set", dim=2,
                 val=matrix(c(1,2, 1,3, 2,3), nrow=3, ncol=2, byrow=TRUE),
                 form="sparse",
                 uels=list(ifUels,jfUels), domains=c("_user","_user"),
                 ts='',
                 te=c("two.two", "two.three", "three.three"))
  ij <- rgdx(fnIn,list(name='ij',form='sparse',uels=list(ifUels,jfUels),te=TRUE,ts=TRUE))
  chk <- chkRgdxRes (ij, ijwant)
  if (!chk$same) {
    stop (paste("test rgdx(ij,filtered,uncompressed) failed",chk$msg))
  }

  ijcwant <- list(name="IJc", type="set", dim=3,
                  val=matrix(c(1,2,9, 1,3,9, 2,3,10),
                             nrow=3, ncol=3, byrow=TRUE),
                  form="sparse",
                  uels=list(ifUels,jfUels,u), domains=c("_user","_user","_user"),
                  te=c("deux deux orly", "deux trois orly", "drei drei schwechat"))
  ijc <- rgdx(fnIn,list(name='ijc',form='sparse',uels=list(ifUels,jfUels,u),te=TRUE))
  chk <- chkRgdxRes (ijc, ijcwant)
  if (!chk$same) {
    stop (paste("test rgdx(ijc,filtered,uncompressed) failed",chk$msg))
  }

  ## ---------- reading form=full, no filter, no compress

  v <- array(0,c(uCard,1))
  v[(1:iCard)] <- 1
  te <- array("",c(uCard,1))
  te[(1:iCard)] <- iText
  iwant <- list(name="I", type="set", dim=1,
                val=v,
                form="full",
                uels=list(u), domains=c("*"),
                te=te)
  i <- rgdx(fnIn,list(name='i',form='full',te=TRUE))
  chk <- chkRgdxRes (i, iwant)
  if (!chk$same) {
    stop (paste("test rgdx(i,full,unfiltered,uncompressed) failed",chk$msg))
  }

  jblock <- iCard + (1:jCard)
  v <- array(0,c(uCard,1))
  v[jblock] <- 1
  te <- array("",c(uCard,1))
  te[jblock] <- jText
  jwant <- list(name="J", type="set", dim=1,
                val=v,
                form="full",
                uels=list(u), domains=c("*"), te=te)
  j <- rgdx(fnIn,list(name='j',form='full',te=TRUE))
  chk <- chkRgdxRes (j, jwant)
  if (!chk$same) {
    stop (paste("test rgdx(j,full,unfiltered,uncompressed) failed",chk$msg))
  }

  cblock <- iCard + jCard + (1:cCard)
  v <- array(0,c(uCard,1))
  v[cblock] <- 1
  te <- array("",c(uCard,1))
  te[cblock] <- cText
  cwant <- list(name="c", type="set", dim=1,
                val=v,
                form="full",
                uels=list(u), domains=c("*"), te=te)
  c <- rgdx(fnIn,list(name='c',form='full',te=TRUE))
  chk <- chkRgdxRes (c, cwant)
  if (!chk$same) {
    stop (paste("test rgdx(c,full,unfiltered,uncompressed) failed",chk$msg))
  }

  v <- array(0,c(iCard,jCard),dimnames=list(iUels,jUels))
  v['i1','j1'] <- 1;
  v['i1','j3'] <- 1;
  v['i2','j2'] <- 1;
  v['i2','j3'] <- 1;
  v['i3','j3'] <- 1;
  te <- array("",c(iCard,jCard),dimnames=list(iUels,jUels))
  te['i1','j1'] <- "one.one";
  te['i1','j3'] <- "one.three";
  te['i2','j2'] <- "two.two";
  te['i2','j3'] <- "two.three";
  te['i3','j3'] <- "three.three";
  ijwant <- list(name="IJ", type="set", dim=2,
                 val=v,
                 form="full",
                 uels=list(iUels,jUels), domains=c("I","J"),
                 ts='',
                 te=te)
  ij <- rgdx(fnIn,list(name='ij',form='full',te=TRUE,ts=TRUE))
  chk <- chkRgdxRes (ij, ijwant)
  if (!chk$same) {
    stop (paste("test rgdx(ij,full,unfiltered,uncompressed) failed",chk$msg))
  }

  v <- array(0,c(iCard,jCard,cCard),dimnames=list(iUels,jUels,cUels))
  v['i1','j1','berlin'] <- 1;
  v['i1','j3','berlin'] <- 1;
  v['i2','j2','paris' ] <- 1;
  v['i2','j3','paris' ] <- 1;
  v['i3','j3','vienna'] <- 1;
  te <- array("",c(iCard,jCard,cCard),dimnames=list(iUels,jUels,cUels))
  te['i1','j1','berlin'] <- "eins eins tempelhof";
  te['i1','j3','berlin'] <- "eins drei tempelhof";
  te['i2','j2','paris' ] <- "deux deux orly";
  te['i2','j3','paris' ] <- "deux trois orly";
  te['i3','j3','vienna'] <- "drei drei schwechat";
  ijcwant <- list(name="IJc", type="set", dim=3,
                  val=v,
                  form="full",
                  uels=list(iUels,jUels,cUels), domains=c("I","J","c"),
                  te=te)
  ijc <- rgdx(fnIn,list(name='ijc',form='full',te=TRUE))
  chk <- chkRgdxRes (ijc, ijcwant)
  if (!chk$same) {
    stop (paste("test rgdx(ijc,full,unfiltered,uncompressed) failed",chk$msg))
  }

  ## ---------- reading form=full, no filter, compress=TRUE

  v <- array(1,c(iCard,1))
  te <- array("",c(iCard,1))
  te[(1:iCard)] <- iText
  iwant <- list(name="I", type="set", dim=1,
                val=v,
                form="full",
                uels=list(iUels), domains=c("_compressed"), te=te)
  i <- rgdx(fnIn,list(name='i',form='full',te=TRUE,compress=TRUE))
  chk <- chkRgdxRes (i, iwant)
  if (!chk$same) {
    stop (paste("test rgdx(i,full,unfiltered,compressed) failed",chk$msg))
  }

  v <- array(1,c(jCard,1))
  te <- array("",c(jCard,1))
  te[(1:jCard)] <- jText
  jwant <- list(name="J", type="set", dim=1,
                val=v,
                form="full",
                uels=list(jUels), domains=c("_compressed"),
                te=te)
  j <- rgdx(fnIn,list(name='j',form='full',te=TRUE,compress=TRUE))
  chk <- chkRgdxRes (j, jwant)
  if (!chk$same) {
    stop (paste("test rgdx(j,full,unfiltered,compressed) failed",chk$msg))
  }

  v <- array(0,c(i2card,jCard),dimnames=list(i2uels,jUels))
  v['i1','j1'] <- 1;
  v['i1','j3'] <- 1;
  v['i2','j2'] <- 1;
  v['i2','j3'] <- 1;
  v['i3','j3'] <- 1;
  te <- array("",c(i2card,jCard),dimnames=list(i2uels,jUels))
  te['i1','j1'] <- "one.one";
  te['i1','j3'] <- "one.three";
  te['i2','j2'] <- "two.two";
  te['i2','j3'] <- "two.three";
  te['i3','j3'] <- "three.three";
  ijwant <- list(name="IJ", type="set", dim=2,
                 val=v,
                 form="full",
                 uels=list(i2uels,jUels), domains=c("_compressed","_compressed"),
                 ts='',
                 te=te)
  ij <- rgdx(fnIn,list(name='ij',form='full',te=TRUE,ts=TRUE,compress=TRUE))
  chk <- chkRgdxRes (ij, ijwant)
  if (!chk$same) {
    stop (paste("test rgdx(ij,full,unfiltered,compressed) failed",chk$msg))
  }

  v <- array(0,c(i2card,jCard,cCard),dimnames=list(i2uels,jUels,cUels))
  v['i1','j1','berlin'] <- 1;
  v['i1','j3','berlin'] <- 1;
  v['i2','j2','paris' ] <- 1;
  v['i2','j3','paris' ] <- 1;
  v['i3','j3','vienna'] <- 1;
  te <- array("",c(i2card,jCard,cCard),dimnames=list(i2uels,jUels,cUels))
  te['i1','j1','berlin'] <- "eins eins tempelhof";
  te['i1','j3','berlin'] <- "eins drei tempelhof";
  te['i2','j2','paris' ] <- "deux deux orly";
  te['i2','j3','paris' ] <- "deux trois orly";
  te['i3','j3','vienna'] <- "drei drei schwechat";
  ijcwant <- list(name="IJc", type="set", dim=3,
                  val=v,
                  form="full",
                  uels=list(i2uels,jUels,cUels),
                  domains=c("_compressed","_compressed","_compressed"),
                  te=te)
  ijc <- rgdx(fnIn,list(name='ijc',form='full',te=TRUE,compress=TRUE))
  chk <- chkRgdxRes (ijc, ijcwant)
  if (!chk$same) {
    stop (paste("test rgdx(ijc,full,unfiltered,uncompressed) failed",chk$msg))
  }

  ## ---------- reading form=full, filtered, no compress

  v <- array(1,c(ifCard,1))
  te <- array("",c(ifCard,1))
  te[(1:ifCard)] <- ifText
  iwant <- list(name="I", type="set", dim=1,
                val=v,
                form="full",
                uels=list(ifUels), domains=c("_user"), te=te)
  i <- rgdx(fnIn,list(name='i',form='full',uels=list(ifUels),te=TRUE))
  chk <- chkRgdxRes (i, iwant)
  if (!chk$same) {
    stop (paste("test rgdx(i,full,filtered,uncompressed) failed",chk$msg))
  }

  v <- array(1,c(jfCard,1))
  te <- array("",c(jfCard,1))
  te[(1:jfCard)] <- jfText
  jwant <- list(name="J", type="set", dim=1,
                val=v,
                form="full",
                uels=list(jfUels), domains=c("_user"),
                te=te)
  j <- rgdx(fnIn,list(name='j',form='full',te=TRUE,uels=list(jfUels)))
  chk <- chkRgdxRes (j, jwant)
  if (!chk$same) {
    stop (paste("test rgdx(j,full,filtered,uncompressed) failed",chk$msg))
  }

  cblock <- iCard + jCard + (1:cCard)
  v <- array(0,c(uCard,1))
  v[cblock] <- 1
  te <- array("",c(uCard,1))
  te[cblock] <- cText
  cwant <- list(name="c", type="set", dim=1,
                val=v,
                form="full",
                uels=list(u), domains=c("_user"),
                ts='cities',
                te=te)
  c <- rgdx(fnIn,list(name='c',form='full',uels=list(u),te=TRUE,ts=TRUE))
  chk <- chkRgdxRes (c, cwant)
  if (!chk$same) {
    stop (paste("test rgdx(c,full,filtered,uncompressed) failed",chk$msg))
  }

  v <- array(0,c(ifCard,jfCard),dimnames=list(ifUels,jfUels))
  v['i2','j2'] <- 1;
  v['i2','j3'] <- 1;
  v['i3','j3'] <- 1;
  te <- array("",c(ifCard,jfCard),dimnames=list(ifUels,jfUels))
  te['i2','j2'] <- "two.two";
  te['i2','j3'] <- "two.three";
  te['i3','j3'] <- "three.three";
  ijwant <- list(name="IJ", type="set", dim=2,
                 val=v,
                 form="full",
                 uels=list(ifUels,jfUels), domains=c("_user","_user"),
                 ts='',
                 te=te)
  ij <- rgdx(fnIn,list(name='ij',form='full',te=TRUE,ts=TRUE,uels=list(ifUels,jfUels)))
  chk <- chkRgdxRes (ij, ijwant)
  if (!chk$same) {
    stop (paste("test rgdx(ij,full,filtered,uncompressed) failed",chk$msg))
  }

  v <- array(0,c(ifCard,jfCard,uCard),dimnames=list(ifUels,jfUels,u))
  v['i2','j2','paris' ] <- 1;
  v['i2','j3','paris' ] <- 1;
  v['i3','j3','vienna'] <- 1;
  te <- array("",c(ifCard,jfCard,uCard),dimnames=list(ifUels,jfUels,u))
  te['i2','j2','paris' ] <- "deux deux orly";
  te['i2','j3','paris' ] <- "deux trois orly";
  te['i3','j3','vienna'] <- "drei drei schwechat";
  ijcwant <- list(name="IJc", type="set", dim=3,
                  val=v,
                  form="full",
                  uels=list(ifUels,jfUels,u), domains=c("_user","_user","_user"),
                  te=te)
  ijc <- rgdx(fnIn,list(name='ijc',form='full',te=TRUE,uels=list(ifUels,jfUels,u)))
  chk <- chkRgdxRes (ijc, ijcwant)
  if (!chk$same) {
    stop (paste("test rgdx(ijc,full,filtered,uncompressed) failed",chk$msg))
  }


  print ("test of rgdx set text handling passed")
  TRUE   ## all tests passed: return TRUE
},

error = function(ex) { print ("test of rgdx set text handling failed"); print(ex) ; FALSE }
)

### Test wgdx
# We write all the transport data using sparse writes and a full universe

if (! require(gdxrrw))      stop ("gdxrrw package is not available")
if (0 == igdx(silent=TRUE)) stop ("the gdx shared library has not been loaded")

tryCatch({

  fn <- "tws1.gdx"

  print ("Test wgdx with form='sparse' and a full universe,")
  print ("using the transport data as the output target")
  wgdx('?')

  # this is the universe for this GDX file
  uu <- list(c("seattle", "san-diego", "new-york", "chicago", "topeka"))

  iv <- matrix(c(1:2), c(2,1))
  ilst <- list (name='i', type='set', dim=1, form='sparse', ts='canning plants', val=iv, uels=c(uu))

  jv <- matrix(c(3:5), c(3,1))
  jlst <- list (name='j', type='set', dim=1, form='sparse', ts='markets', val=jv, uels=c(uu))

  av <- matrix(c(1:2,350,600), c(2,2))
  alst <- list (name='a', type='parameter', dim=1, form='sparse',
                ts='capacity of plant i in cases', val=av, uels=c(uu))

  bv <- matrix(c(3, 325,
                 4, 300,
                 5, 275),  c(3,1), byrow=TRUE)
  blst <- list (name='b', type='parameter', dim=1, form='sparse',
                ts='demand at market j in cases', val=bv, uels=c(uu))

  f <- 90
  fv <- matrix(c(90),c(1,1))
  dv <- matrix(c(1, 3, 2.5,
                 1, 4, 1.7,
                 1, 5, 1.8,
                 2, 3, 2.5,
                 2, 4, 1.8,
                 2, 5, 1.4),  c(6,3), byrow=TRUE)
  cv <- dv
  cv[,3] <- dv[,3] * f / 1000

  clst <- list (name='c', type='parameter', dim=2, form='sparse',
                ts='transport cost in thousands of dollars per case', val=cv, uels=c(uu,uu))
  dlst <- list (name='d', type='parameter', dim=2, form='sparse',
                ts='distance in thousands of miles', val=dv, uels=c(uu,uu))

  flst <- list (name='f', type='parameter', dim=0, form='sparse',
                ts='freight in dollars per case per thousand miles', val=fv)

  wgdx (fn, ilst, jlst, alst, blst, clst, dlst, flst)

  if (file_test ('-f', fn) == TRUE) {
    print (paste("File", fn, "was created"))
  } else {
    stop (paste("FAIL: File", fn, "is not readable"))
  }
  rc <- system (paste("gdxdiff trnsport.gdx",fn,"releps=1e-15 id=i,j,a,b,c,d,f"))
  if (0 != rc) {
    stop(paste("Bad return from gdxdiff: wanted 0, got",rc))
  } else {
    print ("gdxdiff call succeeded")
  }
  return (TRUE)
}

, error = function(ex) { print(ex) ; return (FALSE) }
)

if (! require(gdxrrw))      stop ("gdxrrw package is not available")
if (0 == igdx(silent=TRUE)) stop ("the gdx shared library has not been loaded")

fnData <- "eurodist.gdx"
fnSol <- "eurosol.gdx"
suppressWarnings(file.remove(fnData,fnSol))

n <- attr(eurodist,"Size")
cities <- attr(eurodist,"Labels")
uu <- list(c(cities))
dd <- as.matrix(eurodist)

clst <- list(name='ii', type='set', ts='cities from stats::eurodist', uels=uu)
dlst <- list(name='c', type='parameter', dim=2, form='full',
             ts='distance', val=dd, uels=c(uu,uu))

wgdx (fnData, clst, dlst)
print ("Calling GAMS now - this may take some time.  Be patient.")
flush.console()
rc <- system (paste("gams tspDSE.gms --infile=",fnData,"--outfile=",fnSol))
if (0 != rc) {
  stop(paste("Bad return from gams: wanted 0, got",rc))
} else {
  print ("gams call succeeded")
}

lst <- list(name='modelstat',form='full',compress=TRUE)
v <- rgdx(fnSol, lst)
modelstat <- v$val
if (1 != modelstat)     stop(paste("Bad model status: expected 1, got", modelstat))

lst <- list(name='solvestat',form='full',compress=TRUE)
v <- rgdx(fnSol, lst)
solvestat <- v$val
if (1 != solvestat)     stop(paste("Bad solver status: expected 1, got", solvestat))

# tour <- rgdx.set(fnSol, "tour")
lst <- list(name='tour',form='sparse',compress=TRUE)
v <- rgdx(fnSol, lst)
nxt <- v$val[,2]

# now compute the sequence of cities to display, based on the next
# relationship in nxt
solSeq <- NA * c(1:n+1)
k <- 1
for (j in c(1:n)) {
  solSeq[j] <- k
  k <- nxt[k]
}
solSeq[n+1] <- 1
if (k != 1)  stop ("Bogus tour specified")


loc <- cmdscale(eurodist)
rx <- range(x <- loc[,1])
ry <- range(y <- -loc[,2])
tspres <- loc[solSeq,]
s <- seq(n)

plot(x, y, type="n", asp=1, xlab="", ylab="",
     main="optimal tour for traveling salesman problem")
arrows(tspres[s,1], -tspres[s,2], tspres[s+1,1], -tspres[s+1,2],
       angle=10, col="blue")
text(x, y, labels(eurodist), cex=0.8)

## ## test wgdx with 1-d variable and duplicate labels for the "field" dimension

if (! require(gdxrrw))      stop ("gdxrrw package is not available")
if (0 == igdx(silent=TRUE)) stop ("the gdx shared library has not been loaded")

testName <- 'duplicate field labels in variable writes'

errFunc <- function(ex) {
  print (paste0("test of wgdx on ",testName,": FAILED"))
  print(ex)
  FALSE
} # errFunc

tryCatch({
  print (paste("testing wgdx on", testName))
  wgdx('?')
  fnOut <- "tmp.gdx"
  fnWant <- "tVarTypes.gdx"
  if (! file_test ('-f', fnWant)) {
    stop (paste("FAIL: File-to-duplicate", fnWant, "does not exist"))
  }

  ## all writes should use the same uels
  iUels <- paste0("i","1":"10")
  fUels <- c("l", "m", "lo", "up", "s", "ignored") # this is potentially OK
  uels <- list(iUels,fUels)
  fxUels <- c("l", "m", "lo", "up", "s", "m") # this is potentially OK too
  xuels <- list(iUels,fxUels)

  ## write binary variable to GDX, compare with fnWant version
  val0 <- matrix(0,nrow=5,ncol=3)
  for (i in 1:5) {
    val0[i,1] <- i
    val0[i,2] <- i
  }
  val0[1,3] <- 1                        # binary.L = 1
  val0[2,3] <- 0.5                      # binary.m = 0.5
  val0[3,3] <- 1                        # binary.lo = 1
  val0[4,3] <- 0                        # binary.up = 0
  val0[5,3] <- 10                       # binary.prior = 10
  valBinary <- val0
  vBinary <- list(name='v_binary',type='variable',
                  val=valBinary,uels=uels,domains='i',
                  typeCode=GMS_VARTYPE$BINARY,ts='text for v_binary')
  wgdx (fnOut, vBinary)
  if (file_test ('-f', fnOut) == TRUE) {
    print (paste("File", fnOut, "was created"))
  } else {
    stop (paste("FAIL: File", fnOut, "is not readable"))
  }
  vWant <- rgdx(fnWant,list(name='v_binary',form='sparse',field='all',ts=TRUE))
  vWrote <- rgdx(fnOut,list(name='v_binary',form='sparse',field='all',ts=TRUE))
  if (identical(vWrote$domInfo,"relaxed"))
    vWrote$domInfo <- "full"
  if (identical(vWant,vWrote)) {
  }
  else {
    print(all.equal(vWant,vWrote))
    stop ("FAIL: for v_binary, vWant and vWrote do not agree")
  }

  ## this is OK since we don't use the duplicate
  vBinary$uels <- xuels
  wgdx (fnOut, vBinary)
  if (file_test ('-f', fnOut) == TRUE) {
    print (paste("File", fnOut, "was created"))
  } else {
    stop (paste("FAIL: File", fnOut, "is not readable"))
  }
  vWant <- rgdx(fnWant,list(name='v_binary',form='sparse',field='all',ts=TRUE))
  vWrote <- rgdx(fnOut,list(name='v_binary',form='sparse',field='all',ts=TRUE))
  if (identical(vWrote$domInfo,"relaxed"))
    vWrote$domInfo <- "full"
  if (identical(vWant,vWrote)) {
  }
  else {
    print(all.equal(vWant,vWrote))
    stop ("FAIL: for v_binary, vWant and vWrote do not agree")
  }

  ## this should break since we have duplicate "m" labels used
  vBinary$val[5,1] <- 5                 # 'i5'
  vBinary$val[5,2] <- 6                 # the duplicate 'm'
  vBinary$val[5,3] <- 0
  msg <- "wgdx test for writing variables, duplicate field labels used"
  tcr <- tryCatch({
    wgdx (fnOut, vBinary) ; FALSE
  },
    error = function(e) { print(paste(' Caught error: msg =',e)) ; TRUE }
  )
  if (tcr) {
    print(paste(msg,": passed",sep=""))
  }
  else {
    stop (paste(msg, ": failed",sep=""))
  }


  print (paste0("test of wgdx on ", testName, ": PASSED"))
  invisible(TRUE)   ## all tests passed: return TRUE
},

error = errFunc
)

#### test rgdx reading 1-dim variables
#### test form=['sparse','full'] X [filtered,unfiltered] X squeeze=[T,F]
#### ['l','m','lo','up','s']

#### wanted lists can be produced with    dump("listName",file="")

if (! require(gdxrrw))      stop ("gdxrrw package is not available")
if (0 == igdx(silent=TRUE)) stop ("the gdx shared library has not been loaded")

source ("chkSame.R")
reqIdent <- TRUE

kUels <- c('k1', 'k2', 'k3', 'k4')
kCard <- length(kUels)
dom <- c('k')
domf <- c('k','_field')
fields <- c('l','m','lo','up','s')
nFields <- length(fields)
cart <- list(kUels)
cartn <- cart ; names(cartn) <- dom
cartf <- list(kUels,fields)
cartfn <- cartf ; names(cartfn) <- domf
lev <- 1
mar <- 2
low <- 3
upp <- 4
sca <- 5

tryCatch({
  print ("testing rgdx on 1-dim variable reads")
  rgdx('?')
  fnIn <- "tReadVar1.gdx"
  if (! file_test ('-f', fnIn)) {
    stop (paste("FAIL: File", fnIn, "does not exist"))
  }

  ### ---------- reading form=sparse, no filter
  # all
  t <- matrix(c( 1, lev,   5
                ,1, mar,   0
                ,1, low,   5
                ,1, upp,   5
                ,1, sca,   1
                ,2, lev,   0
                ,2, mar,   1.5
                ,2, low,   0
                ,2, upp,   15
                ,2, sca,   1
                ,3, lev,   0
                ,3, mar,   0
                ,3, low,   0
                ,3, upp,   15
                ,3, sca,   1
             ), nrow=15, ncol=3, byrow=T)
  uwantA <- list(name='u', type='variable', dim=1L,
                 val=t,
                 form='sparse', uels=cartf,
                 domains=domf, domInfo="full",
                 field='all', varTypeText="integer", typeCode=GMS_VARTYPE$INTEGER)
  u <- rgdx(fnIn,list(name='u',form='sparse',field='ALL'))
  chk <- chkRgdxRes (u, uwantA, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(u,'all',unfiltered) failed",chk$msg))
  }
  u <- rgdx(fnIn,list(name='u',form='sparse',field='all'),squeeze=F)
  chk <- chkRgdxRes (u, uwantA, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(u,'all',unfiltered,squeeze=F) failed",chk$msg))
  }
  t <- matrix(c( 1, lev,   0
                ,1, mar,   0
                ,1, low,   -Inf
                ,1, upp,   +Inf
                ,1, sca,   1
                ,2, lev,   -2
                ,2, mar,   -20
                ,2, low,   -2
                ,2, upp,   -2
                ,2, sca,   1
             ), nrow=10, ncol=3, byrow=T)
  vwantA <- list(name='v', type='variable', dim=1L,
                 val=t,
                 form='sparse', uels=cartf,
                 domains=domf, domInfo="full",
                 field='all', varTypeText="negative", typeCode=GMS_VARTYPE$NEGATIVE)
  v <- rgdx(fnIn,list(name='v',form='sparse',field='ALL'))
  chk <- chkRgdxRes (v, vwantA, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(v,'all',unfiltered) failed",chk$msg))
  }
  v <- rgdx(fnIn,list(name='v',form='sparse',field='all'),squeeze=F)
  chk <- chkRgdxRes (v, vwantA, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(v,'all',unfiltered,squeeze=F) failed",chk$msg))
  }
  # level
  uwantL <- list(name='u', type='variable', dim=1L,
                 val=matrix(c( 1,   5), nrow=1, ncol=2, byrow=T),
                 form='sparse', uels=cart,
                 domains=dom, domInfo="full",
                 field='l', varTypeText="integer", typeCode=GMS_VARTYPE$INTEGER)
  u <- rgdx(fnIn,list(name='u',form='sparse',field='L'))
  chk <- chkRgdxRes (u, uwantL, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(u,'L',unfiltered) failed",chk$msg))
  }
  t <- matrix(c( 1,   5,
                 2,   0,
                 3,   0), nrow=3, ncol=2, byrow=T)
  uwantL$val <- t
  u <- rgdx(fnIn,list(name='u',form='sparse',field='L'),squeeze=F)
  chk <- chkRgdxRes (u, uwantL, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(u,'L',unfiltered,squeeze=F) failed",chk$msg))
  }
  vwantL <- list(name='v', type='variable', dim=1L,
                 val=matrix(c( 2,   -2), nrow=1, ncol=2, byrow=T),
                 form='sparse', uels=cart,
                 domains=dom, domInfo="full",
                 field='l', varTypeText="negative", typeCode=GMS_VARTYPE$NEGATIVE)
  v <- rgdx(fnIn,list(name='v',form='sparse',field='L'))
  chk <- chkRgdxRes (v, vwantL, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(v,'L',unfiltered) failed",chk$msg))
  }
  t <- matrix(c( 1,   0,
                 2,  -2), nrow=2, ncol=2, byrow=T)
  vwantL$val <- t
  v <- rgdx(fnIn,list(name='v',form='sparse',field='L'),squeeze=F)
  chk <- chkRgdxRes (v, vwantL, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(v,'L',unfiltered,squeeze=F) failed",chk$msg))
  }
  # marginal
  uwantM <- list(name='u', type='variable', dim=1L,
                 val=matrix(c( 2, 1.5), nrow=1, ncol=2, byrow=T),
                 form='sparse', uels=cart,
                 domains=dom, domInfo="full",
                 field='m', varTypeText="integer", typeCode=GMS_VARTYPE$INTEGER)
  u <- rgdx(fnIn,list(name='u',form='sparse',field='M'))
  chk <- chkRgdxRes (u, uwantM, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(u,'M',unfiltered) failed",chk$msg))
  }
  t <- matrix(c( 1,    0,
                 2,  1.5,
                 3,    0), nrow=3, ncol=2, byrow=T)
  uwantM$val <- t
  u <- rgdx(fnIn,list(name='u',form='sparse',field='M'),squeeze=F)
  chk <- chkRgdxRes (u, uwantM, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(u,'M',unfiltered,squeeze=F) failed",chk$msg))
  }
  vwantM <- list(name='v', type='variable', dim=1L,
                 val=matrix(c( 2,  -20), nrow=1, ncol=2, byrow=T),
                 form='sparse', uels=cart,
                 domains=dom, domInfo="full",
                 field='m', varTypeText="negative", typeCode=GMS_VARTYPE$NEGATIVE)
  v <- rgdx(fnIn,list(name='v',form='sparse',field='M'))
  chk <- chkRgdxRes (v, vwantM, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(v,'M',unfiltered) failed",chk$msg))
  }
  # lower
  uwantLo <- list(name='u', type='variable', dim=1L,
                  val=matrix(c( 1, 5), nrow=1, ncol=2, byrow=T),
                  form='sparse', uels=cart,
                  domains=dom, domInfo="full",
                  field='lo', varTypeText="integer", typeCode=GMS_VARTYPE$INTEGER)
  u <- rgdx(fnIn,list(name='u',form='sparse',field='Lo'))
  chk <- chkRgdxRes (u, uwantLo, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(u,'lo',unfiltered) failed",chk$msg))
  }
  vwantLo <- list(name='v', type='variable', dim=1L,
                  val=matrix(c(2,  -2), nrow=1, ncol=2, byrow=T),
                  form='sparse', uels=cart,
                  domains=dom, domInfo="full",
                  field='lo', varTypeText="negative", typeCode=GMS_VARTYPE$NEGATIVE)
  v <- rgdx(fnIn,list(name='v',form='sparse',field='lo'))
  chk <- chkRgdxRes (v, vwantLo, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(v,'lo',unfiltered) failed",chk$msg))
  }
  vwantLo$val <- matrix(c( 1,  -Inf,
                           2,  -2  ), nrow=2, ncol=2, byrow=T)
  v <- rgdx(fnIn,list(name='v',form='sparse',field='lo'),squeeze=F)
  chk <- chkRgdxRes (v, vwantLo, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(v,'lo',unfiltered,squeeze=F) failed",chk$msg))
  }
  # upper
  uwantUp <- list(name='u', type='variable', dim=1L,
                  val=matrix(c( 1,  5,
                                2, 15,
                                3, 15), nrow=3, ncol=2, byrow=T),
                  form='sparse', uels=cart,
                  domains=dom, domInfo="full",
                  field='up', varTypeText="integer", typeCode=GMS_VARTYPE$INTEGER)
  u <- rgdx(fnIn,list(name='u',form='sparse',field='Up'))
  chk <- chkRgdxRes (u, uwantUp, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(u,'up',unfiltered) failed",chk$msg))
  }
  u <- rgdx(fnIn,list(name='u',form='sparse',field='Up'),squeeze=F)
  chk <- chkRgdxRes (u, uwantUp, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(u,'up',unfiltered,squeeze=F) failed",chk$msg))
  }
  vwantUp <- list(name='v', type='variable', dim=1L,
                  val=matrix(c( 1,  +Inf,
                                2,  -2  ), nrow=2, ncol=2, byrow=T),
                  form='sparse', uels=cart,
                  domains=dom, domInfo="full",
                  field='up', varTypeText="negative", typeCode=GMS_VARTYPE$NEGATIVE)
  v <- rgdx(fnIn,list(name='v',form='sparse',field='up'))
  chk <- chkRgdxRes (v, vwantUp, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(v,'up',unfiltered) failed",chk$msg))
  }
  v <- rgdx(fnIn,list(name='v',form='sparse',field='up'),squeeze=F)
  chk <- chkRgdxRes (v, vwantUp, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(v,'up',unfiltered,squeeze=F) failed",chk$msg))
  }
  # scale
  uwantS <- list(name='u', type='variable', dim=1L,
                 val=matrix(0,nrow=0, ncol=2, byrow=T),
                 form='sparse', uels=cart,
                 domains=dom, domInfo="full",
                 field='s', varTypeText="integer", typeCode=GMS_VARTYPE$INTEGER)
  u <- rgdx(fnIn,list(name='u',form='sparse',field='S'))
  chk <- chkRgdxRes (u, uwantS, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(u,'S',unfiltered) failed",chk$msg))
  }
  u <- rgdx(fnIn,list(name='u',form='sparse',field='S'))
  chk <- chkRgdxRes (u, uwantS, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(u,'S',unfiltered) failed",chk$msg))
  }
  vwantS <- list(name='v', type='variable', dim=1L,
                 val=matrix(0,nrow=0, ncol=2, byrow=T),
                 form='sparse', uels=cart,
                 domains=dom, domInfo="full",
                 field='s', varTypeText="negative", typeCode=GMS_VARTYPE$NEGATIVE)
  v <- rgdx(fnIn,list(name='v',form='sparse',field='s'))
  chk <- chkRgdxRes (v, vwantS, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(v,'S',unfiltered) failed",chk$msg))
  }
  vwantS$val <- matrix(c( 1,  1,
                          2,  1), nrow=2, ncol=2, byrow=T)
  v <- rgdx(fnIn,list(name='v',form='sparse',field='s'),squeeze=F)
  chk <- chkRgdxRes (v, vwantS, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(v,'S',unfiltered,squeeze=F) failed",chk$msg))
  }

  ### ---------- reading form=sparse, filtered
  # all
  f <- list(c('k1','k3','k4'))
  t <- matrix(c( 1, lev,   5
                ,1, mar,   0
                ,1, low,   5
                ,1, upp,   5
                ,1, sca,   1
                ,2, lev,   0
                ,2, mar,   0
                ,2, low,   0
                ,2, upp,   15
                ,2, sca,   1
             ), nrow=10, ncol=3, byrow=T)
  uwantA <- list(name='u', type='variable', dim=1L,
                 val=t,
                 form='sparse', uels=list(f[[1]],fields),
                 domains=domf, domInfo="filtered",
                 field='all', varTypeText="integer", typeCode=GMS_VARTYPE$INTEGER)
  u <- rgdx(fnIn,list(name='u',form='sparse',uels=f,field='all'))
  chk <- chkRgdxRes (u, uwantA, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(u,'all',filtered) failed",chk$msg))
  }
  u <- rgdx(fnIn,list(name='u',field='all',form='sparse',uels=f),squeeze=F)
  chk <- chkRgdxRes (u, uwantA, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(u,'all',filtered,squeeze=F) failed",chk$msg))
  }
  # level
  f <- list(c('k1','k3','k4'))
  uwantL <- list(name='u', type='variable', dim=1L,
                 val=matrix(c( 1,   5), nrow=1, ncol=2, byrow=T),
                 form='sparse', uels=f,
                 domains=dom, domInfo="filtered",
                 field='l', varTypeText="integer", typeCode=GMS_VARTYPE$INTEGER)
  u <- rgdx(fnIn,list(name='u',form='sparse',uels=f))
  chk <- chkRgdxRes (u, uwantL, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(u,'L',filtered) failed",chk$msg))
  }
  uwantL$val <- matrix(c( 1,   5,
                          2,   0), nrow=2, ncol=2, byrow=T)
  u <- rgdx(fnIn,list(name='u',form='sparse',uels=f),squeeze=F)
  chk <- chkRgdxRes (u, uwantL, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(u,'L',filtered,squeeze=F) failed",chk$msg))
  }
  f <- list(c('k2','k3'))
  vwantL <- list(name='v', type='variable', dim=1L,
                 val=matrix(c( 1,  -2), nrow=1, ncol=2, byrow=T),
                 form='sparse', uels=f,
                 domains=dom, domInfo="filtered",
                 field='l', varTypeText="negative", typeCode=GMS_VARTYPE$NEGATIVE)
  v <- rgdx(fnIn,list(name='v',form='sparse',uels=f))
  chk <- chkRgdxRes (v, vwantL, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(v,'L',filtered) failed",chk$msg))
  }
  v <- rgdx(fnIn,list(name='v',form='sparse',uels=f),squeeze=F)
  chk <- chkRgdxRes (v, vwantL, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(v,'L',filtered,squeeze=F) failed",chk$msg))
  }
  # marginal
  f <- list(c('k1','k3','k4'))
  uwantM <- list(name='u', type='variable', dim=1L,
                 val=matrix(0, nrow=0, ncol=2, byrow=T),
                 form='sparse', uels=f,
                 domains=dom, domInfo="filtered",
                 field='m', varTypeText="integer", typeCode=GMS_VARTYPE$INTEGER)
  u <- rgdx(fnIn,list(name='u',form='sparse',uels=f,field='M'))
  chk <- chkRgdxRes (u, uwantM, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(u,'M',filtered) failed",chk$msg))
  }
  uwantM$val <- matrix(c( 1,   0,
                          2,   0), nrow=2, ncol=2, byrow=T)
  u <- rgdx(fnIn,list(name='u',form='sparse',uels=f,field='M'),squeeze=F)
  chk <- chkRgdxRes (u, uwantM, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(u,'M',filtered,squeeze=F) failed",chk$msg))
  }
  f <- list(c('k2','k3'))
  vwantM <- list(name='v', type='variable', dim=1L,
                 val=matrix(c( 1, -20), nrow=1, ncol=2, byrow=T),
                 form='sparse', uels=f,
                 domains=dom, domInfo="filtered",
                 field='m', varTypeText="negative", typeCode=GMS_VARTYPE$NEGATIVE)
  v <- rgdx(fnIn,list(name='v',form='sparse',uels=f,field='M'))
  chk <- chkRgdxRes (v, vwantM, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(v,'M',filtered) failed",chk$msg))
  }
  v <- rgdx(fnIn,list(name='v',form='sparse',uels=f,field='M'),squeeze=F)
  chk <- chkRgdxRes (v, vwantM, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(v,'M',filtered,squeeze=F) failed",chk$msg))
  }
  # lower
  f <- list(c('k1','k3','k4'))
  uwantLo <- list(name='u', type='variable', dim=1L,
                  val=matrix(c(1,   5), nrow=1, ncol=2, byrow=T),
                  form='sparse', uels=f,
                  domains=dom, domInfo="filtered",
                  field='lo', varTypeText="integer", typeCode=GMS_VARTYPE$INTEGER)
  u <- rgdx(fnIn,list(name='u',form='sparse',uels=f,field='Lo'))
  chk <- chkRgdxRes (u, uwantLo, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(u,'lo',filtered) failed",chk$msg))
  }
  uwantLo$val <- matrix(c(1,   5,
                          2,   0), nrow=2, ncol=2, byrow=T)
  u <- rgdx(fnIn,list(name='u',form='sparse',uels=f,field='Lo'),squeeze=F)
  chk <- chkRgdxRes (u, uwantLo, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(u,'lo',filtered,squeeze=F) failed",chk$msg))
  }
  f <- list(c('k2','k3'))
  vwantLo <- list(name='v', type='variable', dim=1L,
                  val=matrix(c( 1, -2), nrow=1, ncol=2, byrow=T),
                  form='sparse', uels=f,
                  domains=dom, domInfo="filtered",
                  field='lo', varTypeText="negative", typeCode=GMS_VARTYPE$NEGATIVE)
  v <- rgdx(fnIn,list(name='v',form='sparse',uels=f,field='lo'))
  chk <- chkRgdxRes (v, vwantLo, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(v,'lo',filtered) failed",chk$msg))
  }
  v <- rgdx(fnIn,list(name='v',form='sparse',uels=f,field='lo'),squeeze=F)
  chk <- chkRgdxRes (v, vwantLo, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(v,'lo',filtered,squeeze=F) failed",chk$msg))
  }
  # upper
  f <- list(c('k1','k3','k4'))
  uwantUp <- list(name='u', type='variable', dim=1L,
                  val=matrix(c( 1,   5,
                                2,  15), nrow=2, ncol=2, byrow=T),
                  form='sparse', uels=f,
                  domains=dom, domInfo="filtered",
                  field='up', varTypeText="integer", typeCode=GMS_VARTYPE$INTEGER)
  u <- rgdx(fnIn,list(name='u',form='sparse',uels=f,field='uP'))
  chk <- chkRgdxRes (u, uwantUp, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(u,'up',filtered) failed",chk$msg))
  }
  u <- rgdx(fnIn,list(name='u',form='sparse',uels=f,field='uP'),squeeze=F)
  chk <- chkRgdxRes (u, uwantUp, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(u,'up',filtered,squeeze=F) failed",chk$msg))
  }
  f <- list(c('k2','k3'))
  vwantUp <- list(name='v', type='variable', dim=1L,
                  val=matrix(c( 1, -2), nrow=1, ncol=2, byrow=T),
                  form='sparse', uels=f,
                  domains=dom, domInfo="filtered",
                  field='up', varTypeText="negative", typeCode=GMS_VARTYPE$NEGATIVE)
  v <- rgdx(fnIn,list(name='v',form='sparse',uels=f,field='up'))
  chk <- chkRgdxRes (v, vwantUp, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(v,'up',filtered) failed",chk$msg))
  }
  v <- rgdx(fnIn,list(name='v',form='sparse',uels=f,field='up'),squeeze=F)
  chk <- chkRgdxRes (v, vwantUp, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(v,'up',filtered,squeeze=F) failed",chk$msg))
  }
  # scale
  f <- list(c('k1','k3','k4'))
  uwantS <- list(name='u', type='variable', dim=1L,
                 val=matrix(0, nrow=0, ncol=2, byrow=T),
                 form='sparse', uels=f,
                 domains=dom, domInfo="filtered",
                 field='s', varTypeText="integer", typeCode=GMS_VARTYPE$INTEGER)
  u <- rgdx(fnIn,list(name='u',form='sparse',uels=f,field='S'))
  chk <- chkRgdxRes (u, uwantS, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(u,'s',filtered) failed",chk$msg))
  }
  uwantS$val <- matrix(c(1,   1,
                         2,   1), nrow=2, ncol=2, byrow=T)
  u <- rgdx(fnIn,list(name='u',form='sparse',uels=f,field='S'),squeeze=F)
  chk <- chkRgdxRes (u, uwantS, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(u,'s',filtered,squeeze=F) failed",chk$msg))
  }
  f <- list(c('k2','k3'))
  vwantS <- list(name='v', type='variable', dim=1L,
                 val=matrix(0, nrow=0, ncol=2, byrow=T),
                 form='sparse', uels=f,
                 domains=dom, domInfo="filtered",
                 field='s', varTypeText="negative", typeCode=GMS_VARTYPE$NEGATIVE)
  v <- rgdx(fnIn,list(name='v',form='sparse',uels=f,field='s'))
  chk <- chkRgdxRes (v, vwantS, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(v,'s',filtered) failed",chk$msg))
  }
  vwantS$val <- matrix(c( 1,  1), nrow=1, ncol=2, byrow=T)
  v <- rgdx(fnIn,list(name='v',form='sparse',uels=f,field='s'),squeeze=F)
  chk <- chkRgdxRes (v, vwantS, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(v,'s',filtered,squeeze=F) failed",chk$msg))
  }

  ### ---------- reading form=full, no filter
  # all
  t <- array(0,c(kCard,nFields),dimnames=cartfn)
  t[    ,'up'] <- 100
  t[    ,'s' ] <- 1
  t['k1','l' ] <- 5
  t['k1','lo'] <- 5
  t['k1','up'] <- 5
  t['k2','m' ] <- 1.5
  t['k2','up'] <- 15
  t['k3','up'] <- 15
  uwantA <- list(name='u', type='variable', dim=1L,
                 val=t,
                 form='full', uels=cartfn,
                 domains=domf, domInfo="full",
                 field='all', varTypeText="integer", typeCode=GMS_VARTYPE$INTEGER)
  u <- rgdx(fnIn,list(name='u',form='full',field='aLL'))
  chk <- chkRgdxRes (u, uwantA, T, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(u,'all',full,unfiltered) failed",chk$msg))
  }
  u <- rgdx(fnIn,list(name='u',form='full',field='all'),squeeze=F)
  chk <- chkRgdxRes (u, uwantA, T, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(u,'all',full,unfiltered,squeeze=F) failed",chk$msg))
  }
  t <- array(0,c(kCard,nFields),dimnames=cartfn)
  t[    ,'lo'] <- -Inf
  t[    ,'s' ] <- 1
  t['k1','up'] <- Inf
  t['k2','l' ] <- -2
  t['k2','m' ] <- -20
  t['k2','lo'] <- -2
  t['k2','up'] <- -2
  vwantA <- list(name='v', type='variable', dim=1L,
                 val=t,
                 form='full', uels=cartfn,
                 domains=domf, domInfo="full",
                 field='all', varTypeText="negative", typeCode=GMS_VARTYPE$NEGATIVE)
  v <- rgdx(fnIn,list(field='all',name='v',form='full'))
  chk <- chkRgdxRes (v, vwantA, T, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(v,'all',full,unfiltered) failed",chk$msg))
  }
  v <- rgdx(fnIn,list(name='v',form='full',field='all'),squeeze=F)
  chk <- chkRgdxRes (v, vwantA, T, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(v,'all',full,unfiltered,squeeze=F) failed",chk$msg))
  }
  # level
  t <- array(0,c(kCard,1),dimnames=cartn)
  t['k1',1] <- 5
  uwantL <- list(name='u', type='variable', dim=1L,
                 val=t,
                 form='full', uels=cartn,
                 domains=dom, domInfo="full",
                 field='l', varTypeText="integer", typeCode=GMS_VARTYPE$INTEGER)
  u <- rgdx(fnIn,list(name='u',form='full'))
  chk <- chkRgdxRes (u, uwantL, T, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(u,'L',full,unfiltered) failed",chk$msg))
  }
  u <- rgdx(fnIn,list(name='u',form='full'),squeeze=F)
  chk <- chkRgdxRes (u, uwantL, T, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(u,'L',full,unfiltered,squeeze=F) failed",chk$msg))
  }
  t <- array(0,c(kCard,1),dimnames=cartn)
  t['k2',1] <- -2
  vwantL <- list(name='v', type='variable', dim=1L,
                 val=t,
                 form='full', uels=cartn,
                 domains=dom, domInfo="full",
                 field='l', varTypeText="negative", typeCode=GMS_VARTYPE$NEGATIVE)
  v <- rgdx(fnIn,list(name='v',form='full'))
  chk <- chkRgdxRes (v, vwantL, T, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(v,'L',full,unfiltered) failed",chk$msg))
  }
  v <- rgdx(fnIn,list(name='v',form='full'),squeeze=F)
  chk <- chkRgdxRes (v, vwantL, T, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(v,'L',full,unfiltered,squeeze=F) failed",chk$msg))
  }
  # marginal
  t <- array(0,c(kCard,1),dimnames=cartn)
  t['k2',1] <- 1.5
  uwantM <- list(name='u', type='variable', dim=1L,
                 val=t,
                 form='full', uels=cartn,
                 domains=dom, domInfo="full",
                 field='m', varTypeText="integer", typeCode=GMS_VARTYPE$INTEGER)
  u <- rgdx(fnIn,list(name='u',form='full',field='M'))
  chk <- chkRgdxRes (u, uwantM, T, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(u,'M',full,unfiltered) failed",chk$msg))
  }
  u <- rgdx(fnIn,list(name='u',form='full',field='M'),squeeze=F)
  chk <- chkRgdxRes (u, uwantM, T, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(u,'M',full,unfiltered,squeeze=F) failed",chk$msg))
  }
  t <- array(0,c(kCard,1),dimnames=cartn)
  t['k2',1] <- -20
  vwantM <- list(name='v', type='variable', dim=1L,
                 val=t,
                 form='full', uels=cartn,
                 domains=dom, domInfo="full",
                 field='m', varTypeText="negative", typeCode=GMS_VARTYPE$NEGATIVE)
  v <- rgdx(fnIn,list(name='v',form='full',field='m'))
  chk <- chkRgdxRes (v, vwantM, T, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(v,'M',full,unfiltered) failed",chk$msg))
  }
  v <- rgdx(fnIn,list(name='v',form='full',field='m'),squeeze=F)
  chk <- chkRgdxRes (v, vwantM, T, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(v,'M',full,unfiltered,squeeze=F) failed",chk$msg))
  }
  # lower
  t <- array(0,c(kCard,1),dimnames=cartn)
  t['k1',1] <- 5
  uwantLo <- list(name='u', type='variable', dim=1L,
                  val=t,
                  form='full', uels=cartn,
                  domains=dom, domInfo="full",
                  field='lo', varTypeText="integer", typeCode=GMS_VARTYPE$INTEGER)
  u <- rgdx(fnIn,list(name='u',form='full',field='LO'))
  chk <- chkRgdxRes (u, uwantLo, T, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(u,'lo',full,unfiltered) failed",chk$msg))
  }
  u <- rgdx(fnIn,list(name='u',form='full',field='LO'),squeeze=F)
  chk <- chkRgdxRes (u, uwantLo, T, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(u,'lo',full,unfiltered,squeeze=F) failed",chk$msg))
  }
  t <- array(-Inf,c(kCard,1),dimnames=cartn)
  t['k2',1] <- -2
  vwantLo <- list(name='v', type='variable', dim=1L,
                  val=t,
                  form='full', uels=cartn,
                  domains=dom, domInfo="full",
                  field='lo', varTypeText="negative", typeCode=GMS_VARTYPE$NEGATIVE)
  v <- rgdx(fnIn,list(name='v',form='full',field='lo'))
  chk <- chkRgdxRes (v, vwantLo, T, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(v,'lo',full,unfiltered) failed",chk$msg))
  }
  v <- rgdx(fnIn,list(name='v',form='full',field='lo'),squeeze=F)
  chk <- chkRgdxRes (v, vwantLo, T, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(v,'lo',full,unfiltered,squeeze=F) failed",chk$msg))
  }
  # upper
  t <- array(100,c(kCard,1),dimnames=cartn)
  t['k1',1] <- 5
  t['k2',1] <- 15
  t['k3',1] <- 15
  uwantUp <- list(name='u', type='variable', dim=1L,
                  val=t,
                  form='full', uels=cartn,
                  domains=dom, domInfo="full",
                  field='up', varTypeText="integer", typeCode=GMS_VARTYPE$INTEGER)
  u <- rgdx(fnIn,list(name='u',form='full',field='UP'))
  chk <- chkRgdxRes (u, uwantUp, T, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(u,'up',full,unfiltered) failed",chk$msg))
  }
  u <- rgdx(fnIn,list(name='u',form='full',field='UP'),squeeze=F)
  chk <- chkRgdxRes (u, uwantUp, T, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(u,'up',full,unfiltered,squeeze=F) failed",chk$msg))
  }
  t <- array(0,c(kCard,1),dimnames=cartn)
  t['k1',1] <- +Inf
  t['k2',1] <- -2
  vwantUp <- list(name='v', type='variable', dim=1L,
                  val=t,
                  form='full', uels=cartn,
                  domains=dom, domInfo="full",
                  field='up', varTypeText="negative", typeCode=GMS_VARTYPE$NEGATIVE)
  v <- rgdx(fnIn,list(name='v',form='full',field='up'))
  chk <- chkRgdxRes (v, vwantUp, T, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(v,'up',full,unfiltered) failed",chk$msg))
  }
  v <- rgdx(fnIn,list(name='v',form='full',field='up'),squeeze=F)
  chk <- chkRgdxRes (v, vwantUp, T, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(v,'up',full,unfiltered,squeeze=F) failed",chk$msg))
  }
  # scale
  t <- array(1,c(kCard,1),dimnames=cartn)
  t['k3',1] <- 1
  uwantS <- list(name='u', type='variable', dim=1L,
                 val=t,
                 form='full', uels=cartn,
                 domains=dom, domInfo="full",
                 field='s', varTypeText="integer", typeCode=GMS_VARTYPE$INTEGER)
  u <- rgdx(fnIn,list(name='u',form='full',field='S'))
  chk <- chkRgdxRes (u, uwantS, T, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(u,'s',full,unfiltered) failed",chk$msg))
  }
  u <- rgdx(fnIn,list(name='u',form='full',field='S'),squeeze=F)
  chk <- chkRgdxRes (u, uwantS, T, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(u,'s',full,unfiltered,squeeze=F) failed",chk$msg))
  }
  t <- array(1,c(kCard,1),dimnames=cartn)
  t['k1',1] <- 1
  vwantS <- list(name='v', type='variable', dim=1L,
                 val=t,
                 form='full', uels=cartn,
                 domains=dom, domInfo="full",
                 field='s', varTypeText="negative", typeCode=GMS_VARTYPE$NEGATIVE)
  v <- rgdx(fnIn,list(name='v',form='full',field='s'))
  chk <- chkRgdxRes (v, vwantS, T, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(v,'S',full,unfiltered) failed",chk$msg))
  }
  v <- rgdx(fnIn,list(name='v',form='full',field='s'),squeeze=F)
  chk <- chkRgdxRes (v, vwantS, T, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(v,'S',full,unfiltered,squeeze=F) failed",chk$msg))
  }

  ### ---------- reading form=full, filtered
  # all
  fc <- c('k1','k3','k4')
  dnames <- list(fc,fields) ; names(dnames) <- domf
  t <- array(0,c(length(fc),nFields),dimnames=dnames)
  t[    ,'up'] <- 100
  t[    ,'s' ] <- 1
  t['k1','l' ] <- 5
  t['k1','lo'] <- 5
  t['k1','up'] <- 5
  t['k3','up'] <- 15
  uwantA <- list(name='u', type='variable', dim=1L,
                 val=t,
                 form='full', uels=dnames,
                 domains=domf, domInfo="filtered",
                 field='all', varTypeText="integer", typeCode=GMS_VARTYPE$INTEGER)
  u <- rgdx(fnIn,list(name='u',form='full',uels=list(fc),field='all'))
  chk <- chkRgdxRes (u, uwantA, T, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(u,'all',full,filtered) failed:",chk$msg))
  }
  u <- rgdx(fnIn,list(name='u',form='full',uels=list(fc),field='all'),squeeze=F)
  chk <- chkRgdxRes (u, uwantA, T, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(u,'all',full,filtered,squeeze=F) failed",chk$msg))
  }

  fc <- c('k1','k2','k3','k4')
  dnames <- list(fc,fields) ; names(dnames) <- domf
  t <- array(0,c(length(fc),nFields),dimnames=dnames)
  t[    ,'lo'] <- -Inf
  t[    ,'s' ] <- 1
  t['k1','up'] <- Inf
  t['k2','l' ] <- -2
  t['k2','m' ] <- -20
  t['k2','lo'] <- -2
  t['k2','up'] <- -2
  vwantA <- list(name='v', type='variable', dim=1L,
                 val=t,
                 form='full', uels=dnames,
                 domains=domf, domInfo="filtered",
                 field='all', varTypeText="negative", typeCode=GMS_VARTYPE$NEGATIVE)
  v <- rgdx(fnIn,list(name='v',form='full',uels=list(fc),field='all'))
  chk <- chkRgdxRes (v, vwantA, T, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(v,'all',full,filtered) failed",chk$msg))
  }
  v <- rgdx(fnIn,list(name='v',form='full',uels=list(fc),field='all'),squeeze=F)
  chk <- chkRgdxRes (v, vwantA, T, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(v,'all',full,filtered,squeeze=F) failed",chk$msg))
  }
  # level
  f <- list(c('k1','k3','k4'))
  dnames <- f ; names(dnames) <- dom
  t <- array(0,c(3,1),dimnames=dnames)
  t['k1',1] <- 5
  uwantL <- list(name='u', type='variable', dim=1L,
                 val=t,
                 form='full', uels=dnames,
                 domains=dom, domInfo="filtered",
                 field='l', varTypeText="integer", typeCode=GMS_VARTYPE$INTEGER)
  u <- rgdx(fnIn,list(name='u',form='full',uels=f))
  chk <- chkRgdxRes (u, uwantL, T, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(u,'L',full,filtered) failed",chk$msg))
  }
  u <- rgdx(fnIn,list(name='u',form='full',uels=f),squeeze=F)
  chk <- chkRgdxRes (u, uwantL, T, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(u,'L',full,filtered,squeeze=F) failed",chk$msg))
  }
  f <- list(c('k1','k2','k3','k4'))
  dnames <- f ; names(dnames) <- dom
  t <- array(0,c(4,1),dimnames=dnames)
  t['k2',1] <- -2
  vwantL <- list(name='v', type='variable', dim=1L,
                 val=t,
                 form='full', uels=dnames,
                 domains=dom, domInfo="filtered",
                 field='l', varTypeText="negative", typeCode=GMS_VARTYPE$NEGATIVE)
  v <- rgdx(fnIn,list(name='v',form='full',uels=f))
  chk <- chkRgdxRes (v, vwantL, T, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(v,'L',full,filtered) failed",chk$msg))
  }
  v <- rgdx(fnIn,list(name='v',form='full',uels=f),squeeze=F)
  chk <- chkRgdxRes (v, vwantL, T, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(v,'L',full,filtered,squeeze=F) failed",chk$msg))
  }
  # marginal
  f <- list(c('k1','k3','k4'))
  dnames <- f ; names(dnames) <- dom
  t <- array(0,c(3,1),dimnames=dnames)
  uwantM <- list(name='u', type='variable', dim=1L,
                 val=t,
                 form='full', uels=dnames,
                 domains=dom, domInfo="filtered",
                 field='m', varTypeText="integer", typeCode=GMS_VARTYPE$INTEGER)
  u <- rgdx(fnIn,list(name='u',form='full',uels=f,field='M'))
  chk <- chkRgdxRes (u, uwantM, T, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(u,'M',full,filtered) failed",chk$msg))
  }
  u <- rgdx(fnIn,list(name='u',form='full',uels=f,field='M'),squeeze=F)
  chk <- chkRgdxRes (u, uwantM, T, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(u,'M',full,filtered,squeeze=F) failed",chk$msg))
  }
  f <- list(c('k1','k2','k3','k4'))
  dnames <- f ; names(dnames) <- dom
  t <- array(0,c(4,1),dimnames=dnames)
  t['k2',1] <- -20
  vwantM <- list(name='v', type='variable', dim=1L,
                 val=t,
                 form='full', uels=dnames,
                 domains=dom, domInfo="filtered",
                 field='m', varTypeText="negative", typeCode=GMS_VARTYPE$NEGATIVE)
  v <- rgdx(fnIn,list(name='v',form='full',uels=f,field='m'))
  chk <- chkRgdxRes (v, vwantM, T, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(v,'M',full,filtered) failed",chk$msg))
  }
  v <- rgdx(fnIn,list(name='v',form='full',uels=f,field='m'),squeeze=F)
  chk <- chkRgdxRes (v, vwantM, T, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(v,'M',full,filtered,squeeze=F) failed",chk$msg))
  }
  # lower
  f <- list(c('k1','k3','k4'))
  dnames <- f ; names(dnames) <- dom
  t <- array(0,c(3,1),dimnames=dnames)
  t['k1',1] <- 5
  uwantLo <- list(name='u', type='variable', dim=1L,
                  val=t,
                  form='full', uels=dnames,
                  domains=dom, domInfo="filtered",
                  field='lo', varTypeText="integer", typeCode=GMS_VARTYPE$INTEGER)
  u <- rgdx(fnIn,list(name='u',form='full',uels=f,field='LO'))
  chk <- chkRgdxRes (u, uwantLo, T, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(u,'lo',full,filtered) failed",chk$msg))
  }
  u <- rgdx(fnIn,list(name='u',form='full',uels=f,field='LO'),squeeze=F)
  chk <- chkRgdxRes (u, uwantLo, T, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(u,'lo',full,filtered,squeeze=F) failed",chk$msg))
  }
  f <- list(c('k1','k2','k3','k4'))
  dnames <- f ; names(dnames) <- dom
  t <- array(-Inf,c(4,1),dimnames=dnames)
  t['k1',1] <- -Inf
  t['k2',1] <- -2
  vwantLo <- list(name='v', type='variable', dim=1L,
                  val=t,
                  form='full', uels=dnames,
                  domains=dom, domInfo="filtered",
                  field='lo', varTypeText="negative", typeCode=GMS_VARTYPE$NEGATIVE)
  v <- rgdx(fnIn,list(name='v',form='full',uels=f,field='lo'))
  chk <- chkRgdxRes (v, vwantLo, T, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(v,'lo',full,filtered) failed",chk$msg))
  }
  v <- rgdx(fnIn,list(name='v',form='full',uels=f,field='lo'),squeeze=F)
  chk <- chkRgdxRes (v, vwantLo, T, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(v,'lo',full,filtered,squeeze=F) failed",chk$msg))
  }
  # upper
  f <- list(c('k1','k3','k4'))
  dnames <- f ; names(dnames) <- dom
  t <- array(100,c(3,1),dimnames=dnames)
  t['k1',1] <-  5
  t['k3',1] <- 15
  uwantUp <- list(name='u', type='variable', dim=1L,
                  val=t,
                  form='full', uels=dnames,
                  domains=dom, domInfo="filtered",
                  field='up', varTypeText="integer", typeCode=GMS_VARTYPE$INTEGER)
  u <- rgdx(fnIn,list(name='u',form='full',uels=f,field='UP'))
  chk <- chkRgdxRes (u, uwantUp, T, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(u,'up',full,filtered) failed",chk$msg))
  }
  u <- rgdx(fnIn,list(name='u',form='full',uels=f,field='UP'),squeeze=F)
  chk <- chkRgdxRes (u, uwantUp, T, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(u,'up',full,filtered,squeeze=F) failed",chk$msg))
  }
  f <- list(c('k1','k2','k3','k4'))
  dnames <- f ; names(dnames) <- dom
  t <- array(0,c(4,1),dimnames=dnames)
  t['k1',1] <- Inf
  t['k2',1] <- -2
  vwantUp <- list(name='v', type='variable', dim=1L,
                  val=t,
                  form='full', uels=dnames,
                  domains=dom, domInfo="filtered",
                  field='up', varTypeText="negative", typeCode=GMS_VARTYPE$NEGATIVE)
  v <- rgdx(fnIn,list(name='v',form='full',uels=f,field='up'))
  chk <- chkRgdxRes (v, vwantUp, T, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(v,'up',full,filtered) failed",chk$msg))
  }
  v <- rgdx(fnIn,list(name='v',form='full',uels=f,field='up'),squeeze=F)
  chk <- chkRgdxRes (v, vwantUp, T, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(v,'up',full,filtered,squeeze=F) failed",chk$msg))
  }
  # scale
  f <- list(c('k1','k3','k4'))
  dnames <- f ; names(dnames) <- dom
  t <- array(1,c(3,1),dimnames=dnames)
  uwantS <- list(name='u', type='variable', dim=1L,
                 val=t,
                 form='full', uels=dnames,
                 domains=dom, domInfo="filtered",
                 field='s', varTypeText="integer", typeCode=GMS_VARTYPE$INTEGER)
  u <- rgdx(fnIn,list(name='u',form='full',uels=f,field='S'))
  chk <- chkRgdxRes (u, uwantS, T, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(u,'S',full,filtered) failed",chk$msg))
  }
  u <- rgdx(fnIn,list(name='u',form='full',uels=f,field='S'),squeeze=F)
  chk <- chkRgdxRes (u, uwantS, T, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(u,'S',full,filtered,squeeze=F) failed",chk$msg))
  }
  f <- list(c('k1','k2','k3','k4'))
  dnames <- f ; names(dnames) <- dom
  t <- array(1,c(4,1),dimnames=dnames)
  vwantS <- list(name='v', type='variable', dim=1L,
                 val=t,
                 form='full', uels=dnames,
                 domains=dom, domInfo="filtered",
                 field='s', varTypeText="negative", typeCode=GMS_VARTYPE$NEGATIVE)
  v <- rgdx(fnIn,list(name='v',form='full',uels=f,field='s'))
  chk <- chkRgdxRes (v, vwantS, T, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(v,'s',full,filtered) failed",chk$msg))
  }
  v <- rgdx(fnIn,list(name='v',form='full',uels=f,field='s'),squeeze=F)
  chk <- chkRgdxRes (v, vwantS, T, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(v,'s',full,filtered,squeeze=F) failed",chk$msg))
  }


  print ("test of rgdx on variable reads passed")
  TRUE   ## all tests passed: return TRUE
},

error = function(ex) { print ("test of rgdx on variable reads failed"); print(ex) ; FALSE }
)

## test wgdx on writing set text
## gdxdump or gdxdiff do not really do what we want here, so just have
## to read from the generated GDX and the target GDX and compare the results
## for I and IJ

if (! require(gdxrrw))      stop ("gdxrrw package is not available")
if (0 == igdx(silent=TRUE)) stop ("the gdx shared library has not been loaded")

testName <- 'writing set text'
logFile <- 'diffLog.txt'
redirect <- paste(' >', logFile)

errFunc <- function(ex) {
  print (paste0("test of wgdx on ",testName,": FAILED"))
  print (paste("Check file", logFile, "for possible gdxdiff output"))
  print(ex)
  FALSE
} # errFunc

tryCatch({
  print (paste("testing wgdx on", testName))
  wgdx('?')
  fnOut <- "tmp.gdx"
  fnWant <- "teWriteSetText.gdx"
  fnWant2 <- "teWriteSetTextAlt.gdx"
  if (! file_test ('-f', fnWant)) {
    stop (paste("FAIL: File-to-duplicate", fnWant, "does not exist"))
  }

  iUels <- paste0("i","1":"4")
  iN <- length(iUels)
  jUels <- paste0("j","1":"3")
  jN <- length(jUels)
  ijN <- 5
  uels <- list(c(iUels,jUels))
  valI <- matrix(0,nrow=iN,ncol=1)
  for (k in 1:iN) {
    valI[k,1] <- k
  }
  teI <- matrix(NA_character_,nrow=iN,ncol=1)
  teI[1,1] <- "i1 associated text"
  teI[2,1] <- "i2's text here"
  teI[3,1] <- "  "
  teI0 <- c("i1 associated text", "i2's text here", "  ", NA_character_)

  valJ <- matrix(0,nrow=jN,ncol=1)
  for (k in 1:jN) {
    valJ[k,1] <- iN + k
  }
  teJ <- matrix(NA_character_,nrow=jN,ncol=1)
  teJ[1,1] <- "j1 text"
  teJ[2,1] <- "j2 text"
  teJ[3,1] <- "j3 text"

  valIJ <- matrix(c(1,1,
                    2,1,
                    2,2,
                    3,3,
                    4,3),
                  nrow=ijN,ncol=2,byrow=TRUE)
  teIJ <- matrix(NA_character_,nrow=ijN,ncol=1)
  teIJ[1,1] <- "one.one"
  teIJ[3,1] <- "trailing blank "
  teIJ[4,1] <- ""
  teIJ[5,1] <- " "
  teIJ0 <- c('one.one', NA_character_, 'trailing blank ', '', ' ')

  vI <- list(name='I',type='set',form='sparse',val=valI,uels=uels,
             ts='',te=teI)
  vJ <- list(name='J',type='set',form='sparse',val=valJ,uels=uels,
             ts='',te=teJ)
  vIJ <- list(name='IJ',type='set',form='sparse',val=valIJ,uels=list(iUels,jUels),
              ts='',te=teIJ)

  ## test with inventSetText at default
  options(gdx.inventSetText=NULL)
  wgdx.lst(fnOut, vI, vJ, vIJ)
  if (file_test ('-f', fnOut) == TRUE) {
    # print (paste("File", fnOut, "was created"))
  } else {
    stop (paste("FAIL: File", fnOut, "is not readable"))
  }
  rc <- system2 ("gdxdiff",args=c(fnWant, fnOut), stdout=logFile)
  if (0 != rc) {
    stop(paste("With gdx.inventSetText=NULL, bad return from gdxdiff: wanted 0, got",rc))
  } else {
#    print ("gdxdiff call succeeded")
  }
  ## no need to test via wgdx: will get done below

  ## test with inventSetText=NA
  options(gdx.inventSetText=NA)
  wgdx.lst(fnOut, vI, vJ, vIJ)
  if (file_test ('-f', fnOut) == TRUE) {
    # print (paste("File", fnOut, "was created"))
  } else {
    stop (paste("FAIL: File", fnOut, "is not readable"))
  }
  rc <- system2 ("gdxdiff",args=c(fnWant, fnOut), stdout=logFile)
  if (0 != rc) {
    stop(paste("With gdx.inventSetText=NA, Bad return from gdxdiff: wanted 0, got",rc))
  } else {
#    print ("gdxdiff call succeeded")
  }
  ## gdxdiff does not differentiate between no set text and
  ## empty set text, so we test that explicitly here
  I1 <- rgdx(fnOut,   list(name='I',form='sparse',te=TRUE))
  teI1 <- teI0
  if (! identical(teI1,I1$te)) {
    stop (paste('With gdx.inventSetText=NA, inconsistent set text for I in file',fnOut))
  }
  IJ1 <- rgdx(fnOut,   list(name='IJ',form='sparse',te=TRUE))
  teIJ1 <- teIJ0
  if (! identical(teIJ1,IJ1$te)) {
    stop (paste('With gdx.inventSetText=NA, inconsistent set text for IJ in file',fnOut))
  }

  ## test with inventSetText=FALSE
  options(gdx.inventSetText=F)
  wgdx.lst(fnOut, vI, vJ, vIJ)
  if (file_test ('-f', fnOut) == TRUE) {
    # print (paste("File", fnOut, "was created"))
  } else {
    stop (paste("FAIL: File", fnOut, "is not readable"))
  }
  rc <- system2 ("gdxdiff",args=c(fnWant, fnOut), stdout=logFile)
  if (0 != rc) {
    stop(paste("With gdx.inventSetText=F, Bad return from gdxdiff: wanted 0, got",rc))
  } else {
    # print ("gdxdiff call succeeded")
  }
  ## gdxdiff does not differentiate between no set text and
  ## empty set text, so we test that explicitly here
  options(gdx.inventSetText=NA)
  I1 <- rgdx(fnOut,   list(name='I',form='sparse',te=TRUE))
  teI1 <- teI0
  if (! identical(teI1,I1$te)) {
    stop (paste('With gdx.inventSetText=F, inconsistent set text for I in file',fnOut))
  }
  ## with inventSetText=F, fnOut should store empty text strings like no string
  ## and this should come back as NA when we read
  IJ1 <- rgdx(fnOut,   list(name='IJ',form='sparse',te=TRUE))
  teIJ1 <- teIJ0
  teIJ1[4] <- NA_character_
  if (! identical(teIJ1,IJ1$te)) {
    stop (paste('JJJ With gdx.inventSetText=F, inconsistent set text for IJ in file',fnOut))
  }

  ## test with inventSetText=TRUE
  options(gdx.inventSetText=T)
  wgdx.lst(fnOut, vI, vJ, vIJ)
  if (file_test ('-f', fnOut) == TRUE) {
    # print (paste("File", fnOut, "was created"))
  } else {
    stop (paste("FAIL: File", fnOut, "is not readable"))
  }
  rc <- system2 ("gdxdiff",args=c(fnWant, fnOut), stdout=logFile)
  if (0 != rc) {
    stop(paste("With gdx.inventSetText=T, Bad return from gdxdiff: wanted 0, got",rc))
  } else {
    # print ("gdxdiff call succeeded")
  }
  ## gdxdiff does not differentiate between no set text and
  ## empty set text, so we test that explicitly here
  options(gdx.inventSetText=NA)
  I1 <- rgdx(fnOut,   list(name='I',form='sparse',te=TRUE))
  teI1 <- teI0
  if (! identical(teI1,I1$te)) {
    stop (paste('With gdx.inventSetText=NA, inconsistent set text for I in file',fnOut))
  }
  IJ1 <- rgdx(fnOut,   list(name='IJ',form='sparse',te=TRUE))
  teIJ1 <- teIJ0
  if (! identical(teIJ1,IJ1$te)) {
    stop (paste('With gdx.inventSetText=NA, inconsistent set text for IJ in file',fnOut))
  }

  print (paste0("test of wgdx on ", testName, ": PASSED"))
  suppressWarnings(file.remove(logFile))
  invisible(TRUE)   ## all tests passed: return TRUE
},

error = errFunc
)

## test wgdx with form='full' and a full universe
## We write all the transport data

if (! require(gdxrrw))      stop ("gdxrrw package is not available")
if (0 == igdx(silent=TRUE)) stop ("the gdx shared library has not been loaded")

testName <- 'writing trnsport with form="full" and full universe'
logFile <- 'diffLog.txt'

errFunc <- function(ex) {
  print (paste0("test of wgdx on ",testName,": FAILED"))
  print (paste("Check file", logFile, "for possible gdxdiff output"))
  print (ex)
  FALSE
} # errFunc

tryCatch({
  print (paste("testing wgdx on", testName))
  wgdx('?')
  fn <- "twd1.gdx"

  # this is the universe for this GDX file
  uu <- list(c("seattle", "san-diego", "new-york", "chicago", "topeka"))

  iv <- as.array(c(1,1,0,0,0))
  ilst <- list (name='i', type='set', dim=1, form='full', ts='canning plants', val=iv, uels=c(uu))

  jv <- as.array(c(0,0,1,1,1))
  jlst <- list (name='j', type='set', form='full', ts='markets', val=jv, uels=c(uu))

  av <- as.array(c(350,600,0,0,0))
  alst <- list (name='a', type='parameter', dim=1, form='full',
                ts='capacity of plant i in cases', val=av, uels=c(uu))

  bv <- as.array(c(0,0,325,300,275))
  blst <- list (name='b', type='parameter', form='full',
                ts='demand at market j in cases', val=bv, uels=c(uu))

  f <- 90
  d <- matrix(0,nrow=5,ncol=5)
  dd <- matrix(c(2.5, 1.7, 1.8,
                 2.5, 1.8, 1.4),  c(2,3), byrow=TRUE)
  d[(1:2),(3:5)] <- dd
  c <- d * f / 1000

  clst <- list (name='c', type='parameter', dim=2, form='full',
                ts='transport cost in thousands of dollars per case', val=c, uels=c(uu,uu))
  dlst <- list (name='d', type='parameter', form='full',
                ts='distance in thousands of miles', val=d, uels=c(uu,uu))

  flst <- list (name='f', type='parameter', form='full',
                ts='freight in dollars per case per thousand miles', val=f)

  wgdx (fn, ilst, jlst, alst, blst, clst, dlst, flst)

  if (file_test ('-f', fn) == TRUE) {
    print (paste("File", fn, "was created"))
  } else {
    stop (paste("FAIL: File", fn, "is not readable"))
  }
  rc <- system2 ("gdxdiff",args=c("trnsport.gdx", fn,
                               "releps=1e-15", "id=i,j,a,b,c,d,f"), stdout=logFile)
  if (0 != rc) {
    stop(paste("Bad return from gdxdiff: wanted 0, got",rc))
  } else {
    print ("gdxdiff call succeeded")
  }

  print (paste0("test of wgdx on ", testName, ": PASSED"))
  suppressWarnings(file.remove(logFile))
  invisible(TRUE)   ## all tests passed: return TRUE
},

error = errFunc
)

## body of tests for comparing behavior in two rgdx cases:
##   1. GDX file written prior to domain information
##   2. GDX file with domain information and useDomInfo=FALSE
## We expect identical behavior so we use a common test file

iUels <- c("i1", "i2", "i3", "i4")
iCard <- length(iUels)
iText <- iUels                        # since no text is in GDX
iVals <- matrix(as.double(1:4), nrow=4, ncol=1)
i2uels <- iUels[1:3]                  # uels from i that appear in ij
i2card <- length(i2uels)
ifUels <- iUels[2:4]                  # uels from i to use in filtered read
ifCard <- length(ifUels)
ifText <- iText[2:4]
jUels <- c("j1", "j2", "j3")
jCard <- length(jUels)
jText <- c("j1 text", "j2 text", "j3 text")
jVals <- matrix(as.double(5:7), nrow=3, ncol=1)
jfUels <- jUels[1:3]                  # uels from j to use in filtered read
jfCard <- length(jfUels)
jfText <- jText[1:3]
cUels <- c("berlin", "paris", "vienna")
cCard <- length(cUels)
cText <- c("city of airport delays", "city of light", "city of dreams")
cVals <- matrix(as.double(8:10), nrow=3, ncol=1)
u <- c(iUels, jUels, cUels)
un <- list(u) ; names(un) <- c("*")
uCard <- length(u)
udom1 <- c("*")
udom2 <- c("*","*")
udom3 <- c("*","*","*")

options(gdx.inventSetText=T)

## ---------- reading form=sparse, no filter, no compress

iwant <- list(name="I", type="set", dim=1L,
              val=iVals,
              form="sparse",
              uels=list(u), domains=c("*"), domInfo=noInfo, te=iText)
i <- rgdx(fnIn,list(name='i',form='sparse',te=TRUE),useDomInfo=useDomInfo)
chk <- chkRgdxRes (i, iwant, reqIdent=reqIdent)
if (!chk$same) {
  stop (paste("test rgdx(i,unfiltered,uncompressed) failed:",chk$msg))
}

jwant <- list(name="J", type="set", dim=1L,
              val=jVals,
              form="sparse",
              uels=list(u), domains=c("*"), domInfo=noInfo,
              te=jText)
j <- rgdx(fnIn,list(name='j',form='sparse',te=TRUE),useDomInfo=useDomInfo)
chk <- chkRgdxRes (j, jwant, reqIdent=reqIdent)
if (!chk$same) {
  stop (paste("test rgdx(j,unfiltered,uncompressed) failed:",chk$msg))
}

cwant <- list(name="c", type="set", dim=1L,
              val=cVals,
              form="sparse",
              uels=list(u), domains=c("*"), domInfo=noInfo,
              ts='cities',
              te=cText)
c <- rgdx(fnIn,list(name='c',form='sparse',te=TRUE,ts=TRUE),useDomInfo=useDomInfo)
chk <- chkRgdxRes (c, cwant, reqIdent=reqIdent)
if (!chk$same) {
  stop (paste("test rgdx(c,unfiltered,uncompressed) failed:",chk$msg))
}

ijwant <- list(name="IJ", type="set", dim=2L,
               val=matrix(c(1,5, 1,7, 2,6, 2,7, 3,7), nrow=5, ncol=2, byrow=TRUE),
               form="sparse",
               uels=list(u,u), domains=c("*","*"), domInfo=noInfo,
               ts='',
               te=c("one.one", "one.three", "two.two", "two.three", "three.three"))
ij <- rgdx(fnIn,list(name='ij',form='sparse',te=TRUE,ts=TRUE),useDomInfo=useDomInfo)
chk <- chkRgdxRes (ij, ijwant, reqIdent=reqIdent)
if (!chk$same) {
  stop (paste("test rgdx(ij,unfiltered,uncompressed) failed:",chk$msg))
}

ijcwant <- list(name="IJc", type="set", dim=3L,
                val=matrix(c(1,5,8, 1,7,8, 2,6,9, 2,7,9, 3,7,10),
                           nrow=5, ncol=3, byrow=TRUE),
                form="sparse",
                uels=list(u,u,u), domains=c("*","*","*"), domInfo=noInfo,
                te=c("eins eins tempelhof", "eins drei tempelhof", "deux deux orly",
                  "deux trois orly", "drei drei schwechat"))
ijc <- rgdx(fnIn,list(name='ijc',form='sparse',te=TRUE),useDomInfo=useDomInfo)
chk <- chkRgdxRes (ijc, ijcwant, reqIdent=reqIdent)
if (!chk$same) {
  stop (paste("test rgdx(ijc,unfiltered,uncompressed) failed:",chk$msg))
}

aicwant <- list(name="AIc", type="parameter", dim=2L,
                val=matrix(c(1,8,11, 1,9,12, 2,9,22, 2,10,23, 3,10,33),
                           nrow=5, ncol=3, byrow=TRUE),
                form="sparse",
                uels=list(u,u), domains=c("*","*"), domInfo=noInfo )
aic <- rgdx(fnIn,list(name='aic',form='sparse'),useDomInfo=useDomInfo)
chk <- chkRgdxRes (aic, aicwant, reqIdent=reqIdent)
if (!chk$same) {
  stop (paste("test rgdx(aic,unfiltered,uncompressed) failed:",chk$msg))
}

aijcwant <- list(name="AIJc", type="parameter", dim=3L,
                 val=matrix(c(1,5,8 ,111,
                              1,7,8 ,131,
                              2,6,9 ,222,
                              2,7,9 ,232,
                              3,7,10,333),
                   nrow=5, ncol=4, byrow=TRUE),
                form="sparse",
                uels=list(u,u,u), domains=c("*","*","*"), domInfo=noInfo
                )
aijc <- rgdx(fnIn,list(name='aijc',form='sparse'),useDomInfo=useDomInfo)
chk <- chkRgdxRes (aijc, aijcwant, reqIdent=reqIdent)
if (!chk$same) {
  stop (paste("test rgdx(aijc,unfiltered,uncompressed) failed:",chk$msg))
}

## ---------- reading form=sparse, no filter, compress=TRUE

iwant <- list(name="I", type="set", dim=1L,
              val=iVals,
              form="sparse",
              uels=list(iUels), domains=c("*"), domInfo="compressed", te=iText)
i <- rgdx(fnIn,list(name='i',form='sparse',te=TRUE,compress=TRUE),useDomInfo=useDomInfo)
chk <- chkRgdxRes (i, iwant, reqIdent=reqIdent)
if (!chk$same) {
  stop (paste("test rgdx(i,unfiltered,compressed) failed:",chk$msg))
}

jwant <- list(name="J", type="set", dim=1L,
              val=jVals-iCard,
              form="sparse",
              uels=list(jUels), domains=c("*"), domInfo="compressed",
              te=jText)
j <- rgdx(fnIn,list(name='j',form='sparse',te=TRUE,compress=TRUE),useDomInfo=useDomInfo)
chk <- chkRgdxRes (j, jwant, reqIdent=reqIdent)
if (!chk$same) {
  stop (paste("test rgdx(j,unfiltered,compressed) failed:",chk$msg))
}

ijwant <- list(name="IJ", type="set", dim=2L,
               val=matrix(c(1,1, 1,3, 2,2, 2,3, 3,3), nrow=5, ncol=2, byrow=TRUE),
               form="sparse",
               uels=list(i2uels,jUels), # i4 is compressed out
               domains=c("*","*"), domInfo="compressed",
               ts='',
               te=c("one.one", "one.three", "two.two", "two.three", "three.three"))
ij <- rgdx(fnIn,list(name='ij',form='sparse',te=TRUE,ts=TRUE,compress=TRUE),useDomInfo=useDomInfo)
chk <- chkRgdxRes (ij, ijwant, reqIdent=reqIdent)
if (!chk$same) {
  stop (paste("test rgdx(ij,unfiltered,compressed) failed:",chk$msg))
}

ijcwant <- list(name="IJc", type="set", dim=3L,
                val=matrix(c(1,1,1, 1,3,1, 2,2,2, 2,3,2, 3,3,3),
                           nrow=5, ncol=3, byrow=TRUE),
                form="sparse",
                uels=list(iUels[1:3],jUels,cUels),
                domains=c("*","*","*"), domInfo="compressed",
                te=c("eins eins tempelhof", "eins drei tempelhof", "deux deux orly",
                  "deux trois orly", "drei drei schwechat"))
ijc <- rgdx(fnIn,list(name='ijc',form='sparse',te=TRUE,compress=TRUE),useDomInfo=useDomInfo)
chk <- chkRgdxRes (ijc, ijcwant, reqIdent=reqIdent)
if (!chk$same) {
  stop (paste("test rgdx(ijc,unfiltered,compressed) failed:",chk$msg))
}

aicwant <- list(name="AIc", type="parameter", dim=2L,
                val=matrix(c(1,1,11,
                             1,2,12,
                             2,2,22,
                             2,3,23,
                             3,3,33),
                  nrow=5, ncol=3, byrow=TRUE),
                form="sparse",
                uels=list(iUels[1:3],cUels),
                domains=c("*","*"), domInfo="compressed" )

aic <- rgdx(fnIn,list(name='aic',form='sparse',compress=TRUE),useDomInfo=useDomInfo)
chk <- chkRgdxRes (aic, aicwant, reqIdent=reqIdent)
if (!chk$same) {
  stop (paste("test rgdx(aic,unfiltered,compressed) failed:",chk$msg))
}

aijcwant <- list(name="AIJc", type="parameter", dim=3L,
                 val=matrix(c(1,1,1,111,
                              1,3,1,131,
                              2,2,2,222,
                              2,3,2,232,
                              3,3,3,333),
                  nrow=5, ncol=4, byrow=TRUE),
                form="sparse",
                uels=list(iUels[1:3],jUels,cUels),
                domains=c("*","*","*"), domInfo="compressed" )
aijc <- rgdx(fnIn,list(name='aijc',form='sparse',compress=TRUE),useDomInfo=useDomInfo)
chk <- chkRgdxRes (aijc, aijcwant, reqIdent=reqIdent)
if (!chk$same) {
  stop (paste("test rgdx(aijc,unfiltered,compressed) failed:",chk$msg))
}

## ---------- reading form=sparse, filtered, no compress

iwant <- list(name="I", type="set", dim=1L,
              val=matrix(c(1,2,3), nrow=3, ncol=1),
              form="sparse",
              uels=list(ifUels), domains=udom1, domInfo="filtered", te=ifText)
i <- rgdx(fnIn,list(name='i',form='sparse',uels=list(ifUels),te=TRUE),useDomInfo=useDomInfo)
chk <- chkRgdxRes (i, iwant)
if (!chk$same) {
  stop (paste("test rgdx(i,filtered,uncompressed) failed:",chk$msg))
}

jwant <- list(name="J", type="set", dim=1L,
              val=jVals-iCard,
              form="sparse",
              uels=list(jfUels),
              domains=udom1, domInfo="filtered",
              te=jfText)
j <- rgdx(fnIn,list(name='j',form='sparse',uels=list(jfUels),te=TRUE),useDomInfo=useDomInfo)
chk <- chkRgdxRes (j, jwant, reqIdent=reqIdent)
if (!chk$same) {
  stop (paste("test rgdx(j,filtered,uncompressed) failed:",chk$msg))
}

cwant <- list(name="c", type="set", dim=1L,
              val=cVals,
              form="sparse",
              uels=list(u),
              domains=udom1, domInfo="filtered",
              ts='cities',
              te=cText)
c <- rgdx(fnIn,list(name='c',form='sparse',uels=list(u),te=TRUE,ts=TRUE),useDomInfo=useDomInfo)
chk <- chkRgdxRes (c, cwant, reqIdent=reqIdent)
if (!chk$same) {
  stop (paste("test rgdx(c,filtered,uncompressed) failed:",chk$msg))
}

ijwant <- list(name="IJ", type="set", dim=2L,
               val=matrix(c(1,2, 1,3, 2,3), nrow=3, ncol=2, byrow=TRUE),
               form="sparse",
               uels=list(ifUels,jfUels),
               domains=udom2, domInfo="filtered",
               ts='',
               te=c("two.two", "two.three", "three.three"))
ij <- rgdx(fnIn,list(name='ij',form='sparse',uels=list(ifUels,jfUels),te=TRUE,ts=TRUE),useDomInfo=useDomInfo)
chk <- chkRgdxRes (ij, ijwant, reqIdent=reqIdent)
if (!chk$same) {
  stop (paste("test rgdx(ij,filtered,uncompressed) failed:",chk$msg))
}

ijcwant <- list(name="IJc", type="set", dim=3L,
                val=matrix(c(1,2,9, 1,3,9, 2,3,10),
                           nrow=3, ncol=3, byrow=TRUE),
                form="sparse",
                uels=list(ifUels,jfUels,u),
                domains=udom3, domInfo="filtered",
                te=c("deux deux orly", "deux trois orly", "drei drei schwechat"))
ijc <- rgdx(fnIn,list(name='ijc',form='sparse',uels=list(ifUels,jfUels,u),te=TRUE),useDomInfo=useDomInfo)
chk <- chkRgdxRes (ijc, ijcwant, reqIdent=reqIdent)
if (!chk$same) {
  stop (paste("test rgdx(ijc,filtered,uncompressed) failed:",chk$msg))
}

aicwant <- list(name="AIc", type="parameter", dim=2L,
                 val=matrix(c(1, 9,22,
                              1,10,23,
                              2,10,33),
                           nrow=3, ncol=3, byrow=TRUE),
                form="sparse",
                uels=list(ifUels,u),
                domains=udom2, domInfo="filtered" )
aic <- rgdx(fnIn,list(name='aic',form='sparse',uels=list(ifUels,u)),useDomInfo=useDomInfo)
chk <- chkRgdxRes (aic, aicwant, reqIdent=reqIdent)
if (!chk$same) {
  stop (paste("test rgdx(aic,filtered,uncompressed) failed:",chk$msg))
}

aijcwant <- list(name="AIJc", type="parameter", dim=3L,
                 val=matrix(c(1,2,9,222,
                              1,3,9,232,
                              2,3,10,333),
                           nrow=3, ncol=4, byrow=TRUE),
                form="sparse",
                uels=list(ifUels,jfUels,u),
                domains=udom3, domInfo="filtered" )
aijc <- rgdx(fnIn,list(name='aijc',form='sparse',uels=list(ifUels,jfUels,u)),useDomInfo=useDomInfo)
chk <- chkRgdxRes (aijc, aijcwant, reqIdent=reqIdent)
if (!chk$same) {
  stop (paste("test rgdx(aijc,filtered,uncompressed) failed:",chk$msg))
}

## ---------- reading form=full, no filter, no compress

v <- array(0,c(uCard,1),dimnames=un)
v[(1:iCard)] <- 1
te <- array("",c(uCard,1),dimnames=un)
te[(1:iCard)] <- iText
iwant <- list(name="I", type="set", dim=1L,
              val=v,
              form="full",
              uels=un,
              domains=c("*"), domInfo=noInfo, te=te)
i <- rgdx(fnIn,list(name='i',form='full',te=TRUE),useDomInfo=useDomInfo)
chk <- chkRgdxRes (i, iwant, reqIdent=reqIdent)
if (!chk$same) {
  stop (paste("test rgdx(i,full,unfiltered,uncompressed) failed:",chk$msg))
}

jblock <- iCard + (1:jCard)
v <- array(0,c(uCard,1),dimnames=un)
v[jblock] <- 1
te <- array("",c(uCard,1),dimnames=un)
te[jblock] <- jText
jwant <- list(name="J", type="set", dim=1L,
              val=v,
              form="full",
              uels=un,
              domains=c("*"), domInfo=noInfo, te=te)
j <- rgdx(fnIn,list(name='j',form='full',te=TRUE),useDomInfo=useDomInfo)
chk <- chkRgdxRes (j, jwant, reqIdent=reqIdent)
if (!chk$same) {
  stop (paste("test rgdx(j,full,unfiltered,uncompressed) failed:",chk$msg))
}

cblock <- iCard + jCard + (1:cCard)
v <- array(0,c(uCard,1),dimnames=un)
v[cblock] <- 1
te <- array("",c(uCard,1),dimnames=un)
te[cblock] <- cText
cwant <- list(name="c", type="set", dim=1L,
              val=v,
              form="full",
              uels=un,
              domains=c("*"), domInfo=noInfo, te=te)
c <- rgdx(fnIn,list(name='c',form='full',te=TRUE),useDomInfo=useDomInfo)
chk <- chkRgdxRes (c, cwant, reqIdent=reqIdent)
if (!chk$same) {
  stop (paste("test rgdx(c,full,unfiltered,uncompressed) failed:",chk$msg))
}

## it is helpful to put the names with the array
## we should consider doing this with the return $val!!
v <- array(0,c(uCard,uCard),dimnames=list('*'=u,'*'=u))
v['i1','j1'] <- 1;
v['i1','j3'] <- 1;
v['i2','j2'] <- 1;
v['i2','j3'] <- 1;
v['i3','j3'] <- 1;
te <- array("",c(uCard,uCard),dimnames=list('*'=u,'*'=u))
te['i1','j1'] <- "one.one";
te['i1','j3'] <- "one.three";
te['i2','j2'] <- "two.two";
te['i2','j3'] <- "two.three";
te['i3','j3'] <- "three.three";
ijwant <- list(name="IJ", type="set", dim=2L,
               val=v,
               form="full",
               uels=list('*'=u,'*'=u), domains=c("*","*"), domInfo=noInfo,
               ts='',
               te=te)
ij <- rgdx(fnIn,list(name='ij',form='full',te=TRUE,ts=TRUE),useDomInfo=useDomInfo)
chk <- chkRgdxRes (ij, ijwant, reqIdent=reqIdent)
if (!chk$same) {
  stop (paste("test rgdx(ij,full,unfiltered,uncompressed) failed:",chk$msg))
}

v <- array(0,c(uCard,uCard,uCard),dimnames=list('*'=u,'*'=u,'*'=u))
v['i1','j1','berlin'] <- 1;
v['i1','j3','berlin'] <- 1;
v['i2','j2','paris' ] <- 1;
v['i2','j3','paris' ] <- 1;
v['i3','j3','vienna'] <- 1;
te <- array("",c(uCard,uCard,uCard),dimnames=list('*'=u,'*'=u,'*'=u))
te['i1','j1','berlin'] <- "eins eins tempelhof";
te['i1','j3','berlin'] <- "eins drei tempelhof";
te['i2','j2','paris' ] <- "deux deux orly";
te['i2','j3','paris' ] <- "deux trois orly";
te['i3','j3','vienna'] <- "drei drei schwechat";
ijcwant <- list(name="IJc", type="set", dim=3L,
                val=v,
                form="full",
                uels=list('*'=u,'*'=u,'*'=u),
                domains=c("*","*","*"), domInfo=noInfo,
                te=te)
ijc <- rgdx(fnIn,list(name='ijc',form='full',te=TRUE),useDomInfo=useDomInfo)
chk <- chkRgdxRes (ijc, ijcwant, reqIdent=reqIdent)
if (!chk$same) {
  stop (paste("test rgdx(ijc,full,unfiltered,uncompressed) failed:",chk$msg))
}

v <- array(0,c(uCard,uCard),dimnames=list('*'=u,'*'=u))
v['i1','berlin'] <- 11;
v['i1','paris' ] <- 12;
v['i2','paris' ] <- 22;
v['i2','vienna'] <- 23;
v['i3','vienna'] <- 33;
aicwant <- list(name="AIc", type="parameter", dim=2L,
                val=v,
                form="full",
                uels=list('*'=u,'*'=u),
                domains=c("*","*"), domInfo=noInfo)
aic <- rgdx(fnIn,list(name='aic',form='full'),useDomInfo=useDomInfo)
chk <- chkRgdxRes (aic, aicwant, reqIdent=reqIdent)
if (!chk$same) {
  stop (paste("test rgdx(aic,full,unfiltered,uncompressed) failed:",chk$msg))
}

v <- array(0,c(uCard,uCard,uCard),dimnames=list('*'=u,'*'=u,'*'=u))
v['i1','j1','berlin'] <- 111;
v['i1','j3','berlin'] <- 131;
v['i2','j2','paris' ] <- 222;
v['i2','j3','paris' ] <- 232;
v['i3','j3','vienna'] <- 333;
aijcwant <- list(name="AIJc", type="parameter", dim=3L,
                val=v,
                form="full",
                uels=list('*'=u,'*'=u,'*'=u),
                domains=c("*","*","*"), domInfo=noInfo)
aijc <- rgdx(fnIn,list(name='aijc',form='full'),useDomInfo=useDomInfo)
chk <- chkRgdxRes (aijc, aijcwant, reqIdent=reqIdent)
if (!chk$same) {
  stop (paste("test rgdx(aijc,full,unfiltered,uncompressed) failed:",chk$msg))
}

## ---------- reading form=full, no filter, compress=TRUE

ilst <- list('*'=iUels)
v <- array(1,c(iCard,1),dimnames=ilst)
te <- array("",c(iCard,1),dimnames=ilst)
te[(1:iCard)] <- iText
iwant <- list(name="I", type="set", dim=1L,
              val=v,
              form="full",
              uels=ilst,
              domains=udom1, domInfo="compressed", te=te)
i <- rgdx(fnIn,list(name='i',form='full',te=TRUE,compress=TRUE),useDomInfo=useDomInfo)
chk <- chkRgdxRes (i, iwant, reqIdent=reqIdent)
if (!chk$same) {
  stop (paste("test rgdx(i,full,unfiltered,compressed) failed:",chk$msg))
}

jlst <- list('*'=jUels)
v <- array(1,c(jCard,1),dimnames=jlst)
te <- array("",c(jCard,1),dimnames=jlst)
te[(1:jCard)] <- jText
jwant <- list(name="J", type="set", dim=1L,
              val=v,
              form="full",
              uels=jlst,
              domains=udom1, domInfo="compressed",
              te=te)
j <- rgdx(fnIn,list(name='j',form='full',te=TRUE,compress=TRUE),useDomInfo=useDomInfo)
chk <- chkRgdxRes (j, jwant, reqIdent=reqIdent)
if (!chk$same) {
  stop (paste("test rgdx(j,full,unfiltered,compressed) failed:",chk$msg))
}

clst <- list('*'=cUels)
v <- array(1,c(cCard,1),dimnames=clst)
te <- array("",c(cCard,1),dimnames=clst)
te[(1:cCard)] <- cText
cwant <- list(name="c", type="set", dim=1L,
              val=v,
              form="full",
              uels=clst,
              domains=udom1, domInfo="compressed",
              te=te)
c <- rgdx(fnIn,list(name='c',form='full',te=TRUE,compress=TRUE),useDomInfo=useDomInfo)
chk <- chkRgdxRes (c, cwant, reqIdent=reqIdent)
if (!chk$same) {
  stop (paste("test rgdx(c,full,unfiltered,compressed) failed:",chk$msg))
}

v <- array(0,c(i2card,jCard),dimnames=list('*'=i2uels,'*'=jUels))
v['i1','j1'] <- 1;
v['i1','j3'] <- 1;
v['i2','j2'] <- 1;
v['i2','j3'] <- 1;
v['i3','j3'] <- 1;
te <- array("",c(i2card,jCard),dimnames=list('*'=i2uels,'*'=jUels))
te['i1','j1'] <- "one.one";
te['i1','j3'] <- "one.three";
te['i2','j2'] <- "two.two";
te['i2','j3'] <- "two.three";
te['i3','j3'] <- "three.three";
ijwant <- list(name="IJ", type="set", dim=2L,
               val=v,
               form="full",
               uels=list('*'=i2uels,'*'=jUels),
               domains=udom2, domInfo="compressed",
               ts='',
               te=te)
ij <- rgdx(fnIn,list(name='ij',form='full',te=TRUE,ts=TRUE,compress=TRUE),useDomInfo=useDomInfo)
chk <- chkRgdxRes (ij, ijwant, reqIdent=reqIdent)
if (!chk$same) {
  stop (paste("test rgdx(ij,full,unfiltered,compressed) failed:",chk$msg))
}

v <- array(0,c(i2card,jCard,cCard),
           dimnames=list('*'=i2uels,'*'=jUels,'*'=cUels))
v['i1','j1','berlin'] <- 1;
v['i1','j3','berlin'] <- 1;
v['i2','j2','paris' ] <- 1;
v['i2','j3','paris' ] <- 1;
v['i3','j3','vienna'] <- 1;
te <- array("",c(i2card,jCard,cCard),
            dimnames=list('*'=i2uels,'*'=jUels,'*'=cUels))
te['i1','j1','berlin'] <- "eins eins tempelhof";
te['i1','j3','berlin'] <- "eins drei tempelhof";
te['i2','j2','paris' ] <- "deux deux orly";
te['i2','j3','paris' ] <- "deux trois orly";
te['i3','j3','vienna'] <- "drei drei schwechat";
ijcwant <- list(name="IJc", type="set", dim=3L,
                val=v,
                form="full",
                uels=list('*'=i2uels,'*'=jUels,'*'=cUels),
                domains=udom3, domInfo="compressed",
                te=te)
ijc <- rgdx(fnIn,list(name='ijc',form='full',te=TRUE,compress=TRUE),useDomInfo=useDomInfo)
chk <- chkRgdxRes (ijc, ijcwant, reqIdent=reqIdent)
if (!chk$same) {
  stop (paste("test rgdx(ijc,full,unfiltered,compressed) failed:",chk$msg))
}

v <- array(0,c(i2card,cCard),dimnames=list('*'=i2uels,'*'=cUels))
v['i1','berlin'] <- 11;
v['i1','paris' ] <- 12;
v['i2','paris' ] <- 22;
v['i2','vienna'] <- 23;
v['i3','vienna'] <- 33;
aicwant <- list(name="AIc", type="parameter", dim=2L,
                val=v,
                form="full",
                uels=list('*'=i2uels,'*'=cUels),
                domains=udom2, domInfo="compressed",
                ts='')
aic <- rgdx(fnIn,list(name='aic',form='full',ts=TRUE,compress=TRUE),useDomInfo=useDomInfo)
chk <- chkRgdxRes (aic, aicwant, reqIdent=reqIdent)
if (!chk$same) {
  stop (paste("test rgdx(aic,full,unfiltered,compressed) failed:",chk$msg))
}

v <- array(0,c(i2card,jCard,cCard),
           dimnames=list('*'=i2uels,'*'=jUels,'*'=cUels))
v['i1','j1','berlin'] <- 111;
v['i1','j3','berlin'] <- 131;
v['i2','j2','paris' ] <- 222;
v['i2','j3','paris' ] <- 232;
v['i3','j3','vienna'] <- 333;
aijcwant <- list(name="AIJc", type="parameter", dim=3L,
                val=v,
                form="full",
                uels=list('*'=i2uels,'*'=jUels,'*'=cUels),
                domains=udom3, domInfo="compressed" )
aijc <- rgdx(fnIn,list(name='aijc',form='full',compress=TRUE),useDomInfo=useDomInfo)
chk <- chkRgdxRes (aijc, aijcwant, reqIdent=reqIdent)
if (!chk$same) {
  stop (paste("test rgdx(aijc,full,unfiltered,compressed) failed:",chk$msg))
}

## ---------- reading form=full, filtered, no compress

dnames <- list(ifUels) ; names(dnames) <- udom1
v <- array(1,c(ifCard,1),dimnames=dnames)
te <- array("",c(ifCard,1),dimnames=dnames)
te[(1:ifCard)] <- ifText
iwant <- list(name="I", type="set", dim=1L,
              val=v,
              form="full",
              uels=dnames, domains=udom1, domInfo="filtered", te=te)
i <- rgdx(fnIn,list(name='i',form='full',uels=list(ifUels),te=TRUE),useDomInfo=useDomInfo)
chk <- chkRgdxRes (i, iwant, reqIdent=reqIdent)
if (!chk$same) {
  stop (paste("test rgdx(i,full,filtered,uncompressed) failed:",chk$msg))
}

dnames <- list(jUels) ; names(dnames) <- udom1
v <- array(1,c(jfCard,1),dimnames=dnames)
te <- array("",c(jfCard,1),dimnames=dnames)
te[(1:jfCard)] <- jfText
jwant <- list(name="J", type="set", dim=1L,
              val=v,
              form="full",
              uels=dnames,
              domains=udom1, domInfo="filtered",
              te=te)
j <- rgdx(fnIn,list(name='j',form='full',te=TRUE,uels=list(jfUels)),useDomInfo=useDomInfo)
chk <- chkRgdxRes (j, jwant, reqIdent=reqIdent)
if (!chk$same) {
  stop (paste("test rgdx(j,full,filtered,uncompressed) failed:",chk$msg))
}

cblock <- iCard + jCard + (1:cCard)
dnames <- list(u) ; names(dnames) <- udom1
v <- array(0,c(uCard,1),dimnames=dnames)
v[cblock] <- 1
te <- array("",c(uCard,1),dimnames=dnames)
te[cblock] <- cText
cwant <- list(name="c", type="set", dim=1L,
              val=v,
              form="full",
              uels=dnames,
              domains=udom1, domInfo="filtered",
              ts='cities',
              te=te)
c <- rgdx(fnIn,list(name='c',form='full',uels=list(u),te=TRUE,ts=TRUE),useDomInfo=useDomInfo)
chk <- chkRgdxRes (c, cwant, reqIdent=reqIdent)
if (!chk$same) {
  stop (paste("test rgdx(c,full,filtered,uncompressed) failed:",chk$msg))
}

dnames <- list(ifUels,jfUels) ; names(dnames) <- udom2
v <- array(0,c(ifCard,jfCard),dimnames=dnames)
v['i2','j2'] <- 1;
v['i2','j3'] <- 1;
v['i3','j3'] <- 1;
te <- array("",c(ifCard,jfCard),dimnames=dnames)
te['i2','j2'] <- "two.two";
te['i2','j3'] <- "two.three";
te['i3','j3'] <- "three.three";
ijwant <- list(name="IJ", type="set", dim=2L,
               val=v,
               form="full",
               uels=dnames,
               domains=udom2, domInfo="filtered",
               ts='',
               te=te)
ij <- rgdx(fnIn,list(name='ij',form='full',te=TRUE,ts=TRUE,uels=list(ifUels,jfUels)),useDomInfo=useDomInfo)
chk <- chkRgdxRes (ij, ijwant, reqIdent=reqIdent)
if (!chk$same) {
  stop (paste("test rgdx(ij,full,filtered,uncompressed) failed:",chk$msg))
}

dnames <- list(ifUels,jfUels,u) ; names(dnames) <- udom3
v <- array(0,c(ifCard,jfCard,uCard),dimnames=dnames)
v['i2','j2','paris' ] <- 1;
v['i2','j3','paris' ] <- 1;
v['i3','j3','vienna'] <- 1;
te <- array("",c(ifCard,jfCard,uCard),dimnames=dnames)
te['i2','j2','paris' ] <- "deux deux orly";
te['i2','j3','paris' ] <- "deux trois orly";
te['i3','j3','vienna'] <- "drei drei schwechat";
ijcwant <- list(name="IJc", type="set", dim=3L,
                val=v,
                form="full",
                uels=dnames,
                domains=udom3, domInfo="filtered",
                te=te)
ijc <- rgdx(fnIn,list(name='ijc',form='full',te=TRUE,uels=list(ifUels,jfUels,u)),useDomInfo=useDomInfo)
chk <- chkRgdxRes (ijc, ijcwant, reqIdent=reqIdent)
if (!chk$same) {
  stop (paste("test rgdx(ijc,full,filtered,uncompressed) failed:",chk$msg))
}

dnames <- list(ifUels,u) ; names(dnames) <- udom2
v <- array(0,c(ifCard,uCard),dimnames=dnames)
v['i2','paris' ] <- 22;
v['i2','vienna'] <- 23;
v['i3','vienna'] <- 33;
aicwant <- list(name="AIc", type="parameter", dim=2L,
                val=v,
                form="full",
                uels=dnames,
                domains=udom2, domInfo="filtered",
                ts='')
aic <- rgdx(fnIn,list(name='aic',form='full',ts=TRUE,uels=list(ifUels,u)),useDomInfo=useDomInfo)
chk <- chkRgdxRes (aic, aicwant, reqIdent=reqIdent)
if (!chk$same) {
  stop (paste("test rgdx(aic,full,filtered,uncompressed) failed:",chk$msg))
}

dnames <- list(ifUels,jfUels,cUels) ; names(dnames) <- udom3
v <- array(0,c(ifCard,jfCard,cCard),dimnames=dnames)
v['i2','j2','paris' ] <- 222;
v['i2','j3','paris' ] <- 232;
v['i3','j3','vienna'] <- 333;
aijcwant <- list(name="AIJc", type="parameter", dim=3L,
                val=v,
                form="full",
                uels=dnames,
                domains=udom3, domInfo="filtered",
                ts='')
aijc <- rgdx(fnIn,list(name='aijc',form='full',ts=TRUE,uels=list(ifUels,jfUels,cUels)),useDomInfo=useDomInfo)
chk <- chkRgdxRes (aijc, aijcwant, reqIdent=reqIdent)
if (!chk$same) {
  stop (paste("test rgdx(aijc,full,filtered,uncompressed) failed:",chk$msg))
}

### Test wgdx
# We write all the transport data using full writes and a full universe

if (! require(gdxrrw))      stop ("gdxrrw package is not available")
if (0 == igdx(silent=TRUE)) stop ("the gdx shared library has not been loaded")

tryCatch({

  fn <- "twd1.gdx"

  print ("Test wgdx with form='full' and a full universe,")
  print ("using the transport data as the output target")
  wgdx('?')

  # this is the universe for this GDX file
  uu <- list(c("seattle", "san-diego", "new-york", "chicago", "topeka"))

  iv <- as.array(c(1,1,0,0,0))
  ilst <- list (name='i', type='set', dim=1, form='full', ts='canning plants', val=iv, uels=c(uu))

  jv <- as.array(c(0,0,1,1,1))
  jlst <- list (name='j', type='set', form='full', ts='markets', val=jv, uels=c(uu))

  av <- as.array(c(350,600,0,0,0))
  alst <- list (name='a', type='parameter', dim=1, form='full',
                ts='capacity of plant i in cases', val=av, uels=c(uu))

  bv <- as.array(c(0,0,325,300,275))
  blst <- list (name='b', type='parameter', form='full',
                ts='demand at market j in cases', val=bv, uels=c(uu))

  f <- 90
  d <- matrix(0,nrow=5,ncol=5)
  dd <- matrix(c(2.5, 1.7, 1.8,
                 2.5, 1.8, 1.4),  c(2,3), byrow=TRUE)
  d[(1:2),(3:5)] <- dd
  c <- d * f / 1000

  clst <- list (name='c', type='parameter', dim=2, form='full',
                ts='transport cost in thousands of dollars per case', val=c, uels=c(uu,uu))
  dlst <- list (name='d', type='parameter', form='full',
                ts='distance in thousands of miles', val=d, uels=c(uu,uu))

  flst <- list (name='f', type='parameter', form='full',
                ts='freight in dollars per case per thousand miles', val=f)

  wgdx (fn, ilst, jlst, alst, blst, clst, dlst, flst)

  if (file_test ('-f', fn) == TRUE) {
    print (paste("File", fn, "was created"))
  } else {
    stop (paste("FAIL: File", fn, "is not readable"))
  }
  rc <- system (paste("gdxdiff trnsport.gdx",fn,"releps=1e-15 id=i,j,a,b,c,d,f"))
  if (0 != rc) {
    stop(paste("Bad return from gdxdiff: wanted 0, got",rc))
  } else {
    print ("gdxdiff call succeeded")
  }
  return (TRUE)
}

, error = function(ex) { print(ex) ; return (FALSE) }
)

## ## test wgdx.lst wrapper
## read from target GDX file, reproduce it in different ways using the
## wgdx.lst wrapper

if (! require(gdxrrw))      stop ("gdxrrw package is not available")
if (0 == igdx(silent=TRUE)) stop ("the gdx shared library has not been loaded")

testName <- 'wgdx.lst wrapper'

errFunc <- function(ex) {
  print (paste0("test of rgdx on ",testName,": FAILED"))
  print(ex)
  FALSE
} # errFunc

tryCatch({
  print (paste("testing wgdx on", testName))
  wgdx('?')
  fnTarg <- "lstTarget.gdx"
  fnOut <- "tmp.gdx"
  if (! file_test ('-f', fnTarg)) {
    stop (paste("FAIL: File-to-duplicate", fnTarg, "does not exist"))
  }

  ## read symbols from target, using multiple formats
  ii <- rgdx (fnTarg, list(name='i'))
  aa <- rgdx (fnTarg, list(name='a'))
  bb <- rgdx (fnTarg, list(name='b'))
  uu <- rgdx (fnTarg, list(name='u'))
  idf <- rgdx.set (fnTarg, 'i')
  adf <- rgdx.param (fnTarg, 'a')
  bdf <- rgdx.param (fnTarg, 'b')
  cdf <- rgdx.param (fnTarg, 'c')
  ddf <- rgdx.param (fnTarg, 'd')
  edf <- rgdx.param (fnTarg, 'e')
  fdf <- rgdx.param (fnTarg, 'f')
  gdf <- rgdx.param (fnTarg, 'g')
  usc <- rgdx.scalar (fnTarg, 'u')
  vsc <- rgdx.scalar (fnTarg, 'v')

  # ---------- works with older wgdx.lst: 0.2.0 and previous ---------------
  wgdx.lst(fnOut, list(idf, adf))
  cmd <- paste('gdxdiff', fnTarg, fnOut, 'id="i a"')
  rc <- system(cmd)
  if (0 != rc) {
    stop (paste("GDXDIFF FAILURE:", cmd));
  } else {
    print (paste("gdxdiff ok:", cmd));
  }
  wgdx.lst(fnOut, list(ii, adf, bb, cdf, vsc))
  cmd <- paste('gdxdiff', fnTarg, fnOut, 'id="i a b c v"')
  rc <- system(cmd)
  if (0 != rc) {
    stop (paste("GDXDIFF FAILURE:", cmd));
  } else {
    print (paste("gdxdiff ok:", cmd));
  }
  wgdx.lst(fnOut, list(ii, adf, bb, cdf, ddf, edf, fdf, gdf, uu, vsc))
  cmd <- paste('gdxdiff', fnTarg, fnOut)
  rc <- system(cmd)
  if (0 != rc) {
    stop (paste("GDXDIFF FAILURE:", cmd));
  } else {
    print (paste("gdxdiff ok:", cmd));
  }

  # ------------ requires newer wgdx.lst: 0.4.0 or later -------------
  wgdx.lst(fnOut, idf, adf)
  cmd <- paste('gdxdiff', fnTarg, fnOut, 'id="i a"')
  rc <- system(cmd)
  if (0 != rc) {
    stop (paste("GDXDIFF FAILURE:", cmd));
  } else {
    print (paste("gdxdiff ok:", cmd));
  }
  wgdx.lst(fnOut, list(idf), list(adf))
  cmd <- paste('gdxdiff', fnTarg, fnOut, 'id="i a"')
  rc <- system(cmd)
  if (0 != rc) {
    stop (paste("GDXDIFF FAILURE:", cmd));
  } else {
    print (paste("gdxdiff ok:", cmd));
  }
  wgdx.lst(fnOut, list(idf,aa,uu), list(bb,vsc,edf,gdf),cdf)
  cmd <- paste('gdxdiff', fnTarg, fnOut, 'id="i a u b v e g c"')
  rc <- system(cmd)
  if (0 != rc) {
    stop (paste("GDXDIFF FAILURE:", cmd));
  } else {
    print (paste("gdxdiff ok:", cmd));
  }
  wgdx.lst(fnOut, fdf, list(idf,aa,uu), ddf, list(bb,vsc,edf,gdf), cdf)
  cmd <- paste('gdxdiff', fnTarg, fnOut)
  rc <- system(cmd)
  if (0 != rc) {
    stop (paste("GDXDIFF FAILURE:", cmd));
  } else {
    print (paste("gdxdiff ok:", cmd));
  }


  print (paste0("test of rgdx on ", testName, ": PASSED"))
  invisible(TRUE)   ## all tests passed: return TRUE
},

error = errFunc
)

### Example showing one way to write the data (sets and parameters)
### for the transport model

tryCatch({

  fn <- "mytransport.gdx"
  if (file_test ('-f', fn) == TRUE) {
    file.remove (fn)
  }

  print ("Example showing how to reproduce the transport data using wgdx")

  # set i: supply nodes
  si <- list(c("seattle", "san-diego"))

  # set j: demand nodes
  sj <- list(c("new-york", "chicago", "topeka"))

  ilst <- list (name='i', type='set', ts='canning plants', uels=c(si))

  jlst <- list (name='j', type='set', ts='markets', uels=c(sj))

  av <- as.array(c(350,600))
  alst <- list (name='a', type='parameter', form='full',
                ts='capacity of plant i in cases', val=av, uels=c(si))

  bv <- as.array(c(325, 300, 275))
  blst <- list (name='b', type='parameter', form='full',
                ts='demand at market j in cases', val=bv, uels=c(sj))

  f <- 90
  d <- matrix(c(2.5, 1.7, 1.8,
                2.5, 1.8, 1.4),  c(2,3), byrow=TRUE)
  c <- d * f / 1000

  clst <- list (name='c', type='parameter', form='full',
                ts='transport cost in thousands of dollars per case', val=c, uels=c(si,sj))
  dlst <- list (name='d', type='parameter', form='full',
                ts='distance in thousands of miles', val=d, uels=c(si,sj))

  flst <- list (name='f', type='parameter', form='full',
                ts='freight in dollars per case per thousand miles', val=f)

  wgdx (fn, ilst, jlst, alst, blst, clst, dlst, flst)

  if (file_test ('-f', fn) == TRUE) {
    print (paste("File", fn, "was created"))
  } else {
    stop (paste("FAIL: File", fn, "is not readable"))
  }
  rc <- system (paste("gdxdiff trnsport.gdx",fn,"releps=1e-15 id=i,j,a,b,c,d,f"))
  if (0 != rc) {
    stop(paste("Bad return from gdxdiff: wanted 0, got",rc))
  } else {
    print ("gdxdiff call succeeded")
  }
}

, error = function(ex) {print(ex)}
)

### Test rgdx on all the transport data using full reads and no filter
### N.B.  This test depends on the domain info in the GDX file
### wanted lists produced with    dump("listName",file="")

if (! require(gdxrrw))      stop ("gdxrrw package is not available")
if (0 == igdx(silent=TRUE)) stop ("the gdx shared library has not been loaded")

source ("chkSame.R")
reqIdent <- TRUE

iUels <- c("seattle", "san-diego")
iCard <- length(iUels)
jUels <- c("new-york", "chicago", "topeka")
jCard <- length(jUels)
uUels <- c(iUels, jUels)
uCard <- length(uUels)

iVals <- matrix(0, nrow=uCard, ncol=1, dimnames=list('*'=uUels)) ; iVals[iUels,1] <- 1
jVals <- matrix(0, nrow=uCard, ncol=1, dimnames=list('*'=uUels)) ; jVals[jUels,1] <- 1
aVals <- matrix(c(350,600), nrow=iCard, ncol=1, dimnames=list('i'=iUels,NULL))
bVals <- matrix(c(325,300,275), nrow=jCard, ncol=1, dimnames=list('j'=jUels,NULL))

dVals <- matrix(c(2.5, 1.7, 1.8,
                  2.5, 1.8, 1.4), nrow=iCard, ncol=jCard,
                dimnames=list('i'=iUels,'j'=jUels), byrow=TRUE)
cVals <- dVals * 90 / 1000


tryCatch({
  fn <- "trnsport.gdx"
  print ("Test rgdx with form='full' and no filter,")
  print ("using the transport data as the input")
  rgdx('?')

  u <- rgdx('trnsport')
  uwant <- list(name="*", type="set", dim=1L,
                val=NULL,
                form=NULL,
                uels=uUels)
  chk <- chkRgdxRes (u, uwant, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx('gdxname') to read universe failed",chk$msg))
  }
  print ("Done reading universe")

  i <- rgdx('trnsport',list(name='i',form='full'))
  iwant <- list(name="i", type="set", dim=1L,
                val=iVals,
                form="full",
                uels=list('*'=uUels),
                domains=c("*"),
                domInfo="none")
  chk <- chkRgdxRes (i, iwant, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(i,form=full) failed:",chk$msg))
  }
  print ("Done reading set i")

  j <- rgdx('trnsport',list(name='j',form='full'))
  jwant <- list(name="j", type="set", dim=1L,
                val=jVals,
                form="full",
                uels=list('*'=uUels),
                domains=c("*"),
                domInfo="none")
  chk <- chkRgdxRes (j, jwant, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(j,form=full) failed:",chk$msg))
  }
  print ("Done reading set j")

  f <- rgdx('trnsport',list(name='f',form='full'))
  fwant <- list(name="f", type="parameter", dim=0L,
                val=90,
                form="full",
                uels=list(),
                domains=character(0),
                domInfo="NA")
  chk <- chkRgdxRes (f, fwant, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(f,form=full) failed:",chk$msg))
  }
  print ("Done reading scalar f")

  a <- rgdx('trnsport',list(name='a',form='full'))
  awant <- list(name="a", type="parameter", dim=1L,
                val=aVals,
                form="full",
                uels=list('i'=iUels),
                domains=c("i"),
                domInfo="full")
  chk <- chkRgdxRes (a, awant, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(a,form='full') failed:",chk$msg))
  }
  print ("Done reading parameter a")

  b <- rgdx('trnsport',list(name='b',form='full'))
  bwant <- list(name="b", type="parameter", dim=1L,
                val=bVals,
                form="full",
                uels=list('j'=jUels),
                domains=c('j'),
                domInfo="full")
  chk <- chkRgdxRes (b, bwant, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(b,form='full') failed:",chk$msg))
  }
  print ("Done reading parameter b")

  c <- rgdx('trnsport',list(name='c',form='full'))
  cwant <- list(name="c", type="parameter", dim=2L,
                val=cVals,
                form="full",
                uels=list('i'=iUels,'j'=jUels),
                domains=c("i","j"),
                domInfo="full")
  chk <- chkRgdxRes (c, cwant, reqIdent=F)
  if (!chk$same) {
    stop (paste("test rgdx(c,form='full') failed:",chk$msg))
  }
  print ("Done reading parameter c")


  print ("Successfully completed tests")
  TRUE   ## all tests passed: return TRUE
}

, error = function(ex) { print(ex) ; FALSE }
)

### Test gdxInfo
# We get a list of symbol names from the transport data

if (! require(gdxrrw))      stop ("gdxrrw package is not available")
if (0 == igdx(silent=TRUE)) stop ("the gdx shared library has not been loaded")

source ("chkSame.R")

tryCatch({

  fn <- "trnsport.gdx"
  s <- gdxInfo (fn, dump=FALSE, returnList=TRUE)

  if (!is.list(s))
    stop ("Expected gdxInfo output to be in list form")
  if (10 != length(s))
    stop ("Expected gdxInfo output to have length 10")
  if (12 != s$symCount)
    stop ("gdxInfo: expected trnsport symCount==12")
  if (5 != s$uelCount)
    stop ("gdxInfo: expected trnsport uelCount==5")
  if (! chkSameVec("sets", c("i","j"), s$sets))
    stop ("gdxInfo: s$sets for trnsport is bogus")
  if (! chkSameVec("parameters", c("a","b", "d", "f", "c"), s$parameters))
    stop ("gdxInfo: s$parameters for trnsport is bogus")
  if (! chkSameVec("variables", c("x","z"), s$variables))
    stop ("gdxInfo: s$variables for trnsport is bogus")
  if (! chkSameVec("equations", c("cost","supply", "demand"), s$equations))
    stop ("gdxInfo: s$equations for trnsport is bogus")
  if (! chkSameVec("aliases", character(0), s$aliases))
    stop ("gdxInfo: s$aliases for trnsport is bogus")

  print ("Successfully completed gdxInfo test 1")
  TRUE
}

, error = function(ex) { print(ex) ; FALSE }
)

## utility functions for checking results: comparing different structures, etc.

isClose <- function (x, y) {
  dif <- abs(x - y)
  if (0 == dif) return (TRUE)
  m <- abs(x)
  t <- abs(y)
  if (t > m)
    m <- t
  if (Inf == m)        return (FALSE)
  if (dif/m <= 1e-15)  return (TRUE)
  return (FALSE)
}  # isClose

# compare the lists f1 and f2, return TRUE if the same, FALSE o/w
## this test assumes a certain ordering of the list elements
## it is not really necessary that they be ordered in this way but it
## makes the test easier to implement
chkLists <- function(s, f1, f2) {
  if (! is.list(f1))   return (FALSE)
  if (! is.list(f2))   return (FALSE)
  n     <- length(f1)
  if (n != length(f2))     return (FALSE)
  if (n < 3)     return (FALSE)

  f1Names <- names(f1)
  f2Names <- names(f2)

  ## element 1: symbol name
  if (! is.character(f1[[1]]))   return (FALSE)
  if (! is.character(f2[[1]]))   return (FALSE)
  if ("name"       != f2Names[[1]])   return (FALSE)
  if (f1Names[[1]] != f2Names[[1]])   return (FALSE)
  if (f1[[1]] != f2[[1]])        return (FALSE)

  ## element 2: symbol type
  if (! is.character(f1[[2]]))   return (FALSE)
  if (! is.character(f2[[2]]))   return (FALSE)
  if ("type"       != f2Names[[2]])   return (FALSE)
  if (f1Names[[2]] != f2Names[[2]])   return (FALSE)
  if (f1[[2]] != f2[[2]])        return (FALSE)

  if ("set" == f2[[2]]) {
    ## element 3: set uels
    if (! is.list(f1[[3]]))   return (FALSE)
    if (! is.list(f2[[3]]))   return (FALSE)
    if ("uels"       != f2Names[[3]])   return (FALSE)
    if (f1Names[[3]] != f2Names[[3]])   return (FALSE)
    uList1 <- f1[[3]]
    uList2 <- f2[[3]]
    if (length(uList1) != length(uList2))  return (FALSE)
    ## loop through the dimensions, comparing the UELs in each
    for (d in 1:length(uList1)) {
      uels1 <- uList1[[d]]
      uels2 <- uList2[[d]]
      nk <- length(uels1)
      if (nk != length(uels2))  return (FALSE)
      for (k in 1:nk) {
        if (uels1[[k]] != uels2[[k]]) {
          return (FALSE)
        }
      }
    }
    if (n > 3) {
      ## element 4: symbol text
      if (! is.character(f1[[4]]))   return (FALSE)
      if (! is.character(f2[[4]]))   return (FALSE)
      if ("ts"         != f2Names[[4]])   return (FALSE)
      if (f1Names[[4]] != f2Names[[4]])   return (FALSE)
      if (f1[[4]] != f2[[4]])        return (FALSE)
    }
    if (n > 4) {
      return (FALSE)
    }
    return (TRUE)
  }

  print (paste("checking", s, ": test is not fully implemented"))
  return (FALSE)
  return (TRUE)
} # chkLists

mb <- function (msg) {
  return (list(same=FALSE,msg=msg))
} # mb

# compare the data frames f1 and f2, return a checkresult list when done
## this test is intended to compare the results of rgdx.XXX() calls
chkRgdxDF <- function(f1, f2, reqIdent=FALSE) {
  if (identical(f1,f2))     return (list(same=TRUE,msg=''))

  if (! is.data.frame(f1))   return (mb("not data frames"))
  if (! is.data.frame(f2))   return (mb("not data frames"))

  nc     <- ncol(f1)
  if (nc != ncol(f2))     return (mb("ncol mismatch"))
  nr     <- nrow(f1)
  if (nr != nrow(f2))     return (mb("nrow mismatch"))
  if (!identical(attr(f1,"symName"), attr(f2,"symName")))  return (mb('symName mismatch'))
  if (!identical(attr(f1,"domains"), attr(f2,"domains")))  return (mb('domains mismatch'))

  r <- list(same=FALSE,msg="decruft this")
  cNames1 <- names(f1)
  cNames2 <- names(f2)
  for (j in c(1:nc)) {
    if (cNames1[j] != cNames2[j]) {
      return (mb(paste("column", j, "names differ")))
    }
    fc1 <- f1[[j]]
    fc2 <- f2[[j]]
    if (is.factor(fc1)) {
      if (! is.factor(fc2))   return (mb(paste("column", j,"is.factor mismatch")))
      if (nlevels(fc1) != nlevels(fc2)) return (mb(paste("column", j,"nlevels mismatch")))
      lvl1 <- levels(fc1)
      lvl2 <- levels(fc2)
      for (k in c(1:nlevels(fc1))) {
        if (! identical(lvl1[[k]], lvl2[[k]]))  return (mb(paste("column", j,"level",k,"mismatch")))
      }
      if (length(fc1) != length(fc2))   return (mb(paste("column", j,"length mismatch")))
      iv1 <- as.integer(fc1)
      iv2 <- as.integer(fc2)
      for (k in c(1:length(fc1))) {
        if (iv1[[k]] != iv2[[k]]) return (mb(paste("column", j,"item",k,"mismatch")))
      }
    }
    else if (is.vector(fc1)) {
      if (! is.vector(fc2))   return (mb(paste("column", j,"is.vector mismatch")))
      if (length(fc1) != length(fc2))   return (mb(paste("column", j,"length mismatch")))
      for (k in c(1:length(fc1))) {
        if (! identical(fc1[[k]], fc2[[k]])) return (mb(paste("column", j,"val",k,"mismatch")))
      }
    }
    else {
      return (mb(paste("column", j,"type unrecognized")))
    }
  }

  if (nr > 0) {
    rNames1 <- row.names(f1)
    rNames2 <- row.names(f2)
    for (i in c(1:nr)) {
      if (rNames1[i] != rNames2[i]) {
        return (mb(paste("row", i, "names differ")))
      }
    }
  }

  ## already checked if identical: they are not!
  if (reqIdent)     return(list(same=FALSE,msg='not identical'))
  return(list(same=TRUE,msg=''))
} # chkRgdxDF


# compare the data frames f1 and f2, return TRUE if the same, FALSE o/w
chkFrames <- function(s, f1, f2) {
  if (! is.data.frame(f1))   return (FALSE)
  if (! is.data.frame(f2))   return (FALSE)
  nc     <- ncol(f1)
  if (nc != ncol(f2))     return (FALSE)
  nr     <- nrow(f1)
  if (nr != nrow(f2))     return (FALSE)
  if (nr == 0)            return (TRUE)
  if (attr(f1,"symName") != attr(f2,"symName"))   return (FALSE)

  cNames1 <- names(f1)
  cNames2 <- names(f2)
  for (j in c(1:nc)) {
    if (cNames1[j] != cNames2[j]) {
      print (paste("checking", s, ": column", j, "names differ"))
      return (FALSE)
    }
    fc1 <- f1[[j]]
    fc2 <- f2[[j]]
    if (is.factor(fc1)) {
      if (! is.factor(fc2))   return (FALSE)
      if (nlevels(fc1) != nlevels(fc2))   return (FALSE)
      lvl1 <- levels(fc1)
      lvl2 <- levels(fc2)
      for (k in c(1:nlevels(fc1))) {
        if (! identical(lvl1[[k]], lvl2[[k]]))   return (FALSE)
      }
      if (length(fc1) != length(fc2))   return (FALSE)
      iv1 <- as.integer(fc1)
      iv2 <- as.integer(fc2)
      for (k in c(1:length(fc1))) {
        if (iv1[[k]] != iv2[[k]])   return (FALSE)
      }
    }
    else if (is.vector(fc1)) {
      if (! is.vector(fc2))   return (FALSE)
      if (length(fc1) != length(fc2))   return (FALSE)
      for (k in c(1:length(fc1))) {
        if (! identical(fc1[[k]], fc2[[k]]))   return (FALSE)
      }
    }
    else {
      print (paste("checking", s, ": column", j, "type unrecognized"))
      return (FALSE)
    }
  }

  rNames1 <- row.names(f1)
  rNames2 <- row.names(f2)
  for (i in c(1:nr)) {
    if (rNames1[i] != rNames2[i]) {
      print (paste("checking", s, ": row", i, "names differ"))
      return (FALSE)
    }
  }
  return (TRUE)
} # chkFrames

# compare the character vectors v1 and v2, return TRUE if the same, FALSE o/w
chkSameVec <- function(s, v1,v2) {
  if (! is.vector(v1,mode="character"))   return (FALSE)
  if (! is.vector(v2,mode="character"))   return (FALSE)
  n <- length(v1)
  if (n != length(v2))     return (FALSE)
  if (n == 0)              return (TRUE)
  for (k in c(1:n)) {
    if (! identical(v1[[k]],v2[[k]])) {
      print (paste("checking", s, ": item", k, "is wrong"))
      return (FALSE)
    }
  }
  return (TRUE)
}  # chkSameVec


# compare the lists f1 and f2, return a checkresult list when done
## this test is intended to compare the results of rgdx() calls and
## assumes a certain ordering of the list elements
## it is not really necessary that they be ordered in this way but it
## makes the test easier to implement
chkRgdxRes <- function(f1, f2, checkDimNames=FALSE, reqIdent=FALSE) {
  if (identical(f1,f2))     return (list(same=TRUE,msg=''))

  isSparse <- TRUE
  isUniverse <- FALSE
  isVar <- FALSE
  isEqu <- FALSE
  symDim <- -1

  r <- list(same=FALSE,msg="not lists")
  if (! is.list(f1))   return (r)
  if (! is.list(f2))   return (r)
  r$msg <- "bogus lengths"
  n     <- length(f1)
  if (n != length(f2))     return (r)
  if (n < 3)     return (r)

  f1Names <- names(f1)
  f2Names <- names(f2)

  r$msg <- "element 1 (name) error"
  ## element 1: symbol name
  if (! is.character(f1[[1]]))   return (r)
  if (! is.character(f2[[1]]))   return (r)
  if ("name"       != f2Names[[1]])   return (r)
  if (f1Names[[1]] != f2Names[[1]])   return (r)
  if (f1[[1]] != f2[[1]])        return (r)
  if ("*" == f2[[1]])
    isUniverse <- TRUE

  r$msg <- "element 2 (type) error"
  ## element 2: symbol type
  if (! is.character(f1[[2]]))   return (r)
  if (! is.character(f2[[2]]))   return (r)
  if ("type"       != f2Names[[2]])   return (r)
  if (f1Names[[2]] != f2Names[[2]])   return (r)
  if (f1[[2]] != f2[[2]])        return (r)
  if (f1[[2]] == 'variable')
    isVar = TRUE
  if (f1[[2]] == 'equation')
    isEqu = TRUE

  if (isUniverse) {
    ## universe set is special: no form, no vals, just uels are returned
    r$msg <- "universe set: expect NULL 'form' element"
    if (! is.null(f1$form)) return (r)
    if (! is.null(f2$form)) return (r)
  }
  else {
    r$msg <- "invalid/missing 'form' element"
    if (is.null(f1$form)) return (r)
    if (is.null(f2$form)) return (r)
    if (! is.character(f1$form))   return (r)
    if (! is.character(f2$form))   return (r)
    if (f1$form != f2$form)        return (r)
    if ('sparse' == f2$form) {
      isSparse <- TRUE
    }
    else if ('full' == f2$form) {
      isSparse <- FALSE
    }
    else {
      return (r)
    }
  }

  for (k in 3:n) {
    r$msg <- paste("element",k,"error")
    if (f1Names[[k]] != f2Names[[k]])  return (r)
    if      ("dim" == f2Names[[k]]) {
      if (! is.numeric(f1[[k]]))   return (r)
      if (! is.numeric(f2[[k]]))   return (r)
      if (f1[[k]] != f2[[k]])      return (r)
      symDim <- f1[[k]]
    }
    else if ("val" == f2Names[[k]]) {
      if (isUniverse) {
        r$msg <- "universe set: expect NULL 'val' element"
        if (! is.null(f1[[k]])) return (r)
        if (! is.null(f2[[k]])) return (r)
        next
      }
      if (! is.numeric(f1[[k]]))   return (r)
      if (! is.numeric(f2[[k]]))   return (r)
      if ((! isSparse) && (0 == symDim)) {
        ## full form for scalars is slightly different
        if (! is.vector(f1[[k]]))   return (r)
        if (! is.vector(f2[[k]]))   return (r)
        if (isVar) {
          if (5 != length(f1[[k]]))   return (r)
          if (5 != length(f2[[k]]))   return (r)
          for (kk in 1:5) {
            if (f1[[k]][k] == f2[[k]][k])  next
            if (! isClose(f1[[k]][k],f2[[k]][k])) return (r)
          }
        }
        else {
          if (1 != length(f1[[k]]))   return (r)
          if (1 != length(f2[[k]]))   return (r)
          if (f1[[k]] == f2[[k]])  next
          if (! isClose(f1[[k]],f2[[k]])) return (r)
        }
        next
      }
      if (! is.array(f1[[k]]))     return (r)
      if (! is.array(f2[[k]]))     return (r)
      dims1 <- dim(f1[[k]])
      dims2 <- dim(f2[[k]])
      nd <- length(dims2)
      if (length(dims1) != nd)     return (r)
      last <- 1
      for (d in 1:nd) {
        if (dims1[d] != dims2[d])  return (r)
        last <- last * dims1[d]
      }
      if (0 == last)               next
      for (kk in 1:last) {
        if (f1[[k]][kk] == f2[[k]][kk])  next
        if (! isClose(f1[[k]][kk],f2[[k]][kk])) return (r)
        ## if (f1[[k]][kk] != f2[[k]][kk])  return (r)
      }
      if ((! isSparse) && checkDimNames) {
        dn1 <- dimnames(f1[[k]])
        dn2 <- dimnames(f2[[k]])
        if (is.null(dn1) && is.null(dn2))   next
        if (is.null(dn1))                   return (r)
        if (is.null(dn2))                   return (r)
        for (d in 1:nd) {
          if (is.null(dn1[[d]]) && is.null(dn2[[d]]))  next
          if (is.null(dn1[[d]]))                       return (r)
          if (is.null(dn2[[d]]))                       return (r)
          if (! chkSameVec ("", dn1[[d]], dn2[[d]]))   return (r)
        }
      }
    }
    else if ("form" == f2Names[[k]]) {
      if (isUniverse) {
        next                            # already checked
      }
      if (! is.character(f1[[k]]))   return (r)
      if (! is.character(f2[[k]]))   return (r)
      if (f1[[k]] != f2[[k]])        return (r)
    }
    else if ("uels" == f2Names[[k]]) {
      if (isUniverse) {
        r$msg <- "universe set: expect vector of uels"
        if (! chkSameVec ("", f1[[k]], f2[[k]])) return (r)
        next
      }
      if (! is.list(f1[[k]]))   return (r)
      if (! is.list(f2[[k]]))   return (r)
      n1 <- length(f1[[k]])
      if (n1 != length(f2[[k]]))  return (r)
      if (0 == n1)                next
      for (i in 1:n1) {
        if (! chkSameVec ("", f1[[k]][[i]], f2[[k]][[i]])) return (r)
      }
    }
    else if ("ts" == f2Names[[k]]) {
      if (! is.character(f1[[k]]))   return (r)
      if (! is.character(f2[[k]]))   return (r)
      if (f1[[k]] != f2[[k]])        return (r)
    }
    else if ("te" == f2Names[[k]]) {
      if (isSparse) {
        if (! chkSameVec ("", f1[[k]], f2[[k]])) return (r)
      }
      else {
        if (! chkSameArray (f1[[k]], f2[[k]])) return (r)
      }
    }
    else if ("domains" == f2Names[[k]]) {
      if (0 == symDim) {
        if (! is.vector(f1[[k]],mode="character"))   return (r)
        if (! is.vector(f2[[k]],mode="character"))   return (r)
        if (0 != length(f1[[k]]))                    return (r)
        if (0 != length(f2[[k]]))                    return (r)
        next
      }
      if (! chkSameVec ("", f1[[k]], f2[[k]])) return (r)
    }
    else if ("field" == f2Names[[k]]) {
      if (! is.character(f1[[k]]))   return (r)
      if (! is.character(f2[[k]]))   return (r)
      if (f1[[k]] != f2[[k]])        return (r)
    }
    else if ("varTypeText" == f2Names[[k]]) {
      if (! is.character(f1[[k]]))   return (r)
      if (! is.character(f2[[k]]))   return (r)
      if (f1[[k]] != f2[[k]])        return (r)
    }
    else if ("typeCode" == f2Names[[k]]) {
      if (! is.numeric(f1[[k]]))   return (r)
      if (! is.numeric(f2[[k]]))   return (r)
      if (f1[[k]] != f2[[k]])      return (r)
    }
    else {
      return (r)
    }
  }                                     # loop over list elements

  ## already checked if identical: they are not!
  if (reqIdent)     return(list(same=FALSE,msg='not identical'))

  r$same <- TRUE ;   r$msg <- ''
  return (r)
} # chkRgdxRes

# compare the arrays v1 and v2, return TRUE if the same, FALSE o/w
chkSameArray <- function (v1,v2) {
  if ("character" == mode(v1)) {
    if ("character" != mode(v2)) return (FALSE)
    if (! is.array(v1))   return (FALSE)
    if (! is.array(v2))   return (FALSE)
    dims1 <- dim(v1)
    dims2 <- dim(v2)
    nd <- length(dims1)
    if (nd != length(dims2))    return (FALSE)
    last <- 1
    for (d in 1:nd) {
      if (dims1[d] != dims2[d]) return (FALSE)
      last <- last * dims1[d]
    }
    for (k in 1:last) {
      if (! identical(v1[[k]], v2[[k]]))   return (FALSE)
    }
  }
  else if ("numeric" == mode(v1)) {
    if ("numeric" != mode(v2)) return (FALSE)
    if (! is.array(v1))   return (FALSE)
    if (! is.array(v2))   return (FALSE)
    dims1 <- dim(v1)
    dims2 <- dim(v2)
    nd <- length(dims1)
    if (nd != length(dims2))    return (FALSE)
    last <- 1
    for (d in 1:nd) {
      if (dims1[d] != dims2[d]) return (FALSE)
      last <- last * dims1[d]
    }
    for (k in 1:last) {
      if (! identical(v1[[k]], v2[[k]]))   return (FALSE)
    }
  }
  else {
    return (FALSE)
  }

  return (TRUE)
}  # chkSameArray

## body of tests for comparing behavior in two rgdx cases:
##   1. GDX file written prior to domain information
##   2. GDX file with domain information and useDomInfo=FALSE
## We expect identical behavior so we use a common test file

iUels <- c("i1", "i2", "i3", "i4")
iCard <- length(iUels)
iText <- iUels                        # since no text is in GDX
i2uels <- iUels[1:3]                  # uels from i that appear in ij
i2card <- length(i2uels)
ifUels <- iUels[2:4]                  # uels from i to use in filtered read
ifCard <- length(ifUels)
ifText <- iText[2:4]
jUels <- c("j1", "j2", "j3")
jCard <- length(jUels)
jText <- c("j1 text", "j2 text", "j3 text")
jfUels <- jUels[1:3]                  # uels from j to use in filtered read
jfCard <- length(jfUels)
jfText <- jText[1:3]
cUels <- c("berlin", "paris", "vienna")
cCard <- length(cUels)
cText <- c("city of airport delays", "city of light", "city of dreams")
u <- c(iUels, jUels, cUels)
uCard <- length(u)

## ---------- reading form=sparse, no filter, no compress

iwant <- list(name="I", type="set", dim=1,
              val=matrix(c(1:4), nrow=4, ncol=1),
              form="sparse",
              uels=list(u), domains=c("*"), te=iText)
i <- rgdx(fnIn,list(name='i',form='sparse',te=TRUE),useDomInfo=useDomInfo)
chk <- chkRgdxRes (i, iwant)
if (!chk$same) {
  stop (paste("test rgdx(i,unfiltered,uncompressed) failed",chk$msg))
}

jwant <- list(name="J", type="set", dim=1,
              val=matrix(c(5:7), nrow=3, ncol=1),
              form="sparse",
              uels=list(u), domains=c("*"),
              te=jText)
j <- rgdx(fnIn,list(name='j',form='sparse',te=TRUE),useDomInfo=useDomInfo)
chk <- chkRgdxRes (j, jwant)
if (!chk$same) {
  stop (paste("test rgdx(j,unfiltered,uncompressed) failed",chk$msg))
}

cwant <- list(name="c", type="set", dim=1,
              val=matrix(c(8:10), nrow=3, ncol=1),
              form="sparse",
              uels=list(u), domains=c("*"),
              ts='cities',
              te=cText)
c <- rgdx(fnIn,list(name='c',form='sparse',te=TRUE,ts=TRUE),useDomInfo=useDomInfo)
chk <- chkRgdxRes (c, cwant)
if (!chk$same) {
  stop (paste("test rgdx(c,unfiltered,uncompressed) failed",chk$msg))
}

ijwant <- list(name="IJ", type="set", dim=2,
               val=matrix(c(1,5, 1,7, 2,6, 2,7, 3,7), nrow=5, ncol=2, byrow=TRUE),
               form="sparse",
               uels=list(u,u), domains=c("*","*"),
               ts='',
               te=c("one.one", "one.three", "two.two", "two.three", "three.three"))
ij <- rgdx(fnIn,list(name='ij',form='sparse',te=TRUE,ts=TRUE),useDomInfo=useDomInfo)
chk <- chkRgdxRes (ij, ijwant)
if (!chk$same) {
  stop (paste("test rgdx(ij,unfiltered,uncompressed) failed",chk$msg))
}

ijcwant <- list(name="IJc", type="set", dim=3,
                val=matrix(c(1,5,8, 1,7,8, 2,6,9, 2,7,9, 3,7,10),
                           nrow=5, ncol=3, byrow=TRUE),
                form="sparse",
                uels=list(u,u,u), domains=c("*","*","*"),
                te=c("eins eins tempelhof", "eins drei tempelhof", "deux deux orly",
                  "deux trois orly", "drei drei schwechat"))
ijc <- rgdx(fnIn,list(name='ijc',form='sparse',te=TRUE),useDomInfo=useDomInfo)
chk <- chkRgdxRes (ijc, ijcwant)
if (!chk$same) {
  stop (paste("test rgdx(ijc,unfiltered,uncompressed) failed",chk$msg))
}

aicwant <- list(name="AIc", type="parameter", dim=2,
                val=matrix(c(1,8,11, 1,9,12, 2,9,22, 2,10,23, 3,10,33),
                           nrow=5, ncol=3, byrow=TRUE),
                form="sparse",
                uels=list(u,u), domains=c("*","*") )
aic <- rgdx(fnIn,list(name='aic',form='sparse'),useDomInfo=useDomInfo)
chk <- chkRgdxRes (aic, aicwant)
if (!chk$same) {
  stop (paste("test rgdx(aic,unfiltered,uncompressed) failed",chk$msg))
}

aijcwant <- list(name="AIJc", type="parameter", dim=3,
                 val=matrix(c(1,5,8 ,111,
                              1,7,8 ,131,
                              2,6,9 ,222,
                              2,7,9 ,232,
                              3,7,10,333),
                   nrow=5, ncol=4, byrow=TRUE),
                form="sparse",
                uels=list(u,u,u), domains=c("*","*","*")
                )
aijc <- rgdx(fnIn,list(name='aijc',form='sparse'),useDomInfo=useDomInfo)
chk <- chkRgdxRes (aijc, aijcwant)
if (!chk$same) {
  stop (paste("test rgdx(aijc,unfiltered,uncompressed) failed",chk$msg))
}

## ---------- reading form=sparse, no filter, compress=TRUE

iwant <- list(name="I", type="set", dim=1,
              val=matrix(c(1:4), nrow=4, ncol=1),
              form="sparse",
              uels=list(iUels), domains=c("_compressed"), te=iText)
i <- rgdx(fnIn,list(name='i',form='sparse',te=TRUE,compress=TRUE),useDomInfo=useDomInfo)
chk <- chkRgdxRes (i, iwant)
if (!chk$same) {
  stop (paste("test rgdx(i,unfiltered,compressed) failed",chk$msg))
}

jwant <- list(name="J", type="set", dim=1,
              val=matrix(c(1:3), nrow=3, ncol=1),
              form="sparse",
              uels=list(jUels), domains=c("_compressed"),
              te=jText)
j <- rgdx(fnIn,list(name='j',form='sparse',te=TRUE,compress=TRUE),useDomInfo=useDomInfo)
chk <- chkRgdxRes (j, jwant)
if (!chk$same) {
  stop (paste("test rgdx(j,unfiltered,compressed) failed",chk$msg))
}

ijwant <- list(name="IJ", type="set", dim=2,
               val=matrix(c(1,1, 1,3, 2,2, 2,3, 3,3), nrow=5, ncol=2, byrow=TRUE),
               form="sparse",
               uels=list(i2uels,jUels), # i4 is compressed out
               domains=c("_compressed","_compressed"),
               ts='',
               te=c("one.one", "one.three", "two.two", "two.three", "three.three"))
ij <- rgdx(fnIn,list(name='ij',form='sparse',te=TRUE,ts=TRUE,compress=TRUE),useDomInfo=useDomInfo)
chk <- chkRgdxRes (ij, ijwant)
if (!chk$same) {
  stop (paste("test rgdx(ij,unfiltered,compressed) failed",chk$msg))
}

ijcwant <- list(name="IJc", type="set", dim=3,
                val=matrix(c(1,1,1, 1,3,1, 2,2,2, 2,3,2, 3,3,3),
                           nrow=5, ncol=3, byrow=TRUE),
                form="sparse",
                uels=list(iUels[1:3],jUels,cUels),
                domains=c("_compressed","_compressed","_compressed"),
                te=c("eins eins tempelhof", "eins drei tempelhof", "deux deux orly",
                  "deux trois orly", "drei drei schwechat"))
ijc <- rgdx(fnIn,list(name='ijc',form='sparse',te=TRUE,compress=TRUE),useDomInfo=useDomInfo)
chk <- chkRgdxRes (ijc, ijcwant)
if (!chk$same) {
  stop (paste("test rgdx(ijc,unfiltered,compressed) failed",chk$msg))
}

aicwant <- list(name="AIc", type="parameter", dim=2,
                val=matrix(c(1,1,11,
                             1,2,12,
                             2,2,22,
                             2,3,23,
                             3,3,33),
                  nrow=5, ncol=3, byrow=TRUE),
                form="sparse",
                uels=list(iUels[1:3],cUels),
                domains=c("_compressed","_compressed") )

aic <- rgdx(fnIn,list(name='aic',form='sparse',compress=TRUE),useDomInfo=useDomInfo)
chk <- chkRgdxRes (aic, aicwant)
if (!chk$same) {
  stop (paste("test rgdx(aic,unfiltered,compressed) failed",chk$msg))
}

aijcwant <- list(name="AIJc", type="parameter", dim=3,
                 val=matrix(c(1,1,1,111,
                              1,3,1,131,
                              2,2,2,222,
                              2,3,2,232,
                              3,3,3,333),
                  nrow=5, ncol=4, byrow=TRUE),
                form="sparse",
                uels=list(iUels[1:3],jUels,cUels),
                domains=c("_compressed","_compressed","_compressed") )
aijc <- rgdx(fnIn,list(name='aijc',form='sparse',compress=TRUE),useDomInfo=useDomInfo)
chk <- chkRgdxRes (aijc, aijcwant)
if (!chk$same) {
  stop (paste("test rgdx(aijc,unfiltered,compressed) failed",chk$msg))
}

## ---------- reading form=sparse, filtered, no compress

iwant <- list(name="I", type="set", dim=1,
              val=matrix(c(1:3), nrow=3, ncol=1),
              form="sparse",
              uels=list(ifUels), domains=c("_user"), te=ifText)
i <- rgdx(fnIn,list(name='i',form='sparse',uels=list(ifUels),te=TRUE),useDomInfo=useDomInfo)
chk <- chkRgdxRes (i, iwant)
if (!chk$same) {
  stop (paste("test rgdx(i,filtered,uncompressed) failed",chk$msg))
}

jwant <- list(name="J", type="set", dim=1,
              val=matrix(1:3, nrow=3, ncol=1),
              form="sparse",
              uels=list(jfUels),
              domains=c("_user"),
              te=jfText)
j <- rgdx(fnIn,list(name='j',form='sparse',uels=list(jfUels),te=TRUE),useDomInfo=useDomInfo)
chk <- chkRgdxRes (j, jwant)
if (!chk$same) {
  stop (paste("test rgdx(j,filtered,uncompressed) failed",chk$msg))
}

cwant <- list(name="c", type="set", dim=1,
              val=matrix(c(8:10), nrow=3, ncol=1),
              form="sparse",
              uels=list(u),
              domains=c("_user"),
              ts='cities',
              te=cText)
c <- rgdx(fnIn,list(name='c',form='sparse',uels=list(u),te=TRUE,ts=TRUE),useDomInfo=useDomInfo)
chk <- chkRgdxRes (c, cwant)
if (!chk$same) {
  stop (paste("test rgdx(c,filtered,uncompressed) failed",chk$msg))
}

ijwant <- list(name="IJ", type="set", dim=2,
               val=matrix(c(1,2, 1,3, 2,3), nrow=3, ncol=2, byrow=TRUE),
               form="sparse",
               uels=list(ifUels,jfUels),
               domains=c("_user","_user"),
               ts='',
               te=c("two.two", "two.three", "three.three"))
ij <- rgdx(fnIn,list(name='ij',form='sparse',uels=list(ifUels,jfUels),te=TRUE,ts=TRUE),useDomInfo=useDomInfo)
chk <- chkRgdxRes (ij, ijwant)
if (!chk$same) {
  stop (paste("test rgdx(ij,filtered,uncompressed) failed",chk$msg))
}

ijcwant <- list(name="IJc", type="set", dim=3,
                val=matrix(c(1,2,9, 1,3,9, 2,3,10),
                           nrow=3, ncol=3, byrow=TRUE),
                form="sparse",
                uels=list(ifUels,jfUels,u),
                domains=c("_user","_user","_user"),
                te=c("deux deux orly", "deux trois orly", "drei drei schwechat"))
ijc <- rgdx(fnIn,list(name='ijc',form='sparse',uels=list(ifUels,jfUels,u),te=TRUE),useDomInfo=useDomInfo)
chk <- chkRgdxRes (ijc, ijcwant)
if (!chk$same) {
  stop (paste("test rgdx(ijc,filtered,uncompressed) failed",chk$msg))
}

aicwant <- list(name="AIc", type="parameter", dim=2,
                 val=matrix(c(1, 9,22,
                              1,10,23,
                              2,10,33),
                           nrow=3, ncol=3, byrow=TRUE),
                form="sparse",
                uels=list(ifUels,u),
                domains=c("_user","_user") )
aic <- rgdx(fnIn,list(name='aic',form='sparse',uels=list(ifUels,u)),useDomInfo=useDomInfo)
chk <- chkRgdxRes (aic, aicwant)
if (!chk$same) {
  stop (paste("test rgdx(aic,filtered,uncompressed) failed",chk$msg))
}

aijcwant <- list(name="AIJc", type="parameter", dim=3,
                 val=matrix(c(1,2,9,222,
                              1,3,9,232,
                              2,3,10,333),
                           nrow=3, ncol=4, byrow=TRUE),
                form="sparse",
                uels=list(ifUels,jfUels,u),
                domains=c("_user","_user","_user") )
aijc <- rgdx(fnIn,list(name='aijc',form='sparse',uels=list(ifUels,jfUels,u)),useDomInfo=useDomInfo)
chk <- chkRgdxRes (aijc, aijcwant)
if (!chk$same) {
  stop (paste("test rgdx(aijc,filtered,uncompressed) failed",chk$msg))
}

## ---------- reading form=full, no filter, no compress

v <- array(0,c(uCard,1))
v[(1:iCard)] <- 1
te <- array("",c(uCard,1))
te[(1:iCard)] <- iText
iwant <- list(name="I", type="set", dim=1,
              val=v,
              form="full",
              uels=list(u), domains=c("*"), te=te)
i <- rgdx(fnIn,list(name='i',form='full',te=TRUE),useDomInfo=useDomInfo)
chk <- chkRgdxRes (i, iwant)
if (!chk$same) {
  stop (paste("test rgdx(i,full,unfiltered,uncompressed) failed",chk$msg))
}

jblock <- iCard + (1:jCard)
v <- array(0,c(uCard,1))
v[jblock] <- 1
te <- array("",c(uCard,1))
te[jblock] <- jText
jwant <- list(name="J", type="set", dim=1,
              val=v,
              form="full",
              uels=list(u), domains=c("*"), te=te)
j <- rgdx(fnIn,list(name='j',form='full',te=TRUE),useDomInfo=useDomInfo)
chk <- chkRgdxRes (j, jwant)
if (!chk$same) {
  stop (paste("test rgdx(j,full,unfiltered,uncompressed) failed",chk$msg))
}

cblock <- iCard + jCard + (1:cCard)
v <- array(0,c(uCard,1))
v[cblock] <- 1
te <- array("",c(uCard,1))
te[cblock] <- cText
cwant <- list(name="c", type="set", dim=1,
              val=v,
              form="full",
              uels=list(u), domains=c("*"), te=te)
c <- rgdx(fnIn,list(name='c',form='full',te=TRUE),useDomInfo=useDomInfo)
chk <- chkRgdxRes (c, cwant)
if (!chk$same) {
  stop (paste("test rgdx(c,full,unfiltered,uncompressed) failed",chk$msg))
}

## it is helpful to put the names with the array
## we should consider doing this with the return $val!!
v <- array(0,c(uCard,uCard),dimnames=list(u,u))
v['i1','j1'] <- 1;
v['i1','j3'] <- 1;
v['i2','j2'] <- 1;
v['i2','j3'] <- 1;
v['i3','j3'] <- 1;
te <- array("",c(uCard,uCard),dimnames=list(u,u))
te['i1','j1'] <- "one.one";
te['i1','j3'] <- "one.three";
te['i2','j2'] <- "two.two";
te['i2','j3'] <- "two.three";
te['i3','j3'] <- "three.three";
ijwant <- list(name="IJ", type="set", dim=2,
               val=v,
               form="full",
               uels=list(u,u), domains=c("*","*"),
               ts='',
               te=te)
ij <- rgdx(fnIn,list(name='ij',form='full',te=TRUE,ts=TRUE),useDomInfo=useDomInfo)
chk <- chkRgdxRes (ij, ijwant)
if (!chk$same) {
  stop (paste("test rgdx(ij,full,unfiltered,uncompressed) failed",chk$msg))
}

v <- array(0,c(uCard,uCard,uCard),dimnames=list(u,u,u))
v['i1','j1','berlin'] <- 1;
v['i1','j3','berlin'] <- 1;
v['i2','j2','paris' ] <- 1;
v['i2','j3','paris' ] <- 1;
v['i3','j3','vienna'] <- 1;
te <- array("",c(uCard,uCard,uCard),dimnames=list(u,u,u))
te['i1','j1','berlin'] <- "eins eins tempelhof";
te['i1','j3','berlin'] <- "eins drei tempelhof";
te['i2','j2','paris' ] <- "deux deux orly";
te['i2','j3','paris' ] <- "deux trois orly";
te['i3','j3','vienna'] <- "drei drei schwechat";
ijcwant <- list(name="IJc", type="set", dim=3,
                val=v,
                form="full",
                uels=list(u,u,u), domains=c("*","*","*"),
                te=te)
ijc <- rgdx(fnIn,list(name='ijc',form='full',te=TRUE),useDomInfo=useDomInfo)
chk <- chkRgdxRes (ijc, ijcwant)
if (!chk$same) {
  stop (paste("test rgdx(ijc,full,unfiltered,uncompressed) failed",chk$msg))
}

v <- array(0,c(uCard,uCard),dimnames=list(u,u))
v['i1','berlin'] <- 11;
v['i1','paris' ] <- 12;
v['i2','paris' ] <- 22;
v['i2','vienna'] <- 23;
v['i3','vienna'] <- 33;
aicwant <- list(name="AIc", type="parameter", dim=2,
                val=v,
                form="full",
                uels=list(u,u), domains=c("*","*"))
aic <- rgdx(fnIn,list(name='aic',form='full'),useDomInfo=useDomInfo)
chk <- chkRgdxRes (aic, aicwant)
if (!chk$same) {
  stop (paste("test rgdx(aic,full,unfiltered,uncompressed) failed",chk$msg))
}

v <- array(0,c(uCard,uCard,uCard),dimnames=list(u,u,u))
v['i1','j1','berlin'] <- 111;
v['i1','j3','berlin'] <- 131;
v['i2','j2','paris' ] <- 222;
v['i2','j3','paris' ] <- 232;
v['i3','j3','vienna'] <- 333;
aijcwant <- list(name="AIJc", type="parameter", dim=3,
                val=v,
                form="full",
                uels=list(u,u,u), domains=c("*","*","*"))
aijc <- rgdx(fnIn,list(name='aijc',form='full'),useDomInfo=useDomInfo)
chk <- chkRgdxRes (aijc, aijcwant)
if (!chk$same) {
  stop (paste("test rgdx(aijc,full,unfiltered,uncompressed) failed",chk$msg))
}

## ---------- reading form=full, no filter, compress=TRUE

v <- array(1,c(iCard,1))
te <- array("",c(iCard,1))
te[(1:iCard)] <- iText
iwant <- list(name="I", type="set", dim=1,
              val=v,
              form="full",
              uels=list(iUels), domains=c("_compressed"), te=te)
i <- rgdx(fnIn,list(name='i',form='full',te=TRUE,compress=TRUE),useDomInfo=useDomInfo)
chk <- chkRgdxRes (i, iwant)
if (!chk$same) {
  stop (paste("test rgdx(i,full,unfiltered,compressed) failed",chk$msg))
}

v <- array(1,c(jCard,1))
te <- array("",c(jCard,1))
te[(1:jCard)] <- jText
jwant <- list(name="J", type="set", dim=1,
              val=v,
              form="full",
              uels=list(jUels), domains=c("_compressed"),
              te=te)
j <- rgdx(fnIn,list(name='j',form='full',te=TRUE,compress=TRUE),useDomInfo=useDomInfo)
chk <- chkRgdxRes (j, jwant)
if (!chk$same) {
  stop (paste("test rgdx(j,full,unfiltered,compressed) failed",chk$msg))
}

v <- array(1,c(cCard,1))
te <- array("",c(cCard,1))
te[(1:cCard)] <- cText
cwant <- list(name="c", type="set", dim=1,
              val=v,
              form="full",
              uels=list(cUels), domains=c("_compressed"),
              te=te)
c <- rgdx(fnIn,list(name='c',form='full',te=TRUE,compress=TRUE),useDomInfo=useDomInfo)
chk <- chkRgdxRes (c, cwant)
if (!chk$same) {
  stop (paste("test rgdx(c,full,unfiltered,compressed) failed",chk$msg))
}

v <- array(0,c(i2card,jCard),dimnames=list(i2uels,jUels))
v['i1','j1'] <- 1;
v['i1','j3'] <- 1;
v['i2','j2'] <- 1;
v['i2','j3'] <- 1;
v['i3','j3'] <- 1;
te <- array("",c(i2card,jCard),dimnames=list(i2uels,jUels))
te['i1','j1'] <- "one.one";
te['i1','j3'] <- "one.three";
te['i2','j2'] <- "two.two";
te['i2','j3'] <- "two.three";
te['i3','j3'] <- "three.three";
ijwant <- list(name="IJ", type="set", dim=2,
               val=v,
               form="full",
               uels=list(i2uels,jUels),
               domains=c("_compressed","_compressed"),
               ts='',
               te=te)
ij <- rgdx(fnIn,list(name='ij',form='full',te=TRUE,ts=TRUE,compress=TRUE),useDomInfo=useDomInfo)
chk <- chkRgdxRes (ij, ijwant)
if (!chk$same) {
  stop (paste("test rgdx(ij,full,unfiltered,compressed) failed",chk$msg))
}

v <- array(0,c(i2card,jCard,cCard),dimnames=list(i2uels,jUels,cUels))
v['i1','j1','berlin'] <- 1;
v['i1','j3','berlin'] <- 1;
v['i2','j2','paris' ] <- 1;
v['i2','j3','paris' ] <- 1;
v['i3','j3','vienna'] <- 1;
te <- array("",c(i2card,jCard,cCard),dimnames=list(i2uels,jUels,cUels))
te['i1','j1','berlin'] <- "eins eins tempelhof";
te['i1','j3','berlin'] <- "eins drei tempelhof";
te['i2','j2','paris' ] <- "deux deux orly";
te['i2','j3','paris' ] <- "deux trois orly";
te['i3','j3','vienna'] <- "drei drei schwechat";
ijcwant <- list(name="IJc", type="set", dim=3,
                val=v,
                form="full",
                uels=list(i2uels,jUels,cUels),
                domains=c("_compressed","_compressed","_compressed"),
                te=te)
ijc <- rgdx(fnIn,list(name='ijc',form='full',te=TRUE,compress=TRUE),useDomInfo=useDomInfo)
chk <- chkRgdxRes (ijc, ijcwant)
if (!chk$same) {
  stop (paste("test rgdx(ijc,full,unfiltered,compressed) failed",chk$msg))
}

v <- array(0,c(i2card,cCard),dimnames=list(i2uels,cUels))
v['i1','berlin'] <- 11;
v['i1','paris' ] <- 12;
v['i2','paris' ] <- 22;
v['i2','vienna'] <- 23;
v['i3','vienna'] <- 33;
aicwant <- list(name="AIc", type="parameter", dim=2,
                val=v,
                form="full",
                uels=list(i2uels,cUels),
                domains=c("_compressed","_compressed"),
                ts='')
aic <- rgdx(fnIn,list(name='aic',form='full',ts=TRUE,compress=TRUE),useDomInfo=useDomInfo)
chk <- chkRgdxRes (aic, aicwant)
if (!chk$same) {
  stop (paste("test rgdx(aic,full,unfiltered,compressed) failed",chk$msg))
}

v <- array(0,c(i2card,jCard,cCard),dimnames=list(i2uels,jUels,cUels))
v['i1','j1','berlin'] <- 111;
v['i1','j3','berlin'] <- 131;
v['i2','j2','paris' ] <- 222;
v['i2','j3','paris' ] <- 232;
v['i3','j3','vienna'] <- 333;
aijcwant <- list(name="AIJc", type="parameter", dim=3,
                val=v,
                form="full",
                uels=list(i2uels,jUels,cUels),
                domains=c("_compressed","_compressed","_compressed") )
aijc <- rgdx(fnIn,list(name='aijc',form='full',compress=TRUE),useDomInfo=useDomInfo)
chk <- chkRgdxRes (aijc, aijcwant)
if (!chk$same) {
  stop (paste("test rgdx(aijc,full,unfiltered,compressed) failed",chk$msg))
}

## ---------- reading form=full, filtered, no compress

v <- array(1,c(ifCard,1))
te <- array("",c(ifCard,1))
te[(1:ifCard)] <- ifText
iwant <- list(name="I", type="set", dim=1,
              val=v,
              form="full",
              uels=list(ifUels), domains=c("_user"), te=te)
i <- rgdx(fnIn,list(name='i',form='full',uels=list(ifUels),te=TRUE),useDomInfo=useDomInfo)
chk <- chkRgdxRes (i, iwant)
if (!chk$same) {
  stop (paste("test rgdx(i,full,filtered,uncompressed) failed",chk$msg))
}

v <- array(1,c(jfCard,1))
te <- array("",c(jfCard,1))
te[(1:jfCard)] <- jfText
jwant <- list(name="J", type="set", dim=1,
              val=v,
              form="full",
              uels=list(jfUels),
              domains=c("_user"),
              te=te)
j <- rgdx(fnIn,list(name='j',form='full',te=TRUE,uels=list(jfUels)),useDomInfo=useDomInfo)
chk <- chkRgdxRes (j, jwant)
if (!chk$same) {
  stop (paste("test rgdx(j,full,filtered,uncompressed) failed",chk$msg))
}

cblock <- iCard + jCard + (1:cCard)
v <- array(0,c(uCard,1))
v[cblock] <- 1
te <- array("",c(uCard,1))
te[cblock] <- cText
cwant <- list(name="c", type="set", dim=1,
              val=v,
              form="full",
              uels=list(u),
              domains=c("_user"),
              ts='cities',
              te=te)
c <- rgdx(fnIn,list(name='c',form='full',uels=list(u),te=TRUE,ts=TRUE),useDomInfo=useDomInfo)
chk <- chkRgdxRes (c, cwant)
if (!chk$same) {
  stop (paste("test rgdx(c,full,filtered,uncompressed) failed",chk$msg))
}

v <- array(0,c(ifCard,jfCard),dimnames=list(ifUels,jfUels))
v['i2','j2'] <- 1;
v['i2','j3'] <- 1;
v['i3','j3'] <- 1;
te <- array("",c(ifCard,jfCard),dimnames=list(ifUels,jfUels))
te['i2','j2'] <- "two.two";
te['i2','j3'] <- "two.three";
te['i3','j3'] <- "three.three";
ijwant <- list(name="IJ", type="set", dim=2,
               val=v,
               form="full",
               uels=list(ifUels,jfUels),
               domains=c("_user","_user"),
               ts='',
               te=te)
ij <- rgdx(fnIn,list(name='ij',form='full',te=TRUE,ts=TRUE,uels=list(ifUels,jfUels)),useDomInfo=useDomInfo)
chk <- chkRgdxRes (ij, ijwant)
if (!chk$same) {
  stop (paste("test rgdx(ij,full,filtered,uncompressed) failed",chk$msg))
}

v <- array(0,c(ifCard,jfCard,uCard),dimnames=list(ifUels,jfUels,u))
v['i2','j2','paris' ] <- 1;
v['i2','j3','paris' ] <- 1;
v['i3','j3','vienna'] <- 1;
te <- array("",c(ifCard,jfCard,uCard),dimnames=list(ifUels,jfUels,u))
te['i2','j2','paris' ] <- "deux deux orly";
te['i2','j3','paris' ] <- "deux trois orly";
te['i3','j3','vienna'] <- "drei drei schwechat";
ijcwant <- list(name="IJc", type="set", dim=3,
                val=v,
                form="full",
                uels=list(ifUels,jfUels,u),
                domains=c("_user","_user","_user"),
                te=te)
ijc <- rgdx(fnIn,list(name='ijc',form='full',te=TRUE,uels=list(ifUels,jfUels,u)),useDomInfo=useDomInfo)
chk <- chkRgdxRes (ijc, ijcwant)
if (!chk$same) {
  stop (paste("test rgdx(ijc,full,filtered,uncompressed) failed",chk$msg))
}

v <- array(0,c(ifCard,uCard),dimnames=list(ifUels,u))
v['i2','paris' ] <- 22;
v['i2','vienna'] <- 23;
v['i3','vienna'] <- 33;
aicwant <- list(name="AIc", type="parameter", dim=2,
                val=v,
                form="full",
                uels=list(ifUels,u),
                domains=c("_user","_user"),
                ts='')
aic <- rgdx(fnIn,list(name='aic',form='full',ts=TRUE,uels=list(ifUels,u)),useDomInfo=useDomInfo)
chk <- chkRgdxRes (aic, aicwant)
if (!chk$same) {
  stop (paste("test rgdx(aic,full,filtered,uncompressed) failed",chk$msg))
}

v <- array(0,c(ifCard,jfCard,cCard),dimnames=list(ifUels,jfUels,cUels))
v['i2','j2','paris' ] <- 222;
v['i2','j3','paris' ] <- 232;
v['i3','j3','vienna'] <- 333;
aijcwant <- list(name="AIJc", type="parameter", dim=3,
                val=v,
                form="full",
                uels=list(ifUels,jfUels,cUels),
                domains=c("_user","_user","_user"),
                ts='')
aijc <- rgdx(fnIn,list(name='aijc',form='full',ts=TRUE,uels=list(ifUels,jfUels,cUels)),useDomInfo=useDomInfo)
chk <- chkRgdxRes (aijc, aijcwant)
if (!chk$same) {
  stop (paste("test rgdx(aijc,full,filtered,uncompressed) failed",chk$msg))
}

fnData <- "norrisData.gdx"
fnSol <- "norrisSol.gdx"

if (! file_test ('-f', fnData)) {
  stop (paste("FAIL: File", fnData, "does not exist"))
}
lst <- list(name='p',form='full',compress=TRUE)
out <- rgdx(fnData,lst)
p <- out$uels
lst <- list(name='data',form='full',compress=TRUE)
out <- rgdx(fnData,lst)
d <- data.frame(y=out$val[,1],x=out$val[,2])

f <- y ~ x
res <- lm(f, data = d)
est <- as.array(coef(res))
smry <- summary(res)
se <- as.array(smry$coefficients[,'Std. Error'])
df <- res$df.residual
residuals <- res$residuals

estlst <- list(name='estimate', type='parameter', form='full',
               ts='Estimated coefficients', val=est, uels=p)
selst <- list(name='se', type='parameter', form='full',
            ts='Standard errors',
            val=se, uels=p)
tlst <- list(name='tval', type='parameter', form='full',
             ts='t values',
             val=as.array(smry$coefficients[,'t value']), uels=p)
plst <- list(name='pval', type='parameter', form='full',
            ts='p values',
            val=as.array(smry$coefficients[,'Pr(>|t|)']), uels=p)
dflst <- list(name='df', type='parameter', form='full', dim=0,
              ts='Degrees of freedom', val=df)
sigmalst <- list(name='sigma', type='parameter', form='full', dim=0,
                 ts='Standard error',
                 val=smry$sigma)
r2lst <- list(name='r2', type='parameter', form='full', dim=0,
              ts='R Squared',
              val=smry$r.squared)
resvarlst <- list(name='resvar', type='parameter', form='full', dim=0,
                  ts='Residual variance',
                  val=(smry$sigma)^2)
rsslst <- list(name='rss', type='parameter', form='full', dim=0,
               ts='Residual sum of squares',
               val=sum(residuals^2))


wgdx (fnSol, estlst, selst, tlst, plst, dflst, sigmalst, r2lst,
      resvarlst, rsslst)

#### test rgdx and reading set text data, i.e. I.te(I) in gams
#### test form=['sparse','full'] X [filtered,unfiltered] X compress=[T,F]

#### wanted lists produced with    dump("listName",file="")

if (! require(gdxrrw))      stop ("gdxrrw package is not available")
if (0 == igdx(silent=TRUE)) stop ("the gdx shared library has not been loaded")

source ("chkSame.R")
reqIdent <- TRUE

testName <- 'associated text (.te) for sets'

errFunc <- function(ex) {
  print (paste0("test of rgdx on ",testName,": FAILED"))
  print(ex)
  FALSE
} # errFunc

tryCatch({
  print (paste("testing rgdx on", testName))
  rgdx('?')
  fnIn <- "teTest.gdx"
  if (! file_test ('-f', fnIn)) {
    stop (paste("FAIL: File", fnIn, "does not exist"))
  }

  ## start test assuming the default behavior for inventing names
  options(gdx.inventSetText=NULL)

  iUels <- c("i1", "i2", "i3", "i4")
  iCard <- length(iUels)
  iText <- iUels                        # since no text is in GDX
  iTextNA <- as.character(c(NA,NA,NA,NA)) # if invented set text is NA
  iTextBL <- c("","","","")             # if invented set text is FALSE
  iVals <- matrix(c(1,2,3,4), nrow=iCard, ncol=1)
  i2uels <- iUels[1:3]                  # uels from i that appear in ij
  i2card <- length(i2uels)
  ifUels <- iUels[2:4]                  # uels from i to use in filtered read
  ifCard <- length(ifUels)
  ifText <- iText[2:4]
  ifTextNA <- iTextNA[2:4]
  ifVals <- matrix(c(1,2,3), nrow=ifCard, ncol=1)
  jUels <- c("j1", "j2", "j3")
  jCard <- length(jUels)
  jText <- c("j1 text", "j2 text", "j3 text")
  jVals <- matrix(iCard+c(1,2,3), nrow=jCard, ncol=1)
  jfUels <- jUels[1:3]                  # uels from j to use in filtered read
  jfCard <- length(jfUels)
  jfText <- jText[1:3]
  cUels <- c("berlin", "paris", "vienna")
  cCard <- length(cUels)
  cText <- c("city of airport delays", "city of light", "city of dreams")
  cVals <- matrix(c(8,9,10), nrow=cCard, ncol=1)
  u <- c(iUels, jUels, cUels)
  uCard <- length(u)
  udom2 <- c("I","J")
  udom3 <- c("I","J","c")
  i_f_u <- factor(iUels,u)
  j_f_u <- factor(jUels,u)
  c_f_u <- factor(cUels,u)

  ## ---------- reading form=sparse, no filter, no compress

  iwant <- list(name="I", type="set", dim=1L,
                val=iVals,
                form="sparse",
                uels=list(u), domains=c("*"), domInfo="none", te=iTextNA)
  i <- rgdx(fnIn,list(name='i',form='sparse',te=TRUE))
  chk <- chkRgdxRes (i, iwant, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(i,unfiltered,uncompressed) failed:",chk$msg))
  }
  idfwant <- data.frame(list("i"=i_f_u,".te"=iTextNA),stringsAsFactors=F)
  attr(idfwant,"symName") <- "I"
  attr(idfwant,"domains") <- c("*")
  attr(idfwant,"domInfo") <- "none"
  idf <- rgdx.set(fnIn,'i',te=TRUE)
  chk <- chkRgdxDF (idf, idfwant, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx.set(i,uncompressed) failed:",chk$msg))
  }

  jwant <- list(name="J", type="set", dim=1L,
                val=jVals,
                form="sparse",
                uels=list(u), domains=c("*"), domInfo="none",
                te=jText)
  j <- rgdx(fnIn,list(name='j',form='sparse',te=TRUE))
  chk <- chkRgdxRes (j, jwant, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(j,unfiltered,uncompressed) failed:",chk$msg))
  }
  jdfwant <- data.frame(list("i"=j_f_u,".te"=jText),stringsAsFactors=F)
  attr(jdfwant,"symName") <- "J"
  attr(jdfwant,"domains") <- c("*")
  attr(jdfwant,"domInfo") <- "none"
  jdf <- rgdx.set(fnIn,'j',te=TRUE)
  chk <- chkRgdxDF (jdf, jdfwant, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx.set(j,uncompressed) failed:",chk$msg))
  }

  cwant <- list(name="c", type="set", dim=1L,
                val=cVals,
                form="sparse",
                uels=list(u), domains=c("*"), domInfo="none",
                ts='cities',
                te=cText)
  c <- rgdx(fnIn,list(name='c',form='sparse',te=TRUE,ts=TRUE))
  chk <- chkRgdxRes (c, cwant, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(c,unfiltered,uncompressed) failed:",chk$msg))
  }
  cdfwant <- data.frame(list("i"=c_f_u,".te"=cText),stringsAsFactors=F)
  attr(cdfwant,"symName") <- "c"
  attr(cdfwant,"domains") <- c("*")
  attr(cdfwant,"domInfo") <- "none"
  cdf <- rgdx.set(fnIn,'c',te=TRUE)
  chk <- chkRgdxDF (cdf, cdfwant, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx.set(c,uncompressed) failed:",chk$msg))
  }

  ijwant <- list(name="IJ", type="set", dim=2L,
                 val=matrix(c(1,1,
                              1,3,
                              2,2,
                              2,3,
                              3,3), nrow=5, ncol=2, byrow=TRUE),
                 form="sparse",
                 uels=list(iUels,jUels), domains=c("I","J"), domInfo="full",
                 ts='',
                 te=c("one.one", "one.three", "two.two", "two.three", "three.three"))
  ij <- rgdx(fnIn,list(name='ij',form='sparse',te=TRUE,ts=TRUE))
  chk <- chkRgdxRes (ij, ijwant, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(ij,unfiltered,uncompressed) failed:",chk$msg))
  }
  f1 <- factor(as.integer(ij$val[,1]),seq(to=length(iUels)),labels=iUels)
  f2 <- factor(as.integer(ij$val[,2]),seq(to=length(jUels)),labels=jUels)
  ijdfwant <- data.frame(list("I"=f1,"J"=f2,".te"=ijwant$te),stringsAsFactors=F)
  attr(ijdfwant,"symName") <- "IJ"
  attr(ijdfwant,"domains") <- c("I","J")
  attr(ijdfwant,"domInfo") <- "full"
  ijdf <- rgdx.set(fnIn,'ij',te=TRUE)
  chk <- chkRgdxDF (ijdf, ijdfwant, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx.set(ij,uncompressed) failed:",chk$msg))
  }
  ijdfwantNA <- ijdfwant

  ijcwant <- list(name="IJc", type="set", dim=3L,
                  val=matrix(c(1,1,1,
                               1,3,1,
                               2,2,2,
			                         2,3,2,
			                         3,3,3),
                             nrow=5, ncol=3, byrow=TRUE),
                  form="sparse",
                  uels=list(iUels,jUels,cUels), domains=c("I","J","c"), domInfo="full",
                  te=c("eins eins tempelhof", "eins drei tempelhof", "deux deux orly",
                    "deux trois orly", "drei drei schwechat"))
  ijc <- rgdx(fnIn,list(name='ijc',form='sparse',te=TRUE))
  chk <- chkRgdxRes (ijc, ijcwant, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(ijc,unfiltered,uncompressed) failed:",chk$msg))
  }
  f1 <- factor(as.integer(ijc$val[,1]),seq(to=length(iUels)),labels=iUels)
  f2 <- factor(as.integer(ijc$val[,2]),seq(to=length(jUels)),labels=jUels)
  f3 <- factor(as.integer(ijc$val[,3]),seq(to=length(cUels)),labels=cUels)
  ijcdfwant <- data.frame(list("I"=f1,"J"=f2,"c"=f3,".te"=ijcwant$te),stringsAsFactors=F)
  attr(ijcdfwant,"symName") <- "IJc"
  attr(ijcdfwant,"domains") <- c("I","J","c")
  attr(ijcdfwant,"domInfo") <- "full"
  ijcdf <- rgdx.set(fnIn,'ijc',te=TRUE)
  chk <- chkRgdxDF (ijcdf, ijcdfwant, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx.set(ijc,uncompressed) failed:",chk$msg))
  }
  ijcdfwantNA <- ijcdfwant

  ## ---------- reading form=sparse, no filter, compress=TRUE

  iwant <- list(name="I", type="set", dim=1L,
                val=iVals,
                form="sparse",
                uels=list(iUels), domains=c("*"), domInfo="compressed", te=iTextNA)
  i <- rgdx(fnIn,list(name='i',form='sparse',te=TRUE,compress=TRUE))
  chk <- chkRgdxRes (i, iwant, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(i,unfiltered,compressed) failed:",chk$msg))
  }
  idfwant <- data.frame(list(".i"=factor(iUels),".te"=iTextNA),stringsAsFactors=F)
  attr(idfwant,"symName") <- "I"
  attr(idfwant,"domains") <- c("*")
  attr(idfwant,"domInfo") <- "compressed"
  idf <- rgdx.set(fnIn,'i',te=TRUE,compress=TRUE)
  chk <- chkRgdxDF (idf, idfwant, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx.set(i,compressed) failed:",chk$msg))
  }

  jwant <- list(name="J", type="set", dim=1L,
                val=jVals-iCard,
                form="sparse",
                uels=list(jUels), domains=c("*"), domInfo="compressed",
                te=jText)
  j <- rgdx(fnIn,list(name='j',form='sparse',te=TRUE,compress=TRUE))
  chk <- chkRgdxRes (j, jwant, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(j,unfiltered,compressed) failed:",chk$msg))
  }
  jdfwant <- data.frame(list(".i"=factor(jUels),".te"=jText),stringsAsFactors=F)
  attr(jdfwant,"symName") <- "J"
  attr(jdfwant,"domains") <- c("*")
  attr(jdfwant,"domInfo") <- "compressed"
  jdf <- rgdx.set(fnIn,'j',te=TRUE,compress=TRUE)
  chk <- chkRgdxDF (jdf, jdfwant, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx.set(j,compressed) failed:",chk$msg))
  }

  ijwant <- list(name="IJ", type="set", dim=2L,
                 val=matrix(c(1,1,
                              1,3,
                              2,2,
                              2,3,
                              3,3), nrow=5, ncol=2, byrow=TRUE),
                 form="sparse",
                 uels=list(i2uels,jUels), # i4 is compressed out
                 domains=c("I","J"), domInfo="compressed",
                 ts='',
                 te=c("one.one", "one.three", "two.two", "two.three", "three.three"))
  ij <- rgdx(fnIn,list(name='ij',form='sparse',te=TRUE,ts=TRUE,compress=TRUE))
  chk <- chkRgdxRes (ij, ijwant, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(ij,unfiltered,compressed) failed:",chk$msg))
  }
  f1 <- factor(as.integer(ij$val[,1]),labels=i2uels)
  f2 <- factor(as.integer(ij$val[,2]),labels=jUels)
  ijdfwant <- data.frame(list("I"=f1,"J"=f2,".te"=ijwant$te),stringsAsFactors=F)
  attr(ijdfwant,"symName") <- "IJ"
  attr(ijdfwant,"domains") <- c("I","J")
  attr(ijdfwant,"domInfo") <- "compressed"
  ijdf <- rgdx.set(fnIn,'ij',te=TRUE,compress=TRUE)
  chk <- chkRgdxDF (ijdf, ijdfwant, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx.set(ij,compressed) failed:",chk$msg))
  }

  ijcwant <- list(name="IJc", type="set", dim=3L,
                  val=matrix(c(1,1,1, 1,3,1, 2,2,2, 2,3,2, 3,3,3),
                             nrow=5, ncol=3, byrow=TRUE),
                  form="sparse",
                  uels=list(iUels[1:3],jUels,cUels),
                  domains=c("I","J","c"), domInfo="compressed",
                  te=c("eins eins tempelhof", "eins drei tempelhof", "deux deux orly",
                    "deux trois orly", "drei drei schwechat"))
  ijc <- rgdx(fnIn,list(name='ijc',form='sparse',te=TRUE,compress=TRUE))
  chk <- chkRgdxRes (ijc, ijcwant, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(ijc,unfiltered,compressed) failed:",chk$msg))
  }
  f1 <- factor(as.integer(ijcwant$val[,1]),labels=iUels[1:3])
  f2 <- factor(as.integer(ijcwant$val[,2]),labels=jUels)
  f3 <- factor(as.integer(ijcwant$val[,3]),labels=cUels)
  ijcdfwant <- data.frame(list("I"=f1,"J"=f2,"c"=f3,".te"=ijcwant$te),stringsAsFactors=F)
  attr(ijcdfwant,"symName") <- "IJc"
  attr(ijcdfwant,"domains") <- c("I","J","c")
  attr(ijcdfwant,"domInfo") <- "compressed"
  ijcdf <- rgdx.set(fnIn,'ijc',te=TRUE,compress=TRUE)
  chk <- chkRgdxDF (ijcdf, ijcdfwant, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx.set(ijc,compressed) failed",chk$msg))
  }

  ## ---------- reading form=sparse, filtered, no compress

  iwant <- list(name="I", type="set", dim=1L,
                val=ifVals,
                form="sparse",
                uels=list(ifUels), domains=c("*"), domInfo="filtered", te=ifTextNA)
  i <- rgdx(fnIn,list(name='i',form='sparse',uels=list(ifUels),te=TRUE))
  chk <- chkRgdxRes (i, iwant, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(i,filtered,uncompressed) failed:",chk$msg))
  }

  jwant <- list(name="J", type="set", dim=1L,
                val=jVals-iCard,
                form="sparse",
                uels=list(jfUels), domains=c("*"), domInfo="filtered",
                te=jfText)
  j <- rgdx(fnIn,list(name='j',form='sparse',uels=list(jfUels),te=TRUE))
  chk <- chkRgdxRes (j, jwant, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(j,filtered,uncompressed) failed:",chk$msg))
  }

  cwant <- list(name="c", type="set", dim=1L,
                val=cVals,
                form="sparse",
                uels=list(u), domains=c("*"), domInfo="filtered",
                ts='cities',
                te=cText)
  c <- rgdx(fnIn,list(name='c',form='sparse',uels=list(u),te=TRUE,ts=TRUE))
  chk <- chkRgdxRes (c, cwant, reqIdent=F)
  if (!chk$same) {
    stop (paste("test rgdx(c,filtered,uncompressed) failed:",chk$msg))
  }

  ijwant <- list(name="IJ", type="set", dim=2L,
                 val=matrix(c(1,2, 1,3, 2,3), nrow=3, ncol=2, byrow=TRUE),
                 form="sparse",
                 uels=list(ifUels,jfUels), domains=c("I","J"), domInfo="filtered",
                 ts='',
                 te=c("two.two", "two.three", "three.three"))
  ij <- rgdx(fnIn,list(name='ij',form='sparse',uels=list(ifUels,jfUels),te=TRUE,ts=TRUE))
  chk <- chkRgdxRes (ij, ijwant, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(ij,filtered,uncompressed) failed:",chk$msg))
  }

  ijcwant <- list(name="IJc", type="set", dim=3L,
                  val=matrix(c(1,2,9, 1,3,9, 2,3,10),
                             nrow=3, ncol=3, byrow=TRUE),
                  form="sparse",
                  uels=list(ifUels,jfUels,u), domains=c("I","J","c"), domInfo="filtered",
                  te=c("deux deux orly", "deux trois orly", "drei drei schwechat"))
  ijc <- rgdx(fnIn,list(name='ijc',form='sparse',uels=list(ifUels,jfUels,u),te=TRUE))
  chk <- chkRgdxRes (ijc, ijcwant, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(ijc,filtered,uncompressed) failed:",chk$msg))
  }

  ## ---------- reading form=full, no filter, no compress
  options(gdx.inventSetText=NA)

  ulst <- list('*'=u)
  v <- array(0,c(uCard,1),dimnames=ulst)
  v[(1:iCard)] <- 1
  te <- array("",c(uCard,1),dimnames=ulst)
  te[(1:iCard)] <- iTextNA
  iwant <- list(name="I", type="set", dim=1L,
                val=v,
                form="full",
                uels=ulst,
                domains=c("*"), domInfo="none",
                te=te)
  i <- rgdx(fnIn,list(name='i',form='full',te=TRUE))
  chk <- chkRgdxRes (i, iwant, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(i,full,unfiltered,uncompressed) failed:",chk$msg))
  }
  idfwant <- data.frame(list("i"=i_f_u,".te"=iTextNA),stringsAsFactors=F)
  attr(idfwant,"symName") <- "I"
  attr(idfwant,"domains") <- c("*")
  attr(idfwant,"domInfo") <- "none"
  idf <- rgdx.set(fnIn,'i',te=TRUE)
  chk <- chkRgdxDF (idf, idfwant, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx.set(i,uncompressed) inventSetText=NA failed:",chk$msg))
  }

  jblock <- iCard + (1:jCard)
  v <- array(0,c(uCard,1),dimnames=ulst)
  v[jblock] <- 1
  te <- array("",c(uCard,1),dimnames=ulst)
  te[jblock] <- jText
  jwant <- list(name="J", type="set", dim=1L,
                val=v,
                form="full",
                uels=ulst,
                domains=c("*"), domInfo="none", te=te)
  j <- rgdx(fnIn,list(name='j',form='full',te=TRUE))
  chk <- chkRgdxRes (j, jwant, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(j,full,unfiltered,uncompressed) failed:",chk$msg))
  }
  jdfwant <- data.frame(list("i"=j_f_u,".te"=jText),stringsAsFactors=F)
  attr(jdfwant,"symName") <- "J"
  attr(jdfwant,"domains") <- c("*")
  attr(jdfwant,"domInfo") <- "none"
  jdf <- rgdx.set(fnIn,'j',te=TRUE)
  chk <- chkRgdxDF (jdf, jdfwant, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx.set(j,uncompressed) inventSetText=NA failed:",chk$msg))
  }

  cblock <- iCard + jCard + (1:cCard)
  v <- array(0,c(uCard,1),dimnames=ulst)
  v[cblock] <- 1
  te <- array("",c(uCard,1),dimnames=ulst)
  te[cblock] <- cText
  cwant <- list(name="c", type="set", dim=1L,
                val=v,
                form="full",
                uels=ulst, domains=c("*"),  domInfo="none", te=te)
  c <- rgdx(fnIn,list(name='c',form='full',te=TRUE))
  chk <- chkRgdxRes (c, cwant, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(c,full,unfiltered,uncompressed) failed:",chk$msg))
  }
  cdfwant <- data.frame(list("i"=c_f_u,".te"=cText),stringsAsFactors=F)
  attr(cdfwant,"symName") <- "c"
  attr(cdfwant,"domains") <- c("*")
  attr(cdfwant,"domInfo") <- "none"
  cdf <- rgdx.set(fnIn,'c',te=TRUE)
  chk <- chkRgdxDF (cdf, cdfwant, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx.set(c,uncompressed) inventSetText=NA failed",chk$msg))
  }

  v <- array(0,c(iCard,jCard),dimnames=list('I'=iUels,'J'=jUels))
  v['i1','j1'] <- 1;
  v['i1','j3'] <- 1;
  v['i2','j2'] <- 1;
  v['i2','j3'] <- 1;
  v['i3','j3'] <- 1;
  te <- array("",c(iCard,jCard),dimnames=list('I'=iUels,'J'=jUels))
  te['i1','j1'] <- "one.one";
  te['i1','j3'] <- "one.three";
  te['i2','j2'] <- "two.two";
  te['i2','j3'] <- "two.three";
  te['i3','j3'] <- "three.three";
  ijwant <- list(name="IJ", type="set", dim=2L,
                 val=v,
                 form="full",
                 uels=list('I'=iUels,'J'=jUels), domains=c("I","J"), domInfo="full",
                 ts='',
                 te=te)
  ij <- rgdx(fnIn,list(name='ij',form='full',te=TRUE,ts=TRUE))
  chk <- chkRgdxRes (ij, ijwant, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(ij,full,unfiltered,uncompressed) failed",chk$msg))
  }
  ijdfwant <- ijdfwantNA
  ijdf <- rgdx.set(fnIn,'ij',te=TRUE)
  chk <- chkRgdxDF (ijdf, ijdfwant, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx.set(ij,uncompressed) inventSetText=NA failed:",chk$msg))
  }

  v <- array(0,c(iCard,jCard,cCard),dimnames=list('I'=iUels,'J'=jUels,'c'=cUels))
  v['i1','j1','berlin'] <- 1;
  v['i1','j3','berlin'] <- 1;
  v['i2','j2','paris' ] <- 1;
  v['i2','j3','paris' ] <- 1;
  v['i3','j3','vienna'] <- 1;
  te <- array("",c(iCard,jCard,cCard),dimnames=list('I'=iUels,'J'=jUels,'c'=cUels))
  te['i1','j1','berlin'] <- "eins eins tempelhof";
  te['i1','j3','berlin'] <- "eins drei tempelhof";
  te['i2','j2','paris' ] <- "deux deux orly";
  te['i2','j3','paris' ] <- "deux trois orly";
  te['i3','j3','vienna'] <- "drei drei schwechat";
  ijcwant <- list(name="IJc", type="set", dim=3L,
                  val=v,
                  form="full",
                  uels=list('I'=iUels,'J'=jUels,'c'=cUels),
                  domains=c("I","J","c"), domInfo="full",
                  te=te)
  ijc <- rgdx(fnIn,list(name='ijc',form='full',te=TRUE))
  chk <- chkRgdxRes (ijc, ijcwant, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(ijc,full,unfiltered,uncompressed) failed:",chk$msg))
  }
  ijcdfwant <- ijcdfwantNA
  ijcdf <- rgdx.set(fnIn,'ijc',te=TRUE)
  chk <- chkRgdxDF (ijcdf, ijcdfwant, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx.set(ijc,uncompressed) inventSetText=NA failed",chk$msg))
  }

  ## ---------- reading form=full, no filter, compress=TRUE
  options(gdx.inventSetText=FALSE)

  ilst <- list('*'=iUels)
  v <- array(1,c(iCard,1),dimnames=ilst)
  te <- array("",c(iCard,1),dimnames=ilst)
  te[(1:iCard)] <- iTextBL
  iwant <- list(name="I", type="set", dim=1L,
                val=v,
                form="full",
                uels=ilst, domains=c("*"), domInfo="compressed", te=te)
  i <- rgdx(fnIn,list(name='i',form='full',te=TRUE,compress=TRUE))
  chk <- chkRgdxRes (i, iwant, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(i,full,unfiltered,compressed) failed:",chk$msg))
  }
  idfwant <- data.frame(list("i"=i_f_u,".te"=iTextBL),stringsAsFactors=F)
  attr(idfwant,"symName") <- "I"
  attr(idfwant,"domains") <- c("*")
  attr(idfwant,"domInfo") <- "none"
  idf <- rgdx.set(fnIn,'i',te=TRUE)
  chk <- chkRgdxDF (idf, idfwant, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx.set(i,uncompressed) inventSetText=F failed:",chk$msg))
  }

  jlst <- list('*'=jUels)
  v <- array(1,c(jCard,1),dimnames=jlst)
  te <- array("",c(jCard,1),dimnames=jlst)
  te[(1:jCard)] <- jText
  jwant <- list(name="J", type="set", dim=1L,
                val=v,
                form="full",
                uels=jlst, domains=c("*"), domInfo="compressed",
                te=te)
  j <- rgdx(fnIn,list(name='j',form='full',te=TRUE,compress=TRUE))
  chk <- chkRgdxRes (j, jwant, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(j,full,unfiltered,compressed) failed:",chk$msg))
  }
  jdfwant <- data.frame(list("i"=j_f_u,".te"=jText),stringsAsFactors=F)
  attr(jdfwant,"symName") <- "J"
  attr(jdfwant,"domains") <- c("*")
  attr(jdfwant,"domInfo") <- "none"
  jdf <- rgdx.set(fnIn,'j',te=TRUE)
  chk <- chkRgdxDF (jdf, jdfwant, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx.set(j,uncompressed) inventSetText=F failed:",chk$msg))
  }

  v <- array(0,c(i2card,jCard),dimnames=list('I'=i2uels,'J'=jUels))
  v['i1','j1'] <- 1;
  v['i1','j3'] <- 1;
  v['i2','j2'] <- 1;
  v['i2','j3'] <- 1;
  v['i3','j3'] <- 1;
  te <- array("",c(i2card,jCard),dimnames=list('I'=i2uels,'J'=jUels))
  te['i1','j1'] <- "one.one";
  te['i1','j3'] <- "one.three";
  te['i2','j2'] <- "two.two";
  te['i2','j3'] <- "two.three";
  te['i3','j3'] <- "three.three";
  ijwant <- list(name="IJ", type="set", dim=2L,
                 val=v,
                 form="full",
                 uels=list('I'=i2uels,'J'=jUels),
                 domains=c("I","J"), domInfo="compressed",
                 ts='',
                 te=te)
  ij <- rgdx(fnIn,list(name='ij',form='full',te=TRUE,ts=TRUE,compress=TRUE))
  chk <- chkRgdxRes (ij, ijwant, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(ij,full,unfiltered,compressed) failed:",chk$msg))
  }
  
  v <- array(0,c(i2card,jCard,cCard),
             dimnames=list('I'=i2uels,'J'=jUels,'c'=cUels))
  v['i1','j1','berlin'] <- 1;
  v['i1','j3','berlin'] <- 1;
  v['i2','j2','paris' ] <- 1;
  v['i2','j3','paris' ] <- 1;
  v['i3','j3','vienna'] <- 1;
  te <- array("",c(i2card,jCard,cCard),
              dimnames=list('I'=i2uels,'J'=jUels,'c'=cUels))
  te['i1','j1','berlin'] <- "eins eins tempelhof";
  te['i1','j3','berlin'] <- "eins drei tempelhof";
  te['i2','j2','paris' ] <- "deux deux orly";
  te['i2','j3','paris' ] <- "deux trois orly";
  te['i3','j3','vienna'] <- "drei drei schwechat";
  ijcwant <- list(name="IJc", type="set", dim=3L,
                  val=v,
                  form="full",
                  uels=list('I'=i2uels,'J'=jUels,'c'=cUels),
                  domains=c("I","J","c"), domInfo="compressed",
                  te=te)
  ijc <- rgdx(fnIn,list(name='ijc',form='full',te=TRUE,compress=TRUE))
  chk <- chkRgdxRes (ijc, ijcwant, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(ijc,full,unfiltered,compressed) failed:",chk$msg))
  }
  ijdfwant <- ijdfwantNA
  ijdf <- rgdx.set(fnIn,'ij',te=TRUE)
  chk <- chkRgdxDF (ijdf, ijdfwant, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx.set(ij,uncompressed) inventSetText=F failed:",chk$msg))
  }

  ## ---------- reading form=full, filtered, no compress
  options(gdx.inventSetText=TRUE)

  ilst <- list('*'=ifUels)
  v <- array(1,c(ifCard,1),dimnames=ilst)
  te <- array("",c(ifCard,1),dimnames=ilst)
  te[(1:ifCard)] <- ifText
  iwant <- list(name="I", type="set", dim=1L,
                val=v,
                form="full",
                uels=ilst, domains=c('*'), domInfo="filtered", te=te)
  i <- rgdx(fnIn,list(name='i',form='full',uels=list(ifUels),te=TRUE))
  chk <- chkRgdxRes (i, iwant, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(i,full,filtered,uncompressed) failed:",chk$msg))
  }
  idfwant <- data.frame(list("i"=i_f_u,".te"=iText),stringsAsFactors=F)
  attr(idfwant,"symName") <- "I"
  attr(idfwant,"domains") <- c("*")
  attr(idfwant,"domInfo") <- "none"
  idf <- rgdx.set(fnIn,'i',te=TRUE)
  chk <- chkRgdxDF (idf, idfwant, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx.set(i,uncompressed) inventSetText=T failed:",chk$msg))
  }

  jlst <- list('*'=jfUels)
  v <- array(1,c(jfCard,1),dimnames=jlst)
  te <- array("",c(jfCard,1),dimnames=jlst)
  te[(1:jfCard)] <- jfText
  jwant <- list(name="J", type="set", dim=1L,
                val=v,
                form="full",
                uels=jlst, domains=c('*'), domInfo="filtered",
                te=te)
  j <- rgdx(fnIn,list(name='j',form='full',te=TRUE,uels=list(jfUels)))
  chk <- chkRgdxRes (j, jwant, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(j,full,filtered,uncompressed) failed:",chk$msg))
  }
  jdfwant <- data.frame(list("i"=j_f_u,".te"=jText),stringsAsFactors=F)
  attr(jdfwant,"symName") <- "J"
  attr(jdfwant,"domains") <- c("*")
  attr(jdfwant,"domInfo") <- "none"
  jdf <- rgdx.set(fnIn,'J',te=TRUE)
  chk <- chkRgdxDF (jdf, jdfwant, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx.set(j,uncompressed) inventSetText=T failed:",chk$msg))
  }

  cblock <- iCard + jCard + (1:cCard)
  ulst <- list('*'=u)
  v <- array(0,c(uCard,1),dimnames=ulst)
  v[cblock] <- 1
  te <- array("",c(uCard,1),dimnames=ulst)
  te[cblock] <- cText
  cwant <- list(name="c", type="set", dim=1L,
                val=v,
                form="full",
                uels=ulst, domains=c("*"), domInfo="filtered",
                ts='cities',
                te=te)
  c <- rgdx(fnIn,list(name='c',form='full',uels=list(u),te=TRUE,ts=TRUE))
  chk <- chkRgdxRes (c, cwant, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(c,full,filtered,uncompressed) failed:",chk$msg))
  }
  cdfwant <- data.frame(list("i"=c_f_u,".te"=cText),stringsAsFactors=F)
  attr(cdfwant,"symName") <- "c"
  attr(cdfwant,"domains") <- c("*")
  attr(cdfwant,"domInfo") <- "none"
  cdf <- rgdx.set(fnIn,'C',te=TRUE)
  chk <- chkRgdxDF (cdf, cdfwant, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx.set(c,uncompressed) inventSetText=T failed:",chk$msg))
  }

  dnames <- list(ifUels,jfUels) ; names(dnames) <- udom2
  v <- array(0,c(ifCard,jfCard),dimnames=dnames)
  v['i2','j2'] <- 1;
  v['i2','j3'] <- 1;
  v['i3','j3'] <- 1;
  te <- array("",c(ifCard,jfCard),dimnames=dnames)
  te['i2','j2'] <- "two.two";
  te['i2','j3'] <- "two.three";
  te['i3','j3'] <- "three.three";
  ijwant <- list(name="IJ", type="set", dim=2L,
                 val=v,
                 form="full",
                 uels=dnames, domains=udom2, domInfo="filtered",
                 ts='',
                 te=te)
  ij <- rgdx(fnIn,list(name='ij',form='full',te=TRUE,ts=TRUE,uels=list(ifUels,jfUels)))
  chk <- chkRgdxRes (ij, ijwant, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(ij,full,filtered,uncompressed) failed:",chk$msg))
  }

  dnames <- list(ifUels,jfUels,u) ; names(dnames) <- udom3
  v <- array(0,c(ifCard,jfCard,uCard),dimnames=dnames)
  v['i2','j2','paris' ] <- 1;
  v['i2','j3','paris' ] <- 1;
  v['i3','j3','vienna'] <- 1;
  te <- array("",c(ifCard,jfCard,uCard),dimnames=dnames)
  te['i2','j2','paris' ] <- "deux deux orly";
  te['i2','j3','paris' ] <- "deux trois orly";
  te['i3','j3','vienna'] <- "drei drei schwechat";
  ijcwant <- list(name="IJc", type="set", dim=3L,
                  val=v,
                  form="full",
                  uels=dnames, domains=udom3, domInfo="filtered",
                  te=te)
  ijc <- rgdx(fnIn,list(name='ijc',form='full',te=TRUE,uels=list(ifUels,jfUels,u)))
  chk <- chkRgdxRes (ijc, ijcwant, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(ijc,full,filtered,uncompressed) failed:",chk$msg))
  }


  print (paste0("test of rgdx on ", testName, ": PASSED"))
  invisible(TRUE)   ## all tests passed: return TRUE
},

error = function(ex) { print ("test of rgdx set text handling failed"); print(ex) ; FALSE }
)

### run through all the tests

if (! require(gdxrrw))      stop ("gdxrrw package is not available")
if (0 == igdx(silent=TRUE)) stop ("the gdx shared library has not been loaded")

gdir <- igdx(NULL,silent=TRUE,returnStr=TRUE)
pth <- Sys.getenv('PATH')
sepChar <- ':'
if (Sys.info()[[1]] == "Windows") sepChar <- ';'
Sys.setenv(PATH=paste(gdir,pth,sep=sepChar))

rc <- source ("tgdxdiff.R")
if (! rc$value)  stop ("The gdxdiff utility is unavailable or broken: Test run aborted.")

if (! interactive()) {
  a <- commandArgs(trailingOnly=TRUE)
  quickMode <- 0
  if ((length(a) > 0) && ("quick" == a[1]))  quickMode <- 1
  print(paste("quick set via commandArgs =",quickMode))
} else {
  f <- find('quickMode',mode='numeric')
  if (0 == length(f)) quickMode <- 0
  print(paste("quick set interactively =",quickMode))
}

# first the majority of tests: these are quicker
tests <- c(
    "tReadSparse1", "tReadFull1",
    "tRead.set", "tRead.param",
    "tReadSV", "tReadText", "tReadCase",
    "tReadErr",
    "tReadWithDomainInfo", "tReadPreDomainInfo",
    "tReadCompressWithoutDomInfo", "tReadCompressWithDomInfo",
    "tReadVar0", "tReadVar1", "tReadVar3",
    "tReadEqu",
    "tReadDFNames",
    "tWriteSparse1", "tWriteSparse2", "tWriteFull1", "tWriteFull2",
    "tWriteSetText", "tWriteSetTextDF",
    "tWriteLst",
    "tWriteSV",
    "tWriteFromTbl",
    "tWriteEquTypes",
    "tWriteVarField", "tWriteVarSort", "tWriteVarOrder",
    "tWriteVarTypesSparse", "tWriteVarFUels",
    "tWriteVarTypesFull",
    "tDomainNames", "tWrap",
    "tInfo1", "tInfo2",
    ## "tLS"
    "tWriteNan"
)
if (0 == quickMode) {
  tests <- c(tests, "tWriteVar20")
}
f <- find('interact',mode='logical')
doPrompt <- FALSE
if (length(f) > 0) {
  doPrompt <- interact
} else {
  doPrompt <- interactive()
}

nRuns <- 0
nFails  <- 0
fTests <- list()
for (ttt in tests) {
  print ('---------------------------------------------------------------')
  print (paste("Starting test", ttt))
  rc <- source (paste(ttt,".R",sep=""))
  if (rc$value) {
    print (paste("Test", ttt, "result: PASSED"))
  } else {
    print (paste("Test", ttt, "result: FAILED"))
    nFails  <- nFails + 1
    fTests[[ttt]] <- T
  }
  nRuns  <- nRuns + 1
  if (doPrompt) {
    ans <- readline("Hit enter to continue ")
    print ("")
  }
}
Sys.setenv(PATH=pth)
if (quickMode) print ("N.B.: quickMode is on, some tests were skipped")
if (nFails) {
  print (paste("Tests complete. ", nRuns,"tests run,",nFails,"tests FAILED"))
  for (nm in names(fTests)) print(paste0('  ',nm))
} else {
  print (paste("Testing complete.  All", nRuns,"tests PASSED"))
}
invisible(nFails)

## ## test wgdx with form='sparse', 1-d variable, write different types
## gdxdump or gdxdiff do not really do what we want here, so just have
## to read from the generated GDX and the target GDX and compare the results

if (! require(gdxrrw))      stop ("gdxrrw package is not available")
if (0 == igdx(silent=TRUE)) stop ("the gdx shared library has not been loaded")

testName <- 'all types of variable writes with form=sparse'

errFunc <- function(ex) {
  print (paste0("test of wgdx on ",testName,": FAILED"))
  print(ex)
  FALSE
} # errFunc

tryCatch({
  print (paste("testing wgdx on", testName))
  wgdx('?')
  fnOut <- "tmp.gdx"
  fnWant <- "tVarTypes.gdx"
  if (! file_test ('-f', fnWant)) {
    stop (paste("FAIL: File-to-duplicate", fnWant, "does not exist"))
  }

  ## all writes should use the same uels
  iUels <- paste0("i","1":"10")
  fUels <- c("l", "m", "lo", "up", "s")
  uels <- list(iUels,fUels)

  ## write binary variable to GDX, compare with fnWant version
  val0 <- matrix(0,nrow=5,ncol=3)
  for (i in 1:5) {
    val0[i,1] <- i
    val0[i,2] <- i
  }
  val0[1,3] <- 1                        # binary.L = 1
  val0[2,3] <- 0.5                      # binary.m = 0.5
  val0[3,3] <- 1                        # binary.lo = 1
  val0[4,3] <- 0                        # binary.up = 0
  val0[5,3] <- 10                       # binary.prior = 10 stored in scale
  valBinary <- val0
  vBinary <- list(name='v_binary',type='variable',
                  val=valBinary,uels=uels,domains='i',
                  typeCode=GMS_VARTYPE$BINARY,ts='text for v_binary')
  wgdx (fnOut, vBinary)
  if (file_test ('-f', fnOut) == TRUE) {
    print (paste("File", fnOut, "was created"))
  } else {
    stop (paste("FAIL: File", fnOut, "is not readable"))
  }

  vWant <- rgdx(fnWant,list(name='v_binary',form='sparse',field='all',ts=TRUE))
  vWrote <- rgdx(fnOut,list(name='v_binary',form='sparse',field='all',ts=TRUE))
  if (identical(vWrote$domInfo,"relaxed"))
    vWrote$domInfo <- "full"
  if (identical(vWant,vWrote)) {
  }
  else {
    print(all.equal(vWant,vWrote))
    stop ("FAIL: for v_binary, vWant and vWrote do not agree")
  }

  ## write integer variable to GDX, compare with fnWant version
  val0 <- matrix(0,nrow=5,ncol=3)
  for (i in 1:5) {
    val0[i,1] <- i
    val0[i,2] <- i
  }
  val0[1,3] <- 1.5                      # integer.L = 1.5
  val0[2,3] <- 0.5                      # integer.m = 0.5
  val0[3,3] <- 3                        # integer.lo = 1
  val0[4,3] <- 16                       # integer.up = 0
  val0[5,3] <- 1000                     # integer.prior = 1000 stored in scale
  valInteger <- val0
  vInteger <- list(name='v_integer',type='variable',
                   val=valInteger,uels=uels,domains='i',
                   typeCode=GMS_VARTYPE$INTEGER,ts='CHECK CASING')
  wgdx (fnOut, vInteger)
  if (file_test ('-f', fnOut) == TRUE) {
    print (paste("File", fnOut, "was created"))
  } else {
    stop (paste("FAIL: File", fnOut, "is not readable"))
  }

  vWant <- rgdx(fnWant,list(name='v_integer',form='sparse',field='all',ts=TRUE))
  vWrote <- rgdx(fnOut,list(name='v_integer',form='sparse',field='all',ts=TRUE))
  if (identical(vWrote$domInfo,"relaxed"))
    vWrote$domInfo <- "full"
  if (identical(vWant,vWrote)) {
  }
  else {
    print(all.equal(vWant,vWrote))
    stop ("FAIL: for v_integer, vWant and vWrote do not agree")
  }

  ## write positive variable to GDX, compare with fnWant version
  val0 <- matrix(0,nrow=5,ncol=3)
  for (i in 1:5) {
    val0[i,1] <- i
    val0[i,2] <- 6-i
  }
  val0[5,3] <- 322                      # positive.L
  val0[4,3] <- -1024                    # positive.m
  val0[3,3] <- -Inf                     # positive.lo
  val0[2,3] <- 0                        # positive.up
  val0[1,3] <- 10                       # positive.scale
  valPositive <- val0
  vPositive <- list(name='v_positive',type='variable',
                    val=valPositive,uels=uels,domains='i',
                    typeCode=GMS_VARTYPE$POSITIVE,ts='try some special values')
  wgdx (fnOut, vPositive)
  if (file_test ('-f', fnOut) == TRUE) {
    print (paste("File", fnOut, "was created"))
  } else {
    stop (paste("FAIL: File", fnOut, "is not readable"))
  }

  vWant <- rgdx(fnWant,list(name='v_positive',form='sparse',field='all',ts=TRUE))
  vWrote <- rgdx(fnOut,list(name='v_positive',form='sparse',field='all',ts=TRUE))
  if (identical(vWrote$domInfo,"relaxed"))
    vWrote$domInfo <- "full"
  if (identical(vWant,vWrote)) {
  }
  else {
    print(all.equal(vWant,vWrote))
    stop ("FAIL: for v_positive, vWant and vWrote do not agree")
  }

  ## write negative variable to GDX, compare with fnWant version
  val0 <- matrix(0,nrow=5,ncol=3)
  ## this is a confusing order, tested so intentionally
  for (i in 1:5) {
    val0[i,1] <- 6-i
    val0[i,2] <- i
  }
  val0[1,3] <- 525                      # negative('i5').L
  val0[2,3] <- -4                       # negative('i4').m
  val0[3,3] <- 1                        # negative('i3').lo
  val0[4,3] <- -1                       # negative('i2').up
  val0[5,3] <- 0.5                      # negative('i1').scale
  valNegative <- val0
  vNegative <- list(name='v_negative',type='variable',
                    val=valNegative,uels=uels,domains='i',
                    typeCode=GMS_VARTYPE$NEGATIVE,ts='')
  wgdx (fnOut, vNegative)
  if (file_test ('-f', fnOut) == TRUE) {
    print (paste("File", fnOut, "was created"))
  } else {
    stop (paste("FAIL: File", fnOut, "is not readable"))
  }

  vWant <- rgdx(fnWant,list(name='v_negative',form='sparse',field='all',ts=TRUE))
  vWrote <- rgdx(fnOut,list(name='v_negative',form='sparse',field='all',ts=TRUE))
  if (identical(vWrote$domInfo,"relaxed"))
    vWrote$domInfo <- "full"
  if (identical(vWant,vWrote)) {
  }
  else {
    print(all.equal(vWant,vWrote))
    stop ("FAIL: for v_negative, vWant and vWrote do not agree")
  }

  ## write free variable to GDX, compare with fnWant version
  val0 <- matrix(0,nrow=5,ncol=3)
  for (i in 1:5) {
    val0[i,1] <- i
    val0[i,2] <- i
  }
  val0[1,3] <- -12.5                    # free.L
  val0[2,3] <- 0.5                      # free.m
  val0[3,3] <- 3                        # free.lo
  val0[4,3] <- -8                       # free.up
  val0[5,3] <- 512                      # free.scale
  valFree <- val0
  vFree <- list(name='v_free',type='variable',
                val=valFree,uels=uels,domains='i',
                typeCode=GMS_VARTYPE$FREE,
                ts='WHAT if we use a long text with special chars __ %% -- @@  ?? !! jj')
  wgdx (fnOut, vFree)
  if (file_test ('-f', fnOut) == TRUE) {
    print (paste("File", fnOut, "was created"))
  } else {
    stop (paste("FAIL: File", fnOut, "is not readable"))
  }

  vWant <- rgdx(fnWant,list(name='v_free',form='sparse',field='all',ts=TRUE))
  vWrote <- rgdx(fnOut,list(name='v_free',form='sparse',field='all',ts=TRUE))
  if (identical(vWrote$domInfo,"relaxed"))
    vWrote$domInfo <- "full"
  if (identical(vWant,vWrote)) {
  }
  else {
    print(all.equal(vWant,vWrote))
    stop ("FAIL: for v_free, vWant and vWrote do not agree")
  }

  ## write sos1 variable to GDX, compare with fnWant version
  val0 <- matrix(0,nrow=5,ncol=3)
  for (i in 1:5) {
    val0[i,1] <- i
    val0[i,2] <- i
  }
  val0[1,3] <- 123                      # sos1.L
  val0[2,3] <- -10.5                    # sos1.m
  val0[3,3] <- 2                        # sos1.lo
  val0[4,3] <- 10                       # sos1.up
  val0[5,3] <- 100                      # sos1.prior
  valSos1 <- val0
  vSos1 <- list(name='v_sos1',type='variable',
                val=valSos1,uels=uels,domains='i',
                typeCode=GMS_VARTYPE$SOS1,ts='v_sos1')
  wgdx (fnOut, vSos1)
  if (file_test ('-f', fnOut) == TRUE) {
    print (paste("File", fnOut, "was created"))
  } else {
    stop (paste("FAIL: File", fnOut, "is not readable"))
  }

  vWant <- rgdx(fnWant,list(name='v_sos1',form='sparse',field='all',ts=TRUE))
  vWrote <- rgdx(fnOut,list(name='v_sos1',form='sparse',field='all',ts=TRUE))
  if (identical(vWrote$domInfo,"relaxed"))
    vWrote$domInfo <- "full"
  if (identical(vWant,vWrote)) {
  }
  else {
    print(all.equal(vWant,vWrote))
    stop ("FAIL: for v_sos1, vWant and vWrote do not agree")
  }

  ## write sos2 variable to GDX, compare with fnWant version
  val0 <- matrix(0,nrow=5,ncol=3)
  for (i in 1:5) {
    val0[i,1] <- i
    val0[i,2] <- i
  }
  val0[1,3] <- 123                      # sos2.L
  val0[2,3] <- -10.5                    # sos2.m
  val0[3,3] <- 2                        # sos2.lo
  val0[4,3] <- 10                       # sos2.up
  val0[5,3] <- 100                      # sos2.prior
  valSos2 <- val0
  vSos2 <- list(name='v_sos2',type='variable',
                val=valSos2,uels=uels,domains='i',
                typeCode=GMS_VARTYPE$SOS2,ts='v_sos2')
  wgdx (fnOut, vSos2)
  if (file_test ('-f', fnOut) == TRUE) {
    print (paste("File", fnOut, "was created"))
  } else {
    stop (paste("FAIL: File", fnOut, "is not readable"))
  }

  vWant <- rgdx(fnWant,list(name='v_sos2',form='sparse',field='all',ts=TRUE))
  vWrote <- rgdx(fnOut,list(name='v_sos2',form='sparse',field='all',ts=TRUE))
  if (identical(vWrote$domInfo,"relaxed"))
    vWrote$domInfo <- "full"
  if (identical(vWant,vWrote)) {
  }
  else {
    print(all.equal(vWant,vWrote))
    stop ("FAIL: for v_sos2, vWant and vWrote do not agree")
  }

  ## write semicont variable to GDX, compare with fnWant version
  val0 <- matrix(0,nrow=5,ncol=3)
  for (i in 1:5) {
    val0[i,1] <- i
    val0[i,2] <- i
  }
  val0[1,3] <- 10.5                     # semicont.L
  val0[2,3] <- .875                     # semicont.m
  val0[3,3] <- 13                       # semicont.lo
  val0[4,3] <- 1000                     # semicont.up
  val0[5,3] <- 999                      # semicont.prior
  valSemicont <- val0
  vSemicont <- list(name='v_semicont',type='variable',
                    val=valSemicont,uels=uels,domains='i',
                    typeCode=GMS_VARTYPE$SEMICONT,ts='v_semicont')
  wgdx (fnOut, vSemicont)
  if (file_test ('-f', fnOut) == TRUE) {
    print (paste("File", fnOut, "was created"))
  } else {
    stop (paste("FAIL: File", fnOut, "is not readable"))
  }

  vWant <- rgdx(fnWant,list(name='v_semicont',form='sparse',field='all',ts=TRUE))
  vWrote <- rgdx(fnOut,list(name='v_semicont',form='sparse',field='all',ts=TRUE))
  if (identical(vWrote$domInfo,"relaxed"))
    vWrote$domInfo <- "full"
  if (identical(vWant,vWrote)) {
  }
  else {
    print(all.equal(vWant,vWrote))
    stop ("FAIL: for v_semicont, vWant and vWrote do not agree")
  }

  ## write semiint variable to GDX, compare with fnWant version
  val0 <- matrix(0,nrow=5,ncol=3)
  for (i in 1:5) {
    val0[i,1] <- i
    val0[i,2] <- i
  }
  val0[1,3] <- 10.5                     # semiint.L
  val0[2,3] <- .875                     # semiint.m
  val0[3,3] <- 13                       # semiint.lo
  val0[4,3] <- 1000                     # semiint.up
  val0[5,3] <- 100000                   # semiint.prior
  valSemiint <- val0
  vSemiint <- list(name='v_semiint',type='variable',
                   val=valSemiint,uels=uels,domains='i',
                   typeCode=GMS_VARTYPE$SEMIINT,ts='v_semiint text')
  wgdx (fnOut, vSemiint)
  if (file_test ('-f', fnOut) == TRUE) {
    print (paste("File", fnOut, "was created"))
  } else {
    stop (paste("FAIL: File", fnOut, "is not readable"))
  }

  vWant <- rgdx(fnWant,list(name='v_semiint',form='sparse',field='all',ts=TRUE))
  vWrote <- rgdx(fnOut,list(name='v_semiint',form='sparse',field='all',ts=TRUE))
  if (identical(vWrote$domInfo,"relaxed"))
    vWrote$domInfo <- "full"
  if (identical(vWant,vWrote)) {
  }
  else {
    print(all.equal(vWant,vWrote))
    stop ("FAIL: for v_semiint, vWant and vWrote do not agree")
  }


  print (paste0("test of wgdx on ", testName, ": PASSED"))
  invisible(TRUE)   ## all tests passed: return TRUE
},

error = errFunc
)

## test wgdx on writing a NaN to GDX: should show up as Undf in GDX
## with gdxrrw 0.4.0, this was working with R 3.0.2, failing with R 3.1.2

if (! require(gdxrrw))      stop ("gdxrrw package is not available")
if (0 == igdx(silent=TRUE)) stop ("the gdx shared library has not been loaded")

testName <- 'writing R-NaN to GDX'
logFile <- 'diffLog.txt'
redirect <- paste(' >', logFile)

errFunc <- function(ex) {
  print (paste0("test of wgdx on ",testName,": FAILED"))
  print (paste("Check file", logFile, "for possible gdxdiff output"))
  print(ex)
  FALSE
} # errFunc

tryCatch({
  print (paste("testing wgdx on", testName))
  wgdx('?')
  fnOut <- "tmp.gdx"
  fnWant <- "tWriteNan.gdx"
  if (! file_test ('-f', fnWant)) {
    stop (paste("FAIL: File-to-duplicate", fnWant, "does not exist"))
  }
  v <- list(name='w',type='parameter',form='full', val=NaN,
            dim=0,ts='R-NaN sent to GDX')
  wgdx.lst(fnOut, v)
  if (file_test ('-f', fnOut) == TRUE) {
    # print (paste("File", fnOut, "was created"))
  } else {
    stop (paste("FAIL: File", fnOut, "is not readable"))
  }
  rc <- system2 ("gdxdiff",args=c(fnWant, fnOut), stdout=logFile)
  if (0 != rc) {
    stop(paste("With val=NaN, bad return from gdxdiff: wanted 0, got",rc))
  } else {
#    print ("gdxdiff call succeeded")
  }

  print (paste0("test of wgdx on ", testName, ": PASSED"))
  suppressWarnings(file.remove(logFile))
  invisible(TRUE)   ## all tests passed: return TRUE
},

error = errFunc
)

### Test rgdx
# We read the transport data using defaults: form=sparse and a full universe
# This test does near-exhaustive checks on the returned structure

if (! require(gdxrrw))      stop ("gdxrrw package is not available")
if (0 == igdx(silent=TRUE)) stop ("the gdx shared library has not been loaded")

source ("chkSame.R")
reqIdent <- TRUE

iUels <- c("seattle", "san-diego")
iCard <- length(iUels)
jUels <- c("new-york", "chicago", "topeka")
jCard <- length(jUels)
uUels <- c(iUels, jUels)
uCard <- length(uUels)

iVals <- matrix(c(1,2), nrow=iCard, ncol=1)
jVals <- matrix(iCard+c(1,2,3), nrow=jCard, ncol=1)
aVals <- matrix(c(1:iCard,350,600), nrow=iCard, ncol=2)
bVals <- matrix(c(1:jCard,325,300,275), nrow=jCard, ncol=2)
dVals <- matrix(c(1,1, 2.5,
                  1,2, 1.7,
                  1,3, 1.8,
                  2,1, 2.5,
                  2,2, 1.8,
                  2,3, 1.4) , c(6,3), byrow=TRUE)
cVals <- dVals
cVals[,3] <- dVals[,3] * 90 / 1000
xVals <- matrix(c(1,1, 50,
                  1,2, 300,
                  2,1, 275,
                  2,3, 275) , c(4,3), byrow=TRUE)

fields <- c('l','m','lo','up','s')
nFields <- length(fields)
lev <- 1
mar <- 2
low <- 3
upp <- 4
sca <- 5

tryCatch({
  print ("Test rgdx with defaults (form='sparse' and no filter)")
  print ("using the transport data as input")
  rgdx('?')

  u <- rgdx('trnsport')
  uwant <- list(name="*", type="set", dim=1L,
                val=NULL,
                form=NULL,
                uels=uUels)
  chk <- chkRgdxRes (u, uwant, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx('gdxname') to read universe failed:",chk$msg))
  }
  print ("Done reading universe")

  i <- rgdx('trnsport',list(name='i'))
  iwant <- list(name="i", type="set", dim=1L,
                val=iVals,
                form="sparse",
                uels=list(uUels),
                domains=c("*"),
                domInfo="none")
  chk <- chkRgdxRes (i, iwant, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(i,form=sparse) failed:",chk$msg))
  }
  print ("Done reading set i")

  j <- rgdx('trnsport',list(name='j'))
  jwant <- list(name="j", type="set", dim=1L,
                val=jVals,
                form="sparse",
                uels=list(uUels),
                domains=c("*"),
                domInfo="none")
  chk <- chkRgdxRes (j, jwant, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(j,form=sparse) failed:",chk$msg))
  }
  print ("Done reading set j")

  f <- rgdx('trnsport',list(name='f'))
  fwant <- list(name="f", type="parameter", dim=0L,
                val=matrix(90,c(1,1)),
                form="sparse",
                uels=list(),
                domains=character(0),
                domInfo="NA")
  chk <- chkRgdxRes (f, fwant, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(f,form=sparse) failed",chk$msg))
  }
  print ("Done reading scalar f")

  a <- rgdx('trnsport',list(name='a'))
  awant <- list(name="a", type="parameter", dim=1L,
                val=aVals,
                form="sparse",
                uels=list(iUels),
                domains=c("i"),
                domInfo="full")
  chk <- chkRgdxRes (a, awant, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(a,form='sparse') failed:",chk$msg))
  }
  print ("Done reading parameter a")

  b <- rgdx('trnsport',list(name='b'))
  bwant <- list(name="b", type="parameter", dim=1L,
                val=bVals,
                form="sparse",
                uels=list(jUels),
                domains=c('j'),
                domInfo='full')
  chk <- chkRgdxRes (b, bwant, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(b,form='sparse') failed:",chk$msg))
  }
  print ("Done reading parameter b")

  c <- rgdx('trnsport',list(name='c'))
  cwant <- list(name="c", type="parameter", dim=2L,
                val=cVals,
                form="sparse",
                uels=list(iUels,jUels),
                domains=c("i","j"),
                domInfo="full")
  # cVals is not bitwise correct
  chk <- chkRgdxRes (c, cwant, reqIdent=F)
  if (!chk$same) {
    stop (paste("test rgdx(c,form='sparse') failed:",chk$msg))
  }
  print ("Done reading parameter c")

  d <- rgdx('trnsport',list(name='d'))
  dwant <- list(name="d", type="parameter", dim=2L,
                val=dVals,
                form="sparse",
                uels=list(iUels,jUels),
                domains=c("i","j"),
                domInfo="full")
  chk <- chkRgdxRes (d, dwant, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(d,form='sparse') failed:",chk$msg))
  }
  print ("Done reading parameter d")

  xwant <- list(name="x", type="variable", dim=2L,
                val=xVals,
                form="sparse",
                uels=list(iUels,jUels),
                domains=c("i","j"),
                domInfo="full",
                field="l",
                varTypeText='positive', typeCode=GMS_VARTYPE$POSITIVE)
  x <- rgdx('trnsport',list(name='x'))
  chk <- chkRgdxRes (x, xwant, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(x,form='sparse') failed:",chk$msg))
  }
  t <- matrix(c( 1, 1, lev,   50
                ,1, 1, mar,    0
                ,1, 1, low,    0
                ,1, 1, upp,  Inf
                ,1, 1, sca,    1
                ,1, 2, lev,  300
                ,1, 2, mar,    0
                ,1, 2, low,    0
                ,1, 2, upp,  Inf
                ,1, 2, sca,    1
                ,1, 3, lev,    0
                ,1, 3, mar,    0.036
                ,1, 3, low,    0
                ,1, 3, upp,  Inf
                ,1, 3, sca,    1
                ,2, 1, lev,  275
                ,2, 1, mar,    0
                ,2, 1, low,    0
                ,2, 1, upp,  Inf
                ,2, 1, sca,    1
                ,2, 2, lev,    0
                ,2, 2, mar,    0.00900000000000001
                ,2, 2, low,    0
                ,2, 2, upp,  Inf
                ,2, 2, sca,    1
                ,2, 3, lev,  275
                ,2, 3, mar,    0
                ,2, 3, low,    0
                ,2, 3, upp,  Inf
                ,2, 3, sca,    1
               ), c(30,4), byrow=TRUE)
  xwantA <- list(name="x", type="variable", dim=2L,
                 val=t,
                 form="sparse",
                 uels=list(iUels,jUels,fields),
                 domains=c("i","j","_field"),
                 domInfo="full",
                 field="all",
                 varTypeText='positive', typeCode=GMS_VARTYPE$POSITIVE)
  x <- rgdx('trnsport',list(name='x',field='all'))
  # the marginals are not bit-exact, so not identical
  chk <- chkRgdxRes (x, xwantA, reqIdent=F)
  if (!chk$same) {
    stop (paste("test rgdx(x,'all',form='sparse') failed:",chk$msg))
  }
  print ("Done reading variable x")

  zwant <- list(name="z", type="variable", dim=0L,
                val=matrix(153.675,c(1,1)),
                form="sparse",
                uels=list(),
                domains=character(0),
                domInfo='NA',
                field="l",
                varTypeText='free', typeCode=GMS_VARTYPE$FREE)
  z <- rgdx('trnsport',list(name='z'))
  chk <- chkRgdxRes (z, zwant, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(z,form='sparse') failed:",chk$msg))
  }
  t <- matrix(c( lev,  153.675
                ,mar,  0
                ,low,  -Inf
                ,upp,  +Inf
                ,sca,  1
               ), nrow=nFields, ncol=2, byrow=T)
  zwantA <- list(name="z", type="variable", dim=0L,
                 val=t,
                 form="sparse",
                 uels=list(fields),
                 domains=c('_field'),
                 domInfo="NA",
                 field="all",
                 varTypeText='free', typeCode=GMS_VARTYPE$FREE)
  z <- rgdx('trnsport',list(name='z',field='all'))
  chk <- chkRgdxRes (z, zwantA, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(z,'all',form='sparse') failed:",chk$msg))
  }
  print ("Done reading variable z")

  print ("tReadSparse1 successfully completed")
  TRUE
}

, error = function(ex) { print(ex) ; FALSE }
)

## test wgdx on writing set text
## gdxdump or gdxdiff do not really do what we want here, so just have
## to read from the generated GDX and the target GDX and compare the results
## for I and IJ

if (! require(gdxrrw))      stop ("gdxrrw package is not available")
if (0 == igdx(silent=TRUE)) stop ("the gdx shared library has not been loaded")

testName <- 'writing set text from a dataframe'
logFile <- 'diffLog.txt'

errFunc <- function(ex) {
  print (paste0("test of wgdx.lst on ",testName,": FAILED"))
  print (paste("Check file", logFile, "for possible gdxdiff output"))
  print (ex)
  FALSE
} # errFunc

tryCatch({
  print (paste("testing wgdx on", testName))
  wgdx('?')
  fnOut <- "tmp.gdx"
  fnWant <- "teWriteSetText.gdx"
  fnWant2 <- "teWriteSetTextAlt.gdx"
  if (! file_test ('-f', fnWant)) {
    stop (paste("FAIL: File-to-duplicate", fnWant, "does not exist"))
  }

  iUels <- paste0("i","1":"4")
  iN <- length(iUels)
  jUels <- paste0("j","1":"3")
  jN <- length(jUels)
  ijN <- 5
  uels <- list(c(iUels,jUels))
  valI <- matrix(0,nrow=iN,ncol=1)
  for (k in 1:iN) {
    valI[k,1] <- k
  }
  teI <- matrix(NA_character_,nrow=iN,ncol=1)
  teI[1,1] <- "i1 associated text"
  teI[2,1] <- "i2's text here"
  teI[3,1] <- "  "
  teI0 <- c("i1 associated text", "i2's text here", "  ", NA_character_)

  valJ <- matrix(0,nrow=jN,ncol=1)
  for (k in 1:jN) {
    valJ[k,1] <- iN + k
  }
  teJ <- matrix(NA_character_,nrow=jN,ncol=1)
  teJ[1,1] <- "j1 text"
  teJ[2,1] <- "j2 text"
  teJ[3,1] <- "j3 text"

  valIJ <- matrix(c(1,1,
                    2,1,
                    2,2,
                    3,3,
                    4,3),
                  nrow=ijN,ncol=2,byrow=TRUE)
  teIJ <- matrix(NA_character_,nrow=ijN,ncol=1)
  teIJ[1,1] <- "one.one"
  teIJ[3,1] <- "trailing blank "
  teIJ[4,1] <- ""
  teIJ[5,1] <- " "
  teIJ0 <- c('one.one', NA_character_, 'trailing blank ', '', ' ')

  dfI <- data.frame(list("i"=factor(iUels),".te"=teI),stringsAsFactors=F)
  attr(dfI,"symName") <- "I"
  attr(dfI,"domains") <- c("*")
  attr(dfI,"ts") <- ""
  
  dfJ <- data.frame(list("j"=factor(jUels),".te"=teJ),stringsAsFactors=F)
  attr(dfJ,"symName") <- "J"
  attr(dfJ,"domains") <- c("*")
  attr(dfJ,"ts") <- ""
  
  f1 <- factor(as.integer(valIJ[,1]),labels=iUels)
  f2 <- factor(as.integer(valIJ[,2]),labels=jUels)
  dfIJ <- data.frame(list("i"=f1,"j"=f2,".te"=teIJ),stringsAsFactors=F)
  attr(dfIJ,"symName") <- "IJ"
  attr(dfIJ,"domains") <- c("*","*")
  attr(dfIJ,"ts") <- ""

  ## test with inventSetText at default
  options(gdx.inventSetText=NULL)
  wgdx.lst(fnOut, dfI, dfJ, dfIJ)
  if (file_test ('-f', fnOut) == TRUE) {
    # print (paste("File", fnOut, "was created"))
  } else {
    stop (paste("FAIL: File", fnOut, "is not readable"))
  }
  rc <- system2 ("gdxdiff",args=c(fnWant, fnOut), stdout=logFile)
  if (0 != rc) {
    stop(paste("With gdx.inventSetText=NULL, bad return from gdxdiff: wanted 0, got",rc))
  } else {
#    print ("gdxdiff call succeeded")
  }
  ## no need to test via wgdx: will get done below

  ## test with inventSetText=NA
  options(gdx.inventSetText=NA)
  wgdx.lst(fnOut, dfI, dfJ, dfIJ)
  if (file_test ('-f', fnOut) == TRUE) {
    # print (paste("File", fnOut, "was created"))
  } else {
    stop (paste("FAIL: File", fnOut, "is not readable"))
  }
  rc <- system2 ("gdxdiff",args=c(fnWant, fnOut), stdout=logFile)
  if (0 != rc) {
    stop(paste("With gdx.inventSetText=NA, Bad return from gdxdiff: wanted 0, got",rc))
  } else {
#    print ("gdxdiff call succeeded")
  }
  ## gdxdiff does not differentiate between no set text and
  ## empty set text, so we test that explicitly here
  I1 <- rgdx(fnOut,   list(name='I',form='sparse',te=TRUE))
  teI1 <- teI0
  if (! identical(teI1,I1$te)) {
    stop (paste('With gdx.inventSetText=NA, inconsistent set text for I in file',fnOut))
  }
  IJ1 <- rgdx(fnOut,   list(name='IJ',form='sparse',te=TRUE))
  teIJ1 <- teIJ0
  if (is.na(IJ1$te[[4]])) {
    teIJ1[[4]] <- NA_character_
  }
  if (! identical(teIJ1,IJ1$te)) {
    stop (paste('With gdx.inventSetText=NA, inconsistent set text for IJ in file',fnOut))
  }

  ## test with inventSetText=FALSE
  options(gdx.inventSetText=F)
  wgdx.lst(fnOut, dfI, dfJ, dfIJ)
  if (file_test ('-f', fnOut) == TRUE) {
    # print (paste("File", fnOut, "was created"))
  } else {
    stop (paste("FAIL: File", fnOut, "is not readable"))
  }
  rc <- system2 ("gdxdiff",args=c(fnWant2, fnOut), stdout=logFile)
  if (0 != rc) {
    stop(paste("With gdx.inventSetText=F, Bad return from gdxdiff: wanted 0, got",rc))
  } else {
    # print ("gdxdiff call succeeded")
  }
  ## gdxdiff does not differentiate between no set text and
  ## empty set text, so we test that explicitly here
  options(gdx.inventSetText=NA)
  I1 <- rgdx(fnOut,   list(name='I',form='sparse',te=TRUE))
  teI1 <- teI0
  if (! identical(teI1,I1$te)) {
    stop (paste('With gdx.inventSetText=F, inconsistent set text for I in file',fnOut))
  }
  ## with inventSetText=F, fnOut should store empty text strings like no string
  ## and this should come back as NA when we read
  IJ1 <- rgdx(fnOut,   list(name='IJ',form='sparse',te=TRUE))
  teIJ1 <- teIJ0
  teIJ1[4] <- NA_character_
  if (! identical(teIJ1,IJ1$te)) {
    stop (paste('JJJ With gdx.inventSetText=F, inconsistent set text for IJ in file',fnOut))
  }

  ## test with inventSetText=TRUE
  options(gdx.inventSetText=T)
  wgdx.lst(fnOut, dfI, dfJ, dfIJ)
  if (file_test ('-f', fnOut) == TRUE) {
    # print (paste("File", fnOut, "was created"))
  } else {
    stop (paste("FAIL: File", fnOut, "is not readable"))
  }
  rc <- system2 ("gdxdiff",args=c(fnWant, fnOut), stdout=logFile)
  if (0 != rc) {
    stop(paste("With gdx.inventSetText=T, Bad return from gdxdiff: wanted 0, got",rc))
  } else {
    # print ("gdxdiff call succeeded")
  }
  ## gdxdiff does not differentiate between no set text and
  ## empty set text, so we test that explicitly here
  options(gdx.inventSetText=NA)
  I1 <- rgdx(fnOut,   list(name='I',form='sparse',te=TRUE))
  teI1 <- teI0
  if (! identical(teI1,I1$te)) {
    stop (paste('With gdx.inventSetText=NA, inconsistent set text for I in file',fnOut))
  }
  IJ1 <- rgdx(fnOut,   list(name='IJ',form='sparse',te=TRUE))
  teIJ1 <- teIJ0
  if (is.na(IJ1$te[[4]])) {
    teIJ1[[4]] <- NA_character_
  }
  if (! identical(teIJ1,IJ1$te)) {
    stop (paste('With gdx.inventSetText=NA, inconsistent set text for IJ in file',fnOut))
  }

  print (paste0("test of wgdx.lst on ", testName, ": PASSED"))
  suppressWarnings(file.remove(logFile))
  invisible(TRUE)   ## all tests passed: return TRUE
},

error = errFunc
)

#### test basic functionality of gams() function

tryCatch({
  print ("basic testing of gams() function")
  gams('?')

  msg <- "gams test with nonexistent file"
  tcr <- tryCatch({
    rc <- gams("notThere.gms") ; FALSE
    },
    error = function(e) { print(paste(' Caught error: msg =',e)) ; TRUE }
  )
  if (tcr) {
    print(paste(msg,": passed",sep=""))
  }
  else {
    stop (paste(msg, ": failed",sep=""))
  }

  ## rc <- gams("notThere.gms")
  ## if (2 != rc) {
  ##  stop (paste("gams('notThere.gms') returned",rc,"expected 2"))
  ## }

  cat ("scalar a / 1 /\n", file="tmp.gms");
  rc <- gams("tmp.gms")
  if (0 != rc) {
    stop (paste("valid gams source: gams('tmp.gms') returned",rc,"expected 0"))
  }

  cat ("skalar a / 1 /\n", file="tmp.gms");
  rc <- gams("tmp.gms")
  if (2 != rc) {
    stop (paste("invalid gams source: gams('tmp.gms') returned",rc,"expected 2"))
  }

  print ("basic gams() tests passed")
  TRUE   ## all tests passed: return TRUE
},

error = function(ex) { print ("basic gams() tests failed"); print(ex) ; FALSE }
)

## illustrate subtle points about empty text when writing set text

if (! require(gdxrrw))      stop ("gdxrrw package is not available")
if (0 == igdx(silent=TRUE)) stop ("the GDX shared library has not been loaded")

## test with inventSetText at default
options(gdx.inventSetText=NULL)

uels <- c("noSetText", "emptySetText", "blankSetText",  "someSetText")
N <- length(uels)
te <- matrix(NA_character_,nrow=N,ncol=1)
te[2,1] <- ""
te[3,1] <- "   "
te[4,1] <- "hello hello"

df <- data.frame(list("s"=factor(1:N,labels=uels),".te"=te),stringsAsFactors=F)
attr(df,"symName") <- "s"
attr(df,"domains") <- c("*")
attr(df,"ts") <- "set with  of set text"

fn <- "tmpset.gdx"
wgdx.lst(fn, df)

s <- rgdx.set(fn,'s',te=T)

options(gdx.inventSetText=NA)
sNA <- rgdx.set(fn,'s',te=T)

options(gdx.inventSetText=T)
sT <- rgdx.set(fn,'s',te=T)

options(gdx.inventSetText=F)
sF <- rgdx.set(fn,'s',te=T)

s

print ("If gdx.inventSetText is not set, it behaves like gdx.inventSetText=NA")
if (! identical(s,sNA)) {
  stop (paste('gdx.inventSetText=NA not identical to gdx.inventSetText=NULL'))
}

print ("With gdx.inventSetText=NA, we get NA_character_ back when no set text exists:")
print(paste(sNA[,2]))

print ("With gdx.inventSetText=T, we get the UEL(s) back when no set text exists:")
print(paste(sT[,2]))

print ("With gdx.inventSetText=F, we get the empty string back when no set text exists:")
print(paste(sF[,2]))

#### test rgdx reading the universe from a compressed GDX file

#### wanted lists can be produced with    dump("listName",file="")

if (! require(gdxrrw))      stop ("gdxrrw package is not available")

# this test is good to run prior to any GDX library being loaded,
# since it tests a bug that is turfed up in that case
# if (0 == igdx(silent=TRUE)) stop ("the gdx shared library has not been loaded")

source ("chkSame.R")
reqIdent <- TRUE

kUels <- c('k1', 'k2', 'k3', 'k4')
jUels <- c('jA', 'jB', 'jC', 'jD', 'jE', 'jF')

tryCatch({
  print ("testing rgdx on read of compressed GDX file")
  rgdx('?')
  fnIn <- "tReadCompr.gdx"
  if (! file_test ('-f', fnIn)) {
    stop (paste("FAIL: File", fnIn, "does not exist"))
  }

  ### ---------- reading universe
  uwantA <- list(name='*', type='set', dim=1L,
                 val=NULL, form=NULL, uels=c(kUels,jUels))
  u <- rgdx(fnIn)
  chk <- chkRgdxRes (u, uwantA, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx() on universe failed",chk$msg))
  }


  print ("test of rgdx on variable reads passed")
  TRUE   ## all tests passed: return TRUE
},

error = function(ex) { print ("test of rgdx on variable reads failed"); print(ex) ; FALSE }
)

### Test that the gdxdiff utility can be run successfully via system()

if (! require(gdxrrw))      stop ("gdxrrw package is not available")
if (0 == igdx(silent=TRUE)) stop ("the gdx shared library has not been loaded")

fnData <- "trnsport.gdx"

tryCatch({
  if (! file_test ('-f', fnData)) {
    stop (paste("FAIL: File", fnData, "does not exist"))
  }
  rc <- system (paste("gdxdiff",fnData,fnData))
  if (0 != rc) {
    stop(paste("Bad return from trivial gdxdiff: wanted 0, got",rc))
  } else {
    print ("gdxdiff call succeeded: it must be available and functional")
  }

  TRUE
}

, error = function(ex) { print(ex) ; FALSE }
)

### Test that the wrappers treat options(gdx.domainNames) properly

if (! require(gdxrrw))      stop ("gdxrrw package is not available")
if (0 == igdx(silent=TRUE)) stop ("the gdx shared library has not been loaded")

source ("chkSame.R")
reqIdent <- TRUE
testName <- 'wrapper treatment of options(gdx.domainNames)'
logFile <- 'diffLog.txt'

errFunc <- function(ex) {
  print (paste0("test of gdxrrw on ",testName,": FAILED"))
  print (paste("Check file", logFile, "for possible gdxdiff output"))
  print (ex)
  FALSE
} # errFunc

tryCatch({
  print (paste("testing gdxrrw on", testName))
  fnIn <- "tDomainNames.gdx"

  print ("")
  print ("testing options(gdx.domainNames=F)")
  options(gdx.domainNames=F)

  # read all the data, using various combination of options
  sdfwant <- structure(
      list(
          i = structure(1:4, .Label = c("s1", "s2", "s3", "s4", "t1", "t2", "t3"), class = "factor")
      ),
      .Names = "i",
      row.names = c(NA, -4L),
      class = "data.frame",
      symName = "s",
      domains = "*",
      domInfo = "none",
      ts = ""
  )                                     # end structure
  sdf <- rgdx.set(fnIn,'s',ts=TRUE)
  chk <- chkRgdxDF (sdf, sdfwant, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("gdx.domainNames=F test rgdx.set(s,ts=TRUE) failed:",chk$msg))
  }
  tdfwant <- structure(
      list(
          i = structure(1:3, .Label = c("t1", "t2", "t3"), class = "factor")
      ),
      .Names = "i",
      row.names = c(NA, -3L),
      class = "data.frame",
      symName = "t",
      domains = "*",
      domInfo = "compressed"
  )                                     # end structure
  tdf <- rgdx.set(fnIn,'t',compress=TRUE)
  chk <- chkRgdxDF (tdf, tdfwant, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("gdx.domainNames=F test rgdx.set(t,compress=TRUE) failed:",chk$msg))
  }
  pdfwant <- structure(
      list(
          i = structure(1:4, .Label = c("s1", "s2", "s3", "s4"), class = "factor"),
          j = structure(1:4, .Label = c("s1", "s2", "s3", "s4"), class = "factor")
      ),
      .Names = c("i","j"),
      row.names = c(NA, -4L),
      class = "data.frame",
      symName = "p",
      domains = c("s","ss"),
      domInfo = "full"
  )                                     # end structure
  pdf <- rgdx.set(fnIn,'p')
  chk <- chkRgdxDF (pdf, pdfwant, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("gdx.domainNames=F test rgdx.set(p) failed:",chk$msg))
  }
  adfwant <- structure(
      list(
          i = structure(1L, .Label = c("t1", "t2", "t3"), class = "factor"),
          j = structure(4L, .Label = c("s1", "s2", "s3", "s4"), class = "factor"),
          a = 3.14159
      ),
      .Names = c("i","j","value"),
      row.names = c(NA, -1L),
      class = "data.frame",
      symName = "a",
      domains = c("t","s"),
      domInfo = "full"
  )                                     # end structure
  adf <- rgdx.param(fnIn,'a')
  chk <- chkRgdxDF (adf, adfwant, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("gdx.domainNames=F test rgdx.param(a) failed:",chk$msg))
  }
  bdfwant <- structure(
      list(
          i = structure(1L, .Label = c("s2"), class = "factor"),
          j = structure(1L, .Label = c("s2"), class = "factor"),
          value = 1.5
      ),
      .Names = c("i","j","value"),
      row.names = c(NA, -1L),
      class = "data.frame",
      symName = "b",
      domains = c("ss","u"),
      domInfo = "compressed"
  )                                     # end structure
  bdf <- rgdx.param(fnIn,'b',compress=T)
  chk <- chkRgdxDF (bdf, bdfwant, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("gdx.domainNames=F test rgdx.param(b,compress=T) failed:",chk$msg))
  }


  print ("")
  print ("testing options(gdx.domainNames=T)")
  options(gdx.domainNames=T)
  sdf <- rgdx.set(fnIn,'s',ts=TRUE)
  chk <- chkRgdxDF (sdf, sdfwant, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("gdx.domainNames=T test rgdx.set(s,ts=TRUE) failed:",chk$msg))
  }
  names(tdfwant) <- ".i"
  tdf <- rgdx.set(fnIn,'t',compress=TRUE)
  chk <- chkRgdxDF (tdf, tdfwant, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("gdx.domainNames=T test rgdx.set(t,compress=TRUE) failed:",chk$msg))
  }
  names(pdfwant) <- attr(pdfwant,"domains")
  pdf <- rgdx.set(fnIn,'p')
  chk <- chkRgdxDF (pdf, pdfwant, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("gdx.domainNames=T test rgdx.set(p) failed:",chk$msg))
  }
  names(adfwant) <- c(attr(adfwant,"domains"),attr(adfwant,"symName"))
  adf <- rgdx.param(fnIn,'a')
  chk <- chkRgdxDF (adf, adfwant, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("gdx.domainNames=T test rgdx.param(a) failed:",chk$msg))
  }
  names(bdfwant) <- c(attr(bdfwant,"domains"),attr(bdfwant,"symName"))
  bdf <- rgdx.param(fnIn,'b',compress=T)
  chk <- chkRgdxDF (bdf, bdfwant, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("gdx.domainNames=T test rgdx.param(b,compress=T) failed:",chk$msg))
  }


  print ("")
  print ("testing options(gdx.domainNames=NULL)")
  options(gdx.domainNames=NULL)         # this should default to TRUE
  sdf <- rgdx.set(fnIn,'s',ts=TRUE)
  chk <- chkRgdxDF (sdf, sdfwant, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("gdx.domainNames=NULL test rgdx.set(s,ts=TRUE) failed:",chk$msg))
  }
  tdf <- rgdx.set(fnIn,'t',compress=TRUE)
  chk <- chkRgdxDF (tdf, tdfwant, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("gdx.domainNames=NULL test rgdx.set(t,compress=TRUE) failed:",chk$msg))
  }
  pdf <- rgdx.set(fnIn,'p')
  chk <- chkRgdxDF (pdf, pdfwant, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("gdx.domainNames=NULL test rgdx.set(p) failed:",chk$msg))
  }
  adf <- rgdx.param(fnIn,'a')
  chk <- chkRgdxDF (adf, adfwant, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("gdx.domainNames=NULL test rgdx.param(a) failed:",chk$msg))
  }
  bdf <- rgdx.param(fnIn,'b',compress=T)
  chk <- chkRgdxDF (bdf, bdfwant, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("gdx.domainNames=NULL test rgdx.param(b,compress=T) failed:",chk$msg))
  }


  print (paste0("test of gdxrrw on ",testName,": PASSED"))
  suppressWarnings(file.remove(logFile))
  invisible(TRUE)   ## all tests passed: return TRUE
},

error = errFunc
)

# We create a GDX file to mimic the data in the trnsport model in the GAMS model library

# sf is a structure representing a GAMS scalar, i.e. a 0-dimensional parameter
sf <- list(name='f',type='parameter',form='full',val=90,ts='freight in dollars per case per thousand miles');

# convenient to create the set of all UELs we will use in this GDX example
uels <- list(c('seattle','san-diego','new-york','chicago','topeka'));
si <- list(name='i',ts='canning plants',type='set',dim=1,
           form='full',uels=uels,val=array(c(1,1)));
sj <- list(name='j',ts='markets',type='set',dim=1,
           form='full',uels=uels,val=array(c(0,0,1,1,1)));
sa <- list(name='a',ts='capacity of plant i in cases',type='parameter',dim=1,
           form='sparse',uels=uels,val=matrix(c(1,2,350,600),nrow=2));
sb <- list(name='b',ts='demand at market j in cases',type='parameter',dim=1,
           form='sparse',uels=uels,val=matrix(c(3,4,5,325,300,275),nrow=3));
d <- matrix(c(1,3, 2.5,
              1,4, 1.7,
              1,5, 1.8,
              2,3, 2.5,
              2,4, 1.8,
              2,5, 1.4),
              nrow=6,ncol=3,byrow=TRUE);
sd <- list(name='d',ts='distance in thousands of miles',type='parameter',dim=2,
           form='sparse',uels=c(uels,uels), val=d);

### Test gdxInfo
# with returnDF=TRUE we get data frames with symbol info for the transport data

if (! require(gdxrrw))      stop ("gdxrrw package is not available")
if (0 == igdx(silent=TRUE)) stop ("the gdx shared library has not been loaded")

# compare the data frames f1 and f2, return TRUE if the same, FALSE o/w
chkFrame <- function(s, f1, f2) {
  if (identical(f1,f2))   return (TRUE)
  return(FALSE) # for now

  if (! is.data.frame(f1))   return (FALSE)
  if (! is.data.frame(f2))   return (FALSE)
  nc     <- ncol(f1)
  if (nc != ncol(f2))     return (FALSE)
  nr     <- nrow(f1)
  if (nr != nrow(f2))     return (FALSE)
  if (nr == 0)            return (TRUE)
  for (k in c(1:nr)) {
    if (f1[k,"name"] != f2[k,"name"]) {
      print (paste("checking", s, ": item", k, "name is wrong"))
      return (FALSE)
    }
    if (f1[k,"index"] != f2[k,"index"]) {
      print (paste("checking", s, ": item", k, "index is wrong"))
      return (FALSE)
    }
    if (f1[k,"dim"] != f2[k,"dim"]) {
      print (paste("checking", s, ": item", k, "dim is wrong"))
      return (FALSE)
    }
    if (f1[k,"card"] != f2[k,"card"]) {
      print (paste("checking", s, ": item", k, "card is wrong"))
      return (FALSE)
    }
    if (! (is.null(f1[k,"text"]) && is.null(f2[k,"text"]))) {
      if (f1[k,"text"] != f2[k,"text"]) {
        print (paste("checking", s, ": item", k, "text is wrong"))
        return (FALSE)
      }
    }
    f1d <- f1[k,"doms"][[1]]
    f2d <- f2[k,"doms"][[1]]
    if (length(f1d) != length(f2d)) {
      print (paste("checking", s, ": item", k, "doms length is wrong"))
      return (FALSE)
    }
    n <- length(f1d)
    if (n > 0) {
      for (kk in c(1:n)) {
        if (f1d[kk] != f2d[kk]) {
          print (paste("checking", s, ": item", k, "doms is wrong"))
          return (FALSE)
        }
      }
    }
  }
  return (TRUE)
} # chkFrame

# compare the data frames f1 and f2, return TRUE if the same, FALSE o/w
chkVarEqu <- function(s, f1, f2) {
  if (identical(f1,f2))   return (TRUE)
  return(FALSE)  # for now

  if (! is.data.frame(f1))   return (FALSE)
  if (! is.data.frame(f2))   return (FALSE)
  nc     <- ncol(f1)
  if (nc != ncol(f2))     return (FALSE)
  nr     <- nrow(f1)
  if (nr != nrow(f2))     return (FALSE)
  if (nr == 0)            return (TRUE)
  for (k in c(1:nr)) {
    if (f1[k,"name"] != f2[k,"name"]) {
      print (paste("checking", s, ": item", k, "name is wrong"))
      return (FALSE)
    }
    if (f1[k,"index"] != f2[k,"index"]) {
      print (paste("checking", s, ": item", k, "index is wrong"))
      return (FALSE)
    }
    if (f1[k,"dim"] != f2[k,"dim"]) {
      print (paste("checking", s, ": item", k, "dim is wrong"))
      return (FALSE)
    }
    if (f1[k,"card"] != f2[k,"card"]) {
      print (paste("checking", s, ": item", k, "card is wrong"))
      return (FALSE)
    }
    if (! (is.null(f1[k,"text"]) && is.null(f2[k,"text"]))) {
      print ("unchecked text")
      return (FALSE)
    }
    f1d <- f1[k,"doms"][[1]]
    f2d <- f2[k,"doms"][[1]]
    if (length(f1d) != length(f2d)) {
      print (paste("checking", s, ": item", k, "doms length is wrong"))
      return (FALSE)
    }
    n <- length(f1d)
    if (n > 0) {
      for (kk in c(1:n)) {
        if (f1d[kk] != f2d[kk]) {
          print (paste("checking", s, ": item", k, "doms is wrong"))
          return (FALSE)
        }
      }
    }
  }
  return (TRUE)
} # chkVarEqu

tryCatch({

  fn <- "trnsport.gdx"
  s <- gdxInfo (fn, dump=FALSE, returnDF=TRUE)

  if (!is.list(s))
    stop ("Expected gdxInfo output to be in list form")
  if (10 != length(s))
    stop ("Expected gdxInfo output to have length 10")
  if (12 != s$symCount)
    stop ("gdxInfo: expected trnsport symCount==12")
  if (5 != s$uelCount)
    stop ("gdxInfo: expected trnsport uelCount==5")

  s_sets <- structure(list(
          name = c("i", "j"),
          index = c(1L, 2L),
          dim = c(1L, 1L),
          card = c(2L, 3L),
          text = c("canning plants", "markets"),
          doms = structure(list(0L, 0L), class = "AsIs"),
          domnames = structure(list("*","*"), class = "AsIs")
  ),
  .Names = c("name", "index", "dim", "card", "text", "doms", "domnames"),
  row.names = 1:2, class = "data.frame")

  s_parameters <- structure(list(
    name = c("a", "b", "d", "f", "c"),
    index = 3:7,
    dim = c(1L, 1L, 2L, 0L, 2L),
    card = c(2L, 3L, 6L, 1L, 6L),
    text = c("capacity of plant i in cases", "demand at market j in cases", 
      "distance in thousands of miles", "freight in dollars per case per thousand miles", 
      "transport cost in thousands of dollars per case"),
    doms = structure(list(1L, 2L, 1:2, integer(0), 1:2), class = "AsIs"),
    domnames = structure(list("i","j",c("i","j"),character(0),c("i","j")), class = "AsIs")
  ),
  .Names = c("name", "index", "dim", "card", "text", "doms", "domnames"),
  row.names = c(NA, 5L), class = "data.frame")

  s_variables <- structure(list(
    name = c("x", "z"),
    index = c(8L, 9L),
    dim = c(2L, 0L),
    card = c(6L, 1L),
    text = c("shipment quantities in cases", "total transportation costs in thousands of dollars"),
    doms = structure(list(1:2, integer(0)), class = "AsIs"),
    domnames = structure(list(c("i","j"),character(0)), class = "AsIs")
  ),
  .Names = c("name", "index", "dim", "card", "text", "doms", "domnames"),
  row.names = 1:2, class = "data.frame")

  s_equations <- structure(list(
    name = c("cost", "supply", "demand"),
    index = c(10L, 11L, 12L),
    dim = c(0L, 1L, 1L),
    card = c(1L, 2L, 3L),
    text = c("define objective function", "observe supply limit at plant i", "satisfy demand at market j"),
    doms = structure(list(integer(0), 1L, 2L), class = "AsIs"),
    domnames = structure(list(character(0),"i","j"), class = "AsIs")
  ),
  .Names = c("name", "index", "dim", "card", "text", "doms", "domnames"),
  row.names = c(NA, 3L), class = "data.frame")

  if (! chkFrame("sets", s_sets, s$sets))
    stop ("gdxInfo: s$sets for trnsport is bogus")
  if (! chkFrame("parameters", s_parameters, s$parameters))
    stop ("gdxInfo: s$parameters for trnsport is bogus")
  if (! chkFrame("variables", s_variables, s$variables))
    stop ("gdxInfo: s$variables for trnsport is bogus")
  if (! chkFrame("equations", s_equations, s$equations))
    stop ("gdxInfo: s$equations for trnsport is bogus")
  if (0 != nrow(s$aliases))
    stop ("gdxInfo: s$aliases for trnsport is bogus")

  print ("Successfully completed gdxInfo test 2")
  TRUE
}

, error = function(ex) { print(ex) ; FALSE }
)

#### test rgdx reading a 3-dim variable
#### test form=['sparse','full'] X [filtered,unfiltered]
#### ['l','m','lo','up','s']

#### wanted lists produced with    dump("listName",file="")

if (! require(gdxrrw))      stop ("gdxrrw package is not available")
if (0 == igdx(silent=TRUE)) stop ("the gdx shared library has not been loaded")

source ("chkSame.R")
reqIdent <- TRUE

iUels <- c("i1", "i2")
iCard <- length(iUels)
jUels <- c("j1", "j2")
jCard <- length(jUels)
kUels <- c("k1", "k2")
kCard <- length(kUels)
fields <- c('l','m','lo','up','s')
nFields <- length(fields)
domains <- c("i","j","k")
domainsf <- c("i","j","k","_field")
cart <- list(iUels,jUels,kUels)
cartN <- list('i'=iUels,'j'=jUels,'k'=kUels)
cartf <- list(iUels,jUels,kUels,fields)
cartfN <- list('i'=iUels,'j'=jUels,'k'=kUels,'_field'=fields)
lev <- 1
mar <- 2
low <- 3
upp <- 4
sca <- 5

tryCatch({
  print ("testing rgdx on variable reads")
  rgdx('?')
  fnIn <- "tReadVar3.gdx"
  if (! file_test ('-f', fnIn)) {
    stop (paste("FAIL: File", fnIn, "does not exist"))
  }

  ### ---------- reading form=sparse, no filter
  # all
  t <- matrix(c( 1,1,1,lev,   0
                ,1,1,1,mar,   0
                ,1,1,1,low,   0
                ,1,1,1,upp, 525
                ,1,1,1,sca,   1
                ,1,1,2,lev,   1
                ,1,1,2,mar,   0.25
                ,1,1,2,low,   0
                ,1,1,2,upp, Inf
                ,1,1,2,sca,   1

                ,1,2,1,lev,  10
                ,1,2,1,mar,   0
                ,1,2,1,low,-Inf
                ,1,2,1,upp, Inf
                ,1,2,1,sca,   1
                ,1,2,2,lev,  11
                ,1,2,2,mar,   0.25
                ,1,2,2,low, 100
                ,1,2,2,upp, Inf
                ,1,2,2,sca,   1

                ,2,1,1,lev, 100
                ,2,1,1,mar,   0
                ,2,1,1,low,   0
                ,2,1,1,upp,   0
                ,2,1,1,sca,   1
                ,2,1,2,lev, 101
                ,2,1,2,mar,   0
                ,2,1,2,low,   0
                ,2,1,2,upp, Inf
                ,2,1,2,sca,   1

                ,2,2,1,lev, 110
                ,2,2,1,mar,   0
                ,2,2,1,low,   0
                ,2,2,1,upp, Inf
                ,2,2,1,sca,  10
                ,2,2,2,lev,   6
                ,2,2,2,mar,   0
                ,2,2,2,low,   6
                ,2,2,2,upp,   6
                ,2,2,2,sca,   1
               ), nrow=40, ncol=5, byrow=T)
  xwantA <- list(name="x", type="variable", dim=3L,
                 val=t,
                 form="sparse",
                 uels=list(iUels,jUels,kUels,fields),
                 domains=domainsf, domInfo="full",
                 field='all',
                 varTypeText='positive', typeCode=GMS_VARTYPE$POSITIVE)
  x <- rgdx(fnIn,list(name='x',form='sparse',field='alL'))
  chk <- chkRgdxRes (x, xwantA, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(x,'all',unfiltered) failed:",chk$msg))
  }
  x <- rgdx(fnIn,list(name='x',form='sparse',field='alL'),squeeze=F)
  chk <- chkRgdxRes (x, xwantA, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(x,'all',unfiltered,squeeze=F) failed:",chk$msg))
  }
  # level
  xwantL <- list(name="x", type="variable", dim=3L,
                 val=matrix(c( 1,1,2,   1
                              ,1,2,1,  10
                              ,1,2,2,  11
                              ,2,1,1, 100
                              ,2,1,2, 101
                              ,2,2,1, 110
                              ,2,2,2,   6), nrow=7, ncol=4, byrow=T),
                 form="sparse",
                 uels=list(iUels,jUels,kUels),
                 domains=domains, domInfo="full",
                 field='l',
                 varTypeText='positive', typeCode=GMS_VARTYPE$POSITIVE)
  x <- rgdx(fnIn,list(name='x',form='sparse',field='L'))
  chk <- chkRgdxRes (x, xwantL, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(x,'L',unfiltered) failed:",chk$msg))
  }
  xwantL$val <- matrix(c( 1,1,1,   0
                         ,1,1,2,   1
                         ,1,2,1,  10
                         ,1,2,2,  11
                         ,2,1,1, 100
                         ,2,1,2, 101
                         ,2,2,1, 110
                         ,2,2,2,   6), nrow=8, ncol=4, byrow=T)
  x <- rgdx(fnIn,list(name='x',form='sparse',field='L'),squeeze=F)
  chk <- chkRgdxRes (x, xwantL, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(x,'L',unfiltered,squeeze=F) failed:",chk$msg))
  }
  # marginal
  xwantM <- list(name="x", type="variable", dim=3L,
                 val=matrix(c( 1,1,2,  .25
                              ,1,2,2,  .25), nrow=2, ncol=4, byrow=T),
                 form="sparse",
                 uels=list(iUels,jUels,kUels),
                 domains=domains, domInfo="full",
                 field='m',
                 varTypeText='positive', typeCode=GMS_VARTYPE$POSITIVE)
  x <- rgdx(fnIn,list(name='x',form='sparse',field='M'))
  chk <- chkRgdxRes (x, xwantM, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(x,'M',unfiltered) failed:",chk$msg))
  }
  xwantM$val <- matrix(c( 1,1,1,   0
                         ,1,1,2,  .25
                         ,1,2,1,  0
                         ,1,2,2,  .25
                         ,2,1,1,  0
                         ,2,1,2,  0
                         ,2,2,1,  0
                         ,2,2,2,  0
                         ), nrow=8, ncol=4, byrow=T)
  x <- rgdx(fnIn,list(name='x',form='sparse',field='M'),squeeze=F)
  chk <- chkRgdxRes (x, xwantM, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(x,'M',unfiltered,squeeze=F) failed:",chk$msg))
  }
  # lower
  xwantLo <- list(name="x", type="variable", dim=3L,
                  val=matrix(c( 1,2,1, -Inf
                               ,1,2,2,  100
                               ,2,2,2,    6), nrow=3, ncol=4, byrow=T),
                  form="sparse",
                  uels=list(iUels,jUels,kUels),
                  domains=domains, domInfo="full",
                  field='lo',
                  varTypeText='positive', typeCode=GMS_VARTYPE$POSITIVE)
  x <- rgdx(fnIn,list(name='x',form='sparse',field='lo'))
  chk <- chkRgdxRes (x, xwantLo, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(x,'lo',unfiltered) failed:",chk$msg))
  }
  xwantLo$val <- matrix(c( 1,1,1,  0
                          ,1,1,2,  0
                          ,1,2,1, -Inf
                          ,1,2,2,  100
                          ,2,1,1,  0
                          ,2,1,2,  0
                          ,2,2,1,  0
                          ,2,2,2,  6), nrow=8, ncol=4, byrow=T)
  x <- rgdx(fnIn,list(name='x',form='sparse',field='lo'),squeeze=F)
  chk <- chkRgdxRes (x, xwantLo, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(x,'lo',unfiltered,squeeze=F) failed:",chk$msg))
  }
  # upper
  xwantUp <- list(name="x", type="variable", dim=3L,
                  val=matrix(c( 1,1,1,  525
                               ,2,1,1,    0
                               ,2,2,2,    6), nrow=3, ncol=4, byrow=T),
                  form="sparse",
                  uels=list(iUels,jUels,kUels),
                  domains=domains, domInfo="full",
                  field='up',
                  varTypeText='positive', typeCode=GMS_VARTYPE$POSITIVE)
  x <- rgdx(fnIn,list(name='x',form='sparse',field='up'))
  chk <- chkRgdxRes (x, xwantUp, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(x,'up',unfiltered) failed:",chk$msg))
  }
  xwantUp$val <- matrix(c( 1,1,1,  525
                          ,1,1,2,  Inf
                          ,1,2,1,  Inf
                          ,1,2,2,  Inf
                          ,2,1,1,    0
                          ,2,1,2,  Inf
                          ,2,2,1,  Inf
                          ,2,2,2,    6), nrow=8, ncol=4, byrow=T)
  x <- rgdx(fnIn,list(name='x',form='sparse',field='up'),squeeze=F)
  chk <- chkRgdxRes (x, xwantUp, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(x,'up',unfiltered,squeeze=F) failed:",chk$msg))
  }
  # scale
  xwantS <- list(name="x", type="variable", dim=3L,
                 val=matrix(c( 2,2,1,   10), nrow=1, ncol=4, byrow=T),
                 form="sparse",
                 uels=list(iUels,jUels,kUels),
                 domains=domains, domInfo="full",
                 field='s',
                 varTypeText='positive', typeCode=GMS_VARTYPE$POSITIVE)
  x <- rgdx(fnIn,list(name='x',form='sparse',field='s'))
  chk <- chkRgdxRes (x, xwantS, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(x,'s',unfiltered) failed:",chk$msg))
  }
  xwantS$val <- matrix(c( 1,1,1,    1
                         ,1,1,2,    1
                         ,1,2,1,    1
                         ,1,2,2,    1
                         ,2,1,1,    1
                         ,2,1,2,    1
                         ,2,2,1,   10
                         ,2,2,2,    1), nrow=8, ncol=4, byrow=T)
  x <- rgdx(fnIn,list(name='x',form='sparse',field='s'),squeeze=F)
  chk <- chkRgdxRes (x, xwantS, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(x,'s',unfiltered,squeeze=F) failed:",chk$msg))
  }

  ### ---------- reading form=sparse, filtered
  # all
  f <- list(c('i2'),jUels,kUels)
  t <- matrix(c( 1,1,1,lev, 100
                ,1,1,1,mar,   0
                ,1,1,1,low,   0
                ,1,1,1,upp,   0
                ,1,1,1,sca,   1
                ,1,1,2,lev, 101
                ,1,1,2,mar,   0
                ,1,1,2,low,   0
                ,1,1,2,upp, Inf
                ,1,1,2,sca,   1

                ,1,2,1,lev, 110
                ,1,2,1,mar,   0
                ,1,2,1,low,   0
                ,1,2,1,upp, Inf
                ,1,2,1,sca,  10
                ,1,2,2,lev,   6
                ,1,2,2,mar,   0
                ,1,2,2,low,   6
                ,1,2,2,upp,   6
                ,1,2,2,sca,   1
               ), nrow=20, ncol=5, byrow=T)
  xwantA <- list(name="x", type="variable", dim=3L,
                 val=t,
                 form="sparse",
                 uels=list(f[[1]],f[[2]],f[[3]],fields),
                 domains=domainsf, domInfo="filtered",
                 field='all',
                 varTypeText='positive', typeCode=GMS_VARTYPE$POSITIVE)
  x <- rgdx(fnIn,list(name='x',form='sparse',uels=f,field='all'))
  chk <- chkRgdxRes (x, xwantA, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(x,'all',filtered) failed:",chk$msg))
  }
  x <- rgdx(fnIn,list(name='x',form='sparse',uels=f,field='all'),squeeze=F)
  chk <- chkRgdxRes (x, xwantA, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(x,'all',filtered,squeeze=F) failed:",chk$msg))
  }
  # level
  f <- list(c('i2'),jUels,kUels)
  xwantL <- list(name="x", type="variable", dim=3L,
                 val=matrix(c( 1,1,1, 100
                              ,1,1,2, 101
                              ,1,2,1, 110
                              ,1,2,2,   6), nrow=4, ncol=4, byrow=T),
                 form="sparse",
                 uels=f, domains=domains, domInfo="filtered",
                 field='l',
                 varTypeText='positive', typeCode=GMS_VARTYPE$POSITIVE)
  x <- rgdx(fnIn,list(name='x',form='sparse',uels=f))
  chk <- chkRgdxRes (x, xwantL, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(x,'L',filtered) failed:",chk$msg))
  }
  x <- rgdx(fnIn,list(name='x',form='sparse',uels=f),squeeze=F)
  chk <- chkRgdxRes (x, xwantL, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(x,'L',filtered,squeeze=F) failed:",chk$msg))
  }
  # marginal
  f <- list(iUels,jUels,kUels)
  xwantM <- list(name="x", type="variable", dim=3L,
                 val=matrix(c( 1,1,2,  .25
                              ,1,2,2,  .25), nrow=2, ncol=4, byrow=T),
                 form="sparse",
                 uels=f, domains=domains, domInfo="filtered",
                 field='m',
                 varTypeText='positive', typeCode=GMS_VARTYPE$POSITIVE)
  x <- rgdx(fnIn,list(name='x',form='sparse',uels=f,field='M'))
  chk <- chkRgdxRes (x, xwantM, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(x,'M',filtered) failed:",chk$msg))
  }
  xwantM$val <- matrix(c( 1,1,1,  0
                         ,1,1,2,  .25
                         ,1,2,1,  0
                         ,1,2,2,  .25
                         ,2,1,1,  0
                         ,2,1,2,  0
                         ,2,2,1,  0
                         ,2,2,2,  0
                        ), nrow=8, ncol=4, byrow=T)
  x <- rgdx(fnIn,list(name='x',form='sparse',uels=f,field='M'),squeeze=F)
  chk <- chkRgdxRes (x, xwantM, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(x,'M',filtered,squeeze=F) failed:",chk$msg))
  }
  # lower
  f <- list(iUels,c('j2'),kUels)
  xwantLo <- list(name="x", type="variable", dim=3L,
                  val=matrix(c( 1,1,1, -Inf
                               ,1,1,2,  100
                               ,2,1,2,    6), nrow=3, ncol=4, byrow=T),
                  form="sparse",
                  uels=f, domains=domains, domInfo="filtered",
                  field='lo',
                  varTypeText='positive', typeCode=GMS_VARTYPE$POSITIVE)
  x <- rgdx(fnIn,list(name='x',form='sparse',uels=f,field='lo'))
  chk <- chkRgdxRes (x, xwantLo, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(x,'lo',filtered) failed:",chk$msg))
  }
  xwantLo$val <- matrix(c( 1,1,1, -Inf
                          ,1,1,2,  100
                          ,2,1,1,    0
                          ,2,1,2,    6), nrow=4, ncol=4, byrow=T)
  x <- rgdx(fnIn,list(name='x',form='sparse',uels=f,field='lo'),squeeze=F)
  chk <- chkRgdxRes (x, xwantLo, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(x,'lo',filtered,squeeze=F) failed:",chk$msg))
  }
  # upper
  f <- list(iUels,jUels,kUels)
  xwantUp <- list(name="x", type="variable", dim=3L,
                  val=matrix(c( 1,1,1,  525
                               ,2,1,1,    0
                               ,2,2,2,    6), nrow=3, ncol=4, byrow=T),
                  form="sparse",
                  uels=f, domains=domains, domInfo="filtered",
                  field='up',
                  varTypeText='positive', typeCode=GMS_VARTYPE$POSITIVE)
  x <- rgdx(fnIn,list(name='x',form='sparse',uels=f,field='UP'))
  chk <- chkRgdxRes (x, xwantUp, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(x,'up',filtered) failed:",chk$msg))
  }
  xwantUp$val <- matrix(c( 1,1,1,  525
                          ,1,1,2, +Inf
                          ,1,2,1, +Inf
                          ,1,2,2, +Inf
                          ,2,1,1,    0
                          ,2,1,2, +Inf
                         ,2,2,1, +Inf
                          ,2,2,2,    6), nrow=8, ncol=4, byrow=T)
  x <- rgdx(fnIn,list(name='x',form='sparse',uels=f,field='UP'),squeeze=F)
  chk <- chkRgdxRes (x, xwantUp, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(x,'up',filtered,squeeze=F) failed:",chk$msg))
  }
  # scale
  f <- list(iUels,jUels,kUels)
  xwantS <- list(name="x", type="variable", dim=3L,
                 val=matrix(c( 2,2,1,   10), nrow=1, ncol=4, byrow=T),
                 form="sparse",
                 uels=f, domains=domains, domInfo="filtered",
                 field='s',
                 varTypeText='positive', typeCode=GMS_VARTYPE$POSITIVE)
  x <- rgdx(fnIn,list(name='x',form='sparse',field='S',uels=f))
  chk <- chkRgdxRes (x, xwantS, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(x,'S',filtered) failed:",chk$msg))
  }
  xwantS$val <- matrix(c( 1,1,1,    1
                         ,1,1,2,    1
                         ,1,2,1,    1
                         ,1,2,2,    1
                         ,2,1,1,    1
                         ,2,1,2,    1
                         ,2,2,1,   10
                         ,2,2,2,    1), nrow=8, ncol=4, byrow=T)
  x <- rgdx(fnIn,list(name='x',form='sparse',field='S',uels=f),squeeze=F)
  chk <- chkRgdxRes (x, xwantS, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(x,'S',filtered,squeeze=F) failed:",chk$msg))
  }

  ### ---------- reading form=full, no filter
  # all
  v <- array(0,c(iCard,jCard,kCard,nFields),dimnames=cartfN)
  for (i in 1:iCard) {
    for (j in 1:jCard) {
      for (k in 1:kCard) {
        v[i,j,k,'l'] <- 100 * (i-1) + 10 * (j-1) + (k-1)
        v[i,j,k,'up'] <- Inf
        v[i,j,k,'s'] <- 1
      }
    }
  }
  v['i2','j2','k2',c('l','lo','up')] <- 6
  v['i1',c('j1','j2'),'k2','m'] <- 0.25
  v['i1','j2','k1','lo'] <- -Inf
  v['i1','j2','k2','lo'] <- 100
  v['i1','j1','k1','up'] <- 525
  v['i2','j1','k1','up'] <- 0
  v['i2','j2','k1','s'] <- 10
  xwantA <- list(name="x", type="variable", dim=3L,
                 val=v,
                 form="full",
                 uels=cartfN,
                 domains=domainsf, domInfo="full",
                 field='all',
                 varTypeText='positive', typeCode=GMS_VARTYPE$POSITIVE)
  x <- rgdx(fnIn,list(name='x',form='full',field='all'))
  chk <- chkRgdxRes (x, xwantA, T, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(x,'all',full,unfiltered) failed:",chk$msg))
  }
  x <- rgdx(fnIn,list(name='x',form='full',field='all'),squeeze=F)
  chk <- chkRgdxRes (x, xwantA, T, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(x,'all',full,unfiltered,squeeze=F) failed:",chk$msg))
  }
  # level
  v <- array(0,c(iCard,jCard,kCard),dimnames=cartN)
  for (i in 1:iCard) {
    for (j in 1:jCard) {
      for (k in 1:kCard) {
        v[i,j,k] <- 100 * (i-1) + 10 * (j-1) + (k-1)
      }
    }
  }
  v['i2','j2','k2'] <- 6
  xwantL <- list(name="x", type="variable", dim=3L,
                 val=v,
                 form="full",
                 uels=cartN,
                 domains=domains, domInfo="full",
                 field='l',
                 varTypeText='positive', typeCode=GMS_VARTYPE$POSITIVE)
  x <- rgdx(fnIn,list(name='x',form='full'))
  chk <- chkRgdxRes (x, xwantL, T, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(x,'L',full,unfiltered) failed:",chk$msg))
  }
  x <- rgdx(fnIn,list(name='x',form='full'),squeeze=F)
  chk <- chkRgdxRes (x, xwantL, T, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(x,'L',full,unfiltered,squeeze=F) failed:",chk$msg))
  }
  # marginal
  v <- array(0,c(iCard,jCard,kCard),dimnames=cartN)
  v['i1','j1',2] <- .25
  v['i1','j2',2] <- .25
  xwantM <- list(name="x", type="variable", dim=3L,
                 val=v,
                 form="full",
                 uels=cartN,
                 domains=domains, domInfo="full",
                 field='m',
                 varTypeText='positive', typeCode=GMS_VARTYPE$POSITIVE)
  x <- rgdx(fnIn,list(name='x',form='full',field='m'))
  chk <- chkRgdxRes (x, xwantM, T, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(x,'M',full,unfiltered) failed:",chk$msg))
  }
  x <- rgdx(fnIn,list(name='x',form='full',field='m'),squeeze=F)
  chk <- chkRgdxRes (x, xwantM, T, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(x,'M',full,unfiltered,squeeze=F) failed:",chk$msg))
  }
  # lower
  v <- array(0,c(iCard,jCard,kCard),dimnames=cartN)
  v['i1','j2','k1'] <- -Inf
  v['i1','j2','k2'] <- 100
  v['i2','j2','k2'] <- 6
  xwantLo <- list(name="x", type="variable", dim=3L,
                  val=v,
                  form="full",
                  uels=cartN,
                  domains=domains, domInfo="full",
                  field='lo',
                  varTypeText='positive', typeCode=GMS_VARTYPE$POSITIVE)
  x <- rgdx(fnIn,list(name='x',form='full',field='lo'))
  chk <- chkRgdxRes (x, xwantLo, T, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(x,'lo',full,unfiltered) failed:",chk$msg))
  }
  x <- rgdx(fnIn,list(name='x',form='full',field='lo'),squeeze=F)
  chk <- chkRgdxRes (x, xwantLo, T, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(x,'lo',full,unfiltered,squeeze=F) failed:",chk$msg))
  }
  # upper
  v <- array(+Inf,c(iCard,jCard,kCard),dimnames=cartN)
  v['i1','j1','k1'] <- 525
  v['i2','j1','k1'] <- 0
  v['i2','j2','k2'] <- 6
  xwantUp <- list(name="x", type="variable", dim=3L,
                  val=v,
                  form="full",
                  uels=cartN, domains=domains, domInfo="full",
                  field='up',
                  varTypeText='positive', typeCode=GMS_VARTYPE$POSITIVE)
  x <- rgdx(fnIn,list(name='x',form='full',field='up'))
  chk <- chkRgdxRes (x, xwantUp, T, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(x,'up',full,unfiltered) failed:",chk$msg))
  }
  x <- rgdx(fnIn,list(name='x',form='full',field='up'),squeeze=F)
  chk <- chkRgdxRes (x, xwantUp, T, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(x,'up',full,unfiltered,squeeze=F) failed:",chk$msg))
  }
  # scale
  v <- array(1,c(iCard,jCard,kCard),dimnames=cartN)
  v[2,2,1] <- 10
  xwantS <- list(name="x", type="variable", dim=3L,
                 val=v,
                 form="full",
                 uels=cartN,
                 domains=domains, domInfo="full",
                 field='s',
                 varTypeText='positive', typeCode=GMS_VARTYPE$POSITIVE)
  x <- rgdx(fnIn,list(name='x',form='full',field='s'))
  chk <- chkRgdxRes (x, xwantS, T, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(x,'s',full,unfiltered) failed:",chk$msg))
  }
  x <- rgdx(fnIn,list(name='x',form='full',field='s'),squeeze=F)
  chk <- chkRgdxRes (x, xwantS, T, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(x,'s',full,unfiltered,squeeze=F) failed:",chk$msg))
  }

  ### ---------- reading form=full, filtered
  # all
  f <- list(c('i2'),jUels,kUels)
  dnames <- f ; dnames[[4]] <- fields ; names(dnames) <- domainsf
  v <- array(0,c(1,jCard,kCard,nFields),dimnames=dnames)
  for (j in 1:jCard) {
    for (k in 1:kCard) {
      v['i2',j,k,'l'] <- 100 + 10 * (j-1) + (k-1)
      v['i2',j,k,'up'] <- Inf
      v['i2',j,k,'s'] <- 1
    }
  }
  v['i2','j2','k2',c('l','lo','up')] <- 6
  v['i2','j1','k1','up'] <- 0
  v['i2','j2','k1','s'] <- 10
  xwantA <- list(name="x", type="variable", dim=3L,
                 val=v,
                 form="full",
                 uels=dnames,
                 domains=domainsf, domInfo="filtered",
                 field='all',
                 varTypeText='positive', typeCode=GMS_VARTYPE$POSITIVE)
  x <- rgdx(fnIn,list(name='x',form='full',field='all',uels=f))
  chk <- chkRgdxRes (x, xwantA, T, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(x,'all',full,filtered) failed:",chk$msg))
  }
  x <- rgdx(fnIn,list(name='x',form='full',field='all',uels=f),squeeze=F)
  chk <- chkRgdxRes (x, xwantA, T, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(x,'all',full,filtered,squeeze=F) failed:",chk$msg))
  }
  # level
  f <- list(c('i2'),jUels,kUels)
  dnames <- f ; names(dnames) <- domains
  v <- array(0,c(1,jCard,kCard),dimnames=dnames)
  for (j in 1:jCard) {
    for (k in 1:kCard) {
      v[1,j,k] <- 100 + 10 * (j-1) + (k-1)
    }
  }
  v['i2','j2','k2'] <- 6
  xwantL <- list(name="x", type="variable", dim=3L,
                 val=v,
                 form="full",
                 uels=dnames, domains=domains, domInfo="filtered",
                 field='l',
                 varTypeText='positive', typeCode=GMS_VARTYPE$POSITIVE)
  x <- rgdx(fnIn,list(name='x',form='full',uels=f))
  chk <- chkRgdxRes (x, xwantL, T, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(x,'L',full,filtered) failed:",chk$msg))
  }
  x <- rgdx(fnIn,list(name='x',form='full',uels=f),squeeze=F)
  chk <- chkRgdxRes (x, xwantL, T, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(x,'L',full,filtered,squeeze=F) failed:",chk$msg))
  }
  # marginal
  f <- cart
  dnames <- f ; names(dnames) <- domains
  v <- array(0,c(iCard,jCard,kCard),dnames)
  v['i1',jUels,'k2'] <- 0.25
  xwantM <- list(name="x", type="variable", dim=3L,
                 val=v,
                 form="full",
                 uels=dnames, domains=domains, domInfo="filtered",
                 field='m',
                 varTypeText='positive', typeCode=GMS_VARTYPE$POSITIVE)
  x <- rgdx(fnIn,list(name='x',form='full',uels=f,field='M'))
  chk <- chkRgdxRes (x, xwantM, T, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(x,'M',full,filtered) failed:",chk$msg))
  }
  x <- rgdx(fnIn,list(name='x',form='full',uels=f,field='M'),squeeze=F)
  chk <- chkRgdxRes (x, xwantM, T, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(x,'M',full,filtered,squeeze=F) failed:",chk$msg))
  }
  # lower
  f <- list(iUels,c('j2'),kUels)
  dnames <- f ; names(dnames) <- domains
  v <- array(0,c(iCard,1,kCard),dimnames=dnames)
  v['i1','j2','k1'] <- -Inf
  v['i1','j2','k2'] <- 100
  v['i2','j2','k2'] <- 6
  xwantLo <- list(name="x", type="variable", dim=3L,
                  val=v,
                  form="full",
                  uels=dnames, domains=domains, domInfo="filtered",
                  field='lo',
                  varTypeText='positive', typeCode=GMS_VARTYPE$POSITIVE)
  x <- rgdx(fnIn,list(name='x',form='full',uels=f,field='lo'))
  chk <- chkRgdxRes (x, xwantLo, T, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(x,'lo',full,filtered) failed:",chk$msg))
  }
  x <- rgdx(fnIn,list(name='x',form='full',uels=f,field='lo'),squeeze=F)
  chk <- chkRgdxRes (x, xwantLo, T, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(x,'lo',full,filtered,squeeze=F) failed:",chk$msg))
  }
  # upper
  f <- cart
  dnames <- f ; names(dnames) <- domains
  v <- array(Inf,c(iCard,jCard,kCard),dimnames=dnames)
  v['i1','j1','k1'] <- 525
  v['i2','j1','k1'] <- 0
  v['i2','j2','k2'] <- 6
  xwantUp <- list(name="x", type="variable", dim=3L,
                  val=v,
                  form="full",
                  uels=dnames, domains=domains, domInfo="filtered",
                  field='up',
                  varTypeText='positive', typeCode=GMS_VARTYPE$POSITIVE)
  x <- rgdx(fnIn,list(name='x',form='full',uels=f,field='up'))
  chk <- chkRgdxRes (x, xwantUp, T, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(x,'up',full,filtered) failed:",chk$msg))
  }
  x <- rgdx(fnIn,list(name='x',form='full',uels=f,field='up'),squeeze=F)
  chk <- chkRgdxRes (x, xwantUp, T, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(x,'up',full,filtered,squeeze=F) failed:",chk$msg))
  }
  # scale
  f <- cart
  dnames <- f ; names(dnames) <- domains
  v <- array(1,c(iCard,jCard,kCard),dimnames=dnames)
  v['i2','j2','k1'] <- 10
  xwantS <- list(name="x", type="variable", dim=3L,
                 val=v,
                 form="full",
                 uels=dnames, domains=domains, domInfo="filtered",
                 field='s',
                 varTypeText='positive', typeCode=GMS_VARTYPE$POSITIVE)
  x <- rgdx(fnIn,list(name='x',form='full',uels=f,field='s'))
  chk <- chkRgdxRes (x, xwantS, T, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(x,'s',full,filtered) failed:",chk$msg))
  }
  x <- rgdx(fnIn,list(name='x',form='full',uels=f,field='s'),squeeze=F)
  chk <- chkRgdxRes (x, xwantS, T, reqIdent=reqIdent)
  if (!chk$same) {
    stop (paste("test rgdx(x,'s',full,filtered,squeeze=F) failed:",chk$msg))
  }


  print ("test of rgdx on variable reads passed")
  TRUE   ## all tests passed: return TRUE
},

error = function(ex) { print ("test of rgdx on variable reads failed"); print(ex) ; FALSE }
)

### Test wgdx
# We write all the transport data using sparse writes and universe
# subsets, with or without values

if (! require(gdxrrw))      stop ("gdxrrw package is not available")
if (0 == igdx(silent=TRUE)) stop ("the gdx shared library has not been loaded")

testName <- 'writing trnsport with form="sparse" and universe subsets'
logFile <- 'diffLog.txt'

errFunc <- function(ex) {
  print (paste0("test of wgdx on ",testName,": FAILED"))
  print (paste("Check file", logFile, "for possible gdxdiff output"))
  print (ex)
  FALSE
} # errFunc

tryCatch({
  print (paste("testing wgdx on", testName))
  wgdx('?')
  fn <- "tws2.gdx"

  # set i: supply nodes
  si <- list(c("seattle", "san-diego"))

  # set j: demand nodes
  sj <- list(c("new-york", "chicago", "topeka"))

  ilst <- list (name='i', type='set', dim=1, form='sparse', ts='canning plants',
                uels=c(si))

  jv <- matrix(c(1:3), c(3,1))
  jlst <- list (name='j', type='set', dim=1, form='sparse', ts='markets',
          val=jv, uels=c(sj))

  av <- matrix(c(1:2,350,600), c(2,2))
  alst <- list (name='a', type='parameter', dim=1, form='sparse',
                ts='capacity of plant i in cases', val=av, uels=c(si))

  bv <- matrix(c(1, 325,
                 2, 300,
                 3, 275),  c(3,1), byrow=TRUE)
  blst <- list (name='b', type='parameter', form='sparse',
                ts='demand at market j in cases', val=bv, uels=c(sj))

  f <- 90
  fv <- matrix(c(f),c(1,1))
  dv <- matrix(c(1, 1, 2.5,
                 1, 2, 1.7,
                 1, 3, 1.8,
                 2, 1, 2.5,
                 2, 2, 1.8,
                 2, 3, 1.4),  c(6,3), byrow=TRUE)
  cv <- dv
  cv[,3] <- dv[,3] * f / 1000

  clst <- list (name='c', type='parameter', dim=2, form='sparse',
                ts='transport cost in thousands of dollars per case', val=cv, uels=c(si,sj))
  dlst <- list (name='d', type='parameter', form='sparse',
                ts='distance in thousands of miles', val=dv, uels=c(si,sj))

  flst <- list (name='f', type='parameter', dim=0, form='sparse',
                ts='freight in dollars per case per thousand miles', val=fv)

  wgdx (fn, ilst, jlst, alst, blst, clst, dlst, flst)

  if (file_test ('-f', fn) == TRUE) {
    print (paste("File", fn, "was created"))
  } else {
    stop (paste("FAIL: File", fn, "is not readable"))
  }
  rc <- system2 ("gdxdiff",args=c("trnsport.gdx", fn, "releps=1e-15",
                               "id=i,j,a,b,c,d,f"), stdout=logFile)
  if (0 != rc) {
    stop(paste("Bad return from gdxdiff: wanted 0, got",rc))
  } else {
    print ("gdxdiff call succeeded")
  }

  print (paste0("test of wgdx on ", testName, ": PASSED"))
  suppressWarnings(file.remove(logFile))
  invisible(TRUE)   ## all tests passed: return TRUE
},

error = errFunc
)

## ## test wgdx with form='full', 1-d variable, write different types
## gdxdump or gdxdiff do not really do what we want here, so just have
## to read from the generated GDX and the target GDX and compare the results

if (! require(gdxrrw))      stop ("gdxrrw package is not available")
if (0 == igdx(silent=TRUE)) stop ("the gdx shared library has not been loaded")

testName <- 'all types of variable writes with form=full'

errFunc <- function(ex) {
  print (paste0("test of wgdx on ",testName,": FAILED"))
  print(ex)
  FALSE
} # errFunc

tryCatch({
  print (paste("testing wgdx on", testName))
  wgdx('?')
  fnOut <- "tmp.gdx"
  fnWant <- "tVarTypes.gdx"
  if (! file_test ('-f', fnWant)) {
    stop (paste("FAIL: File-to-duplicate", fnWant, "does not exist"))
  }

  ## all writes should use the same uels
  iUels <- paste0("i","1":"10")
  fUels <- c("l", "m", "lo", "up", "s")
  uels <- list(iUels,fUels)
  nrow <- length(iUels)
  ncol <- length(fUels)

  val0 <- matrix(0,nrow=nrow,ncol=ncol)
  dimnames(val0) <- uels

  ## write binary variable to GDX, compare with fnWant version
  ## defaults first
  val0[,'up'] <- 1
  val0[,'s'] <- 1
  val0['i1','l'] <- 1
  val0['i2','m'] <- 0.5
  val0['i3','lo'] <- 1
  val0['i4','up'] <- 0
  val0['i5','s'] <- 10
  valBinary <- val0
  vBinary <- list(name='v_binary',type='variable',form='full',val=valBinary,
                  uels=uels,domains='i',
                  typeCode=GMS_VARTYPE$BINARY,ts='text for v_binary')
  wgdx (fnOut, vBinary)
  if (file_test ('-f', fnOut) == TRUE) {
    print (paste("File", fnOut, "was created"))
  } else {
    stop (paste("FAIL: File", fnOut, "is not readable"))
  }

  vWant <- rgdx(fnWant,list(name='v_binary',form='sparse',field='all',ts=TRUE))
  vWrote <- rgdx(fnOut,list(name='v_binary',form='sparse',field='all',ts=TRUE))
  if (identical(vWrote$domInfo,"relaxed"))
    vWrote$domInfo <- "full"
  if (identical(vWant,vWrote)) {
  }
  else {
    print(all.equal(vWant,vWrote))
    stop ("FAIL: for v_binary, vWant and vWrote do not agree")
  }

  ## write integer variable to GDX, compare with fnWant version
  val0[,] <- 0
  ## nonzero defaults first
  val0[,'up'] <- Inf
  val0[,'s'] <- 1
  val0['i1','l'] <- 1.5
  val0['i2','m'] <- 0.5
  val0['i3','lo'] <- 3
  val0['i4','up'] <- 16
  val0['i5','s'] <- 1000
  valInteger <- val0
  vInteger <- list(name='v_integer',type='variable',form='full',val=valInteger,
                   uels=uels,domains='i',
                   typeCode=GMS_VARTYPE$INTEGER,ts='CHECK CASING')
  wgdx (fnOut, vInteger)
  if (file_test ('-f', fnOut) == TRUE) {
    print (paste("File", fnOut, "was created"))
  } else {
    stop (paste("FAIL: File", fnOut, "is not readable"))
  }

  vWant <- rgdx(fnWant,list(name='v_integer',form='sparse',field='all',ts=TRUE))
  vWrote <- rgdx(fnOut,list(name='v_integer',form='sparse',field='all',ts=TRUE))
  if (identical(vWrote$domInfo,"relaxed"))
    vWrote$domInfo <- "full"
  if (identical(vWant,vWrote)) {
  }
  else {
    print(all.equal(vWant,vWrote))
    stop ("FAIL: for v_integer, vWant and vWrote do not agree")
  }

  ## write positive variable to GDX, compare with fnWant version
  val0[,] <- 0
  ## nonzero defaults first
  val0[,'up'] <- Inf
  val0[,'s'] <- 1
  val0['i5','l'] <- 322
  val0['i4','m'] <- -1024
  val0['i3','lo'] <- -Inf
  val0['i2','up'] <- 0
  val0['i1','s'] <- 10
  valPositive <- val0
  vPositive <- list(name='v_positive',type='variable',form='full',val=valPositive,
                    uels=uels,domains='i',
                    typeCode=GMS_VARTYPE$POSITIVE,ts='try some special values')
  wgdx (fnOut, vPositive)
  if (file_test ('-f', fnOut) == TRUE) {
    print (paste("File", fnOut, "was created"))
  } else {
    stop (paste("FAIL: File", fnOut, "is not readable"))
  }

  vWant <- rgdx(fnWant,list(name='v_positive',form='sparse',field='all',ts=TRUE))
  vWrote <- rgdx(fnOut,list(name='v_positive',form='sparse',field='all',ts=TRUE))
  if (identical(vWrote$domInfo,"relaxed"))
    vWrote$domInfo <- "full"
  if (identical(vWant,vWrote)) {
  }
  else {
    print(all.equal(vWant,vWrote))
    stop ("FAIL: for v_positive, vWant and vWrote do not agree")
  }

  ## write negative variable to GDX, compare with fnWant version
  val0[,] <- 0
  ## nonzero defaults first
  val0[,'lo'] <- -Inf
  val0[,'s'] <- 1
  val0['i5','l'] <- 525
  val0['i4','m'] <- -4
  val0['i3','lo'] <- 1
  val0['i2','up'] <- -1
  val0['i1','s'] <- 0.5
  valNegative <- val0
  vNegative <- list(name='v_negative',type='variable',form='full',val=valNegative,
                    uels=uels,domains='i',
                    typeCode=GMS_VARTYPE$NEGATIVE,ts='')
  wgdx (fnOut, vNegative)
  if (file_test ('-f', fnOut) == TRUE) {
    print (paste("File", fnOut, "was created"))
  } else {
    stop (paste("FAIL: File", fnOut, "is not readable"))
  }

  vWant <- rgdx(fnWant,list(name='v_negative',form='sparse',field='all',ts=TRUE))
  vWrote <- rgdx(fnOut,list(name='v_negative',form='sparse',field='all',ts=TRUE))
  if (identical(vWrote$domInfo,"relaxed"))
    vWrote$domInfo <- "full"
  if (identical(vWant,vWrote)) {
  }
  else {
    print(all.equal(vWant,vWrote))
    stop ("FAIL: for v_negative, vWant and vWrote do not agree")
  }

  ## write free variable to GDX, compare with fnWant version
  val0[,] <- 0
  ## nonzero defaults first
  val0[,'lo'] <- -Inf
  val0[,'up'] <-  Inf
  val0[,'s'] <- 1
  val0['i1','l'] <- -12.5
  val0['i2','m'] <- 0.5
  val0['i3','lo'] <- 3
  val0['i4','up'] <- -8
  val0['i5','s'] <- 512
  valFree <- val0
  vFree <- list(name='v_free',type='variable',form='full',val=valFree,
                uels=uels,domains='i',
                typeCode=GMS_VARTYPE$FREE,
                ts='WHAT if we use a long text with special chars __ %% -- @@  ?? !! jj')
  wgdx (fnOut, vFree)
  if (file_test ('-f', fnOut) == TRUE) {
    print (paste("File", fnOut, "was created"))
  } else {
    stop (paste("FAIL: File", fnOut, "is not readable"))
  }

  vWant <- rgdx(fnWant,list(name='v_free',form='sparse',field='all',ts=TRUE))
  vWrote <- rgdx(fnOut,list(name='v_free',form='sparse',field='all',ts=TRUE))
  if (identical(vWrote$domInfo,"relaxed"))
    vWrote$domInfo <- "full"
  if (identical(vWant,vWrote)) {
  }
  else {
    print(all.equal(vWant,vWrote))
    stop ("FAIL: for v_free, vWant and vWrote do not agree")
  }

  ## write sos1 variable to GDX, compare with fnWant version
  val0[,] <- 0
  ## nonzero defaults first
  val0[,'up'] <-  Inf
  val0[,'s'] <- 1
  val0['i1','l'] <- 123
  val0['i2','m'] <- -10.5
  val0['i3','lo'] <- 2
  val0['i4','up'] <- 10
  val0['i5','s'] <- 100
  valSos1 <- val0
  vSos1 <- list(name='v_sos1',type='variable',form='full',val=valSos1,
                uels=uels,domains='i',
                typeCode=GMS_VARTYPE$SOS1,ts='v_sos1')
  wgdx (fnOut, vSos1)
  if (file_test ('-f', fnOut) == TRUE) {
    print (paste("File", fnOut, "was created"))
  } else {
    stop (paste("FAIL: File", fnOut, "is not readable"))
  }

  vWant <- rgdx(fnWant,list(name='v_sos1',form='sparse',field='all',ts=TRUE))
  vWrote <- rgdx(fnOut,list(name='v_sos1',form='sparse',field='all',ts=TRUE))
  if (identical(vWrote$domInfo,"relaxed"))
    vWrote$domInfo <- "full"
  if (identical(vWant,vWrote)) {
  }
  else {
    print(all.equal(vWant,vWrote))
    stop ("FAIL: for v_sos1, vWant and vWrote do not agree")
  }

  ## write sos2 variable to GDX, compare with fnWant version
  val0[,] <- 0
  ## nonzero defaults first
  val0[,'up'] <-  Inf
  val0[,'s'] <- 1
  val0['i1','l'] <- 123
  val0['i2','m'] <- -10.5
  val0['i3','lo'] <- 2
  val0['i4','up'] <- 10
  val0['i5','s'] <- 100
  valSos2 <- val0
  vSos2 <- list(name='v_sos2',type='variable',form='full',val=valSos2,
                uels=uels,domains='i',
                typeCode=GMS_VARTYPE$SOS2,ts='v_sos2')
  wgdx (fnOut, vSos2)
  if (file_test ('-f', fnOut) == TRUE) {
    print (paste("File", fnOut, "was created"))
  } else {
    stop (paste("FAIL: File", fnOut, "is not readable"))
  }

  vWant <- rgdx(fnWant,list(name='v_sos2',form='sparse',field='all',ts=TRUE))
  vWrote <- rgdx(fnOut,list(name='v_sos2',form='sparse',field='all',ts=TRUE))
  if (identical(vWrote$domInfo,"relaxed"))
    vWrote$domInfo <- "full"
  if (identical(vWant,vWrote)) {
  }
  else {
    print(all.equal(vWant,vWrote))
    stop ("FAIL: for v_sos2, vWant and vWrote do not agree")
  }

  ## write semicont variable to GDX, compare with fnWant version
  val0[,] <- 0
  ## nonzero defaults first
  val0[,'lo'] <-  1
  val0[,'up'] <-  Inf
  val0[,'s'] <- 1
  val0['i1','l'] <- 10.5
  val0['i2','m'] <- .875
  val0['i3','lo'] <- 13
  val0['i4','up'] <- 1000
  val0['i5','s'] <- 999
  valSemicont <- val0
  vSemicont <- list(name='v_semicont',type='variable',form='full',val=valSemicont,
                    uels=uels,domains='i',
                    typeCode=GMS_VARTYPE$SEMICONT,ts='v_semicont')
  wgdx (fnOut, vSemicont)
  if (file_test ('-f', fnOut) == TRUE) {
    print (paste("File", fnOut, "was created"))
  } else {
    stop (paste("FAIL: File", fnOut, "is not readable"))
  }

  vWant <- rgdx(fnWant,list(name='v_semicont',form='sparse',field='all',ts=TRUE))
  vWrote <- rgdx(fnOut,list(name='v_semicont',form='sparse',field='all',ts=TRUE))
  if (identical(vWrote$domInfo,"relaxed"))
    vWrote$domInfo <- "full"
  if (identical(vWant,vWrote)) {
  }
  else {
    print(all.equal(vWant,vWrote))
    stop ("FAIL: for v_semicont, vWant and vWrote do not agree")
  }

  ## write semiint variable to GDX, compare with fnWant version
  val0[,] <- 0
  ## nonzero defaults first
  val0[,'lo'] <- 1
  val0[,'up'] <- Inf
  val0[,'s'] <- 1
  val0['i1','l'] <- 10.5
  val0['i2','m'] <- .875
  val0['i3','lo'] <- 13
  val0['i4','up'] <- 1000
  val0['i5','s'] <- 100000
  valSemiint <- val0
  vSemiint <- list(name='v_semiint',type='variable',form='full',val=valSemiint,
                   uels=uels,domains='i',
                   typeCode=GMS_VARTYPE$SEMIINT,ts='v_semiint text')
  wgdx (fnOut, vSemiint)
  if (file_test ('-f', fnOut) == TRUE) {
    print (paste("File", fnOut, "was created"))
  } else {
    stop (paste("FAIL: File", fnOut, "is not readable"))
  }

  vWant <- rgdx(fnWant,list(name='v_semiint',form='sparse',field='all',ts=TRUE))
  vWrote <- rgdx(fnOut,list(name='v_semiint',form='sparse',field='all',ts=TRUE))
  if (identical(vWrote$domInfo,"relaxed"))
    vWrote$domInfo <- "full"
  if (identical(vWant,vWrote)) {
  }
  else {
    print(all.equal(vWant,vWrote))
    stop ("FAIL: for v_semiint, vWant and vWrote do not agree")
  }


  print (paste0("test of wgdx on ", testName, ": PASSED"))
  invisible(TRUE)   ## all tests passed: return TRUE
},

error = errFunc
)

% \VignetteIndexEntry{gdxrrw Tutorial}
% \VignetteDepends{gdxrrw}
% \VignettePackage{gdxrrw}
\documentclass[11pt]{article}
\usepackage{amsmath}
\usepackage[pdftex]{graphicx}
\usepackage{color}
% \usepackage{xspace}
% \usepackage{fancyvrb}
% \usepackage{fancyhdr}
\usepackage[colorlinks=true,
            linkcolor=blue,
            citecolor=blue,
            urlcolor=blue]{hyperref}
\usepackage{lscape}
\usepackage{Sweave}

\newcommand{\rrw}{\texttt{gdxrrw}}

\title{A Tutorial for the {\tt gdxrrw} Package}
\author{Steve Dirkse \\ GAMS Development Corporation}

\begin{document}

\maketitle

\thispagestyle{empty}
\section{Introduction}

In this tutorial introduction to \rrw{} we carry out a small modeling
exercise.  We consider a common use case in which one starts with a
self-contained, fully-functional GAMS model that reads from and writes
to GDX.  The GAMS source for the model is not R-specific; it works
equally well with or independently of R.  Without changing the model
source, we can control the model behavior by passing it flags that
control the GDX data input and output used.

It's worth noting that this tutorial assumes the user is familar with
GAMS and to a lesser extent with R.

\section{First steps}

Here we execute the basic steps: transferring data between GAMS and R,
and running GAMS.

Before you can use any R package, you must load
it.  The \rrw{} package also depends on the GDX shared libraries found
in the GAMS system directory.  The \texttt{igdx} command is useful for
setting and querying this linkage between \rrw{} and GAMS.  For
example, the usage below checks for the GAMS system directory in the
environment variable \texttt{R\_GAMS\_SYSDIR}.
<<loadPackage>>=
library(gdxrrw)
igdx('')
if (! igdx(silent=T)) stop ('Could not load GDX API')
@

Our starting point is a basic transport model where all of the data
inputs and outputs are done via GDX.  Running this model is easy once
we figure out how to get it from the \texttt{doc} subdirectory of the
package:
<<genData>>=
gms <- system.file('doc','transport.gms',package='gdxrrw', mustWork=T)
isWindows <- ("mingw32" == R.Version()$os)
if (isWindows) gms <- gsub("/","\\",gms,fixed=TRUE)
ingdx <- system.file('doc','inputs.gdx',package='gdxrrw', mustWork=T)
if (isWindows) ingdx <- gsub("/","\\",ingdx,fixed=TRUE)
rc <- gams(paste0(gms, " --INPUT=", ingdx))
if (0 != rc) stop ('GAMS run failed: rc = ',rc)
@

For reference, we have included the GDX file \texttt{outputs.gdx}
produced by the run above in the \texttt{doc} directory.
<<inCase>>=
if (! file.exists('outputs.gdx')) {
  ogdx <- system.file('doc','outputs.gdx',package='gdxrrw', mustWork=T)
  file.copy(ogdx,'outputs.gdx')
}
@

The model \texttt{transport} dumps all of its data (including its
inputs) to GDX before it quits.  There are 5 inputs: 2 sets and 3
parameters.
<<origData>>=
outgdx <- 'outputs.gdx'
if (! file.exists(outgdx)) stop (paste('File not found:',outgdx))
I <- rgdx.set(outgdx,'I')
J <- rgdx.set(outgdx,'J')
a <- rgdx.param(outgdx,'a')
b <- rgdx.param(outgdx,'b')
c <- rgdx.param(outgdx,'c')
@

As an exercise, we first generate a GDX file whose data is identical
to the original inputs, and verify that the solution with this data is unchanged:
<<identData>>=
wgdx.lst('intest',list(I,J,a,b,c))
rc <- system2('gdxdiff', paste('intest.gdx', ingdx), stdout=F)
if (0 != rc) stop ('gdxdiff says intest.gdx and inputs.gdx differ: rc = ',rc)
rc <- gams(paste(gms, '--INPUT intest.gdx --OUTPUT outtest.gdx'))
if (0 != rc) stop ('gams failed: rc = ',rc)
# system2('gams', 'transport.gms --INPUT intest.gdx --OUTPUT outtest.gdx')
zlst <- rgdx('outputs.gdx',list(name='z'))
z <- zlst$val
# we don't need to use the intermediate zlst variable to get the val
zz <- rgdx('outtest.gdx',list(name='z'))$val
if (0.0 != round(z-zz,6)) stop (paste("different objectives!! ", z, zz))
@

If we double all transportation costs, we can expect to double the objective.
<<doubleData>>=
c2 <- c
c2[[3]] <- c[[3]] * 2
wgdx.lst('in2',list(I,J,a,b,c2))
gams(paste(gms,'--INPUT in2.gdx --OUTPUT out2.gdx'))
z2 <- rgdx('out2.gdx',list(name='z'))$val
print(paste('original=', z,'  double=',z2))
@

\section{Using New Data}

We can define a new problem by changing the sets I and J.
For example, we can use the state data in R to create a set of source
and destination nodes.  The state data includes populations that we
can use to scale demands, and we can base transportation costs on the
lat/long data for the state centers.
<<statesData>>=
data(state)
src <- c('California','Washington','New York','Maryland')
dst <- setdiff(state.name,src)
supTotal <- 1001
demTotal <- 1000
srcPop <- state.x77[src,'Population']
srcPopTot <- sum(srcPop)
dstPop <- state.x77[dst,'Population']
dstPopTot <- sum(dstPop)
sup <- (srcPop / srcPopTot) * supTotal
dem <- (dstPop / dstPopTot) * demTotal
x <- state.center$x
names(x) <- state.name
y <- state.center$x
names(y) <- state.name
cost <- matrix(0,nrow=length(src),ncol=length(dst),dimnames=list(src,dst))
for (s in src) {
  for (d in dst) {
    cost[s,d] <- sqrt((x[s]-x[d])^2 + (y[s]-y[d])^2)
  }
}
@

Now that we've created the raw data for our transportation problem, we
need to put it in proper form for writing out the GDX.  In this example,
we use a list for each symbol to write, although we could use data
frames too.
<<statesGDX>>=
ilst <- list(name='I',uels=list(src),ts='supply states')
jlst <- list(name='J',uels=list(dst),ts='demand states')
suplst <- list(name='a',val=as.array(sup),uels=list(src),
               dim=1,form='full',type='parameter',ts='supply limits')
demlst <- list(name='b',val=as.array(dem),uels=list(dst),
               dim=1,form='full',type='parameter',ts='demand quantities')
clst <- list(name='c',val=cost,uels=list(src,dst),
             dim=2,form='full',type='parameter',
             ts='transportation costs')
wgdx.lst('inStates',list(ilst,jlst,suplst,demlst,clst))
@

Once the data is written to GDX we can call gams, as before.  A model
status of 1 (Optimal) indicates an optimal solution was found.
<<statesSolve>>=
gams(paste(gms,'--INPUT inStates.gdx --OUTPUT outStates.gdx'))
ms <- rgdx.scalar('outStates.gdx','modelStat')
print(paste('Model status:',ms))
@

\section{Abnormal Results}

Things often fail to go as planned.  In many cases, this is indicated
by a nonzero return code from a GAMS run.  For example, we could point
to a non-existent GDX input:
<<missingGDX>>=
rc <- gams('transport --INPUT notHere')
if (0 == rc) print ("SHOULD NOT GET HERE") else print ("abnormal gams return as expected")
@

Another case to consider is an infeasible model.  This is not an
error: infeasible models are sometimes expected.  The model status
(one of many values available after a solve) can indicate an infeasible
model, among other things.  If we reduce the supply available from
Seattle, we make the model infeasible.
<<infeas>>=
a2 <- a
rows <- a2$i == 'seattle'
a2[rows,2] <- a2[rows,2] - 100
wgdx.lst('inInf',list(I,J,a2,b,c))
gams(paste(gms,'--INPUT inInf.gdx --OUTPUT outInf.gdx'))
ms <- rgdx.scalar('outInf.gdx','modelStat')
if (4 == ms) print ("Reduced supply makes model infeasible")
@

\end{document}
